"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _jstz = _interopRequireDefault(require("jstz"));

var _YIUIBase = require("./YIUI-base");

var _yesCommon = require("yes-common");

var _encrypt = _interopRequireDefault(require("./utils/encrypt"));

var _base = _interopRequireDefault(require("base-64"));

var _actions = require("./actions");

var _qs = _interopRequireDefault(require("qs"));

var _objectHash = _interopRequireDefault(require("object-hash"));

var _dispatchers = _interopRequireDefault(require("./dispatchers"));

var _session = require("./session");

var _exceptions = require("./exceptions");

var _pako = _interopRequireDefault(require("pako"));

var _fetch = _interopRequireDefault(require("./fetch"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var Svr = {};
var _default = Svr;
exports["default"] = _default;

Svr.Request = function () {
  var transData = function transData(data) {
    if (data == null) {
      return data;
    }

    var json = _yesCommon.lodash.toJSON(data);

    return data; // 传送数据 长度 大于 20000 开启压缩   20000长度的数据传输在30K 左右

    if (json.length < 20000) {
      return data;
    }

    var postData = {};
    postData.yigoData = _YIUIBase.YIUI.Base64.encode64(_pako["default"].gzip(json));
    return postData;
  };

  var d_msg = {
    count: 0,
    time: 0,
    size: 0
  };

  var getMSG = function getMSG(time, size) {
    var svr_msg = Svr.MSG = Svr.MSG || d_msg;
    svr_msg.count++;
    svr_msg.time += time;
    svr_msg.size += size;
    console.log(svr_msg);
  };

  var convertResult = function convertResult(msg) {
    var ret = msg.data;

    if (msg.type === _YIUIBase.YIUI.JavaDataType.STR_USER_DATATABLE) {
      ret = _YIUIBase.YIUI.DataUtil.fromJSONDataTable(ret);
    } else if (msg.type === _YIUIBase.YIUI.JavaDataType.STR_USER_DOCUMENT) {
      ret = _YIUIBase.YIUI.DataUtil.fromJSONDoc(ret);
    }

    return ret;
  };

  var requestPromises = {};
  var Return = {
    upload: function () {
      var _upload = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee(file) {
        var options,
            fileName,
            url,
            data,
            key,
            request,
            response,
            result,
            _args = arguments;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                options = _args.length > 1 && _args[1] !== undefined ? _args[1] : {};
                fileName = _args.length > 2 ? _args[2] : undefined;
                url = Svr.SvrMgr.AttachURL;
                data = new FormData();
                data.append('file', file, fileName || file.name);

                for (key in options) {
                  data.append(key, options[key]);
                }

                request = {
                  method: 'post',
                  credentials: 'include',
                  body: data
                };
                _context.next = 9;
                return fetch(url, request);

              case 9:
                response = _context.sent;
                _context.next = 12;
                return response.json();

              case 12:
                result = _context.sent;

                if (!(result.success == null || result.success)) {
                  _context.next = 17;
                  break;
                }

                result = convertResult(result);
                _context.next = 19;
                break;

              case 17:
                if (data.error.error_code === -2146828281) {
                  //超时
                  (0, _dispatchers["default"])().dispatch((0, _actions.logouted)());
                }

                throw new _exceptions.YESException(data.error.error_code, '', data.error.error_info);

              case 19:
                return _context.abrupt("return", result);

              case 20:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      function upload(_x) {
        return _upload.apply(this, arguments);
      }

      return upload;
    }(),
    getData: function () {
      var _getData = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee2(params, url) {
        var convert,
            _args2 = arguments;
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                convert = _args2.length > 2 && _args2[2] !== undefined ? _args2[2] : true;
                _context2.next = 3;
                return Return.getAsyncData(url || Svr.SvrMgr.ServletURL, params, convert);

              case 3:
                return _context2.abrupt("return", _context2.sent);

              case 4:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }));

      function getData(_x2, _x3) {
        return _getData.apply(this, arguments);
      }

      return getData;
    }(),
    getSyncData: function () {
      var _getSyncData = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee4(url, params) {
        var convert,
            useCache,
            requestKey,
            requestPromise,
            requestOwner,
            returnObj,
            locale,
            tz,
            timezone,
            clientID,
            request,
            qq,
            data,
            _args4 = arguments;
        return regeneratorRuntime.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                convert = _args4.length > 2 && _args4[2] !== undefined ? _args4[2] : true;
                useCache = _args4.length > 3 && _args4[3] !== undefined ? _args4[3] : true;
                requestKey = (0, _objectHash["default"])(params);
                requestPromise = null;
                requestOwner = true;

                if (requestPromises[requestKey]) {
                  console.log('Request Cache hit!');
                  requestPromise = requestPromises[requestKey];
                  requestOwner = false;
                } else {
                  params.mode = params.mode || 2;
                  returnObj = null;
                  locale = window.navigator.language || window.navigator.browserLanguage;
                  tz = _jstz["default"].determine();
                  timezone = tz.name(); // var timezone='Indian/Maldives';

                  params.locale = locale;
                  params.timezone = timezone;
                  clientID = (0, _session.getSession)();

                  if (clientID) {
                    params.clientID = clientID;
                  } // try {


                  request = {
                    method: 'post',
                    credentials: 'include',
                    body: _qs["default"].stringify(transData(params)),
                    headers: {
                      'Content-type': "application/x-www-form-urlencoded; charset=UTF-8"
                    }
                  }; // var response = await fetch(url, request);

                  qq =
                  /*#__PURE__*/
                  function () {
                    var _ref = _asyncToGenerator(
                    /*#__PURE__*/
                    regeneratorRuntime.mark(function _callee3() {
                      var response;
                      return regeneratorRuntime.wrap(function _callee3$(_context3) {
                        while (1) {
                          switch (_context3.prev = _context3.next) {
                            case 0:
                              _context3.next = 2;
                              return (0, _fetch["default"])(fetch(url, request), 20000);

                            case 2:
                              response = _context3.sent;
                              _context3.next = 5;
                              return response.json();

                            case 5:
                              return _context3.abrupt("return", _context3.sent);

                            case 6:
                            case "end":
                              return _context3.stop();
                          }
                        }
                      }, _callee3);
                    }));

                    return function qq() {
                      return _ref.apply(this, arguments);
                    };
                  }();

                  requestPromise = qq();
                  requestPromises[requestKey] = requestPromise;
                }

                _context4.prev = 6;
                _context4.next = 9;
                return requestPromise;

              case 9:
                data = _context4.sent;

              case 10:
                _context4.prev = 10;

                if (requestOwner) {
                  if (useCache) {
                    setTimeout(function () {
                      delete requestPromises[requestKey];
                    }, 2000);
                  } else {
                    delete requestPromises[requestKey];
                  }
                }

                return _context4.finish(10);

              case 13:
                if (!(data.success == null || data.success)) {
                  _context4.next = 17;
                  break;
                }

                data = convert ? convertResult(data) : data.data;
                _context4.next = 19;
                break;

              case 17:
                if (data.error.error_code === -2146828286 || data.error.error_code === -2146828281) {
                  //超时
                  (0, _dispatchers["default"])().dispatch((0, _actions.logouted)());
                }

                throw new _exceptions.YESException(data.error.error_code, '', data.error.error_info);

              case 19:
                return _context4.abrupt("return", data);

              case 20:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, null, [[6,, 10, 13]]);
      }));

      function getSyncData(_x4, _x5) {
        return _getSyncData.apply(this, arguments);
      }

      return getSyncData;
    }(),
    getAsyncData: function () {
      var _getAsyncData = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee5(url, params, sucCallback, errorCallback) {
        var result;
        return regeneratorRuntime.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                _context5.next = 2;
                return Return.getSyncData(url, params, sucCallback, errorCallback);

              case 2:
                result = _context5.sent;
                return _context5.abrupt("return", result);

              case 4:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5);
      }));

      function getAsyncData(_x6, _x7, _x8, _x9) {
        return _getAsyncData.apply(this, arguments);
      }

      return getAsyncData;
    }()
  };
  return Return;
}();
/**
* Created with JetBrains WebStorm.
* User: 陈志盛
* Date: 14-1-8
* Time: 下午2:00
* 向服务器发送相关请求及参数，获取返回值进行处理
*/
//  var Svr = Svr || {};


Svr.SvrMgr = function () {
  var location_pathname = _yesCommon.DummyDocument.location.pathname;

  while (location_pathname.indexOf('/') == 0) {
    location_pathname = location_pathname.substr(1);
  }

  var baseurl = unescape(location_pathname.substr(0));
  var service = baseurl.substring(0, baseurl.indexOf('/'));
  var Return = {
    Service: {
      Authenticate: 'Authenticate',
      LoadTreeMenu: 'LoadTreeMenu',
      DealWithPureForm: 'DealWithPureForm',
      DeleteAttachment: 'DeleteAttachment',
      GetPublicKey: 'GetPublicKey',
      PureFormData: 'PureFormData',
      DelFormData: 'DeleteData',
      GoToPage: 'GoToPage',
      PureDictView: 'PureDictView',
      PureViewMap: 'PureViewMap',
      PureTreeEvent: "PureTreeEvent"
    },
    // 静态公有属性
    EventType: {
      Click: 0,
      DBLClick: 1,
      GainFocus: 2,
      LostFocus: 3,
      EnterPress: 4,
      Expand: 5,
      Collapse: 6,
      GotoPage: 7,
      DictViewSearch: 8,
      CellClick: 9,
      CellSelect: 10,
      RowDelete: 11,
      RowInsert: 12,
      RowChange: 13,
      ValueChanged: 14,
      RowClick: 15,
      RowDblClick: 16
    },
    doPureTreeEvent: function doPureTreeEvent(paras, success) {
      paras = _yesCommon.lodash.extend({
        url: Return.ServletURL,
        service: Return.Service.PureTreeEvent
      }, paras);
      return doCmd(paras, null, success);
    },
    loadTreeMenu: function () {
      var _loadTreeMenu = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee6(paras) {
        return regeneratorRuntime.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                paras = _yesCommon.lodash.extend({
                  async: false,
                  url: Return.ServletURL,
                  service: Return.Service.LoadTreeMenu
                }, paras);
                _context6.next = 3;
                return doCmd(paras);

              case 3:
                return _context6.abrupt("return", _context6.sent);

              case 4:
              case "end":
                return _context6.stop();
            }
          }
        }, _callee6);
      }));

      function loadTreeMenu(_x10) {
        return _loadTreeMenu.apply(this, arguments);
      }

      return loadTreeMenu;
    }(),
    dealWithPureForm: function dealWithPureForm(paras, succuss) {
      paras = _yesCommon.lodash.extend({
        async: true,
        url: Return.ServletURL,
        service: Return.Service.DealWithPureForm
      }, paras);
      return doCmd(paras, null, succuss);
    },
    deleteAttachment: function deleteAttachment(paras) {
      paras = _yesCommon.lodash.extend({
        url: Return.AttachURL,
        service: Return.Service.DeleteAttachment
      }, paras);
      doCmd(paras);
    },
    syncServerDate: function () {
      var _syncServerDate = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee7() {
        var paras, result;
        return regeneratorRuntime.wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                paras = {};
                paras.service = "DateService";
                paras.cmd = "ServerDate";
                _context7.next = 5;
                return Svr.Request.getSyncData(Svr.SvrMgr.ServletURL, paras);

              case 5:
                result = _context7.sent;
                (0, _session.setServerDate)(result);

              case 7:
              case "end":
                return _context7.stop();
            }
          }
        }, _callee7);
      }));

      function syncServerDate() {
        return _syncServerDate.apply(this, arguments);
      }

      return syncServerDate;
    }(),
    doLogin: function () {
      var _doLogin = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee8(username, password, sessionPara, mode, opts) {
        var publicKey, loginInfo, data, result, userinfo;
        return regeneratorRuntime.wrap(function _callee8$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                _context8.next = 2;
                return Svr.SvrMgr.getPublicKey({
                  async: false
                });

              case 2:
                publicKey = _context8.sent;
                // rsa.setPublic(publicKey.modulus, publicKey.exponent);
                loginInfo = {};
                loginInfo.user = username;
                loginInfo.password = password;
                loginInfo.mode = mode;
                data = _encrypt["default"].current(publicKey.modulus, publicKey.exponent, _yesCommon.lodash.toJSON(loginInfo));
                data = _base["default"].encode(data);
                opts = _yesCommon.lodash.extend({
                  url: Return.ServletURL,
                  logininfo: data,
                  paras: _yesCommon.lodash.toJSON(sessionPara),
                  cmd: 'Login',
                  service: Return.Service.Authenticate
                }, opts); // var success = function(result) {
                //     if (result) {
                //         if (opts.cmd == "Login") {
                //             $.cookie("userName", result.Name);
                //             var time = result.Time;
                //             var date = new Date(time);
                //             var dateStr = date.Format("yyyy/MM/dd HH:mm:ss");
                //             $.cookie("login_time", dateStr);
                //             if(result.SessionParas) {
                //             	$.cookie("sessionParas", result.SessionParas);
                //             }
                //         }
                //         location.reload();
                //     }
                // };

                _context8.next = 12;
                return doCmd(opts);

              case 12:
                result = _context8.sent;
                _yesCommon.DummyDocument.clientID = result.clientID;
                _context8.next = 16;
                return (0, _session.setSession)(result.clientID);

              case 16:
                if (!result.SessionParas) {
                  _context8.next = 19;
                  break;
                }

                _context8.next = 19;
                return (0, _session.setParas)(JSON.parse(result.SessionParas));

              case 19:
                userinfo = {
                  id: result.UserID,
                  name: result.Name,
                  clientID: result.clientID
                };
                _context8.next = 22;
                return (0, _session.setUserInfo)(userinfo);

              case 22:
                _context8.next = 24;
                return Return.syncServerDate();

              case 24:
                (0, _dispatchers["default"])().dispatch((0, _actions.logined)(userinfo));
                return _context8.abrupt("return", result);

              case 26:
              case "end":
                return _context8.stop();
            }
          }
        }, _callee8);
      }));

      function doLogin(_x11, _x12, _x13, _x14, _x15) {
        return _doLogin.apply(this, arguments);
      }

      return doLogin;
    }(),
    doLogout: function () {
      var _doLogout = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee9(paras) {
        var success;
        return regeneratorRuntime.wrap(function _callee9$(_context9) {
          while (1) {
            switch (_context9.prev = _context9.next) {
              case 0:
                //	        YIUI.Print.delAll();
                paras = _yesCommon.lodash.extend({
                  url: Return.ServletURL,
                  cmd: 'Logout',
                  service: Return.Service.Authenticate
                }, paras);

                success = function success(result) {
                  if (result) {
                    if (paras.cmd == 'Login') {
                      _yesCommon.lodash.cookie('userName', result.Name);
                    } //                    location.href = $.cookie("url");


                    window.location.reload();
                  }
                };

                _context9.next = 4;
                return doCmd(paras, null);

              case 4:
                return _context9.abrupt("return", _context9.sent);

              case 5:
              case "end":
                return _context9.stop();
            }
          }
        }, _callee9);
      }));

      function doLogout(_x16) {
        return _doLogout.apply(this, arguments);
      }

      return doLogout;
    }(),
    getPublicKey: function () {
      var _getPublicKey = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee10(paras) {
        return regeneratorRuntime.wrap(function _callee10$(_context10) {
          while (1) {
            switch (_context10.prev = _context10.next) {
              case 0:
                paras = _yesCommon.lodash.extend({
                  url: Return.ServletURL,
                  isWeb: true,
                  service: Return.Service.GetPublicKey
                }, paras);
                _context10.next = 3;
                return doCmd(paras, null);

              case 3:
                return _context10.abrupt("return", _context10.sent);

              case 4:
              case "end":
                return _context10.stop();
            }
          }
        }, _callee10);
      }));

      function getPublicKey(_x17) {
        return _getPublicKey.apply(this, arguments);
      }

      return getPublicKey;
    }(),
    dealWithPureData: function dealWithPureData(paras) {
      paras = _yesCommon.lodash.extend({
        url: Return.ServletURL,
        service: Return.Service.PureFormData
      }, paras);
      return doCmd(paras);
    },
    delPureData: function () {
      var _delPureData = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee11(paras) {
        return regeneratorRuntime.wrap(function _callee11$(_context11) {
          while (1) {
            switch (_context11.prev = _context11.next) {
              case 0:
                paras = _yesCommon.lodash.extend({
                  url: Return.ServletURL,
                  service: Return.Service.DelFormData
                }, paras);
                _context11.next = 3;
                return doCmd(paras);

              case 3:
                return _context11.abrupt("return", _context11.sent);

              case 4:
              case "end":
                return _context11.stop();
            }
          }
        }, _callee11);
      }));

      function delPureData(_x18) {
        return _delPureData.apply(this, arguments);
      }

      return delPureData;
    }(),
    loadFormData: function loadFormData(paras) {
      paras = _yesCommon.lodash.extend({
        url: Return.ServletURL,
        service: Return.Service.PureFormData
      }, paras);
      return doCmd(paras);
    },
    doGoToPage: function doGoToPage(paras) {
      paras = _yesCommon.lodash.extend({
        url: Return.ServletURL,
        service: Return.Service.GoToPage
      }, paras);
      return doCmd(paras);
    },
    doDictViewEvent: function doDictViewEvent(paras) {
      paras = _yesCommon.lodash.extend({
        url: Return.ServletURL,
        service: Return.Service.PureDictView
      }, paras);
      return doCmd(paras);
    },
    doMapEvent: function doMapEvent(paras) {
      paras = _yesCommon.lodash.extend({
        url: Return.ServletURL,
        service: Return.Service.PureViewMap
      }, paras);
      return doCmd(paras);
    },
    cutImg: function cutImg(paras) {
      paras = _yesCommon.lodash.extend({
        url: Return.ServletURL,
        service: "CutImage"
      }, paras);
      return doCmd(paras);
    },
    saveFormData: function () {
      var _saveFormData = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee12(paras, form, success) {
        return regeneratorRuntime.wrap(function _callee12$(_context12) {
          while (1) {
            switch (_context12.prev = _context12.next) {
              case 0:
                processPara(form);
                paras = _yesCommon.lodash.extend({
                  url: Return.ServletURL
                }, paras);
                _context12.next = 4;
                return doCmd(paras, null, success);

              case 4:
                return _context12.abrupt("return", _context12.sent);

              case 5:
              case "end":
                return _context12.stop();
            }
          }
        }, _callee12);
      }));

      function saveFormData(_x19, _x20, _x21) {
        return _saveFormData.apply(this, arguments);
      }

      return saveFormData;
    }(),
    getErrorMsg: function () {
      var _getErrorMsg = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee13(code, args) {
        var paras;
        return regeneratorRuntime.wrap(function _callee13$(_context13) {
          while (1) {
            switch (_context13.prev = _context13.next) {
              case 0:
                if (!(code === -1)) {
                  _context13.next = 2;
                  break;
                }

                return _context13.abrupt("return", args || 'Server unexpected exception!');

              case 2:
                paras = {
                  url: Return.ServletURL,
                  service: "PureException",
                  code: code
                };

                if (args != null && args != undefined) {
                  paras.args = args;
                }

                _context13.next = 6;
                return doCmd(paras);

              case 6:
                return _context13.abrupt("return", _context13.sent);

              case 7:
              case "end":
                return _context13.stop();
            }
          }
        }, _callee13);
      }));

      function getErrorMsg(_x22, _x23) {
        return _getErrorMsg.apply(this, arguments);
      }

      return getErrorMsg;
    }()
  }; // Return.ServletURL = [window.location.protocol, '//', window.location.host, '/', service, '/', 'servlet'].join('');
  // Return.UIProxyURL = [window.location.protocol, '//', window.location.host, '/', service, '/', 'uiproxy'].join('');
  // Return.AttachURL = [window.location.protocol, '//', window.location.host, '/', service, '/', 'attach'].join('');

  var doCmd =
  /*#__PURE__*/
  function () {
    var _ref2 = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee14(paras, rootDom, success, error) {
      var returnObj;
      return regeneratorRuntime.wrap(function _callee14$(_context14) {
        while (1) {
          switch (_context14.prev = _context14.next) {
            case 0:
              if (!(paras.async == true)) {
                _context14.next = 6;
                break;
              }

              _context14.next = 3;
              return Svr.Request.getAsyncData(paras.url, paras, success, error);

            case 3:
              returnObj = _context14.sent;
              _context14.next = 9;
              break;

            case 6:
              _context14.next = 8;
              return Svr.Request.getSyncData(paras.url, paras, success, error);

            case 8:
              returnObj = _context14.sent;

            case 9:
              return _context14.abrupt("return", returnObj);

            case 10:
            case "end":
              return _context14.stop();
          }
        }
      }, _callee14);
    }));

    return function doCmd(_x24, _x25, _x26, _x27) {
      return _ref2.apply(this, arguments);
    };
  }();

  var processPara = function processPara(form) {
    if (form != null) {
      var paraCollection = form.getParaCollection();

      if (paraCollection != null) {
        for (var i = 0, len = paraCollection.length; i < len; i++) {
          var para = paraCollection[i],
              value;

          switch (para.type) {
            case _YIUIBase.YIUI.ParameterSourceType.CONST:
              value = para.value;
              break;

            case _YIUIBase.YIUI.ParameterSourceType.FORMULA:
              value = form.eval(para.formula, cxt);
              break;
          }

          form.setPara(para.key, value);
        }
      }
    }
  };

  return Return;
}(); // YIUI.DictService = (function () {
//     var Return = {
// 		/**
// 		 * 获取所有父节点ID
// 		 */
//         getAllParentID: function (itemKey, itemDatas, callback) {
//             var result = true;
//             var data = {};
//             data.itemKey = itemKey;
//             data.itemDatas = $.toJSON(itemDatas);
//             data.service = 'DictService';
//             data.cmd = 'GetParentPath';
//             var success = function (msg) {
//                 if ($.isFunction(callback)) {
//                     callback(msg);
//                 } else {
//                     result = msg;
//                 }
//             };
//             Svr.Request.getSyncData(Svr.SvrMgr.ServletURL, data, success);
//             return result;
//         },
// 		/**
// 		 * 根据父节点获取子节点
// 		 */
//         getDictChildren: function (itemKey, itemData, filter, stateMask, callback) {
//             var result = true;
//             var data = {};
//             data.itemKey = itemKey;
//             data.itemData = $.toJSON(itemData);
//             if (filter != null) {
//                 data.filter = $.toJSON(filter);
//             }
//             data.service = 'WebDictService';
//             data.cmd = 'GetDictChildren';
//             data.stateMask = stateMask;
//             var success = function (msg) {
//                 if ($.isFunction(callback)) {
//                     callback(msg);
//                 } else {
//                     result = msg;
//                 }
//             };
//             Svr.Request.getSyncData(Svr.SvrMgr.ServletURL, data, success);
//             return result;
//         },
// 		/**
// 		 * 精确查找
// 		 */
//         locate: function (itemKey, field, value, filter, root, statMask, callback) {
//             var result = true;
//             var data = {};
//             data.itemKey = itemKey;
//             if (field != null) {
//                 data.field = field;
//             }
//             data.value = value;
//             if (filter != null) {
//                 data.filter = $.toJSON(filter);
//             }
//             data.root = $.toJSON(root);
//             data.statMask = statMask;
//             data.service = 'DictService';
//             data.cmd = 'Locate';
//             var success = function (msg) {
//                 if ($.isFunction(callback)) {
//                     callback(msg);
//                 } else {
//                     result = msg;
//                 }
//             };
//             Svr.Request.getSyncData(Svr.SvrMgr.ServletURL, data, success);
//             return result;
//         },
// 		/**
// 		 * 获取一个字典缓存
// 		 */
//         getItem: async function (itemKey, oid, statMask, callback) {
//             // var data = {};
//             // data.itemKey = itemKey;
//             // data.oid = oid;
//             // data.statMask = statMask;
//             // data.cmd = "GetItem";
//             // data.service = "WebDictService";
//             // var result = true;
//             return await CacheSystem.current.DictCache.get(`${itemKey}.${oid}`);
//             // let msg = await Svr.Request.getSyncData(Svr.SvrMgr.ServletURL, data);
//             // result = msg ? YIUI.DataUtil.fromJSONItem(msg) : true;
//             // return result;
//         },
// 		/**
// 		 * 模糊查询　用于dictQueryPane 与　链式字典的dictView
// 		 */
//         getQueryData: function (itemKey, startRow, maxRows, pageIndicatorCount, fuzzyValue, stateMask, filter, root, callback) {
//             var result = true;
//             var data = {};
//             data.itemKey = itemKey;
//             data.startRow = startRow;
//             data.maxRows = maxRows;
//             data.pageIndicatorCount = pageIndicatorCount;
//             data.value = fuzzyValue;
//             data.stateMask = stateMask;
//             if (filter != null) {
//                 data.filter = $.toJSON(filter);
//             }
//             if (root != null) {
//                 data.root = $.toJSON(root);
//             }
//             data.service = 'WebDictService';
//             data.cmd = 'GetQueryData';
//             var success = function (msg) {
//                 if ($.isFunction(callback)) {
//                     callback(msg);
//                 } else {
//                     result = msg;
//                 }
//             };
//             Svr.Request.getSyncData(Svr.SvrMgr.ServletURL, data, success);
//             return result;
//         },
// 		/**
// 		 * 直接输入文本时智能提示相关数据
// 		 */
//         getSuggestData: function (itemKey, suggestValue, statMask, filter, root, callback) {
//             var result = true;
//             var data = {};
//             data.itemKey = itemKey;
//             data.value = suggestValue;
//             data.statMask = statMask;
//             if (filter != null) {
//                 data.filter = $.toJSON(filter);
//             }
//             if (root != null) {
//                 data.root = $.toJSON(root);
//             }
//             data.service = 'WebDictService';
//             data.cmd = 'GetSuggestData';
//             var success = function (msg) {
//                 if ($.isFunction(callback)) {
//                     callback(msg);
//                 } else {
//                     result = msg;
//                 }
//             };
//             Svr.Request.getSyncData(Svr.SvrMgr.ServletURL, data, success);
//             return result;
//         },
// 		/**
// 		 * 获取当前节点的父节点ID
// 		 */
//         getParentID: function (itemKey, itemData, callback) {
//             var result = true;
//             var data = {};
//             data.itemKey = itemKey;
//             data.itemData = $.toJSON(itemData);
//             data.cmd = 'GetParentID';
//             data.service = 'WebDictService';
//             var success = function (msg) {
//                 if ($.isFunction(callback)) {
//                     callback(msg);
//                 } else {
//                     result = msg;
//                 }
//             };
//             Svr.Request.getSyncData(Svr.SvrMgr.ServletURL, data, success);
//             return result;
//         },
// 		/**
// 		 * 修改字典使用状态
// 		 */
//         enableDict: function (itemKey, oid, enable, allChildren, callback) {
//             var result = true;
//             var data = {};
//             data.itemKey = itemKey;
//             data.oid = oid;
//             if (typeof (enable) == undefined || enable == null) {
//                 enable = 1;
//             }
//             data.enable = enable.toString();
//             data.allChildren = allChildren;
//             data.cmd = 'EnableDict';
//             data.service = 'WebDictService';
//             var success = function (msg) {
//                 if ($.isFunction(callback)) {
//                     callback(msg);
//                 } else {
//                     result = msg;
//                 }
//             };
//             Svr.Request.getSyncData(Svr.SvrMgr.ServletURL, data, success);
//             return result;
//         },
// 		/**
// 		 * 根据字典itemKey id取caption
// 		 */
//         getCaption: function (itemKey, oid, callback) {
//             var result = true;
//             var data = {};
//             data.itemKey = itemKey;
//             data.oids = $.toJSON(oid);
//             data.cmd = 'getCaption';
//             data.service = 'WebDictService';
//             var success = function (msg) {
//                 if ($.isFunction(callback)) {
//                     callback(msg);
//                 } else {
//                     result = msg;
//                 }
//             };
//             Svr.Request.getSyncData(Svr.SvrMgr.ServletURL, data, success);
//             return result;
//         },
//         getDictValue: async function (itemKey, oid, fieldKey, callback) {
//             // if (oid == undefined || oid == null) return null;
//             var item = await this.getItem(itemKey, oid);
//             return item.getValue(fieldKey);
//             // var result = true;
//             // var data = {};
//             // data.itemKey = itemKey;
//             // data.oid = oid.toString();
//             // data.fieldKey = fieldKey;
//             // data.cmd = 'GetDictValue';
//             // data.service = 'WebDictService';
//             // return await Svr.Request.getSyncData(Svr.SvrMgr.ServletURL, data);
//         },
//         getTreePath: function (itemKey, child) {
//             var paras = {
//                 service: 'DictService',
//                 cmd: 'GetParentPath',
//                 itemKey,
//                 itemData: $.toJSON(child),
//             };
//             var result = Svr.Request.getSyncData(Svr.SvrMgr.ServletURL, paras);
//             return result;
//         },
//         getParentPath: function (itemKey, child) {
//             var paras = {
//                 service: 'DictService',
//                 cmd: 'GetParentPath',
//                 itemKey,
//                 itemData: $.toJSON(child),
//             };
//             var result = Svr.Request.getSyncData(Svr.SvrMgr.ServletURL, paras);
//             return result;
//         },
//     };
//     return Return;
// })();


_YIUIBase.YIUI.DateFormat = function () {
  var Return = {
    //日期 formatStr、onlyDate
    format: function format(date, meta) {
      var text = "";

      if (date) {
        var formatStr = "yyyy-MM-dd HH:mm:ss";

        if (meta) {
          if (meta.formatStr) {
            formatStr = meta.formatStr;
          }

          if (meta.onlyDate) {
            formatStr = formatStr.split(" ")[0];
          }
        }

        var df = function df(d, f) {
          var o = {
            "M+": d.getMonth() + 1,
            //月份         
            "d+": d.getDate(),
            //日         
            "h+": d.getHours() % 12 == 0 ? 12 : d.getHours() % 12,
            //小时         
            "H+": d.getHours(),
            //小时         
            "m+": d.getMinutes(),
            //分         
            "s+": d.getSeconds(),
            //秒         
            "q+": Math.floor((d.getMonth() + 3) / 3),
            //季度         
            "S": d.getMilliseconds() //毫秒         

          };

          if (/(y+)/.test(f)) {
            f = f.replace(RegExp.$1, (d.getFullYear() + "").substr(4 - RegExp.$1.length));
          }

          for (var k in o) {
            if (new RegExp("(" + k + ")").test(f)) {
              f = f.replace(RegExp.$1, RegExp.$1.length == 1 ? o[k] : ("00" + o[k]).substr(("" + o[k]).length));
            }
          }

          return f;
        };

        text = df(date, formatStr);
      }

      return text;
    }
  };
  return Return;
}();