"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _YIUIBase = require("./YIUI-base");

require("./YIUI-common");

require("./YIUI-parser");

require("./YIUI-svr");

var _yesCommon = require("yes-common");

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

// var YIUI = YIUI || {};
// (function () {
var _default = _YIUIBase.YIUI.AbstractUIProcess = _YIUIBase.YIUI.extend({
  form: null,
  // formRights: null,
  // allEnableRights : true,
  // allVisibleRights : true,
  init: function init(form) {
    this.form = form; // this.formRights = form.getFormRights();
    // if( form.metaForm.authenticate ) {
    //     this.allEnableRights = this.formRights.allEnableRights;
    //     this.allVisibleRights = this.formRights.allVisibleRights;
    // }
  },
  getFormEnable: function getFormEnable() {
    return this.form.operationState == _YIUIBase.YIUI.Form_OperationState.New || this.form.operationState == _YIUIBase.YIUI.Form_OperationState.Edit;
  },
  enableOnly: function enableOnly() {
    return this.form.operationState == _YIUIBase.YIUI.Form_OperationState.New || this.form.operationState == _YIUIBase.YIUI.Form_OperationState.edit ? false : this.form.operationState == _YIUIBase.YIUI.Form_OperationState.Default;
  },
  newContext: function newContext(form, rowIndex, colIndex) {
    var cxt = {};
    cxt.form = form;
    cxt.rowIndex = rowIndex;
    cxt.colIndex = colIndex;
    return cxt;
  },
  isNullValue: function isNullValue(v) {
    if (v == null || v == '') return true;
    if (v instanceof Decimal) return parseFloat(v) == 0;
    return false;
  },
  initTree: function initTree(item) {
    if (!item.items) return;

    for (var i = 0, exp, cnt; exp = item.items[i]; i++) {
      cnt = exp.content || exp.formulaValue;

      if (cnt) {
        exp.syntaxTree = this.form.getSyntaxTree(cnt);
      }
    }

    return item;
  },
  // hasEnableRights: function (key) {
  //     var host = this.form.getBPMStatusProxy();
  //     if (host) {
  //         return host.hasEnableRights(key);
  //     }
  //     return this.allEnableRights || $.inArray(key, this.formRights.enableRights) == -1;
  // },
  // hasVisibleRights: function (key) {
  //     var host = this.form.getBPMStatusProxy();
  //     if (host) {
  //         return host.hasVisibleRights(key);
  //     }
  //     return this.allVisibleRights || $.inArray(key, this.formRights.visibleRights) == -1;
  // },
  calcFormulaValue: function () {
    var _calcFormulaValue = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee(item, context) {
      var result;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              result = null;

              if (!item.syntaxTree) {
                _context.next = 7;
                break;
              }

              _context.next = 4;
              return this.form.evalByTree(item.syntaxTree, context, null);

            case 4:
              result = _context.sent;
              _context.next = 14;
              break;

            case 7:
              if (!item.formula) {
                _context.next = 13;
                break;
              }

              _context.next = 10;
              return this.form.eval(item.formula, context, null);

            case 10:
              result = _context.sent;
              _context.next = 14;
              break;

            case 13:
              if (item.defaultValue) {
                result = item.defaultValue;
              }

            case 14:
              return _context.abrupt("return", result);

            case 15:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    function calcFormulaValue(_x, _x2) {
      return _calcFormulaValue.apply(this, arguments);
    }

    return calcFormulaValue;
  }(),
  calcEnable: function () {
    var _calcEnable = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee2(item, context, defaultValue, accessControl) {
      var i, it, v;
      return regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              if (!(!this.form.hasEnableRight(item.target) || !accessControl)) {
                _context2.next = 2;
                break;
              }

              return _context2.abrupt("return", false);

            case 2:
              if (!(item.items.length == 0)) {
                _context2.next = 4;
                break;
              }

              return _context2.abrupt("return", defaultValue);

            case 4:
              i = 0;

            case 5:
              if (!(i < item.items.length)) {
                _context2.next = 27;
                break;
              }

              it = item.items[i];
              v = true;

              if (!it.syntaxTree) {
                _context2.next = 16;
                break;
              }

              _context2.t0 = _YIUIBase.YIUI.TypeConvertor;
              _context2.next = 12;
              return this.form.evalByTree(it.syntaxTree, context, null);

            case 12:
              _context2.t1 = _context2.sent;
              v = _context2.t0.toBoolean.call(_context2.t0, _context2.t1);
              _context2.next = 22;
              break;

            case 16:
              if (!it.content) {
                _context2.next = 22;
                break;
              }

              _context2.t2 = _YIUIBase.YIUI.TypeConvertor;
              _context2.next = 20;
              return this.form.evalFormula(it.content, context, null);

            case 20:
              _context2.t3 = _context2.sent;
              v = _context2.t2.toBoolean.call(_context2.t2, _context2.t3);

            case 22:
              if (v) {
                _context2.next = 24;
                break;
              }

              return _context2.abrupt("return", false);

            case 24:
              i++;
              _context2.next = 5;
              break;

            case 27:
              return _context2.abrupt("return", true);

            case 28:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, this);
    }));

    function calcEnable(_x3, _x4, _x5, _x6) {
      return _calcEnable.apply(this, arguments);
    }

    return calcEnable;
  }(),
  calcVisible: function () {
    var _calcVisible = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee3(item, context) {
      var i, it, v;
      return regeneratorRuntime.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              if (this.form.hasVisibleRight(item.target)) {
                _context3.next = 2;
                break;
              }

              return _context3.abrupt("return", false);

            case 2:
              i = 0;

            case 3:
              if (!(i < item.items.length)) {
                _context3.next = 25;
                break;
              }

              it = item.items[i];
              v = true;

              if (!it.syntaxTree) {
                _context3.next = 14;
                break;
              }

              _context3.t0 = _YIUIBase.YIUI.TypeConvertor;
              _context3.next = 10;
              return this.form.evalByTree(it.syntaxTree, context, null);

            case 10:
              _context3.t1 = _context3.sent;
              v = _context3.t0.toBoolean.call(_context3.t0, _context3.t1);
              _context3.next = 20;
              break;

            case 14:
              if (!it.content) {
                _context3.next = 20;
                break;
              }

              _context3.t2 = _YIUIBase.YIUI.TypeConvertor;
              _context3.next = 18;
              return this.form.evalFormula(it.content, context, null);

            case 18:
              _context3.t3 = _context3.sent;
              v = _context3.t2.toBoolean.call(_context3.t2, _context3.t3);

            case 20:
              if (v) {
                _context3.next = 22;
                break;
              }

              return _context3.abrupt("return", false);

            case 22:
              i++;
              _context3.next = 3;
              break;

            case 25:
              return _context3.abrupt("return", true);

            case 26:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3, this);
    }));

    function calcVisible(_x7, _x8) {
      return _calcVisible.apply(this, arguments);
    }

    return calcVisible;
  }(),
  calcCheckRule: function () {
    var _calcCheckRule = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee4(it, context) {
      var result, i, item;
      return regeneratorRuntime.wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              result = null;
              i = 0;

            case 2:
              if (!(i < it.items.length)) {
                _context4.next = 17;
                break;
              }

              item = it.items[i];

              if (!item.syntaxTree) {
                _context4.next = 10;
                break;
              }

              _context4.next = 7;
              return this.form.evalByTree(item.syntaxTree, context, null);

            case 7:
              result = _context4.sent;
              _context4.next = 14;
              break;

            case 10:
              if (!item.content) {
                _context4.next = 14;
                break;
              }

              _context4.next = 13;
              return this.form.evalFormula(item.content, context, null);

            case 13:
              result = _context4.sent;

            case 14:
              i++;
              _context4.next = 2;
              break;

            case 17:
              if (result == null || typeof result === 'string' && result === 'true') {
                result = true;
              }

              return _context4.abrupt("return", result);

            case 19:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4, this);
    }));

    function calcCheckRule(_x9, _x10) {
      return _calcCheckRule.apply(this, arguments);
    }

    return calcCheckRule;
  }()
});

exports["default"] = _default;