"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PostChange = PostChange;
exports.logined = logined;
exports.logouted = logouted;
exports.openform = openform;
exports.openClientForm = openClientForm;
exports.openWorkitem = openWorkitem;
exports.closeform = closeform;
exports.workflowchange = workflowchange;
exports.error = error;
exports.warn = warn;
exports.changeuser = changeuser;
exports.changeBusyLoading = changeBusyLoading;
exports.pauseBusyLoading = pauseBusyLoading;
exports.resumeBusyLoading = resumeBusyLoading;
exports.reloadForm = reloadForm;
exports.closeForm = closeForm;
exports.navigateBack = navigateBack;

function PostChange() {
  return {
    type: 'CHANGED'
  };
}

function logined(userinfo) {
  console.log(userinfo);
  return {
    type: 'LOGINED',
    userinfo: userinfo
  };
}

function logouted() {
  return {
    type: 'LOGOUTED'
  };
}

function openform(formKey, oid) {
  return {
    type: 'OPENFORM',
    formKey: formKey,
    oid: oid
  };
}

function openClientForm(formKey, oid, status) {
  return {
    type: 'OPENCLIENTFORM',
    formKey: formKey,
    oid: oid,
    status: status
  };
}

function openWorkitem(wid, onlyShow, loadInfo) {
  return {
    type: 'OPENWORKITEM',
    wid: wid,
    onlyShow: onlyShow,
    loadInfo: loadInfo
  };
}

function closeform() {
  return {
    type: 'CLOSEFORM'
  };
}

function workflowchange() {
  return {
    type: 'WORKFLOWCHANGE'
  };
}

function error(err) {
  return {
    type: 'ERROR',
    error: err.error || err
  };
}

function warn(err) {
  return {
    type: 'WARN',
    error: err.error || err
  };
}

function changeuser(userinfo) {
  return {
    type: 'CHANGEUSER',
    userinfo: userinfo
  };
}

function changeBusyLoading(busyLoading) {
  return {
    type: 'BUSYLOADING',
    busyLoading: busyLoading
  };
}

function pauseBusyLoading() {
  return {
    type: 'PAUSEBUSYLOADING'
  };
}

function resumeBusyLoading() {
  return {
    type: 'RESUMEBUSYLOADING'
  };
}

function reloadForm(key) {
  return {
    type: 'RELOADFORM',
    key: key
  };
}

function closeForm(formKey) {
  return {
    type: 'CLOSEFORM',
    formKey: formKey
  };
}

function navigateBack() {
  return {
    type: 'NAVIGATEBACK'
  };
}