"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _YIUIBase = require("../YIUI-base");

require("../YIUI-common");

require("../YIUI-parser");

require("../YIUI-svr");

require("../yes-ui");

require("./inplacetoolbar");

var _default = _YIUIBase.YIUI.BPMInplaceToolBar = function () {
  var Return = {
    replace: function replace(form, operation) {
      var ret = [];
      var doc = form.getDocument();
      if (doc == null) return ret;
      var table = doc.getExpData(_YIUIBase.YIUI.BPMKeys.LoadBPM_KEY);

      if (table != null) {
        table = _YIUIBase.YIUI.DataUtil.fromJSONDataTable(table);
        table.first();
        var instanceID = table.getByKey(_YIUIBase.YIUI.BPMConstants.BPM_INSTANCE_ID);
        var instanceState = table.getByKey(_YIUIBase.YIUI.BPMConstants.ELEMENT_STATE);
        var processKey = table.getByKey(_YIUIBase.YIUI.BPMConstants.BPM_PROCESS_KEY);

        if (instanceID >= 0 && instanceState == _YIUIBase.YIUI.InstanceState.SIGN || instanceID < 0 && processKey != null && processKey.length > 0) {
          var caption = table.getByKey(_YIUIBase.YIUI.BPMConstants.BPM_STARTCAPTION);
          var action = table.getByKey(_YIUIBase.YIUI.BPMConstants.BPM_STARTACTION);

          if (action == null || action.length == 0) {
            action = "StartInstance(\"" + processKey + "\")";
          }

          var op = {};

          if (!caption) {
            caption = _YIUIBase.YIUI.I18N.toolbar.startUp;
          }

          op.caption = caption;
          op.action = action;
          op.key = operation.key;
          op.tag = 'bpm';
          op.enable = operation.enableCnt || "ReadOnly()";
          op.visible = operation.visibleCnt || "";
          op.managed = true;
          ret.push(op);
        }
      }

      return ret;
    }
  };
  return Return;
}();

exports["default"] = _default;
_YIUIBase.YIUI.BPM_TAG["BPM"] = _YIUIBase.YIUI.BPMInplaceToolBar;