"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _eventemitter = _interopRequireDefault(require("eventemitter3"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

// Table Access 数据访问
// tableName 表名
var TableAccess =
/*#__PURE__*/
function (_EventEmitter) {
  _inherits(TableAccess, _EventEmitter);

  function TableAccess(adapter, tableName, fetchFn) {
    var _this;

    var cacheFirst = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : true;

    _classCallCheck(this, TableAccess);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(TableAccess).call(this));
    _this.fetchingItems = [];
    _this.fetchFn = fetchFn;
    _this.tableName = tableName;
    _this.adapter = adapter;
    _this.cacheFirst = cacheFirst; //默认加载规则，cacheFirst = true的时候先读取Cache 

    return _this;
  } // 此处table为数据表，不是html中的table


  _createClass(TableAccess, [{
    key: "get",
    value: function () {
      var _get = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee(key) {
        var replace,
            args,
            result,
            index,
            _args = arguments;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                replace = _args.length > 1 && _args[1] !== undefined ? _args[1] : false;
                args = _args.length > 2 ? _args[2] : undefined;
                _context.next = 4;
                return this.adapter.get(key, this.tableName);

              case 4:
                result = _context.sent;

                if (result && (!result.time || Date.now() - result.time > 3600000)) {
                  result = null;
                }

                if (!(this.cacheFirst && result && !replace)) {
                  _context.next = 8;
                  break;
                }

                return _context.abrupt("return", result.data);

              case 8:
                if (this.fetchFn) {
                  _context.next = 10;
                  break;
                }

                return _context.abrupt("return", null);

              case 10:
                _context.prev = 10;

                if (!this.fetchingItems.includes(key)) {
                  _context.next = 17;
                  break;
                }

                _context.next = 14;
                return this.wait(key);

              case 14:
                result = _context.sent;
                _context.next = 27;
                break;

              case 17:
                this.fetchingItems.push(key);
                _context.prev = 18;
                _context.next = 21;
                return this.fetchFn(this.tableName, key, args);

              case 21:
                result = _context.sent;
                this.emit('receive', key, result);

              case 23:
                _context.prev = 23;
                index = this.fetchingItems.indexOf(key);
                this.fetchingItems.splice(index, 1);
                return _context.finish(23);

              case 27:
                result.time = Date.now();
                _context.next = 30;
                return this.put(key, result);

              case 30:
                _context.next = 37;
                break;

              case 32:
                _context.prev = 32;
                _context.t0 = _context["catch"](10);
                //当出现错误的时候，如果有Cache则返回Cache的内容
                console.log(_context.t0);

                if (result) {
                  _context.next = 37;
                  break;
                }

                throw _context.t0;

              case 37:
                return _context.abrupt("return", result ? result.data : null);

              case 38:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this, [[10, 32], [18,, 23, 27]]);
      }));

      function get(_x) {
        return _get.apply(this, arguments);
      }

      return get;
    }()
  }, {
    key: "put",
    value: function () {
      var _put = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee2(key, val) {
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return this.adapter.put(key, val, this.tableName);

              case 2:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function put(_x2, _x3) {
        return _put.apply(this, arguments);
      }

      return put;
    }()
  }, {
    key: "clear",
    value: function clear() {
      this.adapter.clear(this.tableName);
    }
  }, {
    key: "wait",
    value: function wait(key) {
      var _this2 = this;

      return new Promise(function (resolve, reject) {
        var fn = function fn(receiveKey, receiveValue) {
          // console.log(key,' === ',receiveKey, `${key === receiveKey}`);
          if (key === receiveKey) {
            // console.log('wait: ',key);
            // console.log('clearTimeout');
            clearTimeout(timer);
            resolve(receiveValue);
          }
        };

        var fnTimeout = function fnTimeout() {
          // console.log(Date.now());
          _this2.removeListener('receive', fn); // console.log('timeout: ',key);


          reject('timeout');
        };

        _this2.on('receive', fn); // console.log(`${key}:::BEGIN:::`,Date.now());


        var timer = setTimeout(fnTimeout, 2 * 1000);
      });
    }
  }]);

  return TableAccess;
}(_eventemitter["default"]);

var _default = TableAccess;
exports["default"] = _default;