"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _memoryAdapter = _interopRequireDefault(require("./memoryAdapter"));

var _cache = _interopRequireDefault(require("./cache"));

var _YIUIBase = require("../YIUI-base");

require("../YIUI-common");

require("../YIUI-parser");

var _YIUISvr = _interopRequireDefault(require("../YIUI-svr"));

require("../services");

var _dispatchers = _interopRequireDefault(require("../dispatchers"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var adapter = _memoryAdapter["default"];
var dispatchToken = null;
var cacheSystem = {
  current: {
    FormCache: null,
    FormDataCache: null,
    DictCache: null
  },
  injectCache: function injectCache(cacheAdapter) {
    if (cacheAdapter) {
      adapter = cacheAdapter;
    }

    if (dispatchToken) {
      (0, _dispatchers["default"])().unregister(dispatchToken);
    }

    dispatchToken = (0, _dispatchers["default"])().register(function (action) {
      switch (action.type) {
        case 'CHANGEUSER':
          onChangeUser(action.userinfo);
          break;

        default:
      }
    });
    cacheSystem.current.FormCache = new _cache["default"](adapter, 'form',
    /*#__PURE__*/
    function () {
      var _ref = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee(table, formKey) {
        var result;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return _YIUIBase.YIUI.MetaService.getMetaForm(formKey);

              case 2:
                result = _context.sent;
                return _context.abrupt("return", {
                  data: result,
                  key: formKey
                });

              case 4:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      return function (_x, _x2) {
        return _ref.apply(this, arguments);
      };
    }());
    cacheSystem.current.Setting = new _cache["default"](adapter, 'setting');
    cacheSystem.current.FormRightCache = new _cache["default"](adapter, 'formright',
    /*#__PURE__*/
    function () {
      var _ref2 = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee2(table, formKey) {
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                return _context2.abrupt("return", {
                  key: formKey,
                  data: {
                    formKey: formKey,
                    allVisibleRights: true,
                    allOptRights: true,
                    allEnableRights: true
                  }
                });

              case 1:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }));

      return function (_x3, _x4) {
        return _ref2.apply(this, arguments);
      };
    }());
    cacheSystem.current.FormDataCache = new _cache["default"](adapter, 'formdata',
    /*#__PURE__*/
    function () {
      var _ref3 = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee3(table, key, ff) {
        var _key$split, _key$split2, formKey, oid, result;

        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _key$split = key.split('.'), _key$split2 = _slicedToArray(_key$split, 2), formKey = _key$split2[0], oid = _key$split2[1]; // const form = await cacheSystem.current.FormCache.get(formKey);
                // const ff = YIUI.FormBuilder.build(form);
                // const rights = await cacheSystem.current.FormRightCache.get(formKey);
                // ff.setFormRights(rights);
                // ff.initViewDataMonitor();

                result = null;
                _context3.prev = 2;

                if (!(oid === 'new')) {
                  _context3.next = 15;
                  break;
                }

                if (!ff.onLoad) {
                  _context3.next = 10;
                  break;
                }

                _context3.next = 7;
                return _YIUIBase.YIUI.DocService.loadFormData(ff, -1, ff.getFilterMap(), ff.getCondParas());

              case 7:
                result = _context3.sent;
                _context3.next = 13;
                break;

              case 10:
                _context3.next = 12;
                return _YIUIBase.YIUI.DocService.newDocument(formKey);

              case 12:
                result = _context3.sent;

              case 13:
                _context3.next = 24;
                break;

              case 15:
                if (!(oid === 'modal')) {
                  _context3.next = 21;
                  break;
                }

                _context3.next = 18;
                return _YIUIBase.YIUI.DocService.loadFormData(ff, ff.getOID(), ff.getFilterMap(), ff.getCondParas());

              case 18:
                result = _context3.sent;
                _context3.next = 24;
                break;

              case 21:
                _context3.next = 23;
                return _YIUIBase.YIUI.DocService.loadFormData(ff, oid, ff.getFilterMap(), ff.getCondParas());

              case 23:
                result = _context3.sent;

              case 24:
                _context3.prev = 24;
                return _context3.finish(24);

              case 26:
                return _context3.abrupt("return", {
                  data: result,
                  key: key
                });

              case 27:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, null, [[2,, 24, 26]]);
      }));

      return function (_x5, _x6, _x7) {
        return _ref3.apply(this, arguments);
      };
    }(), false);
    cacheSystem.current.DictCache = new _cache["default"](adapter, 'dict',
    /*#__PURE__*/
    function () {
      var _ref4 = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee4(table, key) {
        var tmp, _tmp, itemKey, id, data, result;

        return regeneratorRuntime.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                tmp = key.split('.');
                _tmp = _slicedToArray(tmp, 2), itemKey = _tmp[0], id = _tmp[1];
                data = {};
                data.itemKey = itemKey;
                data.oid = id;
                data.statMask = false;
                data.cmd = "GetItem";
                data.service = "WebDictService";
                _context4.next = 10;
                return _YIUISvr["default"].Request.getData(data);

              case 10:
                result = _context4.sent;
                return _context4.abrupt("return", {
                  data: result,
                  key: key
                });

              case 12:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4);
      }));

      return function (_x8, _x9) {
        return _ref4.apply(this, arguments);
      };
    }());
  }
};

var onChangeUser =
/*#__PURE__*/
function () {
  var _ref5 = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee5(userinfo) {
    var currentUserId;
    return regeneratorRuntime.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            _context5.next = 2;
            return cacheSystem.current.Setting.get('currentUserId');

          case 2:
            currentUserId = _context5.sent;
            userinfo = userinfo || {};

            if (userinfo.id !== currentUserId) {
              // 需要清理缓存数据，主要是form相关的所有数据
              cacheSystem.current.FormCache && cacheSystem.current.FormCache.clear();
              cacheSystem.current.FormDataCache && cacheSystem.current.FormDataCache.clear();
              cacheSystem.current.FormRightCache && cacheSystem.current.FormRightCache.clear();
              cacheSystem.current.Setting.put('currentUserId', {
                key: 'currentUserId',
                data: userinfo.id
              });
            }

          case 5:
          case "end":
            return _context5.stop();
        }
      }
    }, _callee5);
  }));

  return function onChangeUser(_x10) {
    return _ref5.apply(this, arguments);
  };
}();

cacheSystem.injectCache(_memoryAdapter["default"]);
var _default = cacheSystem;
exports["default"] = _default;