"use strict";

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

var _ = require("../");

var _flux = require("flux");

var _dispatchers = _interopRequireWildcard(require("../../dispatchers"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

(0, _dispatchers.injectDispatcher)(new _flux.Dispatcher()); // init dispatcher

describe('startChangeLock', function () {
  var catchedActionType;
  var dispatcher;
  var changeCount;
  var addCount;
  var minusCount;
  var defaultToken;

  function unregisterDefaultCb() {
    if (dispatcher._callbacks[defaultToken]) {
      dispatcher.unregister(defaultToken);
    }
  }

  beforeEach(function () {
    dispatcher = (0, _dispatchers["default"])(); // 必须叫做dispatcher。

    unregisterDefaultCb();
    changeCount = 0;
    addCount = 0;
    minusCount = 0;
    defaultToken = dispatcher.register(function (payload) {
      switch (payload.actionType) {
        case 'change':
          catchedActionType = 'change';
          changeCount++;
          break;

        case 'add':
          catchedActionType = 'add';
          addCount++;
          break;

        default:
          catchedActionType = undefined;
      }
    });
  });
  afterEach(function () {
    unregisterDefaultCb();
  });
  test('Dispatch can be catched', function () {
    dispatcher.dispatch({
      actionType: 'change'
    });
    expect(catchedActionType).toBe('change');
    dispatcher.dispatch({
      actionType: 'add'
    });
    expect(catchedActionType).toBe('add');
    dispatcher.dispatch({
      actionType: 'minus'
    });
    expect(catchedActionType).toBe(undefined);
  });
  test('\'change\' action can be called multi times', function () {
    dispatcher.dispatch({
      actionType: 'change'
    });
    dispatcher.dispatch({
      actionType: 'change'
    });
    dispatcher.dispatch({
      actionType: 'change'
    });
    expect(changeCount).toBe(3);
  });
  test('startChangeLock will only call \'change\' once at most ',
  /*#__PURE__*/
  _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee() {
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return (0, _.startChangeLock)(function () {
              dispatcher = (0, _dispatchers["default"])(); // must have this sentence, why?

              dispatcher.dispatch({
                actionType: 'change'
              });
              dispatcher.dispatch({
                actionType: 'change'
              });
              dispatcher.dispatch({
                actionType: 'change'
              });
            });

          case 2:
            expect(changeCount).toBe(1);

          case 3:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  })));
  test('Mix \'change\' and other actions work fine',
  /*#__PURE__*/
  _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee2() {
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return (0, _.startChangeLock)(function () {
              dispatcher = (0, _dispatchers["default"])(); // must have this sentence. why?

              dispatcher.dispatch({
                actionType: 'change'
              });
              dispatcher.dispatch({
                actionType: 'add'
              });
              dispatcher.dispatch({
                actionType: 'add'
              });
              expect(addCount).toBe(2);
              dispatcher.dispatch({
                actionType: 'minus'
              });
              expect(minusCount).toBe(0);
            });

          case 2:
            expect(changeCount).toBe(1);

          case 3:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  })));
  test('Nested use startChangeLock',
  /*#__PURE__*/
  _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee3() {
    return regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            dispatcher.unregister(defaultToken);
            dispatcher.register(function (payload) {
              switch (payload.actionType) {
                case 'change':
                  changeCount++; // 2级 startChangeLock

                  (0, _.startChangeLock)(function () {
                    dispatcher = (0, _dispatchers["default"])(); // must have this sentence. why?

                    dispatcher.dispatch({
                      actionType: 'change'
                    });
                    dispatcher.dispatch({
                      actionType: 'change'
                    });
                  });
                  break;

                default:
              }
            }); // 1级 startChangeLock

            _context3.next = 4;
            return (0, _.startChangeLock)(function () {
              dispatcher = (0, _dispatchers["default"])(); // must have this sentence. why?

              dispatcher.dispatch({
                actionType: 'change'
              });
              dispatcher.dispatch({
                actionType: 'change'
              });
              dispatcher.dispatch({
                actionType: 'change'
              });
            });

          case 4:
            expect(changeCount).toBe(1);

          case 5:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  })));
});