"use strict";

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.startChangeLock = startChangeLock;
exports.stopChangeLock = stopChangeLock;
exports["default"] = void 0;

var _flux = require("flux");

var _dispatchers = _interopRequireWildcard(require("../dispatchers"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var previousDispatcher;
var dispatchToken;
var lastPayload;
var tempDispatcher = new _flux.Dispatcher();

function startChangeLock(_x) {
  return _startChangeLock.apply(this, arguments);
}

function _startChangeLock() {
  _startChangeLock = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee(fn) {
    var isDispatching;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            // 仅处理actionType为'change'的消息
            previousDispatcher = (0, _dispatchers["default"])();
            isDispatching = previousDispatcher.isDispatching();

            if (!isDispatching) {
              _context.next = 4;
              break;
            }

            return _context.abrupt("return");

          case 4:
            (0, _dispatchers.injectDispatcher)(tempDispatcher);
            dispatcher = (0, _dispatchers["default"])(); // 如果action type为'change'，堆积起来，如果不是'change'， 原样发出。

            dispatchToken = dispatcher.register(function (payload) {
              switch (payload.actionType) {
                case 'change':
                  lastPayload = payload;
                  break;

                default:
                  previousDispatcher.dispatch(payload);
              }
            });
            _context.prev = 7;
            _context.next = 10;
            return fn();

          case 10:
            _context.prev = 10;
            stopChangeLock();
            return _context.finish(10);

          case 13:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, null, [[7,, 10, 13]]);
  }));
  return _startChangeLock.apply(this, arguments);
}

function stopChangeLock() {
  tempDispatcher.unregister(dispatchToken);
  (0, _dispatchers.injectDispatcher)(previousDispatcher);
  (0, _dispatchers["default"])().dispatch(lastPayload);
}

var _default = {
  startChangeLock: startChangeLock,
  stopChangeLock: stopChangeLock
};
exports["default"] = _default;