"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _control = _interopRequireDefault(require("./control"));

var _YIUIBase = require("../../YIUI-base");

var _YIUICommon = require("../../YIUI-common");

var _YIUISvr = _interopRequireDefault(require("../../YIUI-svr"));

var _YIUIParser = require("../../YIUI-parser");

var _controlUtil = require("./controlUtil");

var _yesCommon = require("yes-common");

var _immutable = _interopRequireDefault(require("immutable"));

var _objectHash = _interopRequireDefault(require("object-hash"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var _synchronized = function _synchronized(fn, scope) {
  var promise = null;
  return function () {
    if (promise) {
      return promise;
    }

    promise = fn.apply(scope, arguments);

    if (promise.then) {
      promise.then(function () {
        promise = null;
      });
    } else {
      var tmp = promise;
      promise = null;
      return Promise.resolve(tmp);
    }

    return promise;
  };
};

var ComboboxEditor = _YIUIBase.YIUI.extend(_control["default"], {
  needRebuild: true,

  /**
   * 下拉框数据
   */
  items: null,

  /**
   * 是否多选
   * @type Boolean
   */
  multiselect: false,
  hasText: false,
  sourceType: _YIUIBase.YIUI.COMBOBOX_SOURCETYPE.ITEMS,
  dependentKey: null,

  /**
   * 是否可编辑
   * @type Boolean
   */
  editable: true,
  // handler: YIUI.ComboBoxHandler,
  init: function init(options) {
    this.base(options);
    var items = this.items || this.getMetaObj().items;
    this.items = items;
    this.getMetaObj().multiSelect = this.type === _YIUIBase.YIUI.CONTROLTYPE.CHECKLISTBOX;
    this.state = this.state.set('items', _immutable["default"].fromJS(items || []));
    this.itemCache = {};
    this.resetItems = _synchronized(this.resetItemsInner, this);
  },
  calculateDisplayValue: function () {
    var _calculateDisplayValue = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee(v, cxt) {
      var _this = this;

      var items, captions;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.prev = 0;
              v = v + '';
              _context.next = 4;
              return this.resetItems(false, cxt);

            case 4:
              items = [v];

              if (this.getMetaObj().multiSelect) {
                items = v.split(',');
              }

              captions = items.map(function (value) {
                var tmp = _this.state.get('items').find(function (item) {
                  return '' + item.get('value') === value;
                });

                return tmp ? tmp.get('caption') : '';
              });
              return _context.abrupt("return", captions.join(', '));

            case 10:
              _context.prev = 10;
              _context.t0 = _context["catch"](0);
              return _context.abrupt("return", '出错');

            case 13:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this, [[0, 10]]);
    }));

    function calculateDisplayValue(_x, _x2) {
      return _calculateDisplayValue.apply(this, arguments);
    }

    return calculateDisplayValue;
  }(),
  setInnerValue: function () {
    var _setInnerValue = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee2(v) {
      return regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _control["default"].prototype.setInnerValue.apply(this, [v]);

              if (!(v !== this.getState().get('value') && v)) {
                _context2.next = 4;
                break;
              }

              _context2.next = 4;
              return this.resetItems();

            case 4:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, this);
    }));

    function setInnerValue(_x3) {
      return _setInnerValue.apply(this, arguments);
    }

    return setInnerValue;
  }(),
  dependedValueChange: function dependedValueChange(srcField, targetField, v) {
    this.needRebuild = true;
  },
  resetItemsInner: function () {
    var _resetItemsInner = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee3() {
      var force,
          cxt,
          items,
          state,
          _args3 = arguments;
      return regeneratorRuntime.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              force = _args3.length > 0 && _args3[0] !== undefined ? _args3[0] : false;
              cxt = _args3.length > 1 ? _args3[1] : undefined;
              console.log('combobox resetItems');
              _context3.next = 5;
              return this.getComboboxItems(force, cxt);

            case 5:
              items = _context3.sent;

              // this.items = this.clearData(items);
              if (this.items !== items) {
                state = this.state.setIn(['items'], _immutable["default"].fromJS(items));
                this.items = items;
                this.changeState(state);
              }

            case 7:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3, this);
    }));

    function resetItemsInner() {
      return _resetItemsInner.apply(this, arguments);
    }

    return resetItemsInner;
  }(),
  clearData: function clearData(data) {
    var keys = [];
    var result = [];
    data.forEach(function (item) {
      if (!keys.includes(item.value)) {
        result.push(item);
        keys.push(item.value);
      }
    });
    return result;
  },
  getFormulaItems: function () {
    var _getFormulaItems = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee4(form, meta, cxt) {
      var items, rs, item_Arr, _i, _len, item_obj, i1, i2, _item, globalItems, pItems, value, caption, i, len, pItem, item;

      return regeneratorRuntime.wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              items = [];

              if (!meta.formula) {
                _context4.next = 41;
                break;
              }

              _context4.next = 4;
              return form.evalFormula(_yesCommon.lodash.trim(meta.formula), cxt, null);

            case 4:
              rs = _context4.sent;

              if (!_yesCommon.lodash.isString(rs)) {
                _context4.next = 10;
                break;
              }

              item_Arr = rs.split(';');

              for (_i = 0, _len = item_Arr.length; _i < _len; _i++) {
                item_obj = item_Arr[_i].split(',');
                i1 = item_obj[0];
                i2 = '';

                if (item_obj.length > 1) {
                  i2 = item_obj[1];
                } else {
                  i2 = i1;
                }

                _item = {
                  value: i1,
                  caption: i2
                };
                items.push(_item);
              }

              _context4.next = 41;
              break;

            case 10:
              if (!(rs instanceof _YIUICommon.DataDef.DataTable)) {
                _context4.next = 40;
                break;
              }

              rs.beforeFirst();

              if (!(rs.cols.length == 1)) {
                _context4.next = 37;
                break;
              }

              // 如果查询的是一列,那么认为是查询了value,caption从全局中匹配
              globalItems = meta.globalItems;
              _context4.next = 16;
              return form.evalFormula(_yesCommon.lodash.trim(globalItems), cxt, null);

            case 16:
              pItems = _context4.sent;

            case 17:
              if (!rs.next()) {
                _context4.next = 35;
                break;
              }

              value = _YIUIBase.YIUI.TypeConvertor.toString(rs.get(0));
              caption = '';

              if (!(pItems && pItems.length > 0)) {
                _context4.next = 30;
                break;
              }

              i = 0, len = pItems.length;

            case 22:
              if (!(i < len)) {
                _context4.next = 30;
                break;
              }

              pItem = pItems[i];

              if (!(pItem.value == value)) {
                _context4.next = 27;
                break;
              }

              caption = pItem.caption;
              return _context4.abrupt("break", 30);

            case 27:
              i++;
              _context4.next = 22;
              break;

            case 30:
              caption = caption == '' ? value : caption;
              item = {
                value: value,
                caption: caption
              };
              items.push(item);
              _context4.next = 17;
              break;

            case 35:
              _context4.next = 38;
              break;

            case 37:
              if (rs.cols.length > 1) {
                while (rs.next()) {
                  value = _YIUIBase.YIUI.TypeConvertor.toString(rs.get(0));
                  caption = _YIUIBase.YIUI.TypeConvertor.toString(rs.get(1));
                  item = {
                    value: value,
                    caption: caption
                  };
                  items.push(item);
                }
              }

            case 38:
              _context4.next = 41;
              break;

            case 40:
              if (_yesCommon.lodash.isArray(rs)) {
                items = items.concat(rs);
              }

            case 41:
              return _context4.abrupt("return", items);

            case 42:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4);
    }));

    function getFormulaItems(_x4, _x5, _x6) {
      return _getFormulaItems.apply(this, arguments);
    }

    return getFormulaItems;
  }(),
  getQueryItems: function () {
    var _getQueryItems = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee5(form, meta, cxt) {
      var queryParas, data, type, sourceType, value, paras, i, len;
      return regeneratorRuntime.wrap(function _callee5$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              queryParas = meta.queryParas || [];
              data = {};
              data.formKey = form.getFormKey();
              data.fieldKey = meta.key;
              data.typeDefKey = meta.typeDefKey;
              data.queryIndex = 0;
              data.service = 'ComboBoxService';
              data.cmd = 'getQueryItems';
              paras = [];
              i = 0, len = queryParas.length;

            case 10:
              if (!(i < len)) {
                _context5.next = 26;
                break;
              }

              sourceType = queryParas[i].sourceType;
              value = queryParas[i].value;
              _context5.t0 = sourceType;
              _context5.next = _context5.t0 === _YIUIBase.YIUI.COMBOBOX_PARAMETERSOURCETYPE.CONST ? 16 : _context5.t0 === _YIUIBase.YIUI.COMBOBOX_PARAMETERSOURCETYPE.FORMULA ? 17 : _context5.t0 === _YIUIBase.YIUI.COMBOBOX_PARAMETERSOURCETYPE.FIELD ? 17 : 21;
              break;

            case 16:
              return _context5.abrupt("break", 21);

            case 17:
              _context5.next = 19;
              return form.evalFormula(value, cxt, null, true);

            case 19:
              value = _context5.sent;
              return _context5.abrupt("break", 21);

            case 21:
              if (value instanceof Date) {
                value = value.getTime();
              }

              paras.push(value);

            case 23:
              i++;
              _context5.next = 10;
              break;

            case 26:
              data.paras = _yesCommon.lodash.toJSON(paras);
              _context5.next = 29;
              return _YIUISvr["default"].Request.getData(data);

            case 29:
              return _context5.abrupt("return", _context5.sent);

            case 30:
            case "end":
              return _context5.stop();
          }
        }
      }, _callee5);
    }));

    function getQueryItems(_x7, _x8, _x9) {
      return _getQueryItems.apply(this, arguments);
    }

    return getQueryItems;
  }(),
  calcDependentKey: function () {
    var _calcDependentKey = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee6(form, meta, cxt) {
      var sourceType, dependency, data, fields, v, field, i;
      return regeneratorRuntime.wrap(function _callee6$(_context6) {
        while (1) {
          switch (_context6.prev = _context6.next) {
            case 0:
              sourceType = meta.sourceType || _YIUIBase.YIUI.COMBOBOX_SOURCETYPE.ITEMS;

              if (!(sourceType == _YIUIBase.YIUI.COMBOBOX_SOURCETYPE.FORMULA || sourceType == _YIUIBase.YIUI.COMBOBOX_SOURCETYPE.QUERY)) {
                _context6.next = 19;
                break;
              }

              dependency = meta.dependency;

              if (!dependency) {
                _context6.next = 19;
                break;
              }

              data = {};
              fields = dependency.split(",");
              i = 0;

            case 7:
              if (!(i < fields.length)) {
                _context6.next = 16;
                break;
              }

              field = fields[i];
              _context6.next = 11;
              return form.eval(field, cxt, null);

            case 11:
              v = _context6.sent;
              data[field] = v;

            case 13:
              i++;
              _context6.next = 7;
              break;

            case 16:
              data.key = meta.key;
              data.formKey = form.getFormKey();
              return _context6.abrupt("return", (0, _objectHash["default"])(data));

            case 19:
              return _context6.abrupt("return", null);

            case 20:
            case "end":
              return _context6.stop();
          }
        }
      }, _callee6);
    }));

    function calcDependentKey(_x10, _x11, _x12) {
      return _calcDependentKey.apply(this, arguments);
    }

    return calcDependentKey;
  }(),
  getComboboxItems: function () {
    var _getComboboxItems = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee7(force, cxt) {
      var meta, form, data, localCxt, currentDependentKey, sourceType;
      return regeneratorRuntime.wrap(function _callee7$(_context7) {
        while (1) {
          switch (_context7.prev = _context7.next) {
            case 0:
              meta = this.getMetaObj();
              form = _YIUIBase.YIUI.FormStack.getForm(this.ofFormID);
              data = null;
              localCxt = cxt;

              if (localCxt == null) {
                localCxt = new _YIUIParser.View.Context(form);
              }

              currentDependentKey = null;
              sourceType = meta.sourceType || this.sourceType || _YIUIBase.YIUI.COMBOBOX_SOURCETYPE.ITEMS;

              if (!(this.items && this.items.length > 0 && !force && sourceType === _YIUIBase.YIUI.COMBOBOX_SOURCETYPE.ITEMS)) {
                _context7.next = 9;
                break;
              }

              return _context7.abrupt("return", this.items);

            case 9:
              if (!(this.items && this.items.length > 0 && (!this.needRebuild || !form.hasRelation(this.key)))) {
                _context7.next = 11;
                break;
              }

              return _context7.abrupt("return", this.items);

            case 11:
              _context7.t0 = sourceType;
              _context7.next = _context7.t0 === _YIUIBase.YIUI.COMBOBOX_SOURCETYPE.ITEMS ? 14 : _context7.t0 === _YIUIBase.YIUI.COMBOBOX_SOURCETYPE.STATUS ? 14 : _context7.t0 === _YIUIBase.YIUI.COMBOBOX_SOURCETYPE.PARAGROUP ? 14 : _context7.t0 === _YIUIBase.YIUI.COMBOBOX_SOURCETYPE.FORMULA ? 16 : _context7.t0 === _YIUIBase.YIUI.COMBOBOX_SOURCETYPE.QUERY ? 28 : 40;
              break;

            case 14:
              this.needRebuild = false;
              return _context7.abrupt("return", meta.items || this.items);

            case 16:
              console.log('combobox formula');
              _context7.next = 19;
              return this.calcDependentKey(form, meta, localCxt);

            case 19:
              currentDependentKey = _context7.sent;

              if (!this.itemCache[currentDependentKey]) {
                _context7.next = 22;
                break;
              }

              return _context7.abrupt("return", this.itemCache[currentDependentKey]);

            case 22:
              _context7.next = 24;
              return this.getFormulaItems(form, meta.formula ? meta : this, localCxt);

            case 24:
              data = _context7.sent;
              this.itemCache[currentDependentKey] = data;
              this.needRebuild = false;
              return _context7.abrupt("return", data);

            case 28:
              console.log('combobox query');
              _context7.next = 31;
              return this.calcDependentKey(form, meta, localCxt);

            case 31:
              currentDependentKey = _context7.sent;

              if (!this.itemCache[currentDependentKey]) {
                _context7.next = 34;
                break;
              }

              return _context7.abrupt("return", this.itemCache[currentDependentKey]);

            case 34:
              _context7.next = 36;
              return this.getQueryItems(form, meta, localCxt);

            case 36:
              data = _context7.sent;
              this.itemCache[currentDependentKey] = data;
              this.needRebuild = false;
              return _context7.abrupt("return", data);

            case 40:
              return _context7.abrupt("return", null);

            case 41:
            case "end":
              return _context7.stop();
          }
        }
      }, _callee7, this);
    }));

    function getComboboxItems(_x13, _x14) {
      return _getComboboxItems.apply(this, arguments);
    }

    return getComboboxItems;
  }()
});

_YIUIBase.YIUI.reg('combobox', ComboboxEditor);

_YIUIBase.YIUI.reg('checklistbox', ComboboxEditor);

(0, _controlUtil.regControlType)(_YIUIBase.YIUI.CONTROLTYPE.COMBOBOX, 'combobox');
(0, _controlUtil.regControlType)(_YIUIBase.YIUI.CONTROLTYPE.CHECKLISTBOX, 'checklistbox');
var _default = ComboboxEditor;
exports["default"] = _default;