"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _YIUIBase = require("../../YIUI-base");

var _YIUICommon = require("../../YIUI-common");

require("../../YIUI-svr");

var _YIUIParser = require("../../YIUI-parser");

var _component = _interopRequireDefault(require("../component"));

var _immutable = _interopRequireDefault(require("immutable"));

var _decimal = _interopRequireDefault(require("decimal.js"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

_YIUIBase.YIUI.Control = _YIUIBase.YIUI.extend(_component["default"], _defineProperty({
  /**
   * Object。
   * 组件存储到数据库的值，区别于text。
   */
  value: '',

  /**
   * String。
   * 组件显示在界面上的文本，区别于value。
   */
  text: '',

  /**
   * String。
   * 组件值的需要满足的条件。
   */
  checkRule: null,

  /**
   * String。
   * 组件值变化时，需要执行的操作。
   */
  trigger: null,

  /**
   * 组件的事件处理对象
   */
  handler: _YIUIBase.YIUI.Handler,
  setValue: function () {
    var _setValue = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee(v) {
      var commit,
          fireEvent,
          value,
          state,
          form,
          _args = arguments;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              commit = _args.length > 1 && _args[1] !== undefined ? _args[1] : true;
              fireEvent = _args.length > 2 ? _args[2] : undefined;
              value = v != null ? v.value != null ? v.value : v : null;
              state = this.getState();
              _context.next = 6;
              return this.setInnerValue(value);

            case 6:
              if (_immutable["default"].is(this.getState(), state)) {
                _context.next = 10;
                break;
              }

              form = _YIUIBase.YIUI.FormStack.getForm(this.ofFormID); // setTimeout(async () =>

              _context.next = 10;
              return form.doValueChanged(this, this.getValue(), commit, fireEvent);

            case 10:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    function setValue(_x) {
      return _setValue.apply(this, arguments);
    }

    return setValue;
  }(),
  convertValue: function convertValue(v) {
    return v;
  },
  setInnerValue: function setInnerValue(v) {
    var state = this.state.set('value', this.convertValue(v));
    this.changeState(state);
  },
  getValue: function getValue() {
    return this.state.get('value');
  },
  isNull: function isNull() {
    var v = this.getValue();
    return !(v === 0 || v === '0') && !this.getValue();
  },
  doOnClick: function () {
    var _doOnClick = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee2() {
      var form, cxt, script;
      return regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              form = _YIUIBase.YIUI.FormStack.getForm(this.ofFormID);
              cxt = new _YIUIParser.View.Context(form);
              script = this.clickContent || this.getMetaObj().onClick;

              if (!script) {
                _context2.next = 6;
                break;
              }

              _context2.next = 6;
              return form.eval(script, cxt, null);

            case 6:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, this);
    }));

    function doOnClick() {
      return _doOnClick.apply(this, arguments);
    }

    return doOnClick;
  }(),
  getMaster: function getMaster(yigoid) {
    return yigoid;
  }
}, "convertValue", function convertValue(value, type) {
  var ret;

  switch (type) {
    case _YIUICommon.DataType.STRING:
      if (value == null || value == undefined) {
        ret = '';
      } else {
        ret = '' + value;
      }

      break;

    case _YIUICommon.DataType.INT:
    case _YIUICommon.DataType.LONG:
    case _YIUICommon.DataType.DOUBLE:
    case _YIUICommon.DataType.FLOAT:
    case _YIUICommon.DataType.NUMERIC:
      if (value == undefined || value == null || value == '') {
        ret = 0;
      } else {
        if (value.toString().toLowerCase() == "true") value = 1;
        if (value.toString().toLowerCase() == "false") value = 0;
        ret = new _decimal["default"](value, 10);
      }

      break;

    case _YIUICommon.DataType.BOOLEAN:
      ret = value ? true : false;
      break;
    // case DataType.DATETIME:
    // case DataType.DATE:
    //     if(value instanceof Date){
    //         ret = value.getTime();
    //     }else{
    //         ret = null;
    //     }
    //     break;

    default:
      ret = value;
  }

  return ret;
}));

_YIUIBase.YIUI.reg('control', _YIUIBase.YIUI.Control);

var _default = _YIUIBase.YIUI.Control;
exports["default"] = _default;