"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _control = _interopRequireDefault(require("./control"));

var _cache = _interopRequireDefault(require("../../cache"));

var _controlUtil = require("./controlUtil");

var _YIUIBase = require("../../YIUI-base");

var _YIUICommon = require("../../YIUI-common");

require("../../YIUI-svr");

require("../../YIUI-parser");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var DictCache = _cache["default"].current.DictCache;

var DictEditor = _YIUIBase.YIUI.extend(_control["default"], {
  value: null,
  handler: _YIUIBase.YIUI.DictHandler,
  needRebuild: true,
  setInnerValue: function setInnerValue(v) {
    var newV = '' + v;

    if (v == null || v == '') {
      newV = null;
    } //切换到字符串，避免一些公式返回的是数字导致change时间被异常触发


    var state = this.state.set('value', newV);
    this.changeState(state);
  },
  // getDictCaption: (dictItem, column)=> {
  //     if(!dictItem){
  //         return '';
  //     }
  //     dictItem.itemTabls[dictItem.mainTableKey];
  // }
  calculateDisplayValue: function () {
    var _calculateDisplayValue = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee2(v) {
      var _this = this;

      var getValue, vArr, textArr, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, item, text;

      return regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              if (v) {
                _context2.next = 2;
                break;
              }

              return _context2.abrupt("return", '');

            case 2:
              getValue =
              /*#__PURE__*/
              function () {
                var _ref = _asyncToGenerator(
                /*#__PURE__*/
                regeneratorRuntime.mark(function _callee(v) {
                  var dictKey, dictItem, text, dataItem;
                  return regeneratorRuntime.wrap(function _callee$(_context) {
                    while (1) {
                      switch (_context.prev = _context.next) {
                        case 0:
                          dictKey = "".concat(_this.itemKey, ".").concat(v);
                          _context.next = 3;
                          return DictCache.get(dictKey);

                        case 3:
                          dictItem = _context.sent;

                          if (dictItem) {
                            _context.next = 6;
                            break;
                          }

                          return _context.abrupt("return", '');

                        case 6:
                          text = dictItem.caption;

                          if (!_this.getMetaObj().textField) {
                            _context.next = 10;
                            break;
                          }

                          dataItem = new _YIUICommon.DataDef.Item(dictItem);
                          return _context.abrupt("return", dataItem.getValue(_this.getMetaObj().textField));

                        case 10:
                          return _context.abrupt("return", text);

                        case 11:
                        case "end":
                          return _context.stop();
                      }
                    }
                  }, _callee);
                }));

                return function getValue(_x2) {
                  return _ref.apply(this, arguments);
                };
              }(); // 可能多选


              if (!(v && v.split)) {
                _context2.next = 36;
                break;
              }

              vArr = v.split(',');

              if (!(vArr.length > 1)) {
                _context2.next = 36;
                break;
              }

              textArr = [];
              _iteratorNormalCompletion = true;
              _didIteratorError = false;
              _iteratorError = undefined;
              _context2.prev = 10;
              _iterator = vArr[Symbol.iterator]();

            case 12:
              if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
                _context2.next = 21;
                break;
              }

              item = _step.value;
              _context2.next = 16;
              return getValue(item);

            case 16:
              text = _context2.sent;
              textArr.push(text);

            case 18:
              _iteratorNormalCompletion = true;
              _context2.next = 12;
              break;

            case 21:
              _context2.next = 27;
              break;

            case 23:
              _context2.prev = 23;
              _context2.t0 = _context2["catch"](10);
              _didIteratorError = true;
              _iteratorError = _context2.t0;

            case 27:
              _context2.prev = 27;
              _context2.prev = 28;

              if (!_iteratorNormalCompletion && _iterator["return"] != null) {
                _iterator["return"]();
              }

            case 30:
              _context2.prev = 30;

              if (!_didIteratorError) {
                _context2.next = 33;
                break;
              }

              throw _iteratorError;

            case 33:
              return _context2.finish(30);

            case 34:
              return _context2.finish(27);

            case 35:
              return _context2.abrupt("return", textArr.join(', '));

            case 36:
              _context2.next = 38;
              return getValue(v);

            case 38:
              return _context2.abrupt("return", _context2.sent);

            case 39:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, null, [[10, 23, 27, 35], [28,, 30, 34]]);
    }));

    function calculateDisplayValue(_x) {
      return _calculateDisplayValue.apply(this, arguments);
    }

    return calculateDisplayValue;
  }(),
  isNull: function isNull() {
    var v = this.getValue();
    return _YIUIBase.YIUI.TypeConvertor.toLong(v) <= 0;
  },
  init: function init(options) {
    this.base(options);
    this.dictFilter = this.dictFilter || this.getMetaObj().dictFilter;
    this.itemKey = this.itemKey || this.getMetaObj().itemKey;
    this.state = this.state.merge({
      dictFilter: this.dictFilter,
      itemKey: this.itemKey
    });
  },
  setDictInfo: function setDictInfo(itemKey, dictFilter) {
    var state = this.state.merge({
      dictFilter: dictFilter,
      itemKey: itemKey
    });
    this.changetState(state);
  }
});

_YIUIBase.YIUI.reg('dict', DictEditor);

_YIUIBase.YIUI.reg('compdict', DictEditor);

_YIUIBase.YIUI.reg('dynamicdict', DictEditor);

(0, _controlUtil.regControlType)(_YIUIBase.YIUI.CONTROLTYPE.DICT, 'dict');
(0, _controlUtil.regControlType)(_YIUIBase.YIUI.CONTROLTYPE.COMPDICT, 'compdict');
(0, _controlUtil.regControlType)(_YIUIBase.YIUI.CONTROLTYPE.DYNAMICDICT, 'dynamicdict');
var _default = DictEditor;
exports["default"] = _default;