"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _control = _interopRequireDefault(require("./control"));

var _YIUIBase = require("../../YIUI-base");

require("../../YIUI-common");

require("../../YIUI-svr");

var _YIUIParser = require("../../YIUI-parser");

var _immutable = _interopRequireDefault(require("immutable"));

var _controlUtil = require("./controlUtil");

var _yesCommon = require("yes-common");

var _gridhandler = _interopRequireDefault(require("./gridhandler"));

var _empty = _interopRequireDefault(require("empty"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

_YIUIBase.YIUI.Grid = _YIUIBase.YIUI.extend(_control["default"], {
  groupHeaders: [],
  //多重表头
  pageInfo: null,
  //分页信息
  errorInfoes: {
    rows: [],
    cells: []
  },
  //带错误标识的单元格
  hasRowClick: false,
  //是否有行点击事件
  hasRowChange: false,
  // 是否有行焦点变化事件
  hasRowDblClick: false,
  //是否有行双击事件
  gridHandler: _gridhandler["default"],
  rowIDMask: 0,
  randID: function randID() {
    return this.rowIDMask++;
  },
  setTotalRowCount: function setTotalRowCount(v) {
    var state = this.state.set('totalRowCount', v);
    this.changeState(state);
  },
  getTotalRowCount: function getTotalRowCount() {
    return this.state.get('totalRowCount');
  },
  init: function init(options) {
    this.base(options);
    this.orgMetaObj = options.metaObj;

    if (!this.dataModel) {
      this.dataModel = {
        data: [],
        colModel: [],
        rowMap: {},
        expandModel: [],
        totalRowCount: 0
      };
      this.buildColModel();
    }

    if (this.dataModel.data.isFirstShow) {
      this.rowIDMap = this.dataModel.data.rowIDMap;
      this.dataModel.data = this.dataModel.data.addRowArray;
      this.initRowDatas();
    }

    this.initLeafColumns();
    this.editors = {};
    this.activeRowIndex = -1;
    this.state = this.state.set('dataModel', _immutable["default"].fromJS(this.dataModel));
  },
  initLeafColumns: function initLeafColumns() {
    var getLeafColumns = function getLeafColumns(_columns) {
      for (var i = 0, column; column = _columns[i]; i++) {
        if (column.columns != null && column.columns.length > 0) {
          getLeafColumns(column.columns, leafColumns);
        } else {
          leafColumns.push(column);
        }
      }
    };

    var leafColumns = [];
    var columns = this.getMetaObj().columns;
    getLeafColumns(columns);
    this.getMetaObj().leafColumns = leafColumns;
  },
  initDataModel: function initDataModel() {
    var columns = [],
        column;
    var leafColumns = this.getMetaObj().leafColumns;

    for (var i = 0, metaColumn; metaColumn = leafColumns[i]; i++) {
      column = {};
      column.key = metaColumn.key;
      column.label = metaColumn.caption;
      column.formulaCaption = metaColumn.formulaCaption;
      column.name = "column" + i;
      column.index = i;
      column.parentKey = metaColumn.parentKey;
      column.width = metaColumn.width;
      column.hidden = false;
      column.sortable = metaColumn.sortable;
      column.visible = metaColumn.visible;
      column.columnType = metaColumn.columnType;
      columns.push(column);
    }

    this.dataModel.colModel.columns = columns;
    this.state = this.state.setIn(['dataModel', 'colModel', 'columns'], _immutable["default"].fromJS(columns));
  },
  buildColModel: function buildColModel() {
    this.dataModel.colModel = {
      cells: {},
      columns: []
    };
    this.buildColumns();
    this.buildCells();
  },
  buildCells: function buildCells() {
    var _this = this;

    var detailRow = this.getDetailRow();
    detailRow.cells.forEach(function (row) {
      _this.dataModel.colModel.cells[row.key] = row;
    });
  },
  buildColumns: function buildColumns() {
    var _this2 = this;

    this.metaObj.columns.forEach(function (column) {
      return _this2.buildColumn(column);
    });
  },
  buildColumn: function buildColumn(col) {
    var _this3 = this;

    if (col.columns) {
      col.columns.forEach(function (column) {
        return _this3.buildColumn(column);
      });
    }

    this.dataModel.colModel.columns.push(col);
  },
  initRowDatas: function initRowDatas() {
    var len = this.dataModel.data.length,
        row;

    for (var i = 0; i < len; i++) {
      row = this.dataModel.data[i];
      this.initOneRow(row);
    }
  },
  loadMoreData: function () {
    var _loadMoreData = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee() {
      var controlKey, tableKey, form, tblFilter, startRow, doc, dd, table, formDoc, i;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              controlKey = this.key, tableKey = this.tableKey;
              form = _YIUIBase.YIUI.FormStack.getForm(this.ofFormID);
              tblFilter = form.getFilterMap().getTblFilter(tableKey);
              startRow = tblFilter.startRow + tblFilter.maxRows;
              form.getFilterMap().setStartRow(tableKey, startRow);
              _context.next = 7;
              return _YIUIBase.YIUI.DocService.loadFormData(form, form.getFilterMap().OID, form.getFilterMap(), form.getCondParas());

            case 7:
              doc = _context.sent;
              dd = _YIUIBase.YIUI.DataUtil.fromJSONDoc(doc);
              table = dd.getByKey(tableKey);
              formDoc = form.getDocument();
              formDoc.getByKey(tableKey).concat(table); // this.addDataRow(rowList);
              // addGridRow: async function (rowData, rowIndex, isNewGroup, defaultValue) {

              for (i = 0; i < table.size(); i++) {
                this.loadDetailRow(startRow + i);
              }

            case 13:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    function loadMoreData() {
      return _loadMoreData.apply(this, arguments);
    }

    return loadMoreData;
  }(),
  initOneRow: function initOneRow(row) {
    if (row.rowID == undefined) {
      row.rowID = this.randID();
    }

    if (row.rowType == undefined) {
      row.rowType = "Detail";

      if (row.metaRowIndex == undefined || row.metaRowIndex == -1) {
        row.metaRowIndex = this.metaRowInfo.dtlRowIndex;
      }
    }

    row.isDetail = row.rowType == "Detail";
    row.isEditable = row.rowType == "Fix" || row.rowType == "Detail";
    row.cellKeys = this.metaRowInfo.rows[row.metaRowIndex].cellKeys;
    row.rowHeight = this.metaRowInfo.rows[row.metaRowIndex].rowHeight;

    if (this.hasColExpand && row.isDetail && row.cellBkmks == undefined) {
      row.cellBkmks = [];
    }
  },
  setRowBookmark: function setRowBookmark(rowIndex, bkmk) {
    console.log('setRowBookmark');
    this.state = this.state.setIn(['dataModel', 'data', rowIndex, 'bookmark'], bkmk);
  },
  getFocusRowIndex: function getFocusRowIndex() {
    return this.activeRowIndex;
  },
  setFocusRowIndex: function setFocusRowIndex(rowIndex) {
    this.activeRowIndex = rowIndex;
  },
  setGridEnable: function setGridEnable(enable) {
    this.setEnable(enable); // 在设置为Enable=true的时候不再主动新增行
    // if (enable && this.treeType === -1 && !this.hasRowExpand && this.metaRowInfo.dtlRowIndex != -1) {
    //     if (!this.isSubDetail && this.newEmptyRow) {
    //         if (this.hasGroupRow) {
    //             //this.appendAutoRowAndGroup();
    //             console('group not supported!');
    //         } else {
    //             this.addGridRow();
    //         }
    //     }
    // }
  },
  clearGridData: function clearGridData() {
    this.state = this.state.setIn(['dataModel', 'data'], _immutable["default"].fromJS([]));
  },
  findRowIndex: function findRowIndex(fn) {
    var data = this.state.getIn(['dataModel', 'data']);
    return data.findIndex(fn);
  },
  getCellNeedValue: function () {
    var _getCellNeedValue = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee2(rowIndex, colIndex, value, isData, rowData) {
      return regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              return _context2.abrupt("return", [value, null]);

            case 1:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    }));

    function getCellNeedValue(_x, _x2, _x3, _x4, _x5) {
      return _getCellNeedValue.apply(this, arguments);
    }

    return getCellNeedValue;
  }(),
  insertRow: function insertRow(rowIndex, rowData) {
    this.state = this.state.updateIn(['dataModel', 'data'], function (data) {
      return data.insert(rowIndex, _immutable["default"].fromJS(rowData));
    });
  },
  appendRow: function appendRow(rowData) {
    this.state = this.state.updateIn(['dataModel', 'data'], function (data) {
      return data.push(_immutable["default"].fromJS(rowData));
    });
  },
  getRowCount: function getRowCount() {
    return this.state.getIn(['dataModel', 'data']).size;
  },
  getCellKey: function getCellKey(row, col) {
    if (col != null) {
      return this.state.getIn(['dataModel', 'data', row, 'cellKeys', col]);
    }

    var dtlRow = this.getDetailRow();
    return dtlRow.cellKeys[row];
  },
  getCellEditor: function getCellEditor(cellKey) {
    return this.state.getIn(['dataModel', 'colModel', 'cells', cellKey]);
  },
  getColumnCount: function getColumnCount() {
    return this.state.getIn(['dataModel', 'colModel', 'cells']).size;
  },
  isRowDataLoaded: function isRowDataLoaded(rowIndex) {
    if (rowIndex > this.getRowCount()) {
      return;
    }

    return !this.state.getIn(['dataModel', 'data', rowIndex, 'unloaded']);
  },

  /**
   * 新增表格行
   * @param rowData 行数据对象
   * @param rowIndex 行数据对象在表格数据对象中的序号
   * @param isNewGroup 是否为新分组中的明细
   */
  addGridRow: function () {
    var _addGridRow = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee3(rowData, rowIndex, isNewGroup, defaultValue) {
      var data, dataLength, form, isNewData, dtrRowIndex, dtlMetaRow, rd, lastDetailRow, ri, dtrRow, _dtrRow, i, len, value, cm, cellKey, editOpt, defaultFV, defaultV, newState, newRowIndex;

      return regeneratorRuntime.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              data = this.dataModel.data, dataLength = this.getRowCount(), form = _YIUIBase.YIUI.FormStack.getForm(this.ofFormID), isNewData = false, dtrRowIndex = this.getMetaObj().detailMetaRowIndex, dtlMetaRow = this.getDetailRow();

              if (!rowData) {
                rowData = {};
                rowData.isDetail = true;
                rowData.isEditable = true;
                rowData.rowHeight = dtlMetaRow.rowHeight;
                rowData.rowID = this.randID();
                rowData.metaRowIndex = dtrRowIndex;
                rowData.rowType = "Detail";
                rowData.cellKeys = dtlMetaRow.cellKeys;
                rowData.data = [];
                rowData.cellBkmks = [];
                rowData.rowGroupLevel = dtlMetaRow.rowGroupLevel;
                isNewData = true;
              }

              rowIndex = parseInt(rowIndex, 10);

              if (isNaN(rowIndex) || rowIndex < 0 || rowIndex >= dataLength && !isNewGroup) {
                rowIndex = -1;
              }

              if (!(rowIndex == -1)) {
                _context3.next = 15;
                break;
              }

              ri = dataLength - 1;

            case 6:
              if (!(ri >= 0)) {
                _context3.next = 14;
                break;
              }

              rd = this.getRowDataAt(ri);

              if (!rd.isDetail) {
                _context3.next = 11;
                break;
              }

              lastDetailRow = ri;
              return _context3.abrupt("break", 14);

            case 11:
              ri--;
              _context3.next = 6;
              break;

            case 14:
              if (dataLength == 0) {
                rowData.insertRowID = -1;
                rowIndex = 0;
              } else {
                if (lastDetailRow == undefined) {
                  dtrRow = this.getRowDataAt(dtrRowIndex - 1);
                  rowData.insertRowID = !dtrRow ? -1 : dtrRow.rowID;
                  rowIndex = dtrRowIndex;
                } else {
                  _dtrRow = this.getRowDataAt(lastDetailRow);
                  rowData.insertRowID = _dtrRow.rowID;
                  rowIndex = lastDetailRow + 1;
                }
              }

            case 15:
              if (!isNewData) {
                _context3.next = 34;
                break;
              }

              i = 0, len = this.getColumnCount();

            case 17:
              if (!(i < len)) {
                _context3.next = 34;
                break;
              }

              value = null;
              cm = this.getColumnConfig(i), cellKey = this.getCellKey(i), editOpt = this.getCellEditor(cellKey), defaultFV = dtlMetaRow.cells[i].defaultFormulaValue, defaultV = dtlMetaRow.cells[i].defaultValue;

              if (!(cm.get('name') == "rowID")) {
                _context3.next = 22;
                break;
              }

              return _context3.abrupt("continue", 31);

            case 22:
              if (editOpt !== undefined && editOpt.tableKey == undefined && editOpt.columnKey == undefined && (editOpt.get('edittype') == "label" || editOpt.get('edittype') == "button" || editOpt.get('edittype') == "hyperLink")) {
                value = dtlMetaRow.cells[i].caption;
              }

              value = defaultValue ? defaultValue[cellKey] : null;

              if (value) {
                _context3.next = 30;
                break;
              }

              if (!(defaultFV !== undefined && defaultFV !== null && defaultFV.length > 0)) {
                _context3.next = 29;
                break;
              }

              _context3.next = 28;
              return form.eval(defaultFV, {
                form: form,
                rowIndex: rowIndex
              }, null);

            case 28:
              value = _context3.sent;

            case 29:
              if (defaultV !== undefined && defaultV !== null && defaultV.length > 0) {
                value = defaultV;
              }

            case 30:
              //value = await this.getCellNeedValue(rowIndex, i, value, true, rowData);
              //value.push(true);
              rowData.data[i] = [value, '', true];

            case 31:
              i++;
              _context3.next = 17;
              break;

            case 34:
              newState = null;
              newRowIndex = rowIndex;
              rowData.rowIndex = rowIndex;

              if (rowIndex == -1) {
                newRowIndex = this.getRowCount();
                rowData.rowIndex = newRowIndex;
                newState = this.state.updateIn(['dataModel', 'data'], function (data) {
                  return data.push(_immutable["default"].fromJS(rowData));
                });
              } else {
                newState = this.state.updateIn(['dataModel', 'data'], function (data) {
                  return data.insert(rowIndex, _immutable["default"].fromJS(rowData));
                });
              } // this.refreshErrors(rowIndex, false);


              this.changeState(newState);
              _context3.next = 41;
              return form.getUIProcess().doPostInsertRow(this, rowIndex, true);

            case 41:
              return _context3.abrupt("return", rowData);

            case 42:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3, this);
    }));

    function addGridRow(_x6, _x7, _x8, _x9) {
      return _addGridRow.apply(this, arguments);
    }

    return addGridRow;
  }(),
  deleteGridRow: function () {
    var _deleteGridRow = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee4(rowIndex) {
      var bkmk, form, dataTable, newState, metaObj, cxt;
      return regeneratorRuntime.wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              bkmk = this.getRowBkmk(rowIndex);
              form = _YIUIBase.YIUI.FormStack.getForm(this.ofFormID);
              dataTable = form.getDocument().getByKey(this.tableKey);
              newState = this.state.removeIn(['dataModel', 'data', rowIndex]);
              this.changeState(newState);

              if (dataTable) {
                dataTable.setByBkmk(bkmk);
                dataTable.delRow();
              }

              _context4.next = 8;
              return form.getUIProcess().doPostDeleteRow(this);

            case 8:
              metaObj = this.getMetaObj();

              if (!metaObj.rowDelete) {
                _context4.next = 13;
                break;
              }

              cxt = new _YIUIParser.View.Context(form);
              _context4.next = 13;
              return form.eval(metaObj.rowDelete, cxt, null);

            case 13:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4, this);
    }));

    function deleteGridRow(_x10) {
      return _deleteGridRow.apply(this, arguments);
    }

    return deleteGridRow;
  }(),
  refreshErrors: function refreshErrors(rowIndex, isDelete) {
    var grid = this,
        eCell,
        eRow;

    for (var i = grid.errorInfoes.cells.length - 1; i >= 0; i--) {
      eCell = grid.errorInfoes.cells[i];

      if (eCell.rowIndex >= rowIndex) {
        if (isDelete && eCell.rowIndex == rowIndex) {
          grid.errorInfoes.cells.splice(i, 1);
        } else {
          eCell.rowIndex = isDelete ? eCell.rowIndex - 1 : eCell.rowIndex + 1;
        }
      }
    }

    for (var j = grid.errorInfoes.rows.length - 1; j >= 0; j--) {
      eRow = grid.errorInfoes.rows[j];

      if (eRow.rowIndex >= rowIndex) {
        if (isDelete && eRow.rowIndex == rowIndex) {
          grid.errorInfoes.rows.splice(j, 1);
        } else {
          eRow.rowIndex = isDelete ? eRow.rowIndex - 1 : eRow.rowIndex + 1;
        }
      }
    }
  },
  setGridErrorCells: function setGridErrorCells(cells) {//this.el.setErrorCells(cells);
  },
  setGridErrorRows: function setGridErrorRows(rows) {//this.el.setErrorRows(rows);
  },

  /**
   * 并不支持fixrow
   */
  getFixRowInfoByCellKey: function getFixRowInfoByCellKey(key) {
    // var getFixInfoes = function (grid, rowData, cellKey) {
    //     var cKey , cEditOpt, isMatch = false, cellInfoes = [], column;
    //     for (var j = 0, clen = grid.dataModel.colModel.columns.length; j < clen; j++) {
    //         cKey = rowData.cellKeys[j];
    //         if (cKey == cellKey) {
    //             column = grid.dataModel.colModel.columns[j];
    //             cEditOpt = grid.dataModel.colModel.cells[cellKey];
    //             if (grid.hasColExpand) {
    //                 cellInfoes.push({rowIndex: i, colIndex: j, col: column, cell: cEditOpt});
    //                 isMatch = true;
    //             } else {
    //                 return [
    //                     {rowIndex: i, colIndex: j, col: column, cell: cEditOpt}
    //                 ];
    //             }
    //         } else if (grid.hasColExpand && isMatch) {
    //             return cellInfoes;
    //         }
    //     }
    //     return null;
    // };
    // var rowData, result;
    // for (var i = 0, rlen = this.dataModel.data.length; i < rlen; i++) {
    //     rowData = this.dataModel.data[i];
    //     if (rowData.rowType == "Fix" || rowData.rowType == "Total") {
    //         result = getFixInfoes(this, rowData, key);
    //         if (result !== null) {
    //             return result;
    //         }
    //     } else if (rowData.rowType == "Detail" || rowData.rowType == "Group") {
    //         break;
    //     }
    // }
    // for (var m = this.dataModel.data.length - 1; m >= 0; m--) {
    //     rowData = this.dataModel.data[m];
    //     if (rowData.rowType == "Fix" || rowData.rowType == "Total") {
    //         result = getFixInfoes(this, rowData, key);
    //         if (result !== null) {
    //             return result;
    //         }
    //     } else if (rowData.rowType == "Detail" || rowData.rowType == "Group") {
    //         break;
    //     }
    // }
    return null;
  },
  getCellIndexByKey: function getCellIndexByKey(colKey) {
    var detailRow = this.getDetailRow();

    if (detailRow) {
      return detailRow.cellKeys.indexOf(colKey);
    }

    return -1; // return this.getColumnIndex(colKey);
  },
  reShowCheckColumn: _empty["default"].func,
  getColInfoByKey: function getColInfoByKey(key) {
    var cell = this.getColumnCellConfig(key);
    if (cell == null || cell == undefined) return null;

    if (this.hasColExpand) {
      console.log('colexpand not supported!');
    } else {
      // var c = cell.toJS();
      // var ci = c.colIndex;
      var ci = this.getCellIndexByKey(key);
      var column = this.getColumnConfigByKey(key);
      return [{
        col: column ? column.toJS() : null,
        cell: cell,
        colIndex: ci
      }];
    }
  },
  initEmptyData: function initEmptyData(rowCount) {
    this.rowCount = rowCount;
    var emtpyData = Array(rowCount).fill({
      unloaded: true
    });
    this.state = this.state.setIn(['dataModel', 'data'], _immutable["default"].fromJS(emtpyData));
  },
  getColumnConfig: function getColumnConfig(index) {
    var cellKey = this.getCellKey(index);
    return this.getColumnConfigByKey(cellKey); // return this.state.getIn(['dataModel', 'colModel', 'columns', index]);
  },
  getColumnConfigByKey: function getColumnConfigByKey(key) {
    var columns = this.state.getIn(['dataModel', 'colModel', 'columns']);
    return columns.find(function (item) {
      return item.get('key') === key;
    });
  },
  getColumnCellConfig: function getColumnCellConfig(key) {
    return this.state.getIn(['dataModel', 'colModel', 'cells', key]);
  },
  colInfoMap: {},

  /**
   * 根据rowID获得表格行数据的序号
   * @param rowID   表格行数据的标识
   * @returns {number} 表格数据行序号
   */
  getRowIndexByID: function getRowIndexByID(rowID) {
    var result = this.state.getIn(['dataModel', 'data']).findEntry(function (item) {
      return item.get('rowID') == rowID;
    });
    if (result) return result[0];
    return -1;
  },
  getRowDataByID: function getRowDataByID(rowID) {
    // for (var i = 0, len = this.dataModel.data.length; i < len; i++) {
    //     var row = this.dataModel.data[i];
    //     if (row.rowID === rowID) return  row;
    // }
    // return null;
    var result = this.state.getIn(['dataModel', 'data']).find(function (item) {
      return item.get('rowID') == rowID;
    });
    if (result) return result.toJS();
    return null;
  },
  getRowType: function getRowType(rowIndex) {
    return this.state.getIn(['dataModel', 'data', rowIndex, 'rowType']);
  },
  isEmptyRow: function isEmptyRow(rowIndex) {
    var rowData = this.state.getIn(['dataModel', 'data', rowIndex]);

    if (rowData) {
      return rowData.get('rowType') === 'Detail' ? rowData.get('bookmark') == null && rowData.get('bkmkRow') == null : false;
    }

    return false;
  },
  getRowBookmark: function getRowBookmark(rowIndex) {
    var result = this.state.getIn(['dataModel', 'data', rowIndex, 'bookmark']); // if (result) {
    //     return result.toJS();
    // }

    return result;
  },
  isRowDetail: function isRowDetail(rowIndex) {
    return this.state.getIn(['dataModel', 'data', rowIndex, 'isDetail']);
  },
  getRowDataAt: function getRowDataAt(rowIndex) {
    var result = this.state.getIn(['dataModel', 'data', rowIndex]);
    if (result) return result.toJS();
    return null;
  },
  setColumnEnable: function setColumnEnable(colIndex, enable) {
    this.state = this.state.setIn(['dataModel', 'colModel', 'columns', colIndex, 'editable'], enable);
  },
  isCellEnable: function isCellEnable(rowIndex, cellKey) {
    var defaultV = this.state.get('enable');
    var colindex = cellKey;

    if (typeof cellKey === 'string') {
      var colInfoes = this.colInfoMap[cellKey];

      if (colInfoes == undefined) {
        colInfoes = this.getColInfoByKey(cellKey);

        if (colInfoes !== null) {
          this.colInfoMap[cellKey] = colInfoes;
        }
      }

      if (colInfoes == null || colInfoes.length <= 0) return;
      colindex = colInfoes[0].colIndex;
    }

    var result = this.state.getIn(['dataModel', 'data', rowIndex, 'data', colindex, 2]);
    result = result == null ? defaultV : result;
    return result;
  },
  setCellEnable: function setCellEnable(rowIndex, cellKey, enable) {
    var // rd = this.dataModel.data[rowIndex], gridRow,
    colInfoes = this.colInfoMap[cellKey];
    var colindex = cellKey;

    if (typeof cellKey === 'string') {
      if (colInfoes == undefined) {
        colInfoes = this.getColInfoByKey(cellKey);

        if (colInfoes !== null) {
          this.colInfoMap[cellKey] = colInfoes;
        }
      }

      if (colInfoes == null) return;

      for (var i = 0, len = colInfoes.length; i < len; i++) {
        var colIndex = colInfoes[i].colIndex;
        this.state = this.state.setIn(['dataModel', 'data', rowIndex, 'data', colIndex, 2], enable); //rd.data[colIndex][2] = enable;
      }
    } else {
      var state = this.state.setIn(['dataModel', 'data', rowIndex, 'data', colindex, 2], enable);
      this.changeState(state);
    }
  },

  /**
   * 不支持这个函数
   * @param {[type]} colKey  [description]
   * @param {[type]} visible [description]
   */
  setColumnVisible: function setColumnVisible(colIndex, visible) {
    var cellKey = this.getCellKey(colIndex);
    var columnIndex = this.getColumnIndex(cellKey);
    this.state = this.state.setIn(['dataModel', 'colModel', 'columns', columnIndex, 'hidden'], !visible); // 
    // console.log('setColumnVisible');
    // var ci, clen, colM, gridCM, gridCi, hidden, isChange = false, isMatch = false, columnKey;
    // visible = YIUI.TypeConvertor.toBoolean(visible);
    // for (ci = 0, clen = this.dataModel.colModel.columns.length; ci < clen; ci++) {
    //     colM = this.dataModel.colModel.columns[ci];
    //     columnKey = colM.key;
    //     if (colM.isExpandCol && colM.refColumn) {
    //         columnKey = colM.refColumn;
    //     }
    //     if (columnKey === colKey) {
    //         hidden = (visible == null ? false : !visible);
    //         isChange = (colM.hidden !== hidden);
    //         colM.hidden = hidden;
    //         isMatch = true;
    //         if (!this.hasColExpand) {
    //             break;
    //         }
    //     } else if (this.hasColExpand && isMatch) {
    //         break;
    //     }
    // }
    // if (isChange) {
    // }
  },
  getVisibleColumns: function getVisibleColumns() {
    var result = [];

    for (var col = 0; col < this.getColumnCount(); col++) {
      var colCfg = this.getColumnConfig(col);

      if (!colCfg.get('hidden')) {
        var cellCfg = this.getColumnCellConfig(colCfg.get('key'));

        if (cellCfg) {
          result.push({
            key: colCfg.get('key'),
            caption: colCfg.get('caption') || colCfg.get('label'),
            type: cellCfg.getIn(['editOptions', 'cellType']),
            isSelect: cellCfg.getIn(['isSelect'])
          });
        }
      }
    }

    return result;
  },
  setValueByKey: function () {
    var _setValueByKey = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee5(rowIndex, colKey, newValue, commitValue, fireEvent) {
      var colInfoes, i, len;
      return regeneratorRuntime.wrap(function _callee5$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              colInfoes = this.getColInfoByKey(colKey);
              i = 0, len = colInfoes.length;

            case 2:
              if (!(i < len)) {
                _context5.next = 8;
                break;
              }

              _context5.next = 5;
              return this.setValueAt(rowIndex, colInfoes[i].colIndex, newValue, commitValue, fireEvent, true);

            case 5:
              i++;
              _context5.next = 2;
              break;

            case 8:
            case "end":
              return _context5.stop();
          }
        }
      }, _callee5, this);
    }));

    function setValueByKey(_x11, _x12, _x13, _x14, _x15) {
      return _setValueByKey.apply(this, arguments);
    }

    return setValueByKey;
  }(),
  setValueAt: function () {
    var _setValueAt = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee6(rowIndex, colIndex, newValue, commitValue, fireEvent) {
      var render,
          state,
          cellKey,
          form,
          _args6 = arguments;
      return regeneratorRuntime.wrap(function _callee6$(_context6) {
        while (1) {
          switch (_context6.prev = _context6.next) {
            case 0:
              render = _args6.length > 5 && _args6[5] !== undefined ? _args6[5] : true;

              if (!(rowIndex == undefined || rowIndex < 0 || rowIndex > this.getRowCount())) {
                _context6.next = 3;
                break;
              }

              return _context6.abrupt("return");

            case 3:
              //var dt = await this.getCellNeedValue(rowIndex, colIndex, newValue, isData);
              state = this.state.setIn(['dataModel', 'data', rowIndex, 'data', colIndex, 0], newValue); //this.state = this.state.setIn(['dataModel', 'data', rowIndex, 'data', colIndex, 1], dt[1]);

              this.changeState(state, render);
              cellKey = this.getCellKey(rowIndex, colIndex);

              if (!commitValue) {
                _context6.next = 16;
                break;
              }

              form = _YIUIBase.YIUI.FormStack.getForm(this.ofFormID);
              this.gridHandler.setCellValueToDocument(form, this, rowIndex, colIndex, newValue);
              _context6.next = 11;
              return form.getViewDataMonitor().preFireCellValueChanged(this, rowIndex, colIndex, cellKey);

            case 11:
              if (!fireEvent) {
                _context6.next = 14;
                break;
              }

              _context6.next = 14;
              return this.gridHandler.fireCellChangeEvent(form, this, rowIndex, colIndex);

            case 14:
              _context6.next = 16;
              return this.gridHandler.doPostCellChangeEvent(form, this, rowIndex, colIndex);

            case 16:
            case "end":
              return _context6.stop();
          }
        }
      }, _callee6, this);
    }));

    function setValueAt(_x16, _x17, _x18, _x19, _x20) {
      return _setValueAt.apply(this, arguments);
    }

    return setValueAt;
  }(),
  getColumnIndex: function getColumnIndex(key) {
    var columns = this.state.getIn(['dataModel', 'colModel', 'columns']);
    return columns.findIndex(function (item) {
      return item.get('key') === key;
    }); // const detailRow = this.getDetailRow();
    // if (detailRow) {
    //     return detailRow.cellKeys.indexOf(key);
    // }
    // return -1;
    // return this.getCellIndexByKey(key);
  },
  getValueByKey: function getValueByKey(rowIndex, colKey) {
    // var colIndex = this.getColInfoByKey(colKey)[0].colIndex;
    var colIndex = this.getCellIndexByKey(colKey);
    return this.getValueAt(rowIndex, colIndex);
  },
  setCellError: function setCellError() {},
  getValueAt: function getValueAt(rowIndex, colIndex) {
    return this.state.getIn(['dataModel', 'data', rowIndex, 'data', colIndex, 0]);
  },
  getDisplayValueByKey: function getDisplayValueByKey(rowIndex, colKey) {
    var colIndex = this.getColInfoByKey(colKey)[0].colIndex;
    return this.getDisplayValueAt(rowIndex, colIndex);
  },
  getDisplayValueAt: function getDisplayValueAt(rowIndex, colIndex) {
    return this.state.getIn(['dataModel', 'data', rowIndex, 'data', colIndex, 1]);
  },
  showSubDetailData: function showSubDetailData() {},
  showDetailRow: function showDetailRow(rowIndex, calcRow) {
    var form = _YIUIBase.YIUI.FormStack.getForm(this.ofFormID),
        table = form.getDocument().getByKey(this.tableKey || this.metaObj.tableKey),
        metaRow = this.getDetailRow(),
        rd = this.getRowDataAt(rowIndex);

    if (table == undefined || rd == undefined || rd == null || !rd.isDetail || rd.bookmark == undefined) return;
    var bookmark = rd.bookmark,
        editOpt,
        metaCell,
        cBookmark;

    for (var i = 0, len = this.getColumnCount(); i < len; i++) {
      metaCell = metaRow.cells[i]; // editOpt = this.dataModel.colModel.cells[rd.cellKeys[i]];

      editOpt = this.getCellEditor(rd.cellKeys[i]).toJS();

      if (editOpt.hasDB) {
        if (metaCell.isColExpand) {
          cBookmark = rd.cellBkmks[i];

          if (cBookmark) {
            table.setByBkmk(cBookmark);
            this.setValueAt(rowIndex, i, table.getByKey(editOpt.columnKey), false, false, true);
          }
        } else {
          table.setByBkmk(bookmark);
          this.setValueAt(rowIndex, i, table.getByKey(editOpt.columnKey), false, false, true);
        }
      } else if (editOpt.edittype == "label" || editOpt.edittype == "button" || editOpt.edittype == "hyperLink") {
        this.setValueAt(rowIndex, i, metaCell.caption, false, false, false);
      } else if (metaCell.isSelect) {
        table.setByBkmk(bookmark);
        this.setValueAt(rowIndex, i, table.getByKey(_YIUIBase.YIUI.SystemField.SELECT_FIELD_KEY), false, false, false);
      }
    }

    if (calcRow) {
      form.getUIProcess().calcEmptyRow(this, rowIndex);
    }
  },
  toggleSelect: function () {
    var _toggleSelect = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee7(rowIndex) {
      var form, columnKey, editor, field, datatable, row, bkmk;
      return regeneratorRuntime.wrap(function _callee7$(_context7) {
        while (1) {
          switch (_context7.prev = _context7.next) {
            case 0:
              if (!(this.selectFieldIndex < 0 || !this.tableKey)) {
                _context7.next = 2;
                break;
              }

              return _context7.abrupt("return");

            case 2:
              form = _YIUIBase.YIUI.FormStack.getForm(this.ofFormID);

              if (form) {
                _context7.next = 5;
                break;
              }

              return _context7.abrupt("return");

            case 5:
              if (this.isCellEnable(rowIndex, this.selectFieldIndex)) {
                _context7.next = 7;
                break;
              }

              return _context7.abrupt("return");

            case 7:
              columnKey = this.getCellKey(rowIndex, this.selectFieldIndex);
              editor = this.getColumnEditor(columnKey);
              field = editor.columnKey || _YIUIBase.YIUI.SystemField.SELECT_FIELD_KEY;
              datatable = form.getDocument().getByKey(this.tableKey);
              row = this.getRowDataAt(rowIndex);
              bkmk = row.bkmkRow;
              datatable.setByBkmk(bkmk.getBookmark());
              datatable.setByKey(field, !this.getValueAt(rowIndex, this.selectFieldIndex));
              _context7.next = 17;
              return this.setValueAt(rowIndex, this.selectFieldIndex, !this.getValueAt(rowIndex, this.selectFieldIndex), false, false);

            case 17:
            case "end":
              return _context7.stop();
          }
        }
      }, _callee7, this);
    }));

    function toggleSelect(_x21) {
      return _toggleSelect.apply(this, arguments);
    }

    return toggleSelect;
  }(),
  selectAll: function () {
    var _selectAll = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee8() {
      var form, rowIndex, datatable, row, bkmk;
      return regeneratorRuntime.wrap(function _callee8$(_context8) {
        while (1) {
          switch (_context8.prev = _context8.next) {
            case 0:
              if (!(this.selectFieldIndex < 0 || !this.tableKey)) {
                _context8.next = 2;
                break;
              }

              return _context8.abrupt("return");

            case 2:
              form = _YIUIBase.YIUI.FormStack.getForm(this.ofFormID);

              if (form) {
                _context8.next = 5;
                break;
              }

              return _context8.abrupt("return");

            case 5:
              rowIndex = 0;

            case 6:
              if (!(rowIndex < this.getRowCount())) {
                _context8.next = 17;
                break;
              }

              datatable = form.getDocument().getByKey(this.tableKey);
              row = this.getRowDataAt(rowIndex);
              bkmk = row.bkmkRow || row.bkmk;
              datatable.setByBkmk(bkmk.getBookmark ? bkmk.getBookmark() : bkmk);
              datatable.setByKey(_YIUIBase.YIUI.SystemField.SELECT_FIELD_KEY, true);
              _context8.next = 14;
              return this.setValueAt(rowIndex, this.selectFieldIndex, true, false, false);

            case 14:
              rowIndex++;
              _context8.next = 6;
              break;

            case 17:
              this.dispatchChange();

            case 18:
            case "end":
              return _context8.stop();
          }
        }
      }, _callee8, this);
    }));

    function selectAll() {
      return _selectAll.apply(this, arguments);
    }

    return selectAll;
  }(),
  unselectAll: function () {
    var _unselectAll = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee9() {
      var form, rowIndex, datatable, row, bkmk;
      return regeneratorRuntime.wrap(function _callee9$(_context9) {
        while (1) {
          switch (_context9.prev = _context9.next) {
            case 0:
              if (!(this.selectFieldIndex < 0 || !this.tableKey)) {
                _context9.next = 2;
                break;
              }

              return _context9.abrupt("return");

            case 2:
              form = _YIUIBase.YIUI.FormStack.getForm(this.ofFormID);

              if (form) {
                _context9.next = 5;
                break;
              }

              return _context9.abrupt("return");

            case 5:
              rowIndex = 0;

            case 6:
              if (!(rowIndex < this.getRowCount())) {
                _context9.next = 17;
                break;
              }

              datatable = form.getDocument().getByKey(this.tableKey);
              row = this.getRowDataAt(rowIndex);
              bkmk = row.bkmkRow || row.bkmk;
              datatable.setByBkmk(bkmk.getBookmark ? bkmk.getBookmark() : bkmk);
              datatable.setByKey(_YIUIBase.YIUI.SystemField.SELECT_FIELD_KEY, false);
              _context9.next = 14;
              return this.setValueAt(rowIndex, this.selectFieldIndex, false, false, false);

            case 14:
              rowIndex++;
              _context9.next = 6;
              break;

            case 17:
              this.dispatchChange();

            case 18:
            case "end":
              return _context9.stop();
          }
        }
      }, _callee9, this);
    }));

    function unselectAll() {
      return _unselectAll.apply(this, arguments);
    }

    return unselectAll;
  }(),
  loadData: function loadData() {
    var form = _YIUIBase.YIUI.FormStack.getForm(this.ofFormID);

    var table = form.getDocument().getByKey(this.tableKey || this.metaObj.tableKey);

    for (var i = 0; i < table.size(); i++) {
      this.loadDetailRow(i);
    }
  },
  loadDetailRow: function loadDetailRow(rowIndex) {
    //加载指定行的数据
    //如果已经存在行数据，则重新从Document中读取数据到控件中
    //如果不存在，则新增，加载数据
    // if(this.isRowDataLoaded(rowIndex)){//不存在
    //     return;
    // }
    var dataLength = this.getRowCount(),
        form = _YIUIBase.YIUI.FormStack.getForm(this.ofFormID),
        isNewData = false,
        // dtrRowIndex = this.metaRowInfo.dtlRowIndex,
    dtrRowIndex = this.getMetaObj().detailMetaRowIndex,
        // dtlMetaRow = this.metaRowInfo.rows[dtrRowIndex];
    dtlMetaRow = this.getDetailRow();

    var table = form.getDocument().getByKey(this.tableKey || this.metaObj.tableKey);
    var rowData = {};
    rowData.isDetail = true;
    rowData.isEditable = true;
    rowData.rowHeight = dtlMetaRow.rowHeight;
    rowData.rowID = rowIndex;
    rowData.metaRowIndex = dtrRowIndex;
    rowData.rowType = "Detail";
    rowData.cellKeys = dtlMetaRow.cellKeys;
    rowData.data = [];
    rowData.cellBkmks = [];
    rowData.bkmk = rowIndex;
    rowData.rowGroupLevel = dtlMetaRow.rowGroupLevel;
    isNewData = false;
    var bkmk = rowIndex;

    for (var i = 0, len = this.getColumnCount(); i < len; i++) {
      var metaCell = dtlMetaRow.cells[i]; // editOpt = this.dataModel.colModel.cells[rd.cellKeys[i]];

      var editOpt = this.getCellEditor(rowData.cellKeys[i]).toJS();

      if (editOpt.hasDB) {
        if (metaCell.isColExpand) {
          cBookmark = rd.cellBkmks[i];

          if (cBookmark) {
            table.setByBkmk(cBookmark);
            rowData.data.push([table.getByKey(editOpt.columnKey), null, true]); // this.setValueAt(rowIndex, i, table.getByKey(editOpt.columnKey), false, false, true);
          }
        } else {
          table.setByBkmk(bkmk);
          rowData.data.push([table.getByKey(editOpt.columnKey), null, true]); // this.setValueAt(rowIndex, i, table.getByKey(editOpt.columnKey), false, false, true);
        }
      } else if (editOpt.edittype == "label" || editOpt.edittype == "button" || editOpt.edittype == "hyperLink") {
        // this.setValueAt(rowIndex, i, metaCell.caption, false, false, false);
        rowData.data.push([metaCell.caption, metaCell.caption, true]);
      } else if (metaCell.isSelect) {
        table.setByBkmk(bkmk);
        rowData.data.push([table.getByKey(_YIUIBase.YIUI.DataUtil.System_SelectField_Key), null, true]); // this.setValueAt(rowIndex, i, table.getByKey(YIUI.DataUtil.System_SelectField_Key), false, false, false);
      }
    }

    var state = this.state.setIn(['dataModel', 'data', rowIndex], _immutable["default"].fromJS(rowData));
    this.changeState(state); // form.getUIProcess().calcEmptyRow(this, rowIndex);
  },
  getRowBkmk: function getRowBkmk(rowIndex) {
    // return this.rootGroupBkmk[rowIndex];
    var rowData = this.getRowDataAt(rowIndex);

    if (rowData) {
      return rowData.bookmark;
    }

    return null;
  },
  getCellEditOpt: function getCellEditOpt(column) {
    var editor = this.getCellEditor(column);

    if (editor) {
      return editor.toJS().editOptions;
    }

    return null;
  },
  getDetailRow: function getDetailRow() {
    var meta = this.getMetaObj();
    var result = meta.rows[meta.detailMetaRowIndex];

    if (!result.cellKeys) {
      result.cellKeys = result.cells.map(function (cell) {
        return cell.key;
      });
    }

    return result;
  },
  getCellDataAt: function getCellDataAt(row, column) {
    var result = this.state.getIn(['dataModel', 'data', row, 'data', column]);
    return result.toJS();
  },
  refreshSelectEnable: function refreshSelectEnable() {},
  getMetaCellByKey: function getMetaCellByKey(cellKey) {
    var metaRow, metaCell;

    for (var i = 0, len = this.getMetaObj().rows.length; i < len; i++) {
      metaRow = this.getMetaObj().rows[i];

      for (var j = 0, length = metaRow.cells.length; j < length; j++) {
        metaCell = metaRow.cells[j];

        if (metaCell.key == cellKey) {
          return metaCell;
        }
      }
    }

    return null;
  },
  getColumnEditor: function getColumnEditor(columnKey) {
    if (!this.editors[columnKey]) {
      var editor = this.getCellEditor(columnKey);

      if (editor) {
        var ed = editor.toJS();
        var colConfig = this.getColumnConfigByKey(columnKey);
        var result = ed.editOptions;
        result.ofFormID = this.ofFormID;
        result.key = columnKey;
        result.tagName = (0, _controlUtil.getTagName)(result.cellType);
        result.metaObj = result;
        result.columnKey = ed.columnKey;
        result.caption = colConfig.get('label') || colConfig.get('caption');
        result.formulaCaption = colConfig.get('formulaCaption');

        var cmp = _YIUIBase.YIUI.create(result);

        cmp.init();
        this.editors[columnKey] = cmp;
      }
    }

    return this.editors[columnKey];
  },
  doOnCellClick: function () {
    var _doOnCellClick = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee10(rowIndex, columnKey) {
      var form, colEditor, cxt;
      return regeneratorRuntime.wrap(function _callee10$(_context10) {
        while (1) {
          switch (_context10.prev = _context10.next) {
            case 0:
              form = _YIUIBase.YIUI.FormStack.getForm(this.ofFormID);
              colEditor = this.getColumnEditor(columnKey);
              _context10.t0 = colEditor.cellType;
              _context10.next = _context10.t0 === _YIUIBase.YIUI.CONTROLTYPE.BUTTON ? 5 : _context10.t0 === _YIUIBase.YIUI.CONTROLTYPE.HYPERLINK ? 5 : _context10.t0 === _YIUIBase.YIUI.CONTROLTYPE.IMAGE ? 5 : _context10.t0 === _YIUIBase.YIUI.CONTROLTYPE.TEXTBUTTON ? 5 : 12;
              break;

            case 5:
              if (!colEditor.onClick) {
                _context10.next = 11;
                break;
              }

              cxt = new _YIUIParser.View.Context(form);
              cxt.setRowIndex(rowIndex);
              this.activeRowIndex = rowIndex;
              _context10.next = 11;
              return form.eval(_yesCommon.lodash.trim(colEditor.onClick), cxt, null);

            case 11:
              return _context10.abrupt("break", 12);

            case 12:
            case "end":
              return _context10.stop();
          }
        }
      }, _callee10, this);
    }));

    function doOnCellClick(_x22, _x23) {
      return _doOnCellClick.apply(this, arguments);
    }

    return doOnCellClick;
  }(),
  doOnRowDblClick: function () {
    var _doOnRowDblClick = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee11(rowIndex) {
      var rowDblClick, formID, form, cxt;
      return regeneratorRuntime.wrap(function _callee11$(_context11) {
        while (1) {
          switch (_context11.prev = _context11.next) {
            case 0:
              rowDblClick = this.getMetaObj().rowDblClick;

              if (!rowDblClick) {
                _context11.next = 7;
                break;
              }

              formID = this.ofFormID, form = _YIUIBase.YIUI.FormStack.getForm(formID), cxt = new _YIUIParser.View.Context(form);
              cxt.setRowIndex(rowIndex);
              this.activeRowIndex = rowIndex;
              _context11.next = 7;
              return form.eval(rowDblClick, cxt, null);

            case 7:
            case "end":
              return _context11.stop();
          }
        }
      }, _callee11, this);
    }));

    function doOnRowDblClick(_x24) {
      return _doOnRowDblClick.apply(this, arguments);
    }

    return doOnRowDblClick;
  }(),
  isNullValue: function isNullValue(value) {
    if (value == null || value == '') {
      // 文本
      return true;
    }

    if (value instanceof Decimal) {
      // 数值
      return value.isZero();
    }

    if (value instanceof _YIUIBase.YIUI.ItemData) {
      // 字典
      return value.oid == 0;
    }

    if (_yesCommon.lodash.isArray(value)) {
      // 多选字典
      return value.length == 0;
    }

    return false;
  },
  isCellNull: function isCellNull(rowIndex, colIndex) {
    var val = this.getValueAt(rowIndex, colIndex);
    return this.isNullValue(val);
  }
});

_YIUIBase.YIUI.reg('grid', _YIUIBase.YIUI.Grid);

(0, _controlUtil.regControlType)(_YIUIBase.YIUI.CONTROLTYPE.GRID, 'grid');
var _default = _YIUIBase.YIUI.Grid;
exports["default"] = _default;