"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _control = _interopRequireDefault(require("./control"));

var _immutable = _interopRequireDefault(require("immutable"));

var _empty = _interopRequireDefault(require("empty"));

var _controlUtil = require("./controlUtil");

var _YIUIBase = require("../../YIUI-base");

require("../../YIUI-common");

require("../../YIUI-svr");

var _YIUIParser = require("../../YIUI-parser");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

_YIUIBase.YIUI.ListView = _YIUIBase.YIUI.extend(_control["default"], {
  handler: _YIUIBase.YIUI.ListViewHandler,
  init: function init(options) {
    this.base(options);
    this.columnInfo = this.getMetaObj().columnInfo;
    this.state = this.state.set('columnInfo', _immutable["default"].fromJS(this.columnInfo));
    this.state = this.state.set('data', _immutable["default"].fromJS(this.data));
    this.editors = {};
    this.activeRowIndex = -1;
    this._pagination = {
      hidePagination: _empty["default"].func,
      setTotalRowCount: _empty["default"].func
    };
  },
  findIndex: function findIndex(colKey) {
    var cols = this.columnInfo;
    var index = -1;

    for (var i = 0, len = cols.length; i < len; i++) {
      if (cols[i].key === colKey) {
        index = i;
        break;
      }
    }

    return index;
  },
  diff: function diff(diffJson) {
    var listView = this;
    listView.totalRowCount = diffJson.totalRowCount || listView.totalRowCount;
    var columnInfo = diffJson.columnInfo; // let oldState = this.state;

    var state = null;

    if (diffJson.data) {
      state = this.state.set('data', _immutable["default"].fromJS(diffJson.data));
    } else if (columnInfo) {
      state = this.state.mergeDeep('columnInfo', columnInfo);
      state = this.state.set('data', _immutable["default"].fromJS(diffJson.data));
    }

    this.changeState(state);
  },

  /**
   * 加载更多数据
   */
  loadMoreData: function () {
    var _loadMoreData = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee() {
      var controlKey, tableKey, form, tblFilter, startRow, doc, table, formDoc, rowList, j, length, row, m, size, column, columnKey, value;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              controlKey = this.key, tableKey = this.tableKey;
              form = _YIUIBase.YIUI.FormStack.getForm(this.ofFormID);
              tblFilter = form.getFilterMap().getTblFilter(tableKey);
              startRow = tblFilter.startRow + tblFilter.maxRows;
              form.getFilterMap().setStartRow(tableKey, startRow);
              _context.next = 7;
              return _YIUIBase.YIUI.DocService.loadFormData(form, form.getFilterMap().OID, form.getFilterMap(), form.getCondParas());

            case 7:
              doc = _context.sent;
              doc = _YIUIBase.YIUI.DataUtil.fromJSONDoc(doc);
              table = doc.getByKey(tableKey);
              formDoc = form.getDocument();
              formDoc.getByKey(tableKey).concat(table);
              rowList = [];

              for (j = 0, length = table.getRowCount(); j < length; j++) {
                row = {}; // listView.data.push(row);

                table.setPos(j); // var bkmkRow = new YIUI.DetailRowBkmk();
                // bkmkRow.setBookmark(table.getBkmk());

                row.bkmkRow = startRow + table.getBkmk();

                for (m = 0, size = this.columnInfo.length; m < size; m++) {
                  column = this.columnInfo[m];
                  columnKey = column.columnKey;
                  value = null;

                  if (columnKey) {
                    value = table.getByKey(columnKey);
                  } else {
                    if (column.type == _YIUIBase.YIUI.CONTROLTYPE.HYPERLINK || column.type == _YIUIBase.YIUI.CONTROLTYPE.BUTTON || column.type == _YIUIBase.YIUI.CONTROLTYPE.LABEL) {
                      value = column.caption;
                    } else if (column.type == _YIUIBase.YIUI.CONTROLTYPE.HYPERLINK) {
                      value = false;
                    }
                  } // listView.setValueAt(j, m, value);


                  row[columnKey] = value;
                }

                rowList.push(row);
              }

              this.addDataRow(rowList);

            case 15:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    function loadMoreData() {
      return _loadMoreData.apply(this, arguments);
    }

    return loadMoreData;
  }(),
  hasMore: function hasMore() {
    var tableKey = this.tableKey;

    var form = _YIUIBase.YIUI.FormStack.getForm(this.ofFormID);

    var tblFilter = form.getFilterMap().getTblFilter(tableKey);

    if (!tblFilter) {
      return false;
    }

    var pageRowCount = tblFilter.maxRows;

    if (this.getTotalRowCount() <= pageRowCount) {
      return false;
    }

    return true;
  },
  clearDataRow: function clearDataRow() {// this.data = [];
    // this.state = this.state.set('data',Immutable.fromJS(this.data));
  },
  clearAllRows: function clearAllRows() {
    this.data = [];
    var state = this.state.set('data', _immutable["default"].fromJS(this.data));
    this.changeState(state);
  },
  getValue: function getValue(rowIndex, colIndex) {
    if (rowIndex == null) {
      return this.data;
    }

    var dbKey = this.columnInfo[colIndex].columnKey;
    return this.getValByKey(rowIndex, dbKey);
  },
  getValByKey: function getValByKey(rowIndex, colKey) {
    var colCfg = this.getColumnConfig(colKey);
    return this.state.getIn(['data', rowIndex, colCfg.columnKey]);
  },
  rowClick: function () {
    var _rowClick = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee2(rowIndex) {
      var form, cxt, formula;
      return regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              form = _YIUIBase.YIUI.FormStack.getForm(this.ofFormID);
              cxt = new _YIUIParser.View.Context(form);
              cxt.setRowIndex(rowIndex);
              this.activeRowIndex = rowIndex;
              formula = this.getMetaObj().rowDblClick;

              if (!formula) {
                _context2.next = 8;
                break;
              }

              _context2.next = 8;
              return form.eval(formula, cxt, null);

            case 8:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, this);
    }));

    function rowClick(_x) {
      return _rowClick.apply(this, arguments);
    }

    return rowClick;
  }(),
  setDisplayValueByKey: function setDisplayValueByKey(rowIndex, colKey, v) {},
  getDisplayValueByKey: function getDisplayValueByKey(rowIndex, colKey) {
    return '';
  },
  getRowCount: function getRowCount() {
    this.state.get('data').size;
  },
  deleteRow: function deleteRow(rowIndex) {
    // this.data.splice(rowIndex,1);
    var state = this.state.deleteIn(['data', rowIndex]);
    this.changeState(state);
  },
  addNewRow: function addNewRow(row) {
    if (row) {} // 新增行，首先计算新增空白行的数据，这个数据需要缓存下来，


    this.data.push(row);
    var newRow = [];
    newRow.push(row);
    this.addDataRow(newRow);
  },
  getEmtpyRowData: function getEmtpyRowData() {
    return this.emptyRowData || this.calculateEmptyData();
  },
  calculateEmptyRowData: function () {
    var _calculateEmptyRowData = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee3() {
      var form, column, v;
      return regeneratorRuntime.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              this.emptyRowData = [];
              form = _YIUIBase.YIUI.FormStack.getForm(this.ofFormID);
              _context3.t0 = regeneratorRuntime.keys(this.columnInfo);

            case 3:
              if ((_context3.t1 = _context3.t0()).done) {
                _context3.next = 14;
                break;
              }

              column = _context3.t1.value;
              v = '';

              if (!column.defaultValueFormula) {
                _context3.next = 10;
                break;
              }

              _context3.next = 9;
              return form.evalFormulua(column.defaultValueFormulua);

            case 9:
              v = _context3.sent;

            case 10:
              if (column.defaultValue) {
                //设置了默认数值
                v = column.defaultValue;
              }

              this.emptyRowData.push(v);
              _context3.next = 3;
              break;

            case 14:
              return _context3.abrupt("return", this.emptyRowData());

            case 15:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3, this);
    }));

    function calculateEmptyRowData() {
      return _calculateEmptyRowData.apply(this, arguments);
    }

    return calculateEmptyRowData;
  }(),
  setColumnVisible: function setColumnVisible(key, visible) {
    var editor = this.columnInfo.find(function (item) {
      return item.key === key;
    });
    editor.visible = visible;
  },
  setColumnEnable: function setColumnEnable(key, enable) {
    var editor = this.columnInfo.find(function (item) {
      return item.key === key;
    });
    editor.enable = enable;
  },
  addDataRow: function addDataRow(rows) {
    // if (rows) {
    //     this.data = rows;
    // }
    var data = this.state.get('data');
    var state = this.state.set('data', data.concat(_immutable["default"].fromJS(rows)));
    this.changeState(state); // this.state = this.state.set('data', Immutable.fromJS(this.data));
  },
  resetData: function resetData(data) {
    this.data = data;
    var state = this.state.set('data', _immutable["default"].fromJS(this.data));
    this.changeState(state);
  },
  setTotalRowCount: function setTotalRowCount(v) {
    var state = this.state.set('totalRowCount', v);
    this.changeState(state);
  },
  getTotalRowCount: function getTotalRowCount() {
    return this.state.get('totalRowCount');
  },
  getColumnConfig: function getColumnConfig(columnKey) {
    return this.columnInfo.find(function (item) {
      return item.key === columnKey || item.columnKey === columnKey;
    });
  },

  /**
   * 获取所有列的控件
   */
  getAllColumnEditors: function getAllColumnEditors() {
    var _this = this;

    this.columnInfo.forEach(function (item) {
      _this.getColumnEditor(item.key);
    });
    return Object.values(this.editors);
  },
  getColumnEditor: function getColumnEditor(columnKey) {
    if (!this.editors[columnKey]) {
      var editor = this.columnInfo.find(function (item) {
        return item.key === columnKey || item.columnKey === columnKey;
      });

      if (!editor) {
        return null;
      }

      editor.tagName = (0, _controlUtil.getTagName)(editor.columnType);
      editor.ofFormID = this.ofFormID; // editor.metaObj = editor;

      var cmp = _YIUIBase.YIUI.create(editor);

      this.editors[columnKey] = cmp;
    }

    return this.editors[columnKey];
  },
  getFocusRowIndex: function getFocusRowIndex() {
    return this.activeRowIndex;
  },
  createColumnHead: _empty["default"].func,
  _createHandles: _empty["default"].func,
  syncHandleWidths: _empty["default"].func
});

_YIUIBase.YIUI.reg('listview', _YIUIBase.YIUI.ListView);

_YIUIBase.YIUI.reg('rotator', _YIUIBase.YIUI.ListView);

_YIUIBase.YIUI.reg('gallery', _YIUIBase.YIUI.ListView);

(0, _controlUtil.regControlType)(_YIUIBase.YIUI.CONTROLTYPE.LISTVIEW, 'listview');
var _default = _YIUIBase.YIUI.ListView;
exports["default"] = _default;