"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _control = _interopRequireDefault(require("./control"));

var _YIUIBase = require("../../YIUI-base");

require("../../YIUI-common");

require("../../YIUI-svr");

require("../../YIUI-parser");

var _controlUtil = require("./controlUtil");

var _decimal = _interopRequireDefault(require("decimal.js"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/*
 * @Author: gmf
 * @Date:   2016-05-03 11:17:40
 * @Last Modified by:   gmf
 * @Last Modified time: 2016-05-03 11:20:02
 */
var NumberEditor = _YIUIBase.YIUI.extend(_control["default"], {
  // handler: YIUI.NumberEditorHandler,
  calculateDisplayValue: function calculateDisplayValue(v) {
    if (!v) {
      return v;
    }

    var scale = this.getMetaObj().scale === null ? 2 : this.getMetaObj().scale;
    var dt = v;

    if (!(v instanceof _decimal["default"])) {
      dt = new _decimal["default"](v);
    }

    if (dt == 0 && !this.getMetaObj().showZero) {
      return this.getMetaObj().zeroString || '';
    }

    return dt.toFixed(scale);
  },
  isNull: function isNull() {
    var v = this.getValue();

    if (v) {
      if (v instanceof _decimal["default"]) {
        return v.isZero();
      }

      return !v;
    }

    return true;
  },
  getText: function getText() {
    if (this.value instanceof _decimal["default"]) {
      return this.value.toNumber();
    }

    return this.value;
  }
});

_YIUIBase.YIUI.reg('numbereditor', NumberEditor);

(0, _controlUtil.regControlType)(_YIUIBase.YIUI.CONTROLTYPE.NUMBEREDITOR, 'numbereditor');
var _default = NumberEditor;
exports["default"] = _default;