"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _yesCommon = require("yes-common");

var _YIUIBase = require("../../YIUI-base");

require("../../YIUI-common");

require("../../YIUI-svr");

require("../../YIUI-parser");

var _controlUtil = require("./controlUtil");

var _control = _interopRequireDefault(require("./control"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

_YIUIBase.YIUI.Panel = _YIUIBase.YIUI.extend(_control["default"], {
  /** 如果items未定义type，默认为component */
  defaultType: 'component',

  /** 容器中子控件布局方式 */
  layout: 'auto',
  // overflowX: 'visible',
  // overflowY: 'visible',
  // backImage: '',
  // backImagePosition: '',
  // isBackImageRepeatX: false,
  // isBackImageRepeatY: false,
  // padding: 1,
  init: function init(options) {
    this.base(options);
    var items = this.items;

    if (items) {
      delete this.items;
      this.add(items);
    }
  },
  initItems: function initItems() {
    if (!this.items) {
      this.items = [];
    }
  },
  add: function add(comp) {
    this.initItems();

    if (_yesCommon.lodash.isArray(comp)) {
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = comp[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var cc = _step.value;
          this.add(cc);
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator["return"] != null) {
            _iterator["return"]();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      return;
    }

    if (this.get(comp.id)) return;
    var c = this.lookupComponent(comp);
    this.items.push(c);
    c.ownerCt = this;
  },
  lookupComponent: function lookupComponent(comp) {
    if (_yesCommon.lodash.isString(comp)) {
      return _YIUIBase.YIUI.ComponentMgr.get(comp);
    } else if (!(comp instanceof _YIUIBase.YIUI.Component)) {
      return _YIUIBase.YIUI.create(comp, this.defaultType);
    }

    return comp;
  },
  get: function get(comp) {
    if (_yesCommon.lodash.isNumber(comp)) {
      return this.items[comp];
    } else if (_yesCommon.lodash.isString(comp)) {
      var items = this.items,
          item;

      for (var i = 0, len = items.length; i < len; i++) {
        item = items[i];

        if (item && (item.id === comp || item.key === comp)) {
          return item;
        }
      }
    }

    return null;
  },
  build: function build(form) {
    var rootpanel = form.getRootPanel();
    this.add(rootpanel);
    form.setContainer(this);
  }
});

_YIUIBase.YIUI.reg('panel', _YIUIBase.YIUI.Panel);

_YIUIBase.YIUI.reg('splitpanel', _YIUIBase.YIUI.Panel);

_YIUIBase.YIUI.reg('fluidtablelayoutpanel', _YIUIBase.YIUI.Panel);

_YIUIBase.YIUI.reg('flexflowlayoutpanel', _YIUIBase.YIUI.Panel);

_YIUIBase.YIUI.reg('flowlayoutpanel', _YIUIBase.YIUI.Panel);

_YIUIBase.YIUI.reg('linearlayoutpanel', _YIUIBase.YIUI.Panel);

_YIUIBase.YIUI.reg('refreshcontrol', _YIUIBase.YIUI.Panel);

_YIUIBase.YIUI.reg('tabpanel', _YIUIBase.YIUI.Panel); // YIUI.reg('stackcontainer', YIUI.Panel);


_YIUIBase.YIUI.reg('shrinkview', _YIUIBase.YIUI.Panel);

_YIUIBase.YIUI.reg('separator', _YIUIBase.YIUI.Panel);

(0, _controlUtil.regControlType)(_YIUIBase.YIUI.CONTROLTYPE.PANEL, 'panel');
(0, _controlUtil.regControlType)(_YIUIBase.YIUI.CONTROLTYPE.GRIDLAYOUTPANEL, 'linearlayoutpanel');
(0, _controlUtil.regControlType)(_YIUIBase.YIUI.CONTROLTYPE.SPLITPANEL, 'splitpanel');
(0, _controlUtil.regControlType)(_YIUIBase.YIUI.CONTROLTYPE.FLUIDTABLELAYOUTPANEL, 'fluidtablelayoutpanel');
(0, _controlUtil.regControlType)(_YIUIBase.YIUI.CONTROLTYPE.FLEXFLOWLAYOUTPANEL, 'flexflowlayoutpanel');
(0, _controlUtil.regControlType)(_YIUIBase.YIUI.CONTROLTYPE.TABPANEL, 'tabpanel');
(0, _controlUtil.regControlType)(_YIUIBase.YIUI.CONTROLTYPE.FLOWLAYOUTPANEL, 'flowlayoutpanel');
(0, _controlUtil.regControlType)(_YIUIBase.YIUI.CONTROLTYPE.SEPARATOR, 'separator');
(0, _controlUtil.regControlType)(268, 'refreshcontrol');
(0, _controlUtil.regControlType)(280, 'shrinkview');
var _default = _YIUIBase.YIUI.Panel;
exports["default"] = _default;