"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _control = _interopRequireDefault(require("./control"));

var _YIUIBase = require("../../YIUI-base");

require("../../YIUI-common");

require("../../YIUI-svr");

require("../../YIUI-parser");

var _controlUtil = require("./controlUtil");

var _immutable = _interopRequireDefault(require("immutable"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var Radiobox = _YIUIBase.YIUI.extend(_control["default"], {
  init: function init(options) {
    this.base(options);
    this.state = this.state.set('items', _immutable["default"].fromJS([]));
  },
  // handler: YIUI.ButtonHandler,
  calculateDisplayValue: function () {
    var _calculateDisplayValue = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee(v) {
      var itm, text;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.prev = 0;
              _context.next = 3;
              return this.resetItems();

            case 3:
              itm = this.state.get('items').find(function (item) {
                return item.get('value') == v;
              });
              text = itm ? itm.get('caption') : '';
              return _context.abrupt("return", text);

            case 8:
              _context.prev = 8;
              _context.t0 = _context["catch"](0);
              console.log(_context.t0);
              return _context.abrupt("return", '出错');

            case 12:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this, [[0, 8]]);
    }));

    function calculateDisplayValue(_x) {
      return _calculateDisplayValue.apply(this, arguments);
    }

    return calculateDisplayValue;
  }(),
  setVisible: function setVisible() {
    return;
  },
  getGroupKey: function getGroupKey() {
    return this.getMetaObj().groupKey;
  },
  resetItems: function () {
    var _resetItems = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee2() {
      var trigger,
          form,
          radios,
          items,
          state,
          _args2 = arguments;
      return regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              trigger = _args2.length > 0 && _args2[0] !== undefined ? _args2[0] : true;
              form = _YIUIBase.YIUI.FormStack.getForm(this.ofFormID);

              if (form) {
                _context2.next = 4;
                break;
              }

              return _context2.abrupt("return");

            case 4:
              radios = form.getRadios(this.getMetaObj().groupKey);
              items = [];
              radios.forEach(function (radio) {
                // if (radio.isVisible() && radio.isEnable()) {
                var enable = radio.isVisible() && radio.isEnable();
                var metaObj = radio.getMetaObj();
                items.push({
                  value: metaObj.metaValue,
                  caption: metaObj.caption,
                  enable: enable
                }); // }
              });
              state = this.state.mergeDeepIn(['items'], _immutable["default"].fromJS(items));
              this.changeState(state, trigger);

            case 9:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, this);
    }));

    function resetItems() {
      return _resetItems.apply(this, arguments);
    }

    return resetItems;
  }()
});

_YIUIBase.YIUI.reg('radiobutton', Radiobox);

(0, _controlUtil.regControlType)(_YIUIBase.YIUI.CONTROLTYPE.RADIOBUTTON, 'radiobutton');
var _default = Radiobox;
exports["default"] = _default;