"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _control = _interopRequireDefault(require("./control"));

var _immutable = _interopRequireDefault(require("immutable"));

var _yesCommon = require("yes-common");

var _YIUIBase = require("../../YIUI-base");

require("../../YIUI-common");

require("../../YIUI-svr");

require("../../YIUI-parser");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

_YIUIBase.YIUI.TableViewList = _YIUIBase.YIUI.extend(_control["default"], {
  init: function init(options) {
    this.base(options); // this.state = this.state.set('data',Immutable.fromJS(this.data));

    this.resetData(this.data);
  },
  getColumnEditor: function getColumnEditor(key, isGroup) {
    if (this.detailView) {
      this.detailAdapt = new _YIUIBase.YIUI.FormAdapt({
        rootPanelObj: this.detailView,
        formID: this.ofFormID
      });
    }

    if (this.groupView) {
      this.groupAdapt = new _YIUIBase.YIUI.FormAdapt({
        rootPanelObj: this.groupView,
        formID: this.ofFormID
      });
    }

    if (isGroup) {
      return this.groupAdapt.getComp(key);
    }

    return this.detailAdapt.getComp(key);
  },
  changeData: function changeData(path, v) {
    var state = this.state.setIn(['data'].concat(_toConsumableArray(path)), v);
    this.changeState(state);
  },
  resetData: function resetData(data) {
    this.data = data;
    var state = null; // this.state = this.state.set('data', Immutable.fromJS(this.data));

    if (this.metaObj.GroupColumnKeys) {
      // 是一个合并的列表
      var keys = this.metaObj.GroupColumnKeys.split(',');

      var groupData = _yesCommon.lodash.groupBy(data, function (row) {
        return keys.map(function (key) {
          return row[key].value;
        }).join();
      });

      state = this.state.set('data', _immutable["default"].fromJS(groupData));
    } else {
      state = this.state.set('data', _immutable["default"].fromJS(this.data));
    }

    this.changeState(state);
  }
});

_YIUIBase.YIUI.reg('tableviewlist', _YIUIBase.YIUI.TableViewList);

var _default = _YIUIBase.YIUI.TableViewList;
exports["default"] = _default;