"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _control = _interopRequireDefault(require("./control"));

var _empty = _interopRequireDefault(require("empty"));

var _immutable = _interopRequireDefault(require("immutable"));

var _controlUtil = require("./controlUtil");

var _YIUIBase = require("../../YIUI-base");

require("../../YIUI-common");

require("../../YIUI-svr");

require("../../YIUI-parser");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/*
 * @Author: gmf
 * @Date:   2016-03-18 09:58:48
 * @Last Modified by:   gmf
 * @Last Modified time: 2016-03-18 14:27:15
 */
var Toolbar = _YIUIBase.YIUI.extend(_control["default"], {
  handler: _YIUIBase.YIUI.ListViewHandler,
  repaint: _empty["default"].func,
  init: function init(options) {
    this.base(options);
    this.isDefault = this.getMetaObj().isDefault == null ? true : this.getMetaObj().isDefault;
    this.state = this.state.set('items', _immutable["default"].fromJS(this.items || []));
  },
  setItemVisible: function setItemVisible(key, visible) {
    var optItem = this.state.get('items').find(function (item) {
      return item.get('key') === key;
    });

    if (optItem) {
      var index = this.state.get('items').indexOf(optItem);
      var state = this.state.setIn(['items', index, 'visible'], visible);
      this.changeState(state);
    }
  },
  setItemEnable: function setItemEnable(key, enable) {
    var optItem = this.state.get('items').find(function (item) {
      return item.get('key') === key;
    });

    if (optItem) {
      var index = this.state.get('items').indexOf(optItem);
      var state = this.state.setIn(['items', index, 'enable'], enable);
      this.changeState(state);
    }
  },
  setItems: function setItems(items) {
    this.items = items;
    var state = this.state.set('items', _immutable["default"].fromJS(items));
    this.changeState(state);
  },
  hasItem: function hasItem(key) {
    var optItem = this.state.get('items').find(function (item) {
      return item.get('key') === key;
    });
    return optItem;
  },
  addItem: function addItem(item) {
    var index = this.state.get('items').size;
    var state = this.state.setIn(['items', index], _immutable["default"].fromJS(item));
    this.changeState(state);
  },
  getItems: function getItems() {
    return this.getState.get('items');
  },
  clear: function clear(item) {
    this.setItems([]);
  }
});

_YIUIBase.YIUI.reg('toolbar', Toolbar);

(0, _controlUtil.regControlType)(_YIUIBase.YIUI.CONTROLTYPE.TOOLBAR, 'toolbar');
var _default = Toolbar;
exports["default"] = _default;