"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _control = _interopRequireDefault(require("./control"));

var _YIUIBase = require("../../YIUI-base");

require("../../YIUI-common");

require("../../YIUI-svr");

require("../../YIUI-parser");

var _controlUtil = require("./controlUtil");

var _moment = _interopRequireDefault(require("moment"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var DateEditor = _YIUIBase.YIUI.extend(_control["default"], {
  init: function init(options) {
    this.base(options);
    var format = this.getMetaObj().format;

    if (format) {
      format = format.replace(/y/gm, 'Y');
      format = format.replace(/d/gm, 'D');
      format = format.replace(/H/gm, 'h');
      this.getMetaObj().format = format;
    }
  },
  convertValue: function convertValue(v) {
    var metaObj = this.getMetaObj();
    var onlyDate = metaObj.onlyDate;
    var date = v;

    if (typeof v === 'string') {
      // String 分为两种一种其实是数字，一种是日期的文本形式
      if (isNaN(v)) {
        date = date.replace(/-/g, '/');

        if (__DEV__) {
          console.log('datepicker');
        }

        date = new Date(date);
      } else {
        var dt = parseInt(v, 10); // date = new Date(dt);

        return dt || null;
      }
    } else if (typeof v === 'number') {
      // this.changeState(this.state.set('value', v));
      return v || null;
    } else {
      if (v) {
        date = new Date(v);
      }
    }

    var parseFormat = 'YYYYMMDD';

    if (!onlyDate) {
      parseFormat = 'YYYYMMDDHHmmss';
    }

    var result = (0, _moment["default"])(date).format(parseFormat);
    return result;
  },
  // setInnerValue(v) {
  //     const metaObj = this.getMetaObj();
  //     const { onlyDate } = metaObj;
  //     let date = v;
  //     if (typeof v === 'string') {
  //         // String 分为两种一种其实是数字，一种是日期的文本形式
  //         if (isNaN(v)) {
  //             date = date.replace(/-/g, '/');
  //             if (__DEV__) {
  //                 console.log('datepicker');
  //             }
  //             date = new Date(date);
  //         } else {
  //             const dt = parseInt(v, 10);
  //             date = new Date(dt);
  //         }
  //     } else if (typeof v === 'number') {
  //         this.changeState(this.state.set('value', v));
  //         return;
  //     } else {
  //         if (v) {
  //             date = new Date(v);
  //         }
  //     }
  //     let parseFormat = 'YYYYMMDD';
  //     if (!onlyDate) {
  //         parseFormat = 'YYYYMMDDHHmmss';
  //     }
  //     const result = moment(date).format(parseFormat);
  //     const state = this.state.set('value', parseInt(result, 10));
  //     this.changeState(state);
  // },
  calculateDisplayValue: function () {
    var _calculateDisplayValue = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee(v) {
      var metaObj, onlyDate, propFormat, text, format, parseFormat, date;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              // eslint-disable-line object-shorthand
              metaObj = this.getMetaObj();
              onlyDate = metaObj.onlyDate;
              propFormat = metaObj.format;
              text = '';

              if (v) {
                _context.next = 6;
                break;
              }

              return _context.abrupt("return", '');

            case 6:
              // let date = v;
              // if (v instanceof String) {
              //     // String 分为两种一种其实是数字，一种是日期的文本形式
              //     const dt = parseInt(v, 10);
              //     if (isNaN(dt)) {
              //         date = new Date(v);
              //     } else {
              //         date = new Date(dt);
              //     }
              // } else {
              //     date = new Date(v);
              // }
              // default format
              format = 'YYYY-MM-DD';

              if (!onlyDate) {
                format = 'YYYY-MM-DD HH:mm:ss';
              }

              parseFormat = 'YYYYMMDD';

              if (!onlyDate) {
                parseFormat = 'YYYYMMDDHHmmss';
              }

              date = (0, _moment["default"])('' + v, parseFormat); // props format

              if (propFormat) {
                format = propFormat;
              }

              text = date.format(format);
              return _context.abrupt("return", text);

            case 14:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    function calculateDisplayValue(_x) {
      return _calculateDisplayValue.apply(this, arguments);
    }

    return calculateDisplayValue;
  }()
});

_YIUIBase.YIUI.reg('utcdatepicker', DateEditor);

(0, _controlUtil.regControlType)(_YIUIBase.YIUI.CONTROLTYPE.UTCDATEPICKER, 'utcdatepicker');
var _default = DateEditor;
exports["default"] = _default;