"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FilterMap = FilterMap;
exports.TableFilterDetail = TableFilterDetail;

var _YIUIBase = require("./YIUI-base");

require("./YIUI-common");

require("./YIUI-parser");

require("./YIUI-svr");

function FilterMap(jsonObj) {
  jsonObj = jsonObj || {};
  var Return = {
    type: jsonObj["type"] || _YIUIBase.YIUI.DocumentType.DATAOBJECT,
    OID: jsonObj["OID"] || -1,
    needDocInfo: jsonObj["needDocInfo"] || true,
    filterMap: jsonObj["filterMap"] || new Array(),
    setOID: function setOID(OID) {
      this.OID = OID;
    },
    getOID: function getOID() {
      return this.OID;
    },
    setType: function setType(type) {
      this.type = type;
    },
    getType: function getType() {
      return this.type;
    },
    setNeedDocInfo: function setNeedDocInfo(needDocInfo) {
      this.needDocInfo = needDocInfo;
    },
    isNeedDocInfo: function isNeedDocInfo() {
      return this.needDocInfo;
    },
    setFilterMap: function setFilterMap(filterMap) {
      this.filterMap = filterMap;
    },
    getFilterMap: function getFilterMap() {
      return this.filterMap;
    },
    addTblDetail: function addTblDetail(tblDetail) {
      this.filterMap.push(tblDetail);
    },
    setStartRow: function setStartRow(tableKey, row) {
      //				this.getTblFilter(tableKey).setStartRow(row);
      this.getTblFilter(tableKey).startRow = row;
    },
    setMaxRows: function setMaxRows(tableKey, max) {
      //				this.getTblFilter(tableKey).setMaxRows(max);
      this.getTblFilter(tableKey).maxRows = max;
    },
    setIndicatorCount: function setIndicatorCount(tableKey, count) {
      this.getTblFilter(tableKey).INDICATORCOUNT = count;
    },
    getTblFilter: function getTblFilter(tableKey) {
      var tbl = this.get(tableKey);

      if (tbl == null) {
        tbl = new TableFilterDetail();
        tbl.setTableKey(tableKey);
        this.addTblDetail(tbl);
      }

      return tbl;
    },
    get: function get(tableKey) {
      var maps = this.filterMap,
          map;

      for (var i = 0, len = maps.length; i < len; i++) {
        map = maps[i];

        if (map.tableKey == tableKey) {
          return map;
        }
      }

      return null;
    },
    reset: function reset() {
      this.filterMap.forEach(function (fd) {
        return fd.reset();
      });
    }
  };
  return Return;
}

;

function TableFilterDetail() {
  var Return = {
    tableKey: "",
    filter: "",
    startRow: 0,
    maxRows: 0,
    OID: -1,
    fieldValues: null,
    paraValues: null,
    SourceKey: "",
    indicatorCount: 1,
    OrderField: [],
    OrderFieldType: [],
    setTableKey: function setTableKey(tableKey) {
      this.tableKey = tableKey;
    },
    setFilter: function setFilter(filter) {
      this.filter = filter;
    },
    setStartRow: function setStartRow(startRow) {
      this.startRow = startRow;
    },
    setMaxRows: function setMaxRows(maxRows) {
      this.maxRows = maxRows;
    },
    setPageIndicatorCount: function setPageIndicatorCount(count) {
      this.indicatorCount = count;
    },
    setFieldValues: function setFieldValues(fieldValues) {
      this.fieldValues = fieldValues;
    },
    setParaValues: function setParaValues(paraValues) {
      this.paraValues = paraValues;
    },
    setSourceKey: function setSourceKey(sourceKey) {
      this.SourceKey = sourceKey;
    },
    addOrderField: function addOrderField(key, value) {
      var i = this.OrderField.indexOf(key);

      if (i > -1) {
        this.OrderField.splice(i, 1);
        this.OrderFieldType.splice(i, 1);
      }

      this.OrderField.push(key);
      this.OrderFieldType.push(value);
    },
    clearOrderField: function clearOrderField() {
      this.OrderField.splice(0, this.OrderField.length);
      this.OrderFieldType.splice(0, this.OrderFieldType.length);
    },
    reset: function reset() {
      this.startRow = 0;
    }
  };
  return Return;
}

;