"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MetaForm = exports["default"] = void 0;

var _YIUIBase = require("./YIUI-base");

var _YIUICommon = require("./YIUI-common");

var _YIUIParser = require("./YIUI-parser");

require("./YIUI-svr");

require("./formIdGenerator");

require("./yes-ui");

var _filtermap = require("./filtermap");

require("./showdata");

require("./formadapt");

require("./paras");

require("./formstack");

require("./process/viewdatamonitor");

var _memoryAdapter = require("./cache/memoryAdapter");

var _cache = _interopRequireDefault(require("./cache/cache"));

var _decimal = _interopRequireDefault(require("decimal.js"));

var _dispatchers = _interopRequireDefault(require("./dispatchers"));

var _actions = require("./actions");

var _YIUI$extend;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var _default = _YIUIBase.YIUI.Form = _YIUIBase.YIUI.extend((_YIUI$extend = {
  init: function init(metaForm, formID) {
    var _this = this;

    this.formID = formID != null ? formID : _YIUIBase.YIUI.Form_allocFormID();
    this.metaForm = metaForm;
    this.setOperationState(metaForm.initState == _YIUIBase.YIUI.Form_OperationState.Edit ? metaForm.operationState : metaForm.initState);
    this.type = metaForm.type;
    this.operations = metaForm.operations;
    this.metaOpts = metaForm.metaOpts; // 只有可见可用的配置

    this.defTbr = metaForm.defTbr;
    this.formKey = metaForm.formKey;
    this.caption = metaForm.caption;
    this.abbrCaption = metaForm.abbrCaption;
    this.formulaCaption = metaForm.formulaCaption;
    this.formulaAbbrCaption = metaForm.formulaAbbrCaption;
    this.target = metaForm.target;
    this.mainTableKey = metaForm.mainTableKey;
    this.onLoad = metaForm.onLoad;
    this.onClose = metaForm.onClose;
    var rootObj = metaForm.root;
    this.standalone = metaForm.standalone;
    this.relations = metaForm.relations;
    this.macroMap = metaForm.macroMap;
    this.statusItems = metaForm.statusItems;
    this.paraGroups = metaForm.paraGroups;
    this.sysExpVals = metaForm.sysExpVals; //        this.filterMap = metaForm.filterMap;

    this.dependency = metaForm.dependency;
    this.paras = metaForm.paras;
    this.callParas = metaForm.callParas;
    this.paraCollection = metaForm.paraCollection;
    this.checkRules = metaForm.checkRules;
    this.subDetailInfo = metaForm.subDetailInfo;
    this.mapGrids = metaForm.mapGrids;
    this.errorInfo = metaForm.errorInfo;
    this.dataObjectKey = metaForm.dataObjectKey; //this.refObjectKey = metaForm.refObjectKey;
    //this.refTableKey = metaForm.refTableKey;

    this.postShow = metaForm.postShow;
    this.parser = new _YIUIParser.View.Parser(this); // this.uiProcess = new YIUI.UIProcess(this);
    // this.focusManager = new FocusPolicy(this);
    // this.viewDataMonitor = new YIUI.ViewDataMonitor(this);

    this.result = null;
    this.eventList = {};
    this.timerTask = metaForm.timerTask;
    this.metaComps = metaForm.metaComps;
    this.metaCells = metaForm.metaCells; // this.metaOpts = metaForm.metaOpts;

    this.buddyKeys = metaForm.buddyKeys || [];
    this.popWidth = metaForm.popWidth;
    this.popHeight = metaForm.popHeight;
    this.topMargin = metaForm.topMargin;
    this.bottomMargin = metaForm.bottomMargin;
    this.leftMargin = metaForm.leftMargin;
    this.rightMargin = metaForm.rightMargin;
    this.templateKey = metaForm.templateKey;
    var options = {
      form: this,
      rootObj: rootObj // focusManager:this.focusManager

    };
    this.mergeOptContainer = null;
    this.formAdapt = new _YIUIBase.YIUI.FormAdapt(options);
    this.formAdapt.load();
    var fm = new _filtermap.FilterMap();
    var map = this.formAdapt.LVMap.concat(this.formAdapt.gridMap);

    for (var i = 0, len = map.length; i < len; i++) {
      var key = map[i].key;
      var tableKey = map[i].tableKey;

      if (tableKey) {
        var comp = this.getComponent(key);
        var meta = comp.getMetaObj();
        var controlType = meta.type;
        var loadType = _YIUIBase.YIUI.PageLoadType.NONE;

        if (controlType == _YIUIBase.YIUI.CONTROLTYPE.LISTVIEW) {
          loadType = meta.pageLoadType;
        } else if (controlType == _YIUIBase.YIUI.CONTROLTYPE.GRID) {
          loadType = meta.pageLoadType;
        }

        if (loadType == _YIUIBase.YIUI.PageLoadType.DB) {
          var tblKey = meta.tableKey;
          var tblDetail = new _filtermap.TableFilterDetail();
          tblDetail.setTableKey(tblKey);
          tblDetail.setStartRow(0);
          tblDetail.setMaxRows(meta.pageRowCount || 50);
          tblDetail.setPageIndicatorCount(5);
          fm.addTblDetail(tblDetail);
        }
      }
    }

    this.filterMap = fm;
    var ma = new _memoryAdapter.MemoryAdapter();
    var cxt = new _YIUIParser.View.Context(this);
    this.formulaCache = new _cache["default"](ma, 'formula',
    /*#__PURE__*/
    function () {
      var _ref = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee(table, key) {
        var data;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                cxt.rowIndex = _this.formulaRowIndex;
                _context.next = 3;
                return _this.parser.eval(key, cxt);

              case 3:
                data = _context.sent;
                return _context.abrupt("return", {
                  data: data
                });

              case 5:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      return function (_x, _x2) {
        return _ref.apply(this, arguments);
      };
    }());

    _YIUIBase.YIUI.FormStack.addForm(this);

    this.snaps = {};
  },
  resetFilterMap: function resetFilterMap() {
    var fm = this.filterMap;
    fm.filterMap = new Array();
    var map = this.formAdapt.LVMap.concat(this.formAdapt.gridMap);

    for (var i = 0, len = map.length; i < len; i++) {
      var key = map[i].key;
      var tableKey = map[i].tableKey;

      if (tableKey) {
        var comp = this.getComponent(key);
        var meta = comp.getMetaObj();
        var controlType = meta.type;
        var loadType = _YIUIBase.YIUI.PageLoadType.NONE;

        if (controlType == _YIUIBase.YIUI.CONTROLTYPE.LISTVIEW) {
          loadType = meta.pageLoadType;
        } else if (controlType == _YIUIBase.YIUI.CONTROLTYPE.GRID) {
          loadType = meta.pageLoadType;
        }

        if (loadType == _YIUIBase.YIUI.PageLoadType.DB) {
          var tblKey = meta.tableKey;
          var tblDetail = new _filtermap.TableFilterDetail();
          tblDetail.setTableKey(tblKey);
          tblDetail.setStartRow(0);
          tblDetail.setMaxRows(meta.pageRowCount || 50);
          tblDetail.setPageIndicatorCount(5);
          fm.addTblDetail(tblDetail);
        }
      }
    }
  },
  convertValue: function convertValue(value, type) {
    var ret;

    switch (type) {
      case _YIUICommon.DataType.STRING:
        if (value == null || value == undefined) {
          ret = '';
        } else {
          ret = '' + value;
        }

        break;

      case _YIUICommon.DataType.INT:
      case _YIUICommon.DataType.LONG:
      case _YIUICommon.DataType.DOUBLE:
      case _YIUICommon.DataType.FLOAT:
      case _YIUICommon.DataType.NUMERIC:
        if (value == undefined || value == null || value == '') {
          ret = 0;
        } else {
          if (value.toString().toLowerCase() == "true") value = 1;
          if (value.toString().toLowerCase() == "false") value = 0;
          ret = new _decimal["default"](value, 10);
        }

        break;

      case _YIUICommon.DataType.BOOLEAN:
        ret = value ? true : false;
        break;
      // case DataType.DATETIME:
      // case DataType.DATE:
      //     if(value instanceof Date){
      //         ret = value.getTime();
      //     }else{
      //         ret = null;
      //     }
      //     break;

      default:
        ret = value;
    }

    return ret;
  },
  setUniqueId: function setUniqueId(id) {
    this.uniqueId = id;
  },
  getUniqueId: function getUniqueId() {
    return this.uniqueId;
  },
  getRadios: function getRadios(groupKey) {
    return this.formAdapt.getRadios(groupKey);
  },
  isError: function isError() {
    return this.errorInfo.error;
  },

  /**
   * 设置工作流权限处理类
   * @param proxy
   */
  setBPMStatusProxy: function setBPMStatusProxy(proxy) {
    this.BPMStatusProxy = proxy;
  },

  /**
   * 获取工作流权限处理类
   * @returns {*|YIUI.HostStatusProxy}
   */
  getBPMStatusProxy: function getBPMStatusProxy() {
    return this.BPMStatusProxy;
  },
  hasEnableRight: function hasEnableRight(fieldKey) {
    return fieldKey && this.formRights && (this.formRights.allEnableRights || this.formRights.enableRights && !this.formRights.enableRights.includes(fieldKey));
  },
  hasVisibleRight: function hasVisibleRight(fieldKey) {
    return fieldKey && this.formRights && (this.formRights.allVisibleRights || this.formRights.visibleRights && !this.formRights.visibleRights.includes(fieldKey));
  },
  hasOptRight: function hasOptRight(optKey) {
    return optKey && this.formRights && (this.formRights.allOptRights || this.formRights.optRights && this.formRights.optRights.includes(optKey));
  },

  /**
   * 初始化界面处理逻辑
   */
  initViewDataMonitor: function initViewDataMonitor() {
    this.viewDataMonitor = new _YIUIBase.YIUI.ViewDataMonitor(this);
  },

  /**
   *  获取需要合并操作的容易标识
   * @returns {mergeOptContainer}
   */
  getMergeOptContainer: function getMergeOptContainer() {
    return this.mergeOptContainer;
  },
  getCaption: function getCaption() {
    var caption = "";
    var formula = this.formulaCaption;

    if (formula) {
      var cxt = new _YIUIParser.View.Context(this);
      caption = this.eval(formula, cxt);
    }

    if (!caption) {
      caption = this.caption;
    }

    return caption;
  },
  setTemplateKey: function setTemplateKey(templateKey) {
    this.templateKey = templateKey;
  },
  getTemplateKey: function getTemplateKey() {
    return this.templateKey;
  },
  getAbbrCaption: function getAbbrCaption() {
    var abbr = "";
    var formula = this.formulaAbbrCaption;

    if (formula) {
      var cxt = new _YIUIParser.View.Context(this);
      abbr = this.eval(formula, cxt);
    }

    if (!abbr) {
      abbr = this.abbrCaption;
    }

    if (!abbr) {
      abbr = this.getCaption();
    }

    return abbr;
  },
  //产生一个单据当前状态的夸张
  makeSnapshot: function makeSnapshot() {
    var snap = {};
    var cmpList = this.getComponentList();

    for (var key in cmpList) {
      var cmp = cmpList[key];

      if (cmp.getState) {
        snap[key] = cmp.getState();
      }
    }

    return snap;
  },
  //单据退回到摸个快照
  rollbackToSnapshot: function rollbackToSnapshot(snap) {
    if (!snap) {
      return;
    }

    for (var key in snap) {
      var state = snap[key];
      var cmp = this.getComponent(key);

      if (cmp) {
        cmp.changeState(state, false);
      }
    }

    (0, _dispatchers["default"])().dispatch((0, _actions.PostChange)());
  },
  doOnLoad: function () {
    var _doOnLoad = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee2() {
      var metaForm, scriptCollection, loadScript, cxt, onLoad, data, doc, oid, _data, _doc, _oid;

      return regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              metaForm = this.metaForm;
              scriptCollection = metaForm.scriptCollection;
              loadScript = scriptCollection["load"];
              cxt = new _YIUIParser.View.Context(this);
              onLoad = this.onLoad;

              if (!(this.getOID() == -1 || this.operationState === _YIUIBase.YIUI.Form_OperationState.New)) {
                _context2.next = 26;
                break;
              }

              _context2.next = 8;
              return _YIUIBase.YIUI.DocService.newDocument(this.getFormKey());

            case 8:
              data = _context2.sent;
              doc = _YIUIBase.YIUI.DataUtil.fromJSONDoc(data);
              oid = this.getOID();
              this.setDocument(doc);
              doc.oid = oid;
              doc.setNew();

              if (!onLoad) {
                _context2.next = 17;
                break;
              }

              _context2.next = 17;
              return this.eval(onLoad, cxt);

            case 17:
              (0, _dispatchers["default"])().dispatch({
                type: 'STOPEVENT'
              });
              _context2.prev = 18;
              _context2.next = 21;
              return this.showDocument();

            case 21:
              _context2.prev = 21;
              (0, _dispatchers["default"])().dispatch({
                type: 'ENABLEEVENT'
              });
              return _context2.finish(21);

            case 24:
              _context2.next = 40;
              break;

            case 26:
              if (this.getDocument()) {
                _context2.next = 34;
                break;
              }

              _context2.next = 29;
              return _YIUIBase.YIUI.DocService.newDocument(this.getFormKey());

            case 29:
              _data = _context2.sent;
              _doc = _YIUIBase.YIUI.DataUtil.fromJSONDoc(_data);
              _oid = this.getOID();
              _doc.oid = _oid;
              this.setDocument(_doc);

            case 34:
              if (!(loadScript && this.getDocument().oid > 0)) {
                _context2.next = 37;
                break;
              }

              _context2.next = 37;
              return this.eval(loadScript, cxt, null);

            case 37:
              if (!onLoad) {
                _context2.next = 40;
                break;
              }

              _context2.next = 40;
              return this.eval(onLoad, cxt);

            case 40:
              this.formLoaded = true;

            case 41:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, this, [[18,, 21, 24]]);
    }));

    function doOnLoad() {
      return _doOnLoad.apply(this, arguments);
    }

    return doOnLoad;
  }(),
  setOptQueue: function setOptQueue(optQueue) {
    this.optQueue = optQueue;
  },
  doOptQueue: function doOptQueue() {
    var optQueue = this.optQueue;

    if (optQueue) {
      return optQueue.doOpt();
    }

    return $.Deferred(function (def) {
      def.resolve(false);
    });
  },
  setOperationEnable: function setOperationEnable(key, enable) {
    if (!this.defaultToolBar) return;
    this.defaultToolBar.setItemEnable(key, enable);
  },
  setOperationVisible: function setOperationVisible(key, visible) {
    if (!this.defaultToolBar) return;
    this.defaultToolBar.setItemVisible(key, visible);
  },
  getMetaComp: function getMetaComp(key) {
    return this.metaComps[key];
  },
  getMetaOpt: function getMetaOpt(key) {
    return this.metaOpts[key];
  },
  getMetaCell: function getMetaCell(key) {
    return this.metaCells[key];
  },
  setOID: function setOID(oid) {
    this.filterMap.setOID(oid);
  },
  getOID: function getOID() {
    var document = this.getDocument();

    if (document) {
      return document.oid;
    } else {
      return this.filterMap.getOID();
    }
  },
  setSysExpVals: function setSysExpVals(key, value) {
    if (!this.sysExpVals) {
      this.sysExpVals = {};
    }

    this.sysExpVals[key] = value;
  },
  getSysExpVals: function getSysExpVals(key) {
    if (this.sysExpVals) {
      return this.sysExpVals[key];
    }

    return null;
  },
  removeSysExpVals: function removeSysExpVals(key) {
    if (this.sysExpVals) {
      delete this.sysExpVals[key];
    }
  },
  isStandalone: function isStandalone() {
    return this.standalone;
  },
  setResult: function setResult(result) {
    this.result = result;
  },
  getResult: function getResult() {
    return this.result;
  },
  getFormAdapt: function getFormAdapt() {
    return this.formAdapt;
  },
  //
  // addOpt: function(tbr, expOpts, optMap) {
  // 	if(!expOpts || !expOpts.items) return;
  // 	var items = expOpts.items;
  //
  //     var metaTbl = tbr.getMetaObj();
  //     var metaItems = metaTbl.metaItems;
  //     $.extend(metaItems, expOpts.metaItems)
  // 	for (var i = 0, len = items.length; i < len; i++) {
  // 	var item = items[i];
  // 	item.formID = expOpts.formID;
  // 	tbr.items.push(item);
  // 	optMap[item.key] = {
  // 		barKey: this.defTbr,
  // 		opt: item
  // 	};
  // }
  // this.cFormID = expOpts.formID;
  // this.hasMerge = true;
  // },
  //
  // delOpt: function(tbr, expOpts, optMap) {
  // 	var items = expOpts.items;
  // var len = items.length;
  // var len2 = tbr.items.length;
  // tbr.items.splice(len2 - len, len);
  //
  //     var metaTbl = tbr.getMetaObj();
  //     var metaItems = metaTbl.metaItems;
  //
  // this.hasMerge = false;
  // for (var i = 0, len = items.length; i < len; i++) {
  // 	var item = items[i];
  // 	delete optMap[item.key];
  //        delete metaItems[item.key];
  // }
  // },
  getOptMap: function getOptMap() {
    return this.formAdapt.getOptMap(); // var expOpts = this.expOpts;
    // if(this.mergeOpt) {
    // 	if(this.cFormID) {
    // 		var cFormID = expOpts.formID;
    // 	var cForm = YIUI.FormStack.getForm(cFormID);
    // 	this.delOpt(this.defaultToolBar, expOpts, optMap);
    // 		if(!cForm) {
    // 		this.cFormID = null;
    // 		} else {
    // 		expOpts.formID = cForm.formID;
    // 		this.addOpt(this.defaultToolBar, expOpts, optMap);
    // 		}
    // 	} else if(!this.hasMerge) {
    // 	this.addOpt(this.defaultToolBar, expOpts, optMap);
    // 	}
    // }
    // return optMap;
  },
  setError: function setError(error, errorMsg, errorSource) {
    this.errorInfo = {
      error: error,
      errorMsg: errorMsg,
      errorSource: errorSource
    };

    if (error) {
      this.showErrMsg(errorMsg);
    } else {
      this.hideErrMsg();
    }
  },
  getCellSubDtlComps: function getCellSubDtlComps(gridKey, cellKey) {
    var map = this.formAdapt.getCellSubDtlCompMap();
    if (map == null) return null;
    var gridMap = map[gridKey];
    if (gridMap == null) return null;
    return gridMap[cellKey];
  },
  getGridInfoMap: function getGridInfoMap() {
    return this.formAdapt.getGridMap();
  },
  getGridInfoByTableKey: function getGridInfoByTableKey(tableKey) {
    var gridMap = this.getGridInfoMap(),
        grid;

    for (var i = 0, len = gridMap.length; i < len; i++) {
      grid = gridMap[i];

      if (grid.tableKey == tableKey) {
        return grid;
      }
    }
  },
  getGridInfoByKey: function getGridInfoByKey(key) {
    var gridMap = this.getGridInfoMap(),
        grid;

    for (var i = 0, len = gridMap.length; i < len; i++) {
      grid = gridMap[i];

      if (grid.key == key) {
        return grid;
      }
    }
  },
  getListView: function getListView(arg) {
    return this.formAdapt.getListView(arg);
  },
  setDefaultToolBar: function setDefaultToolBar(toolBar) {
    this.defaultToolBar = toolBar;
  },
  getComponentList: function getComponentList() {
    return this.formAdapt.getCompList();
  },
  getComponent: function getComponent(comKey) {
    return this.formAdapt.getComp(comKey);
  },
  getCompByDataBinding: function getCompByDataBinding(tableKey, columnKey) {
    var compList = this.formAdapt.compList,
        com;

    for (var key in compList) {
      com = compList[key];
      if (com.tableKey === tableKey && com.columnKey === columnKey) return com;
    }

    return null;
  },
  getPanel: function getPanel(key) {
    return this.formAdapt.getPanel(key);
  },
  setFormKey: function setFormKey(formKey) {
    this.formKey = formKey;
  },
  getFormKey: function getFormKey() {
    return this.formKey;
  },
  setCaption: function setCaption(caption) {
    this.caption = caption;
  }
}, _defineProperty(_YIUI$extend, "getCaption", function getCaption() {
  return this.caption;
}), _defineProperty(_YIUI$extend, "getDataObjectKey", function getDataObjectKey() {
  return this.dataObjectKey;
}), _defineProperty(_YIUI$extend, "getDataObject", function getDataObject() {
  return this.metaForm.dataObject;
}), _defineProperty(_YIUI$extend, "getRoot", function getRoot() {
  return this.formAdapt.getRoot();
}), _defineProperty(_YIUI$extend, "setDocument", function setDocument(document) {
  this.documentNotShow = true;
  this.document = document;

  if (document) {
    this.setSysExpVals(_YIUIBase.YIUI.BPMConstants.WORKITEM_INFO, document.getExpData(_YIUIBase.YIUI.BPMKeys.WORKITEM_INFO));
  } else {
    this.removeSysExpVals(_YIUIBase.YIUI.BPMConstants.WORKITEM_INFO);
  }
}), _defineProperty(_YIUI$extend, "getDocument", function getDocument() {
  return this.document;
}), _defineProperty(_YIUI$extend, "showDocument", function () {
  var _showDocument = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee3(commitValue) {
    var showData, cxt;
    return regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            if (!(this.isShowing || !this.documentNotShow)) {
              _context3.next = 2;
              break;
            }

            return _context3.abrupt("return");

          case 2:
            this.isShowing = true;
            _context3.prev = 3;
            _context3.next = 6;
            return this.reloadFormRights();

          case 6:
            showData = new _YIUIBase.YIUI.ShowData(this);
            _context3.next = 9;
            return showData.show(commitValue);

          case 9:
            if (!this.postShow) {
              _context3.next = 13;
              break;
            }

            cxt = {
              form: this
            };
            _context3.next = 13;
            return this.eval(this.postShow, cxt);

          case 13:
            _context3.prev = 13;
            this.documentNotShow = false;
            this.isShowing = false;
            return _context3.finish(13);

          case 17:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3, this, [[3,, 13, 17]]);
  }));

  function showDocument(_x3) {
    return _showDocument.apply(this, arguments);
  }

  return showDocument;
}()), _defineProperty(_YIUI$extend, "reloadFormRights", function () {
  var _reloadFormRights = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee4() {
    var info, workitemID, formKey, params, rights;
    return regeneratorRuntime.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            info = this.getSysExpVals(_YIUIBase.YIUI.BPMKeys.WORKITEM_INFO);
            workitemID = -1;

            if (info) {
              workitemID = info.WorkitemID;
            }

            formKey = this.metaForm.formKey;
            params = {
              formKey: formKey,
              OID: this.getOID(),
              workitemID: workitemID,
              parameters: this.getParas().toJSON()
            };
            _context4.next = 7;
            return _YIUIBase.YIUI.RightsService.loadFormRights(formKey, params);

          case 7:
            rights = _context4.sent;
            this.setFormRights(rights);

          case 9:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4, this);
  }));

  function reloadFormRights() {
    return _reloadFormRights.apply(this, arguments);
  }

  return reloadFormRights;
}()), _defineProperty(_YIUI$extend, "setWillShow", function setWillShow(show) {
  this.show = show;
}), _defineProperty(_YIUI$extend, "willShow", function willShow() {
  return this.show;
}), _defineProperty(_YIUI$extend, "setShowing", function setShowing(showing) {
  this.showing = showing;
}), _defineProperty(_YIUI$extend, "showing", function showing() {
  return this.showing();
}), _defineProperty(_YIUI$extend, "setComponentValue", function () {
  var _setComponentValue = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee5(key, value, fireEvent) {
    return regeneratorRuntime.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            _context5.next = 2;
            return this.formAdapt.setCompValue(key, value, fireEvent);

          case 2:
          case "end":
            return _context5.stop();
        }
      }
    }, _callee5, this);
  }));

  function setComponentValue(_x4, _x5, _x6) {
    return _setComponentValue.apply(this, arguments);
  }

  return setComponentValue;
}()), _defineProperty(_YIUI$extend, "setCellValByIndex", function setCellValByIndex(key, rowIndex, colIndex, value, fireEvent) {
  this.formAdapt.setCellValByIndex(key, rowIndex, colIndex, value, fireEvent);
}), _defineProperty(_YIUI$extend, "getCellValByIndex", function getCellValByIndex(key, rowIndex, colIndex) {
  return this.formAdapt.getCellValByIndex(key, rowIndex, colIndex);
}), _defineProperty(_YIUI$extend, "setCellValByKey", function setCellValByKey(key, rowIndex, colKey, value, fireEvent) {
  this.formAdapt.setCellValByKey(key, rowIndex, colKey, value, fireEvent);
}), _defineProperty(_YIUI$extend, "getCellValByKey", function getCellValByKey(key, rowIndex, colKey) {
  return this.formAdapt.getCellValByKey(key, rowIndex, colKey);
}), _defineProperty(_YIUI$extend, "getValueFromDocument", function getValueFromDocument(tableKey, columnKey) {
  var table = this.document.getByKey(tableKey);

  if (table) {
    return table.getByKey(columnKey);
  }

  return null;
}), _defineProperty(_YIUI$extend, "getValue", function getValue(key) {
  var com = this.getComponent(key);
  var cellLocation = this.getCellLocation(key);
  var row,
      column,
      value = null;

  if (cellLocation) {
    com = this.getComponent(cellLocation.key);

    switch (com.getMetaObj().type) {
      case _YIUIBase.YIUI.CONTROLTYPE.GRID:
        row = cellLocation.row;

        if (row == null || row == -1) {
          row = com.getFocusRowIndex();
        }

        value = com.getValueAt(row, cellLocation.column);
        break;

      case _YIUIBase.YIUI.CONTROLTYPE.LISTVIEW:
        row = com.getFocusRowIndex();
        value = com.getValue(row, cellLocation.column);
        break;

      case _YIUIBase.YIUI.CONTROLTYPE.TABLEVIEW:
        value = this.getValueFromDocument(cellLocation.tableKey, cellLocation.columnKey);
        break;
    }
  } else {
    // 直接写表格key,取焦点行列值
    com = this.getComponent(key);

    if (!com) {
      return null;
    }

    switch (com.getMetaObj().type) {
      case _YIUIBase.YIUI.CONTROLTYPE.GRID:
        var row = com.getFocusRowIndex(),
            column = com.getFocusColIndex();

        if (row != -1 && column != -1) {
          value = com.getValueAt(row, column);
        }

        break;

      default:
        value = com.getValue();
        break;
    }
  }

  return value;
}), _defineProperty(_YIUI$extend, "getCellLocation", function getCellLocation(key) {
  return this.formAdapt.getCellLocation(key);
}), _defineProperty(_YIUI$extend, "getColumnInfo", function getColumnInfo(key) {
  return this.formAdapt.getColumnInfo(key);
}), _defineProperty(_YIUI$extend, "setFilterMap", function setFilterMap(filterMap) {
  this.filterMap = filterMap;
}), _defineProperty(_YIUI$extend, "getFilterMap", function getFilterMap() {
  return this.filterMap;
}), _defineProperty(_YIUI$extend, "getMainTableKey", function getMainTableKey() {
  return this.mainTableKey;
}), _defineProperty(_YIUI$extend, "setCondParas", function setCondParas(conParas) {
  this.conParas = conParas;
}), _defineProperty(_YIUI$extend, "getCondParas", function getCondParas() {
  return this.conParas == null ? {} : this.conParas;
}), _defineProperty(_YIUI$extend, "setInitOperationState", function setInitOperationState(initOperationState) {
  this.initOperationState = initOperationState;
}), _defineProperty(_YIUI$extend, "getInitOperationState", function getInitOperationState() {
  return this.initOperationState;
}), _defineProperty(_YIUI$extend, "setOperationState", function setOperationState(operationState) {
  this.operationState = operationState;
}), _defineProperty(_YIUI$extend, "getOperationState", function getOperationState() {
  return this.operationState;
}), _defineProperty(_YIUI$extend, "resetUIStatus", function () {
  var _resetUIStatus = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee6(mask) {
    return regeneratorRuntime.wrap(function _callee6$(_context6) {
      while (1) {
        switch (_context6.prev = _context6.next) {
          case 0:
            _context6.next = 2;
            return this.getUIProcess().resetUIStatus(mask);

          case 2:
          case "end":
            return _context6.stop();
        }
      }
    }, _callee6, this);
  }));

  function resetUIStatus(_x7) {
    return _resetUIStatus.apply(this, arguments);
  }

  return resetUIStatus;
}()), _defineProperty(_YIUI$extend, "getUIProcess", function getUIProcess() {
  return this.viewDataMonitor.getUIProcess();
}), _defineProperty(_YIUI$extend, "getViewDataMonitor", function getViewDataMonitor() {
  return this.viewDataMonitor;
}), _defineProperty(_YIUI$extend, "setDefContainer", function setDefContainer(defContainer) {
  this.formAdapt.setDefContainer(defContainer);
}), _defineProperty(_YIUI$extend, "getDefContainer", function getDefContainer() {
  return this.formAdapt.getDefContainer(this.defCtKey);
}), _defineProperty(_YIUI$extend, "setContainer", function setContainer(container) {
  var self = this;
  this.formAdapt.setContainer(container); //        self.initFirstFocus();
}), _defineProperty(_YIUI$extend, "render", function render() {// var ct = this.getContainer();
  // if(ct) {
  // 	ct.renderDom(this);
  //     if(this.defCtKey) {
  //     	var ct = this.getComponent(this.defCtKey);
  //     	ct && this.setDefContainer(ct);
  //     }
  //     this.rendered = true;
  //     var errDiv = $('<div class="errorinfo"><label/><span class="closeIcon"></span></div>');
  //     errDiv.prependTo(this.getRoot().el);
  //     this.setErrDiv(errDiv);
  // }
}), _defineProperty(_YIUI$extend, "getContainer", function getContainer() {// return this.formAdapt.getContainer();
}), _defineProperty(_YIUI$extend, "newCxt", function newCxt() {
  var cxt = new _YIUIParser.View.Context(this);
  return cxt;
}), _defineProperty(_YIUI$extend, "getRelations", function getRelations() {
  return this.dependency.relations;
}), _defineProperty(_YIUI$extend, "setPara", function setPara(key, value) {
  this.paras.put(key, value);
}), _defineProperty(_YIUI$extend, "hasRelation", function hasRelation(key) {
  for (var relations in this.dependency.relationTree) {
    if (relations.includes(key)) {
      return true;
    }
  }

  return false;
}), _defineProperty(_YIUI$extend, "getPara", function getPara(key) {
  return this.paras != null ? this.paras.get(key) : null;
}), _defineProperty(_YIUI$extend, "setCallPara", function setCallPara(key, value) {
  this.callParas.put(key, value);
}), _defineProperty(_YIUI$extend, "getCallPara", function getCallPara(key) {
  return this.callParas.get(key);
}), _defineProperty(_YIUI$extend, "getParaCollection", function getParaCollection() {
  return this.paraCollection;
}), _defineProperty(_YIUI$extend, "getParas", function getParas() {
  if (this.paras == undefined) {
    this.paras = {};
  }

  return this.paras;
}), _defineProperty(_YIUI$extend, "getCallParas", function getCallParas() {
  if (this.callParas == undefined) {
    this.callParas = {};
  }

  return this.callParas;
}), _defineProperty(_YIUI$extend, "getUIProcess", function getUIProcess() {
  return this.viewDataMonitor.getUIProcess();
}), _defineProperty(_YIUI$extend, "refreshParas", function () {
  var _refreshParas = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee7() {
    return regeneratorRuntime.wrap(function _callee7$(_context7) {
      while (1) {
        switch (_context7.prev = _context7.next) {
          case 0:
            _context7.next = 2;
            return this.getUIProcess().refreshParas();

          case 2:
            return _context7.abrupt("return", _context7.sent);

          case 3:
          case "end":
            return _context7.stop();
        }
      }
    }, _callee7, this);
  }));

  function refreshParas() {
    return _refreshParas.apply(this, arguments);
  }

  return refreshParas;
}()), _defineProperty(_YIUI$extend, "setErrDiv", function setErrDiv(errDiv) {// this.errDiv = errDiv;
  // var self = this;
  // setTimeout(function () {
  //     if (!self.isDestroyed) {
  //         self.setError(self.errorInfo.error, self.errorInfo.errorMsg, self.errorInfo.errorSource);
  //     }
  // }, 0);
}), _defineProperty(_YIUI$extend, "showErrMsg", function showErrMsg(msg) {// if (!this.errDiv || this.errDiv.css("display") == "block") return;
  // $("label", this.errDiv).text(msg);
  // this.errDiv.show();
  // var newH = this.getRoot().getHeight() - this.errDiv.height();
  // var newW = this.getRoot().getWidth();
  // this.getRoot().doLayout(newW, newH);
}), _defineProperty(_YIUI$extend, "hideErrMsg", function hideErrMsg() {// if (!this.errDiv || this.errDiv.css("display") == "none") return;
  // this.errDiv.hide();
  // var newH = this.getRoot().getHeight();
  // var newW = this.getRoot().getWidth();
  // this.getRoot().doLayout(newW, newH);
}), _defineProperty(_YIUI$extend, "reloadTable", function reloadTable(key) {
  var document = this.getDocument();
  var filterMap = this.getFilterMap();
  filterMap.setType(_YIUIBase.YIUI.DocumentType.DETAIL);
  var condParas = this.getCondParas();
  var paras = {};
  paras.service = "PureOpt";
  paras.cmd = "ReloadTable";
  paras.tableKey = key;
  paras.formKey = this.formKey;
  paras.filterMap = $.toJSON(filterMap);
  paras.condParas = $.toJSON(condParas);
  var table = Svr.Request.getSyncData(Svr.SvrMgr.ServletURL, paras);

  if (table) {
    document.remove(key);
    document.add(key, table);
  }
}), _defineProperty(_YIUI$extend, "initFirstFocus", function initFirstFocus() {// var size = this.formAdapt.getOrderList().length;
  // this.focusManager.focusNextNode(0,size);
}), _defineProperty(_YIUI$extend, "getParentForm", function getParentForm() {
  return _YIUIBase.YIUI.FormStack.getForm(this.pFormID);
}), _defineProperty(_YIUI$extend, "fireClose", function fireClose() {
  if (this.type != _YIUIBase.YIUI.Form_Type.Entity) {
    this.close();
    return true;
  }

  if (this.operationState == _YIUIBase.YIUI.Form_OperationState.Default || this.operationState == _YIUIBase.YIUI.Form_OperationState.Delete) {
    this.close();
    return true;
  } // var options = {
  //     msg: YIUI.I18N.form.closeInterface,
  //     msgType: YIUI.Dialog_MsgType.YES_NO
  // };
  // var dialog = new YIUI.Control.Dialog(options);
  // dialog.render();
  // var $form = this;
  // dialog.regEvent(YIUI.Dialog_Btn.STR_YES, function () {
  //     $form.close();
  // });
  // dialog.regEvent(YIUI.Dialog_Btn.STR_NO, function () {
  // });

}), _defineProperty(_YIUI$extend, "onChildClose", function onChildClose(child) {}), _defineProperty(_YIUI$extend, "close", function () {
  var _close = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee8() {
    var onClose;
    return regeneratorRuntime.wrap(function _callee8$(_context8) {
      while (1) {
        switch (_context8.prev = _context8.next) {
          case 0:
            onClose = this.onClose;

            if (!onClose) {
              _context8.next = 4;
              break;
            }

            _context8.next = 4;
            return this.eval(onClose);

          case 4:
          case "end":
            return _context8.stop();
        }
      }
    }, _callee8, this);
  }));

  function close() {
    return _close.apply(this, arguments);
  }

  return close;
}()), _defineProperty(_YIUI$extend, "evalFormula", function () {
  var _evalFormula = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee9(formula, context, callback) {
    var noCache,
        rowIndex,
        _args9 = arguments;
    return regeneratorRuntime.wrap(function _callee9$(_context9) {
      while (1) {
        switch (_context9.prev = _context9.next) {
          case 0:
            noCache = _args9.length > 3 && _args9[3] !== undefined ? _args9[3] : false;

            if (!(typeof formula != 'string')) {
              _context9.next = 3;
              break;
            }

            return _context9.abrupt("return", formula);

          case 3:
            rowIndex = context ? context.rowIndex : null;

            if (rowIndex != this.formulaRowIndex) {
              console.log("change context rowIndex=".concat(context.rowIndex));
              this.formulaRowIndex = context.rowIndex;
              this.clearFormulaCache();
            }

            _context9.next = 7;
            return this.formulaCache.get(formula, noCache);

          case 7:
            return _context9.abrupt("return", _context9.sent);

          case 8:
          case "end":
            return _context9.stop();
        }
      }
    }, _callee9, this);
  }));

  function evalFormula(_x8, _x9, _x10) {
    return _evalFormula.apply(this, arguments);
  }

  return evalFormula;
}()), _defineProperty(_YIUI$extend, "eval", function () {
  var _eval2 = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee10(formula, context, callback) {
    var result;
    return regeneratorRuntime.wrap(function _callee10$(_context10) {
      while (1) {
        switch (_context10.prev = _context10.next) {
          case 0:
            if (!formula) {
              _context10.next = 10;
              break;
            }

            if (!this.parser) {
              _context10.next = 9;
              break;
            }

            // console.log(formula);
            if (!context) {
              context = new _YIUIParser.View.Context(this);
            }

            _context10.next = 5;
            return this.parser.eval(formula, context, callback);

          case 5:
            result = _context10.sent;
            return _context10.abrupt("return", result);

          case 9:
            console.error('form is destroyed ' + formula + '  formKey' + this.formKey);

          case 10:
            return _context10.abrupt("return", null);

          case 11:
          case "end":
            return _context10.stop();
        }
      }
    }, _callee10, this);
  }));

  function _eval(_x11, _x12, _x13) {
    return _eval2.apply(this, arguments);
  }

  return _eval;
}()), _defineProperty(_YIUI$extend, "eval2", function () {
  var _eval3 = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee11(formula, syntaxTree, evalContext, scope) {
    return regeneratorRuntime.wrap(function _callee11$(_context11) {
      while (1) {
        switch (_context11.prev = _context11.next) {
          case 0:
            if (!formula) {
              _context11.next = 4;
              break;
            }

            _context11.next = 3;
            return this.parser.eval2(formula, syntaxTree, evalContext, scope);

          case 3:
            return _context11.abrupt("return", _context11.sent);

          case 4:
            return _context11.abrupt("return", null);

          case 5:
          case "end":
            return _context11.stop();
        }
      }
    }, _callee11, this);
  }));

  function eval2(_x14, _x15, _x16, _x17) {
    return _eval3.apply(this, arguments);
  }

  return eval2;
}()), _defineProperty(_YIUI$extend, "evalByTree", function () {
  var _evalByTree = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee12(tree, context, callback) {
    return regeneratorRuntime.wrap(function _callee12$(_context12) {
      while (1) {
        switch (_context12.prev = _context12.next) {
          case 0:
            if (!(tree !== null && tree !== undefined)) {
              _context12.next = 4;
              break;
            }

            _context12.next = 3;
            return this.parser.evalByTree(tree, context, callback);

          case 3:
            return _context12.abrupt("return", _context12.sent);

          case 4:
            return _context12.abrupt("return", null);

          case 5:
          case "end":
            return _context12.stop();
        }
      }
    }, _callee12, this);
  }));

  function evalByTree(_x18, _x19, _x20) {
    return _evalByTree.apply(this, arguments);
  }

  return evalByTree;
}()), _defineProperty(_YIUI$extend, "getSyntaxTree", function getSyntaxTree(script) {
  if (script.length == 0) {
    return null;
  } else {
    return this.parser.getSyntaxTree(script);
  }
}), _defineProperty(_YIUI$extend, "toJSON", function toJSON() {
  var json = {};
  var jsonArr = this.formAdapt.toJSON();
  json.key = this.formKey;
  json.items = jsonArr;
  json.filterMap = this.getFilterMap();
  json.condParas = this.getCondParas();
  json.operationState = this.operationState;
  return $.toJSON(json);
}), _defineProperty(_YIUI$extend, "destroy", function destroy() {
  this.uiProcess = null;
  this.parser = null;
  this.document = null;
  this.dependency = null;
  this.isDestroyed = true; // YIUI.Print.del(this.formID);
}), _defineProperty(_YIUI$extend, "regEvent", function regEvent(key, callback) {
  if (!this.eventList) {
    this.eventList = {};
  }

  this.eventList[key] = callback;
}), _defineProperty(_YIUI$extend, "getEvent", function getEvent(key) {
  var event = null;

  if (this.eventList) {
    event = this.eventList[key];
  }

  return event;
}), _defineProperty(_YIUI$extend, "removeEvent", function removeEvent(key) {
  if (this.eventList) {
    delete this.eventList[key];
  }
}), _defineProperty(_YIUI$extend, "getTabCompList", function getTabCompList() {
  return this.formAdapt.getOrderList();
}), _defineProperty(_YIUI$extend, "getFocusManager", function getFocusManager() {
  return this.focusManager;
}), _defineProperty(_YIUI$extend, "dealTabOrder", function dealTabOrder() {// var orderList = this.formAdapt.getOrderList(),com;
  // orderList.sort(function (comp1, comp2) {
  //     return comp1.tabOrder - comp2.tabOrder;
  // });
  // orderList = orderList.concat(this.formAdapt.getUnOrderList());
  // for (var i = 0, len = orderList.length; i < len; i++) {
  //     orderList[i].setTabIndex(i);
  // }
  // this.formAdapt.orderList = orderList;
  // this.formAdapt.unOrderList = null;
}), _defineProperty(_YIUI$extend, "setFormRights", function setFormRights(rights) {
  this.formRights = rights;
}), _defineProperty(_YIUI$extend, "getFormRights", function getFormRights() {
  return this.formRights || null;
}), _defineProperty(_YIUI$extend, "setValueToDocument", function setValueToDocument(control, dataTable, columnKey, bookmark, newValue) {
  if (dataTable.indexByKey(columnKey) == -1) return;
  var type = control.type;
  var dataType = dataTable.cols[dataTable.indexByKey(columnKey)].type;
  bookmark == -1 ? dataTable.first() : dataTable.setByBkmk(bookmark);

  if (newValue == undefined || newValue == null) {
    newValue = this.convertValue(newValue, dataType);
    dataTable.setByKey(columnKey, newValue);
  } else {
    switch (type) {
      case _YIUIBase.YIUI.CONTROLTYPE.DICT:
      case _YIUIBase.YIUI.CONTROLTYPE.DYNAMICDICT:
      case _YIUIBase.YIUI.CONTROLTYPE.COMPDICT:
        if (control.multiSelect) {
          if (newValue.length > 0) {
            var str = '';

            for (var i = 0; i < newValue.length; i++) {
              str += ',' + newValue[i].oid;
            }

            str = str.substring(1);
            dataTable.setByKey(columnKey, str); // if (type == YIUI.CONTROLTYPE.DYNAMICDICT || type == YIUI.CONTROLTYPE.COMPDICT) {
            //     dataTable.setByKey(columnKey + 'ItemKey', newValue[0].itemKey);
            // }
          }
        } else {
          dataTable.setByKey(columnKey, newValue); // if (type == YIUI.CONTROLTYPE.DYNAMICDICT || type == YIUI.CONTROLTYPE.COMPDICT) {
          //     dataTable.setByKey(columnKey + 'ItemKey', newValue.itemKey);
          // }
        }

        break;
      // case YIUI.CONTROLTYPE.DATEPICKER:
      //     if (newValue instanceof Date) {
      //         newValue = newValue.getTime();
      //     } else {
      //         newValue = new Date(newValue).getTime();
      //     }
      //     dataTable.setByKey(columnKey, newValue);
      //     break;

      default:
        newValue = this.convertValue(newValue, dataType);
        dataTable.setByKey(columnKey, newValue);
    }
  }
}), _defineProperty(_YIUI$extend, "clearFormulaCache", function clearFormulaCache() {
  this.formulaCache.clear();
}), _defineProperty(_YIUI$extend, "doValueChanged", function () {
  var _doValueChanged = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee13(control, newValue, commitValue, fireEvent) {
    var form, columnKey, tableKey, dataTable, document, cellKey, grid, row, colIndex, rowIndex;
    return regeneratorRuntime.wrap(function _callee13$(_context13) {
      while (1) {
        switch (_context13.prev = _context13.next) {
          case 0:
            form = this, columnKey = control.columnKey, tableKey = control.tableKey, document = form.getDocument();
            this.formulaCache.clear();

            if (commitValue && document) {
              if (tableKey) {
                dataTable = document.getByKey(tableKey);
              } // 子明细设置值


              if (control.isSubDetail) {
                cellKey = control.bindingCellKey;
                grid = form.getComponent(control.parentGridKey), rowIndex = grid == null ? -1 : grid.getFocusRowIndex();

                if (isNaN(rowIndex) || rowIndex == -1) {
                  rowIndex = grid.getLastDetailRowIndex();

                  if (rowIndex != -1) {
                    grid.setFocusRowIndex(rowIndex);
                    grid.setCellFocus(rowIndex, grid.getCellIndexByKey(cellKey));
                  }
                }

                if (rowIndex >= 0) {
                  if (cellKey) {
                    //  绑定单元格
                    colIndex = grid.getCellIndexByKey(cellKey);

                    if (colIndex !== -1) {
                      grid.setValueAt(rowIndex, colIndex, newValue, true, fireEvent);
                    }
                  } else {
                    // 自有数据绑定
                    row = grid.dataModel.data[rowIndex];

                    if (row.isDetail && row.bookmark !== undefined) {
                      if (dataTable) {
                        if (dataTable.tableMode == _YIUIBase.YIUI.TableMode.HEAD) {
                          this.setValueToDocument(control, dataTable, columnKey, -1, newValue);
                        } else {
                          this.setValueToDocument(control, dataTable, columnKey, row.bookmark, newValue);
                        }
                      }
                    }
                  }
                }
              } else {
                if (dataTable) {
                  this.setValueToDocument(control, dataTable, columnKey, -1, newValue);
                }
              }
            } // 触发事件之前需要做的事


            _context13.next = 5;
            return form.getViewDataMonitor().preFireValueChanged(control);

          case 5:
            if (!fireEvent) {
              _context13.next = 8;
              break;
            }

            _context13.next = 8;
            return form.getViewDataMonitor().fireValueChanged(control);

          case 8:
            _context13.next = 10;
            return form.getViewDataMonitor().postFireValueChanged(control);

          case 10:
          case "end":
            return _context13.stop();
        }
      }
    }, _callee13, this);
  }));

  function doValueChanged(_x21, _x22, _x23, _x24) {
    return _doValueChanged.apply(this, arguments);
  }

  return doValueChanged;
}()), _YIUI$extend));

exports["default"] = _default;

var MetaForm = _YIUIBase.YIUI.MetaForm = _YIUIBase.YIUI.extend({
  init: function init(jsonObj) {
    this.operationState = jsonObj["operationState"] ? jsonObj["operationState"] : _YIUIBase.YIUI.Form_OperationState.Default;
    this.initState = jsonObj["initState"] || _YIUIBase.YIUI.Form_OperationState.Default;
    this.type = jsonObj["type"] || _YIUIBase.YIUI.Form_Type.Normal;
    this.operations = jsonObj["operations"];
    this.metaOpts = jsonObj["metaOpts"];
    this.defTbr = jsonObj["defTbr"];
    this.formKey = jsonObj["key"];
    this.caption = jsonObj["caption"];
    this.abbrCaption = jsonObj["abbrCaption"];
    this.formulaCaption = jsonObj["formulaCaption"];
    this.formulaAbbrCaption = jsonObj["formulaAbbrCaption"];
    this.target = jsonObj["target"];
    this.mainTableKey = jsonObj["mainTableKey"];
    this.onLoad = jsonObj["onLoad"];
    this.onClose = jsonObj["onClose"];
    this.scriptCollection = jsonObj["scriptCollection"];
    this.cellTypeGroup = jsonObj["cellTypeGroup"];
    var body = jsonObj["body"];
    var indexOfblock = body["index_of_block"];
    var block = body["items"][indexOfblock];
    var root = block["root"];
    root.topMargin = jsonObj["topMargin"];
    root.bottomMargin = jsonObj["bottomMargin"];
    root.leftMargin = jsonObj["leftMargin"];
    root.rightMargin = jsonObj["rightMargin"];
    root.abbrCaption = jsonObj["abbrCaption"];
    root.hAlign = jsonObj["hAlign"];
    root.height = "100%";
    this.root = root;
    this.authenticate = jsonObj["authenticate"];
    this.standalone = jsonObj["standalone"] || false;
    this.relations = jsonObj["relations"];
    this.macroMap = jsonObj["macroMap"];
    this.statusItems = jsonObj["statusItems"];
    this.paraGroups = jsonObj["paraGroups"];
    this.sysExpVals = jsonObj["sysExpVals"];
    this.dependency = jsonObj["dependency"];
    this.paras = new _YIUIBase.YIUI.Paras(jsonObj["parameters"]);
    this.callParas = new _YIUIBase.YIUI.Paras(jsonObj["callParameters"]);
    this.paraCollection = jsonObj["paraCollection"];
    this.checkRules = jsonObj["checkRules"];
    this.subDetailInfo = jsonObj["subDetailInfo"];
    this.mapGrids = jsonObj["mapGrids"];
    this.errorInfo = {
      error: jsonObj["isError"],
      errorMsg: jsonObj["errorMsg"],
      errorSource: jsonObj["errorSource"]
    };
    this.dataObject = jsonObj["dataObject"] || {};
    this.dataObjectKey = this.dataObject.key || null; //this.refObjectKey = jsonObj["refObjectKey"] || null;
    //this.refTableKey = jsonObj["refTableKey"] || null;

    this.postShow = jsonObj["postShow"] || null;
    this.timerTask = jsonObj["timerTask"];
    this.metaComps = jsonObj["metaComps"] || {};
    this.metaCells = jsonObj["metaCells"] || {};
    this.buddyKeys = jsonObj["buddyKeys"] || [];
    this.popWidth = jsonObj["popWidth"];
    this.popHeight = jsonObj["popHeight"];
    this.topMargin = jsonObj["topMargin"];
    this.bottomMargin = jsonObj["bottomMargin"];
    this.leftMargin = jsonObj["leftMargin"];
    this.rightMargin = jsonObj["rightMargin"];
    this.templateKey = jsonObj["templateKey"];
  },
  getComponent: function getComponent(key) {
    return this.metaComps[key];
  }
});

exports.MetaForm = MetaForm;