"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _YIUIBase = require("./YIUI-base");

require("./YIUI-common");

require("./YIUI-parser");

require("./YIUI-svr");

require("./yes-ui");

var _yesCommon = require("yes-common");

require("./component/componentmgr");

require("./utils/gridlookuputil");

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var _default = _YIUIBase.YIUI.FormAdapt = function (options) {
  var Return = {
    form: null,
    compList: {},
    orderList: [],
    unOrderList: [],
    cellMap: {},
    columnMap: {},
    gridMap: [],
    cellSubDtlCompMap: {},
    LVMap: [],
    panelMap: [],
    optMap: {},
    radioMap: {},
    rootPanel: null,
    metaComps: {},
    metaCells: {},
    init: function init(rootObj) {
      if (!rootObj) return;
      this.formID = this.form.formID;
      this.metaComps = this.form.metaComps;
      this.metaCells = this.form.metaCells;
      this.rootPanel = _YIUIBase.YIUI.create(rootObj);
    },
    load: function load() {
      var _this = this;

      var loadComp = function loadComp(array, parentCom) {
        parentCom.ofFormID = _this.formID;
        parentCom.id = parentCom.ofFormID + "_" + parentCom.key;

        if (parentCom.type == _YIUIBase.YIUI.CONTROLTYPE.LISTVIEW) {
          _this.loadListViewMap(parentCom);

          _YIUIBase.YIUI.GridLookupUtil.buildCellLookup(_this.form, parentCom);
        } else if (parentCom.type == _YIUIBase.YIUI.CONTROLTYPE.GRID) {
          _this.loadGridMap(parentCom);

          _YIUIBase.YIUI.GridLookupUtil.buildCellLookup(_this.form, parentCom);
        } else if (parentCom.type === _YIUIBase.YIUI.CONTROLTYPE.TABLEVIEW) {
          _YIUIBase.YIUI.GridLookupUtil.buildCellLookup(_this.form, parentCom);
        } else if (parentCom.type == _YIUIBase.YIUI.CONTROLTYPE.RADIOBUTTON) {
          _this.radioMap[parentCom.metaObj.groupKey || ''] = _this.radioMap[parentCom.metaObj.groupKey || ''] || [];

          _this.radioMap[parentCom.metaObj.groupKey || ''].push(parentCom);
        } else if (parentCom.type == _YIUIBase.YIUI.CONTROLTYPE.CONTAINER) {
          if (parentCom.mergeOperation) {
            _this.form.mergeOptContainer = parentCom.key;
          }

          if (parentCom.isDefault) {
            _this.form.defCtKey = parentCom.key;
          }
        }

        if (parentCom.items && parentCom instanceof _YIUIBase.YIUI.Panel) {
          _this.panelMap[parentCom.key] = parentCom;

          for (var i = 0; i < parentCom.items.length; i++) {
            loadComp(array, parentCom.items[i]);
          }
        } else {
          if (parentCom.type == _YIUIBase.YIUI.CONTROLTYPE.TOOLBAR) {
            if (parentCom.isDefault) {
              _this.form.defaultToolBar = parentCom;

              _this.loadOptMap(_this.optMap, _this.form.operations, parentCom.key);
            }
          }
        }

        array[parentCom.key] = parentCom;
        parentCom.setFocusManager(_this.focusManager);

        if (parentCom.receiveFocus) {
          if (_yesCommon.lodash.isNumeric(parentCom.tabOrder) && parentCom.tabOrder != -1) {
            _this.orderList.push(parentCom); // tabOrder不为-1的

          } else {
            _this.unOrderList.push(parentCom); // tabOrder为-1的

          }
        }

        _this.metaComps[parentCom.key] = parentCom.getMetaObj();
        var cellKey = parentCom.bindingCellKey;
        var p_gridKey = parentCom.parentGridKey;

        if (cellKey != null && p_gridKey != null) {
          var gridMap = _this.cellSubDtlCompMap[p_gridKey];

          if (gridMap == null) {
            gridMap = {};
            _this.cellSubDtlCompMap[p_gridKey] = gridMap;
          }

          if (gridMap[cellKey] == null) {
            gridMap[cellKey] = [];
          }

          gridMap[cellKey].push(parentCom);
        }
      };

      loadComp(_this.compList, _this.rootPanel);
    },
    loadOptMap: function loadOptMap(optMap, operations, defTbr) {
      for (var i = 0, item, len = operations.length; i < len; i++) {
        item = operations[i];
        optMap[item.key] = {
          barKey: defTbr,
          opt: item
        };

        if (item.items) {
          for (var j = 0, subItem, jlen = item.items.length; j < jlen; j++) {
            subItem = item.items[j];
            optMap[subItem.key] = {
              barKey: defTbr,
              opt: subItem
            };
          }
        }
      }
    },
    loadGridMap: function loadGridMap(parentCom) {
      var gridInfo = {
        key: parentCom.key,
        tableKey: parentCom.tableKey
      };
      this.gridMap.push(gridInfo);
    },
    loadListViewMap: function loadListViewMap(parentCom) {
      var lvInfo = {
        key: parentCom.key,
        tableKey: parentCom.tableKey
      };
      this.LVMap.push(lvInfo);
    },
    addCellLocation: function addCellLocation(key, cellLocation) {
      this.cellMap[key] = cellLocation;
      this.metaCells[key] = cellLocation;
    },
    getRadios: function getRadios(groupKey) {
      return this.radioMap[groupKey];
    },
    getOptMap: function getOptMap() {
      return this.optMap;
    },
    getListView: function getListView(arg) {
      var key;

      if (_yesCommon.lodash.isNumeric(arg)) {
        var index = _YIUIBase.YIUI.TypeConvertor.toInt(arg);

        key = this.LVMap[index].key;
      } else {
        for (var i = 0, len = this.LVMap.length; i < len; i++) {
          var lv = this.LVMap[i];

          if (lv.tableKey == arg) {
            key = lv.key;
          }
        }
      }

      if (key) {
        return this.getComp(key);
      }

      return null;
    },
    getPanel: function getPanel(key) {
      return this.panelMap[key];
    },
    getCellSubDtlCompMap: function getCellSubDtlCompMap() {
      return this.cellSubDtlCompMap;
    },
    getGridMap: function getGridMap() {
      return this.gridMap;
    },
    getCompList: function getCompList() {
      return this.compList;
    },
    getOrderList: function getOrderList() {
      return this.orderList;
    },
    getUnOrderList: function getUnOrderList() {
      return this.unOrderList;
    },
    getComp: function getComp(comKey) {
      return this.compList[comKey];
    },
    getRoot: function getRoot() {
      return this.rootPanel;
    },
    setRootPanel: function setRootPanel(rootPanel) {
      this.rootPanel = rootPanel;
    },
    setCompValue: function () {
      var _setCompValue = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee(key, value, fireEvent) {
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (this.getComp(key) == undefined) {
                  _YIUIBase.YIUI.ViewException.throwException(_YIUIBase.YIUI.ViewException.NO_COMPONENT_KEY, key);
                }

                _context.next = 3;
                return this.getComp(key).setValue(value, true, fireEvent);

              case 3:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function setCompValue(_x, _x2, _x3) {
        return _setCompValue.apply(this, arguments);
      }

      return setCompValue;
    }(),
    setCellValByIndex: function setCellValByIndex(key, rowIndex, colIndex, value, fireEvent) {
      var comp = this.getComp(key);
      var type = comp == undefined ? -1 : comp.type;

      switch (type) {
        case _YIUIBase.YIUI.CONTROLTYPE.LISTVIEW:
          comp.setValByIndex(rowIndex, colIndex, value, true, fireEvent);
          break;

        case _YIUIBase.YIUI.CONTROLTYPE.GRID:
          if (comp.getRowDataAt(rowIndex).isDetail) {
            comp.setValueAt(rowIndex, colIndex, value, true, fireEvent);
          }

          break;

        default:
          _YIUIBase.YIUI.ViewException.throwException(_YIUIBase.YIUI.ViewException.NO_CELL_CANNOT_SET_VALUE);

      }
    },
    getCellValByIndex: function getCellValByIndex(key, rowIndex, colIndex) {
      var comp = this.getComp(key);
      var type = comp == undefined ? -1 : comp.type,
          value;

      switch (type) {
        case _YIUIBase.YIUI.CONTROLTYPE.LISTVIEW:
          value = comp.getValue(rowIndex, colIndex);
          break;

        case _YIUIBase.YIUI.CONTROLTYPE.GRID:
          value = comp.getValueAt(rowIndex, colIndex);
          break;

        default:
          _YIUIBase.YIUI.ViewException.throwException(_YIUIBase.YIUI.ViewException.CANNNOT_GET_NO_CELL_VALUE);

      }

      return value;
    },
    setCellValByKey: function setCellValByKey(key, rowIndex, colKey, value, fireEvent) {
      var comp = this.getComp(key);
      var type = comp == undefined ? -1 : comp.type;

      switch (type) {
        case _YIUIBase.YIUI.CONTROLTYPE.LISTVIEW:
          comp.setValByKey(rowIndex, colKey, value, true, fireEvent);
          break;

        case _YIUIBase.YIUI.CONTROLTYPE.GRID:
          if (rowIndex != -1 && comp.getRowDataAt(rowIndex).isDetail) {
            comp.setValueByKey(rowIndex, colKey, value, true, fireEvent);
          }

          break;

        default:
          _YIUIBase.YIUI.ViewException.throwException(_YIUIBase.YIUI.ViewException.NO_CELL_CANNOT_SET_VALUE);

      }
    },
    getCellValByKey: function getCellValByKey(key, rowIndex, colKey) {
      var comp = this.getComp(key);
      var type = comp == undefined ? -1 : comp.type,
          value;

      switch (type) {
        case _YIUIBase.YIUI.CONTROLTYPE.LISTVIEW:
          value = comp.getValByKey(rowIndex, colKey);
          break;

        case _YIUIBase.YIUI.CONTROLTYPE.GRID:
          value = comp.getValueByKey(rowIndex, colKey);
          break;

        default:
          _YIUIBase.YIUI.ViewException.throwException(_YIUIBase.YIUI.ViewException.CANNNOT_GET_NO_CELL_VALUE);

      }

      return value;
    },
    getCellLocation: function getCellLocation(key) {
      return this.cellMap[key];
    },
    getColumnInfo: function getColumnInfo(key) {
      return this.columnMap[key];
    },
    setDefContainer: function setDefContainer(defContainer) {
      this.defContainer = defContainer;
    },
    getDefContainer: function getDefContainer(defCtKey) {
      if (defCtKey) {
        return this.getComp(defCtKey);
      }

      return null;
    },
    setContainer: function setContainer(container) {
      this.container = container;
    },
    getContainer: function getContainer() {
      return this.container;
    },
    toJSON: function toJSON() {
      var jsonArr = [],
          rootPanel = this.rootPanel;
      this.compToJson(rootPanel, jsonArr);
      return jsonArr;
    },
    compToJson: function compToJson(panel, comps) {
      var items = panel.items,
          item,
          comp;

      for (var i = 0, len = items.length; i < len; i++) {
        item = items[i];

        if (item instanceof _YIUIBase.YIUI.Panel) {
          this.compToJson(item, comps);
        } else if (!(item.type == _YIUIBase.YIUI.CONTROLTYPE.LISTVIEW || item.type == _YIUIBase.YIUI.CONTROLTYPE.GRID)) {
          comp = {};
          comp.key = item.key;

          if (item.type == _YIUIBase.YIUI.CONTROLTYPE.DATEPICKER) {
            if (item.getValue()) {
              comp.value = item.getValue().getTime();
            } else {
              comp.value = null;
            }
          } else {
            comp.value = item.getValue();
          }

          comp.caption = item.caption;
          comps.push(comp);
        }
      }
    }
  };
  Return = _yesCommon.lodash.extend(Return, options);
  Return.init(Return.rootObj);
  return Return;
}; // })();


exports["default"] = _default;