"use strict";

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
var _exportNames = {
  injectServer: true,
  DataDef: true,
  Svr: true,
  YIUI: true,
  UI: true,
  injectDispatcher: true,
  cacheSystem: true,
  View: true,
  injectEncrypt: true,
  injectConfirm: true
};
exports.injectServer = injectServer;
Object.defineProperty(exports, "DataDef", {
  enumerable: true,
  get: function get() {
    return _YIUICommon.DataDef;
  }
});
Object.defineProperty(exports, "Svr", {
  enumerable: true,
  get: function get() {
    return _YIUISvr["default"];
  }
});
Object.defineProperty(exports, "YIUI", {
  enumerable: true,
  get: function get() {
    return _YIUIBase.YIUI;
  }
});
Object.defineProperty(exports, "UI", {
  enumerable: true,
  get: function get() {
    return _YIUIBase.UI;
  }
});
Object.defineProperty(exports, "injectDispatcher", {
  enumerable: true,
  get: function get() {
    return _dispatchers.injectDispatcher;
  }
});
Object.defineProperty(exports, "cacheSystem", {
  enumerable: true,
  get: function get() {
    return _cache["default"];
  }
});
Object.defineProperty(exports, "View", {
  enumerable: true,
  get: function get() {
    return _YIUIParser.View;
  }
});
Object.defineProperty(exports, "injectEncrypt", {
  enumerable: true,
  get: function get() {
    return _encrypt.injectEncrypt;
  }
});
Object.defineProperty(exports, "injectConfirm", {
  enumerable: true,
  get: function get() {
    return _confirm.injectConfirm;
  }
});

var _YIUICommon = require("./YIUI-common");

require("./formbuilder");

var _YIUISvr = _interopRequireDefault(require("./YIUI-svr"));

var _YIUIBase = require("./YIUI-base");

var _dispatchers = require("./dispatchers");

var _cache = _interopRequireWildcard(require("./cache"));

Object.keys(_cache).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _cache[key];
    }
  });
});

var _YIUIParser = require("./YIUI-parser");

require("./component/controls");

var _encrypt = require("./utils/encrypt");

var _confirm = require("./utils/confirm");

var _session = require("./session");

Object.keys(_session).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _session[key];
    }
  });
});

var _exceptions = require("./exceptions");

Object.keys(_exceptions).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _exceptions[key];
    }
  });
});

var _actions = require("./actions");

Object.keys(_actions).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _actions[key];
    }
  });
});

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/**
 * 用于注入yigo2服务器的根地址
 * @param {yigo2服务器的根地址} server
 */
function injectServer(server) {
  _YIUISvr["default"].SvrMgr.ServletURL = "".concat(server, "/servlet");
  _YIUISvr["default"].SvrMgr.UIProxyURL = "".concat(server, "/uiproxy");
  _YIUISvr["default"].SvrMgr.AttachURL = "".concat(server, "/attach");
  _YIUISvr["default"].SvrMgr.ServerURL = server;
}