"use strict";

var _YIUIBase = require("./YIUI-base");

require("./YIUI-common");

require("./YIUI-parser");

require("./YIUI-svr");

var _yesCommon = require("yes-common");

var _dispatchers = _interopRequireDefault(require("./dispatchers"));

var _actions = require("./actions");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

// (function () {
_YIUIBase.YIUI.OptQueue = function (opts) {
  var reFun = function reFun(opts) {
    var Return = {
      optArray: [],
      init: function init() {
        if (opts) {
          if (_yesCommon.lodash.isArray(opts)) {
            for (var i = 0, len = opts.length; i < len; i++) {
              this.optArray.push(opts[i]);
            }
          } else {
            this.optArray.push(opts);
          }
        }
      },
      doOpt: function doOpt() {
        var self = this;

        var stackExecOpt = function stackExecOpt() {
          if (self.optArray.length > 0) {
            var o = self.optArray.shift();
            return o.doOpt().then(stackExecOpt);
          }

          return _yesCommon.lodash.Deferred(function (def) {
            def.resolve();
          }, function (err) {
            self.optArray = [];
            throw err;
          }).promise();
        };

        var opt = self.optArray.shift();
        return opt.doOpt().then(stackExecOpt);
      }
    };
    Return.init();
    return Return;
  };

  return reFun(opts);
};

_YIUIBase.YIUI.UICheckOpt = function (form) {
  var opt = _YIUIBase.YIUI.I18N.opt;
  var Return = {
    showError: function showError(errorMsg, type) {
      // if(type == YIUI.Dialog_Type.WARN) {
      //     errorMsg = errorMsg.replace("Uncaught Error: ", "");
      //     getDispatcher().dispatch(warn(errorMsg));
      // } else {
      throw new Error(errorMsg); // getDispatcher().dispatch(error(errorMsg));
      // }
    },
    _doOpt: function _doOpt() {
      var self = this;
      console.log('uicheck doopt');

      if (form.errorInfo.error) {
        this.showError(form.errorInfo.errorMsg);
      }

      for (var i in form.getComponentList()) {
        var comp = form.getComponentList()[i];

        if (comp.type == _YIUIBase.YIUI.CONTROLTYPE.GRID) {
          for (var ri = 0, size = comp.getRowCount(); ri < size; ri++) {
            var rowData = comp.getRowDataAt(ri);
            if (rowData == null || !rowData.isDetail || rowData.bookmark == null) continue;

            if (rowData.error) {
              self.showError(opt.table + "(" + comp.key + " " + comp.caption + ")" + opt.the + (ri + 1) + opt.line + rowData.errorMsg);
            }

            for (var ci = 0, length = comp.getColumnCount(); ci < length; ci++) {
              var cellData = comp.getCellDataAt(ri, ci),
                  cm = comp.dataModel.colModel.columns[ci];

              if (cellData[3]) {
                self.showError(opt.table + "(" + comp.key + " " + comp.caption + ")\n" + opt.the + (ri + 1) + opt.lineThe + (ci + (comp.getMetaObj().showRowHead ? 1 : 0)) + opt.column + cm.label + opt.required);
              } else if (cellData[4]) {
                self.showError(opt.table + "(" + comp.key + " " + comp.caption + ")" + opt.the + (ri + 1) + opt.lineThe + (ci + (comp.getMetaObj().showRowHead ? 1 : 0)) + opt.column + cellData[5]);
              }
            }
          }
        } else {
          if (comp.errorInfo && comp.errorInfo.error) {
            self.showError(comp.caption + ":" + comp.errorInfo.msg);
          } else if (comp.isRequired() && comp.isNull()) {
            self.showError(comp.caption + opt.noFill);
          }
        }
      }

      return true;
    },
    doOpt: function () {
      var _doOpt2 = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee() {
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                return _context.abrupt("return", this._doOpt());

              case 1:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function doOpt() {
        return _doOpt2.apply(this, arguments);
      }

      return doOpt;
    }()
  };
  return Return;
};

_YIUIBase.YIUI.EditOpt = function (form) {
  var Return = {
    doOpt: function () {
      var _doOpt3 = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee2() {
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                // return $.Deferred(function(def){
                form.setInitOperationState(_YIUIBase.YIUI.Form_OperationState.Edit); //设置操作状态

                form.setOperationState(_YIUIBase.YIUI.Form_OperationState.Edit); //重置界面状态

                form.resetUIStatus(_YIUIBase.YIUI.FormUIStatusMask.ENABLE | _YIUIBase.YIUI.FormUIStatusMask.VISIBLE | _YIUIBase.YIUI.FormUIStatusMask.OPERATION); //获取计算表达式处理类
                //form.getUIProcess().checkAll(); //TODO 目前屏蔽状态转换后的检查，之后再进行处理
                //在表单进入编辑状态的时候为orderIndex为1的首个组件设定焦点
                // form.initFirstFocus();
                // def.resolve(true);
                // }).promise();

              case 3:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }));

      function doOpt() {
        return _doOpt3.apply(this, arguments);
      }

      return doOpt;
    }()
  };
  return Return;
};

_YIUIBase.YIUI.SaveOpt = function (form) {
  var Return = {
    doOpt: function () {
      var _doOpt4 = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee3() {
        var metaForm, scriptCollection, saveScript;
        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                metaForm = form.metaForm;
                scriptCollection = metaForm.scriptCollection;
                saveScript = scriptCollection['save'];

                if (!saveScript) {
                  _context3.next = 6;
                  break;
                }

                _context3.next = 6;
                return form.eval(saveScript, {
                  form: form
                }, null);

              case 6:
                form.setOperationState(_YIUIBase.YIUI.Form_OperationState.Default);

              case 7:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3);
      }));

      function doOpt() {
        return _doOpt4.apply(this, arguments);
      }

      return doOpt;
    }()
  };
  return Return;
};

_YIUIBase.YIUI.LoadOpt = function (form) {
  var Return = {
    doOpt: function () {
      var _doOpt5 = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee4() {
        var metaForm, scriptCollection, loadScript;
        return regeneratorRuntime.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                metaForm = form.metaForm;
                scriptCollection = metaForm.scriptCollection;
                loadScript = scriptCollection["load"];

                if (!loadScript) {
                  _context4.next = 6;
                  break;
                }

                _context4.next = 6;
                return form.eval(loadScript, {
                  form: form
                }, null);

              case 6:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4);
      }));

      function doOpt() {
        return _doOpt5.apply(this, arguments);
      }

      return doOpt;
    }()
  };
  return Return;
};

_YIUIBase.YIUI.NewOpt = function (form, refreshUI) {
  var Return = {
    doOpt: function doOpt() {
      var docDef = _YIUIBase.YIUI.DocService.newDocument(form.formKey);

      var oidDef = _YIUIBase.YIUI.RemoteService.applyNewOID();

      return _yesCommon.lodash.when(docDef, oidDef).then(function (doc, oid) {
        if (!doc) {
          return;
        }

        if (form.metaForm.type == _YIUIBase.YIUI.Form_Type.Entity && doc.mainTableKey) {
          doc.oid = oid;
          var dt = doc.getByKey(doc.mainTableKey);
          dt.setByKey(_YIUIBase.YIUI.SystemField.OID_SYS_KEY, oid);
        }

        doc.setNew();
        form.setDocument(doc);
        form.setInitOperationState(_YIUIBase.YIUI.Form_OperationState.New);
        form.setOperationState(_YIUIBase.YIUI.Form_OperationState.New);

        if (refreshUI) {
          form.showDocument(); //form.resetUIStatus(YIUI.FormUIStatusMask.ENABLE | YIUI.FormUIStatusMask.VISIBLE | YIUI.FormUIStatusMask.OPERATION);
        }

        return form;
      }); // var paras = {};
      // paras.service = "PureOpt";
      // paras.cmd = "GetNewDocument";
      // paras.formKey = form.formKey;
      // paras.type = YIUI.OptScript.LOAD;
      // var document = Svr.Request.getSyncData(Svr.SvrMgr.ServletURL, paras);
      // form.setDocument(document);
      // form.setInitOperationState(YIUI.Form_OperationState.New);
      // form.setOperationState(YIUI.Form_OperationState.New);
      // if (refreshUI) {
      //     form.showDocument();
      //     //form.resetUIStatus(YIUI.FormUIStatusMask.ENABLE | YIUI.FormUIStatusMask.VISIBLE | YIUI.FormUIStatusMask.OPERATION);
      // }
    }
  };
  return Return;
};

_YIUIBase.YIUI.CopyNewOpt = function (form) {
  var Return = {
    doOpt: function doOpt() {
      return _yesCommon.lodash.Deferred(function (def) {
        var paras = {};
        paras.service = "PureOpt";
        paras.cmd = "GetNewCopyDocument";
        paras.formKey = form.formKey;
        paras.type = _YIUIBase.YIUI.OptScript.LOAD;

        var docStr = _YIUIBase.YIUI.DataUtil.toJSONDoc(form.getDocument());

        paras.document = _yesCommon.lodash.toJSON(docStr);
        var document = Svr.Request.getSyncData(Svr.SvrMgr.ServletURL, paras);

        if (document) {
          form.setDocument(document);
        }

        form.setInitOperationState(_YIUIBase.YIUI.Form_OperationState.New);
        form.setOperationState(_YIUIBase.YIUI.Form_OperationState.New);
        form.showDocument();
        form.resetUIStatus(_YIUIBase.YIUI.FormUIStatusMask.ENABLE | _YIUIBase.YIUI.FormUIStatusMask.VISIBLE | _YIUIBase.YIUI.FormUIStatusMask.OPERATION);
      }).promise();
    }
  };
  return Return;
}; // })();