"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FormParasUtil = exports.Paras = void 0;

var _YIUIBase = require("./YIUI-base");

var _yesCommon = require("yes-common");

var _decimal = _interopRequireDefault(require("decimal.js"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

// (function () {
var Paras = _YIUIBase.YIUI.Paras = function (json) {
  var Return = {
    map: {},
    mapType: {},
    put: function put(key, value) {
      this.map[key] = value;
    },
    get: function get(key) {
      if (this.map.hasOwnProperty(key)) {
        return this.map[key];
      }

      return null;
    },
    getMap: function getMap() {
      return this.map;
    },
    init: function init() {
      if (_yesCommon.lodash.isEmptyObject(json)) return;
      var items = json.items;

      for (var i = 0, len = items.length; i < len; i++) {
        var item = items[i];
        this.put(item.key, item.value);
        this.mapType[item.key] = item.type;
      }
    },
    toJSON: function toJSON() {
      var json = {};

      if (!_yesCommon.lodash.isEmptyObject(this.map)) {
        var items = [];

        for (var m in this.map) {
          var v = this.map[m];
          var type = this.mapType[m];

          if (!type || type == -1) {
            if (_yesCommon.lodash.isNumeric(v)) {
              //TODO 判断类型是int还是long
              //int
              //								type = YIUI.JavaDataType.USER_INT;
              //long
              type = _YIUIBase.YIUI.JavaDataType.USER_LONG;
            } else if (v instanceof _decimal["default"]) {
              type = _YIUIBase.YIUI.JavaDataType.USER_NUMERIC;
              v = v.toString();
            } else if (typeof v == "boolean") {
              type = _YIUIBase.YIUI.JavaDataType.USER_BOOLEAN;
            } else if (v instanceof Date) {
              type = _YIUIBase.YIUI.JavaDataType.USER_DATETIME;
              v = v.getTime();
            } else if (typeof v == "string") {
              type = _YIUIBase.YIUI.JavaDataType.USER_STRING;
            }
          }

          var item = {
            key: m,
            value: v,
            type: type
          };
          items.push(item);
        }

        json.items = items;
      }

      return _yesCommon.lodash.toJSON(json);
    }
  };
  Return.init();
  return Return;
};

exports.Paras = Paras;

var FormParasUtil = _YIUIBase.YIUI.FormParasUtil = function () {
  var Return = {
    processCallParas: function processCallParas(parent, form) {
      if (parent != null) {
        var callParas = parent.getCallParas();

        if (callParas != null) {
          var map = callParas.map;

          for (var key in map) {
            form.setPara(key, map[key]);
          }
        }
      }
    }
  };
  return Return;
}(); // })();


exports.FormParasUtil = FormParasUtil;