"use strict";

var _YIUIBase = require("../YIUI-base");

require("../YIUI-common");

require("../YIUI-parser");

require("../YIUI-svr");

var _yesCommon = require("yes-common");

require("../uiprocess");

require("../abstractuiprocess");

require("../yes-ui");

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

// var YIUI = YIUI || {};
// (function () {
_YIUIBase.YIUI.UICheckRuleProcess = _YIUIBase.YIUI.extend(_YIUIBase.YIUI.AbstractUIProcess, {
  init: function init(form) {
    this.base(form);
  },
  calcAll: function calcAll() {
    this.checkGlobal();
    this.calcAllComponents(this.enableOnly());
    this.checkGridRows();
  },
  checkGlobal: function checkGlobal() {
    if (this.enableOnly()) {
      if (this.form.isError()) {
        this.form.setError(false, null);
      }

      return;
    }

    var globalItems = this.form.dependency.checkRuleTree.globalItems;
    if (!globalItems) return;

    for (var i = 0, size = globalItems.length; i < size; i++) {
      var exp = globalItems[i];
      if (!exp.content) continue;
      var result = this.form.eval(exp.content, this.newContext(this.form, -1, -1));

      if (typeof result === 'string') {
        if (result) {
          if (!this.form.isError) {
            this.form.setError(true, result, this.form.formKey);
          }

          break;
        } else {
          if (this.form.isError() && this.form.errorInfo.errorSource && this.form.errorInfo.errorSource === this.form.formKey) {
            this.form.setError(false, null, null);
          }
        }
      } else {
        if (result) {
          if (this.form.isError() && this.form.errorInfo.errorSource && this.form.errorInfo.errorSource === this.form.formKey) {
            this.form.setError(false, null, null);
          }
        } else {
          this.form.setError(true, exp.errorMsg, this.form.formKey);
          break;
        }
      }
    }
  },
  calcAllComponents: function calcAllComponents(enableOnly) {
    var items = this.form.dependency.checkRuleTree.items;

    for (var i = 0, size = items.length; i < size; i++) {
      var component = this.form.getComponent(items[i].source);
      if (!component || component.getMetaObj().isSubDetail) continue;

      switch (items[i].objectType) {
        case _YIUIBase.YIUI.ExprItem_Type.Item:
          this.checkHead(component, items[i], enableOnly, false);
          break;

        case _YIUIBase.YIUI.ExprItem_Type.Set:
          this.checkGrid(component, this.initTree(items[i]), enableOnly, false);
          break;
      }
    }
  },
  checkHead: function () {
    var _checkHead = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee(component, item, enableOnly, checkBindCell) {
      var cellLocation, index, cellData, editOpt, result, grid, rowIndex, bindingCellKey, location;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              if (!(component.type == _YIUIBase.YIUI.CONTROLTYPE.GRID)) {
                _context.next = 20;
                break;
              }

              return _context.abrupt("return");

            case 4:
              cellLocation = this.form.getCellLocation(item.target);
              index = item.pos.index;
              cellData = component.getCellDataAt(cellLocation.row, index);
              editOpt = component.getCellEditOpt(item.target);

              if (!(enableOnly && !cellData[2])) {
                _context.next = 12;
                break;
              }

              if (cellData[3]) {
                component.setCellRequired(cellLocation.row, index, false);
              }

              if (cellData[4]) {
                component.setCellError(cellLocation.row, index, false, "");
              }

              return _context.abrupt("return");

            case 12:
              // 计算必填
              if (editOpt.isRequired) {
                component.setCellRequired(cellLocation.row, index, cellData[1] == null || cellData[1] == "");
              } // 计算检查规则


              if (!item.content) {
                _context.next = 18;
                break;
              }

              _context.next = 16;
              return this.calcCheckRule(item, this.newContext(this.form, -1, -1));

            case 16:
              result = _context.sent;

              if (typeof result === 'string') {
                component.setCellError(cellLocation.row, index, result, result);
              } else {
                component.setCellError(cellLocation.row, index, !result, result ? null : item.errorMsg);
              }

            case 18:
              _context.next = 30;
              break;

            case 20:
              if (!(enableOnly && !component.isEnable())) {
                _context.next = 24;
                break;
              }

              if (component.isRequired()) {
                component.setRequired(false);
              }

              if (component.isError()) {
                component.setError(false, null);
              }

              return _context.abrupt("return");

            case 24:
              // 计算必填
              if (component.getMetaObj().required) {
                component.setRequired(component.isNull());
              } // if (item.content) {


              _context.next = 27;
              return this.calcCheckRule(item, this.newContext(this.form, -1, -1));

            case 27:
              result = _context.sent;

              if (typeof result === 'string') {
                component.setError(result, result);
              } else {
                component.setError(!result, result ? null : item.errorMsg);
              } // }
              // 如果是子明细组件


              if (component.getMetaObj().isSubDetail) {
                cellData = _YIUIBase.YIUI.SubDetailUtil.getBindingCellData(this.form, component);

                if (cellData) {
                  if (!component.getMetaObj().required) {
                    component.setRequired[cellData[3]];
                  }

                  if (!item.content && cellData[4]) {
                    component.setError(true, cellData[5]);
                  }
                } // 检查绑定的表格当前行的单元格


                grid = _YIUIBase.YIUI.SubDetailUtil.getBindingGrid(this.form, component);
                rowIndex = grid.getFocusRowIndex();

                if (checkBindCell && cellData != null && rowIndex != -1) {
                  bindingCellKey = component.bindingCellKey;
                  location = this.form.getCellLocation(bindingCellKey);
                  grid.setCellError(rowIndex, location.column, component.isError(), component.getErrorMsg());
                }
              } // 如果当前控件不可见,那么将错误显示在表头
              // if (!component.isVisible()) {
              //     if (!this.form.isError() || this.form.formKey != this.form.errorInfo.errorSource) {
              //         if (component.isError()) {
              //             this.form.setError(true, component.getErrorMsg(), component.key);
              //         }
              //         if (component.isRequired()) {
              //             this.form.setError(true, component.caption + "is Required", component.key);
              //         }
              //     }
              // } else {
              //     if (this.form.isError() && this.form.errorInfo.errorSource === component.key) {
              //         this.form.setError(false, null, null);
              //     }
              // }


            case 30:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    function checkHead(_x, _x2, _x3, _x4) {
      return _checkHead.apply(this, arguments);
    }

    return checkHead;
  }(),
  checkGrid: function checkGrid(grid, item, enableOnly, checkSubDetails) {
    for (var i = 0, size = grid.getRowCount(); i < size; i++) {
      // var row = grid.getRowDataAt(i);
      if (!grid.isRowDetail()) continue;
      this.checkGridRowCell(grid, i, null, item, enableOnly, checkSubDetails);
    }
  },
  checkGridRowCell: function () {
    var _checkGridRowCell = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee3(grid, rowIndex, specialInfo, item, enableOnly, checkSubDetail) {
      var _this, checkSingleItem, exp, pos, cxt, editOpt, specialLoc, specialKey, i, size, p, length, subDetails, cellData, c, count;

      return regeneratorRuntime.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              if (item.items) {
                _context3.next = 2;
                break;
              }

              return _context3.abrupt("return");

            case 2:
              _this = this;

              checkSingleItem =
              /*#__PURE__*/
              function () {
                var _ref = _asyncToGenerator(
                /*#__PURE__*/
                regeneratorRuntime.mark(function _callee2(grid, rowIndex, editOpt, idx, cxt, item, enableOnly) {
                  var cellData, result;
                  return regeneratorRuntime.wrap(function _callee2$(_context2) {
                    while (1) {
                      switch (_context2.prev = _context2.next) {
                        case 0:
                          cellData = grid.getCellDataAt(rowIndex, idx);

                          if (!(enableOnly && !cellData[2])) {
                            _context2.next = 5;
                            break;
                          }

                          if (cellData[3]) {
                            grid.setCellRequired(rowIndex, idx, false);
                          }

                          if (cellData[4]) {
                            grid.setCellError(rowIndex, idx, false, null);
                          }

                          return _context2.abrupt("return");

                        case 5:
                          // 计算必填
                          if (editOpt.isRequired) {
                            grid.setCellRequired(rowIndex, idx, cellData[0] == null || cellData[0] == "");
                          } // 计算检查规则


                          if (!item.content) {
                            _context2.next = 11;
                            break;
                          }

                          _context2.next = 9;
                          return _this.calcCheckRule(item, cxt);

                        case 9:
                          result = _context2.sent;

                          if (typeof result === 'string') {
                            grid.setCellError(rowIndex, idx, result, result);
                          } else {
                            grid.setCellError(rowIndex, idx, !result, result ? null : item.errorMsg);
                          }

                        case 11:
                        case "end":
                          return _context2.stop();
                      }
                    }
                  }, _callee2);
                }));

                return function checkSingleItem(_x11, _x12, _x13, _x14, _x15, _x16, _x17) {
                  return _ref.apply(this, arguments);
                };
              }();

              specialLoc = specialInfo || -1, specialKey = specialInfo || null;
              i = 0, size = item.items.length;

            case 6:
              if (!(i < size)) {
                _context3.next = 29;
                break;
              }

              exp = item.items[i], pos = exp.pos;
              cxt = this.newContext(this.form, rowIndex, -1);
              editOpt = grid.getCellEditOpt(exp.target);

              if (!pos.columnExpand) {
                _context3.next = 23;
                break;
              }

              p = 0, length = pos.indexes.length;

            case 12:
              if (!(p < length)) {
                _context3.next = 21;
                break;
              }

              if (!(specialLoc != -1 && exp.target === specialKey && p !== specialLoc)) {
                _context3.next = 15;
                break;
              }

              return _context3.abrupt("continue", 18);

            case 15:
              cxt.colIndex = pos.indexes[p];
              _context3.next = 18;
              return checkSingleItem(grid, rowIndex, editOpt, pos.indexes[p], cxt, exp, this.enableOnly());

            case 18:
              p++;
              _context3.next = 12;
              break;

            case 21:
              _context3.next = 26;
              break;

            case 23:
              _context3.next = 25;
              return checkSingleItem(grid, rowIndex, editOpt, pos.index, cxt, exp, this.enableOnly());

            case 25:
              // 子明细
              if (checkSubDetail && grid.getFocusRowIndex() == rowIndex) {
                subDetails = this.form.getCellSubDtlComps(grid.key, exp.target);

                if (subDetails && subDetails.length > 0) {
                  cellData = grid.getCellDataAt(rowIndex, pos.index);

                  for (c = 0, count = subDetails.length; c < count; c++) {
                    subDetails[c].setError(cellData[4], cellData[5]);
                  }
                }
              }

            case 26:
              i++;
              _context3.next = 6;
              break;

            case 29:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3, this);
    }));

    function checkGridRowCell(_x5, _x6, _x7, _x8, _x9, _x10) {
      return _checkGridRowCell.apply(this, arguments);
    }

    return checkGridRowCell;
  }(),
  doAfterInsertRow: function doAfterInsertRow(component, rowIndex) {
    if (component.type != _YIUIBase.YIUI.CONTROLTYPE.GRID) return; // var row = component.getRowDataAt(rowIndex);

    if (!component.isRowDetail(rowIndex)) return;
    var items = this.form.dependency.checkRuleTree.items;

    for (var i = 0, size = items.length; i < size; i++) {
      if (items[i].objectType == _YIUIBase.YIUI.ExprItem_Type.Set && items[i].source === component.key) {
        this.checkGridRowCell(component, rowIndex, null, items[i], this.enableOnly(), false);
      }
    }

    this.checkGridRowCheckRule(component, rowIndex);
    this.impl_valueChanged(component, component.key + ":RowCount");
    this.checkGlobal();
  },
  doAfterDeleteRow: function doAfterDeleteRow(grid) {
    this.impl_valueChanged(grid, grid.key + ":RowCount");
    this.checkGlobal();
  },
  checkGridRows: function checkGridRows() {
    if (this.enableOnly()) return;
    var gridMap = this.form.getGridInfoMap();

    for (var i = 0, size = gridMap.length; i < size; i++) {
      var gridInfo = gridMap[i];
      var grid = this.form.getComponent(gridInfo.key);

      for (var c = 0, length = grid.getRowCount(); c < length; c++) {
        this.checkGridRowCheckRule(grid, c);
      }
    }
  },
  checkGridRowCheckRule: function checkGridRowCheckRule(grid, rowIndex) {
    var rowCheckRules = grid.getMetaObj().rowCheckRules; // var rowData = grid.getRowDataAt(rowIndex);

    if (!rowCheckRules || grid.getRowType(rowIndex) !== 'Detail') return;

    for (var k = 0, len = rowCheckRules.length; k < len; k++) {
      var rowCheckRule = rowCheckRules[k];
      var result = this.calcCheckRule(rowCheckRule, this.newContext(this.form, rowIndex, -1));

      if (typeof result === 'string') {
        grid.setRowError(rowIndex, result, result);
      } else {
        grid.setRowError(rowIndex, !result, result ? null : rowCheckRule.errorMsg);
      }
    }
  },
  reCalcComponent: function reCalcComponent(component) {
    var items = this.form.dependency.checkRuleTree.items;

    for (var i = 0, size = items.length; i < size; i++) {
      if (items[i].objectType != _YIUIBase.YIUI.ExprItem_Type.Set) continue;
      if (items[i].source !== component.key) continue; // 检查表格

      this.checkGrid(component, this.initTree(items[i]), this.enableOnly(), true);
    }

    if (component.type == _YIUIBase.YIUI.CONTROLTYPE.GRID) {
      for (var i = 0, size = component.getRowCount(); i < size; i++) {
        this.checkGridRowCheckRule(component, i);
      }
    }

    this.checkGlobal();
  },
  valueChanged: function () {
    var _valueChanged = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee4(component) {
      var needCheck, grid;
      return regeneratorRuntime.wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              needCheck = false;

              if (component.getMetaObj().isSubDetail) {
                grid = _YIUIBase.YIUI.SubDetailUtil.getBindingGrid(this.form, component);
                needCheck = component.bindingCellKey && grid.getCellEditOpt(component.bindingCellKey).isRequired;
              }

              if (component.getMetaObj().required || needCheck) {
                component.setRequired(component.isNull());
              } // 计算影响项


              _context4.next = 5;
              return this.impl_valueChanged(component, component.key);

            case 5:
              // 如果是子明细组件,如果绑定了单元格,则联动显示,如果没有绑定单元格,检查一下当前行行的检查规则
              if (component.getMetaObj().required && component.bindingCellKey) {
                grid = _YIUIBase.YIUI.SubDetailUtil.getBindingGrid(this.form, component);

                if (grid && grid.getFocusRowIndex() != -1) {
                  this.checkGridRowCheckRule(grid, grid.getFocusRowIndex());
                }
              } //算全局的检查规则


              this.checkGlobal();

            case 7:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4, this);
    }));

    function valueChanged(_x18) {
      return _valueChanged.apply(this, arguments);
    }

    return valueChanged;
  }(),
  impl_valueChanged: function () {
    var _impl_valueChanged = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee5(component, key) {
      var items, i, size, exp, com, calcParGrid;
      return regeneratorRuntime.wrap(function _callee5$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              items = this.form.dependency.checkRuleTree.affectItems[key];

              if (items) {
                _context5.next = 3;
                break;
              }

              return _context5.abrupt("return");

            case 3:
              i = 0, size = items.length;

            case 4:
              if (!(i < size)) {
                _context5.next = 22;
                break;
              }

              exp = items[i];
              com = this.form.getComponent(exp.source);

              if (com) {
                _context5.next = 9;
                break;
              }

              return _context5.abrupt("continue", 19);

            case 9:
              _context5.t0 = exp.type;
              _context5.next = _context5.t0 === _YIUIBase.YIUI.ExprItem_Type.Item ? 12 : _context5.t0 === _YIUIBase.YIUI.ExprItem_Type.Set ? 15 : 18;
              break;

            case 12:
              _context5.next = 14;
              return this.checkHead(com, exp, this.enableOnly(), true);

            case 14:
              return _context5.abrupt("break", 19);

            case 15:
              calcParGrid = _YIUIBase.YIUI.SubDetailUtil.isSubDetail(this.form, component, com.key);

              if (calcParGrid) {
                this.checkGridRowCell(com, com.getFocusRowIndex(), null, this.initTree(exp), this.enableOnly(), true);
              } else {
                this.checkGrid(com, this.initTree(exp), this.enableOnly(), true);
              }

              return _context5.abrupt("break", 19);

            case 18:
              return _context5.abrupt("break", 19);

            case 19:
              i++;
              _context5.next = 4;
              break;

            case 22:
            case "end":
              return _context5.stop();
          }
        }
      }, _callee5, this);
    }));

    function impl_valueChanged(_x19, _x20) {
      return _impl_valueChanged.apply(this, arguments);
    }

    return impl_valueChanged;
  }(),
  cellValueChanged: function () {
    var _cellValueChanged = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee6(grid, rowIndex, colIndex) {
      var rowData, cellKey, editOpt, cellData, affectItems, items, i, size, exp, component;
      return regeneratorRuntime.wrap(function _callee6$(_context6) {
        while (1) {
          switch (_context6.prev = _context6.next) {
            case 0:
              rowData = grid.getRowDataAt(rowIndex);

              if (!(rowData.rowType !== "Detail" && rowData.rowType !== "Fix")) {
                _context6.next = 3;
                break;
              }

              return _context6.abrupt("return");

            case 3:
              // var rowData = grid.getRowDataAt(rowIndex);
              cellKey = rowData.cellKeys[colIndex];
              editOpt = grid.getCellEditOpt(cellKey);
              cellData = grid.getCellDataAt(rowIndex, colIndex);

              if (editOpt.isRequired) {
                grid.setCellRequired(rowIndex, colIndex, cellData == null || cellData == "");
              }

              affectItems = this.form.dependency.checkRuleTree.affectItems;
              items = null;
              i = 0, size = affectItems.length;

            case 10:
              if (!(i < size)) {
                _context6.next = 17;
                break;
              }

              if (!(affectItems[i].key === cellKey)) {
                _context6.next = 14;
                break;
              }

              items = affectItems[i];
              return _context6.abrupt("break", 17);

            case 14:
              i++;
              _context6.next = 10;
              break;

            case 17:
              if (!items) {
                _context6.next = 42;
                break;
              }

              i = 0, size = items.expItems.length;

            case 19:
              if (!(i < size)) {
                _context6.next = 42;
                break;
              }

              exp = items.expItems[i];
              component = this.form.getComponent(exp.source);

              if (component) {
                _context6.next = 24;
                break;
              }

              return _context6.abrupt("continue", 39);

            case 24:
              _context6.t0 = exp.objectType;
              _context6.next = _context6.t0 === _YIUIBase.YIUI.ExprItem_Type.Item ? 27 : _context6.t0 === _YIUIBase.YIUI.ExprItem_Type.Set ? 30 : 38;
              break;

            case 27:
              _context6.next = 29;
              return this.checkHead(component, exp, this.enableOnly(), true);

            case 29:
              return _context6.abrupt("break", 39);

            case 30:
              if (!(rowData.isDetail && component.key == grid.key)) {
                _context6.next = 35;
                break;
              }

              _context6.next = 33;
              return this.checkGridRowCell(component, rowIndex, {
                specialLoc: colIndex,
                specialKey: cellKey
              }, exp, this.enableOnly(), true);

            case 33:
              _context6.next = 37;
              break;

            case 35:
              _context6.next = 37;
              return this.checkGrid(component, this.initTree(exp), this.enableOnly(), true);

            case 37:
              return _context6.abrupt("break", 39);

            case 38:
              return _context6.abrupt("break", 39);

            case 39:
              i++;
              _context6.next = 19;
              break;

            case 42:
              //重算当前行的检查规则
              this.checkGridRowCheckRule(grid, rowIndex); //算全局的检查规则

              this.checkGlobal();

            case 44:
            case "end":
              return _context6.stop();
          }
        }
      }, _callee6, this);
    }));

    function cellValueChanged(_x21, _x22, _x23) {
      return _cellValueChanged.apply(this, arguments);
    }

    return cellValueChanged;
  }(),
  calcSubDetail: function calcSubDetail(grid) {
    var items = this.form.dependency.checkRuleTree.items;

    for (var i = 0, size = items.length; i < size; i++) {
      var exp = items[i];
      var component = this.form.getComponent(exp.source);
      if (!component) continue;

      switch (exp.objectType) {
        case _YIUIBase.YIUI.ExprItem_Type.Item:
          this.checkHead(component, exp, this.enableOnly(), false);
          break;

        case _YIUIBase.YIUI.ExprItem_Type.Set:
          this.checkGrid(component, this.initTree(exp), this.enableOnly(), false);
          break;

        default:
          break;
      }
    }
  }
}); // })();