"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _YIUIBase = require("../YIUI-base");

require("../YIUI-common");

require("../YIUI-parser");

require("../YIUI-svr");

var _yesCommon = require("yes-common");

require("../uiprocess");

require("../abstractuiprocess");

require("../yes-ui");

require("../utils/viewutil");

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

// var YIUI = YIUI || {};
// (function () {
var _default = _YIUIBase.YIUI.UIEnableProcess = _YIUIBase.YIUI.extend(_YIUIBase.YIUI.AbstractUIProcess, {
  EnableItemType: {
    Head: 0,
    List: 1,
    Column: 2,
    Operation: 3
  },
  init: function init(form) {
    this.base(form);
  },
  calcExprItemObject: function () {
    var _calcExprItemObject = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee(com, item, fireEvent) {
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.t0 = item.objectType;
              _context.next = _context.t0 === _YIUIBase.YIUI.ExprItem_Type.Item ? 3 : _context.t0 === _YIUIBase.YIUI.ExprItem_Type.Set ? 15 : 25;
              break;

            case 3:
              if (!(item.type == this.EnableItemType.Operation)) {
                _context.next = 12;
                break;
              }

              _context.t1 = this.form;
              _context.t2 = item.target;
              _context.next = 8;
              return this.form.eval(item.content, this.newContext(this.form, -1, -1), null);

            case 8:
              _context.t3 = _context.sent;

              _context.t1.setOperationEnable.call(_context.t1, _context.t2, _context.t3);

              _context.next = 14;
              break;

            case 12:
              _context.next = 14;
              return this.calcHeadItem(com, item, fireEvent);

            case 14:
              return _context.abrupt("break", 25);

            case 15:
              _context.t4 = com.type;
              _context.next = _context.t4 === _YIUIBase.YIUI.CONTROLTYPE.GRID ? 18 : _context.t4 === _YIUIBase.YIUI.CONTROLTYPE.LISTVIEW ? 21 : 24;
              break;

            case 18:
              _context.next = 20;
              return this.calcGrid(com, this.initTree(item), fireEvent);

            case 20:
              return _context.abrupt("break", 24);

            case 21:
              _context.next = 23;
              return this.calcListView(com, this.initTree(item));

            case 23:
              return _context.abrupt("break", 24);

            case 24:
              return _context.abrupt("break", 25);

            case 25:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    function calcExprItemObject(_x, _x2, _x3) {
      return _calcExprItemObject.apply(this, arguments);
    }

    return calcExprItemObject;
  }(),
  calcHeadItem: function () {
    var _calcHeadItem = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee2(component, item, defaultValue, calcBindCell) {
      var context, accessControl, enable, grid, rowIndex, colIndex;
      return regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              if (!(component.type == _YIUIBase.YIUI.CONTROLTYPE.GRID && item.target && item.source !== item.target)) {
                _context2.next = 4;
                break;
              }

              return _context2.abrupt("return");

            case 4:
              context = this.newContext(this.form, -1, -1);
              accessControl = _YIUIBase.YIUI.ViewUtil.checkComAccessControl(this.form, component);
              _context2.next = 8;
              return this.calcEnable(item, context, defaultValue, accessControl);

            case 8:
              enable = _context2.sent;
              component.setEnable(enable, false);

              if (calcBindCell && component.isSubDetail && component.bindingCellKey) {
                grid = _YIUIBase.YIUI.SubDetailUtil.getBindingGrid(this.form, component);
                rowIndex = grid.getFocusRowIndex();

                if (rowIndex != -1) {
                  colIndex = grid.getCellIndexByKey(component.bindingCellKey);
                  grid.setCellEnable(rowIndex, colIndex, enable);
                }
              }

            case 11:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, this);
    }));

    function calcHeadItem(_x4, _x5, _x6, _x7) {
      return _calcHeadItem.apply(this, arguments);
    }

    return calcHeadItem;
  }(),
  calcGrid: function () {
    var _calcGrid = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee3(grid, item, formEnable, calcSubDetails) {
      return regeneratorRuntime.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              _context3.t0 = this;
              _context3.t1 = this.newContext(this.form, -1, -1);
              _context3.t2 = grid;
              _context3.t3 = item;
              _context3.next = 6;
              return this.getFormEnable();

            case 6:
              _context3.t4 = _context3.sent;
              _context3.t5 = calcSubDetails;
              _context3.next = 10;
              return _context3.t0.calcGridRows.call(_context3.t0, _context3.t1, _context3.t2, _context3.t3, _context3.t4, _context3.t5);

            case 10:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3, this);
    }));

    function calcGrid(_x8, _x9, _x10, _x11) {
      return _calcGrid.apply(this, arguments);
    }

    return calcGrid;
  }(),
  // calcGridColumns:function (context,grid,item,formEnable) {
  //     var items = item.items;
  //     if( !items )
  //         return;
  //     for( var i = 0,size = items.length;i < size;i++ ) {
  //         if( items[i].type == this.EnableItemType.Column ) {
  //             var enable = this.calcEnable(items[i],this.newContext(this.form,-1,-1),this.getFormEnable(),true);
  //             var pos = items[i].pos;
  //             if( pos.columnExpand ) {
  //                 for( var i = 0,size = pos.indexes.length;i < size;i++ ) {
  //                     grid.setColumnEnable(pos.indexes[i],enable);
  //                 }
  //             } else {
  //                 grid.setColumnEnable(pos.index,enable);
  //             }
  //         }
  //     }
  // },
  calcGridRows: function () {
    var _calcGridRows = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee4(context, grid, item, formEnable, calcSubDetails) {
      var items, i, size;
      return regeneratorRuntime.wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              items = item.items;

              if (items) {
                _context4.next = 3;
                break;
              }

              return _context4.abrupt("return");

            case 3:
              console.time('calcGridRows');
              i = 0, size = grid.getRowCount();

            case 5:
              if (!(i < size)) {
                _context4.next = 15;
                break;
              }

              if (grid.isRowDetail(i)) {
                _context4.next = 8;
                break;
              }

              return _context4.abrupt("continue", 12);

            case 8:
              context.rowIndex = i;
              _context4.next = 11;
              return this.impl_calcGridRow(context, grid, i, item, formEnable, calcSubDetails);

            case 11:
              console.log("calcGridRows_".concat(i));

            case 12:
              i++;
              _context4.next = 5;
              break;

            case 15:
              console.timeEnd('calcGridRows');

            case 16:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4, this);
    }));

    function calcGridRows(_x12, _x13, _x14, _x15, _x16) {
      return _calcGridRows.apply(this, arguments);
    }

    return calcGridRows;
  }(),
  impl_calcGridRow: function () {
    var _impl_calcGridRow = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee5(context, grid, rowIndex, item, calcSubDetails) {
      var i, exp, pos, c, size, access, enable, subDetails, j, length;
      return regeneratorRuntime.wrap(function _callee5$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              if (!(rowIndex == -1)) {
                _context5.next = 2;
                break;
              }

              return _context5.abrupt("return");

            case 2:
              i = 0;

            case 3:
              if (!((exp = item.items[i]) && (pos = exp.pos))) {
                _context5.next = 32;
                break;
              }

              if (!(exp.type != this.EnableItemType.List || !exp.target)) {
                _context5.next = 6;
                break;
              }

              return _context5.abrupt("continue", 29);

            case 6:
              if (!pos.columnExpand) {
                _context5.next = 19;
                break;
              }

              c = 0, size = pos.indexes.length;

            case 8:
              if (!(c < size)) {
                _context5.next = 17;
                break;
              }

              context.colIndex = pos.indexes[c];
              _context5.next = 12;
              return this.calcEnable(exp, context, this.getFormEnable(), access);

            case 12:
              enable = _context5.sent;
              grid.setCellEnable(rowIndex, pos.indexes[c], enable);

            case 14:
              c++;
              _context5.next = 8;
              break;

            case 17:
              _context5.next = 29;
              break;

            case 19:
              access = _YIUIBase.YIUI.ViewUtil.checkCellAccessControl(this.form, grid, rowIndex, exp.target);
              _context5.next = 22;
              return this.calcEnable(exp, context, this.getFormEnable(), access);

            case 22:
              enable = _context5.sent;
              grid.setCellEnable(rowIndex, pos.index, enable);

              if (!(calcSubDetails && grid.getFocusRowIndex() != -1)) {
                _context5.next = 29;
                break;
              }

              subDetails = this.form.getCellSubDtlComps(grid.key, exp.target);

              if (subDetails) {
                _context5.next = 28;
                break;
              }

              return _context5.abrupt("continue", 29);

            case 28:
              for (j = 0, length = subDetails.length; j < length; j++) {
                subDetails[j].setEnable(enable);
              }

            case 29:
              i++;
              _context5.next = 3;
              break;

            case 32:
            case "end":
              return _context5.stop();
          }
        }
      }, _callee5, this);
    }));

    function impl_calcGridRow(_x17, _x18, _x19, _x20, _x21) {
      return _impl_calcGridRow.apply(this, arguments);
    }

    return impl_calcGridRow;
  }(),
  calcListViewColumns: function () {
    var _calcListViewColumns = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee6(listView, item, formEnable) {
      var items, i, size, enable;
      return regeneratorRuntime.wrap(function _callee6$(_context6) {
        while (1) {
          switch (_context6.prev = _context6.next) {
            case 0:
              items = item.items;

              if (items) {
                _context6.next = 3;
                break;
              }

              return _context6.abrupt("return");

            case 3:
              i = 0, size = items.length;

            case 4:
              if (!(i < size)) {
                _context6.next = 14;
                break;
              }

              if (!(items[i].type != this.EnableItemType.Column)) {
                _context6.next = 7;
                break;
              }

              return _context6.abrupt("continue", 11);

            case 7:
              _context6.next = 9;
              return this.calcEnable(items[i], this.newContext(this.form, -1, -1), formEnable, true);

            case 9:
              enable = _context6.sent;
              listView.setColumnEnable(items[i].target, enable);

            case 11:
              i++;
              _context6.next = 4;
              break;

            case 14:
            case "end":
              return _context6.stop();
          }
        }
      }, _callee6, this);
    }));

    function calcListViewColumns(_x22, _x23, _x24) {
      return _calcListViewColumns.apply(this, arguments);
    }

    return calcListViewColumns;
  }(),
  calcSubDetail: function calcSubDetail(gridKey) {
    var items = this.form.dependency.enableTree.items;

    for (var i = 0, size = items.length; i < size; i++) {
      var component = this.form.getComponent(items[i].source);
      if (!component || !_YIUIBase.YIUI.SubDetailUtil.isSubDetail(this.form, component, gridKey)) continue;

      switch (items[i].objectType) {
        case _YIUIBase.YIUI.ExprItem_Type.Item:
          var cell = _YIUIBase.YIUI.SubDetailUtil.getBindingCellData(this.form, component);

          this.calcHeadItem(component, items[i], cell ? cell[2] : this.getFormEnable(), false);
          break;

        case _YIUIBase.YIUI.ExprItem_Type.Set:
          switch (component.type) {
            case _YIUIBase.YIUI.CONTROLTYPE.GRID:
              this.calcGrid(component, this.initTree(items[i]), this.getFormEnable(), false);
              break;

            case _YIUIBase.YIUI.CONTROLTYPE.LISTVIEW:
              this.calcListViewColumns(component, this.initTree(items[i]), this.getFormEnable());
              break;

            default:
              break;
          }

      }
    }
  },
  cellValueChanged: function () {
    var _cellValueChanged = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee7(grid, rowIndex, colIndex) {
      var rowData, cellKey, context;
      return regeneratorRuntime.wrap(function _callee7$(_context7) {
        while (1) {
          switch (_context7.prev = _context7.next) {
            case 0:
              rowData = grid.getRowDataAt(rowIndex);
              cellKey = rowData.cellKeys[colIndex];
              context = this.newContext(this.form, rowIndex, colIndex);
              _context7.next = 5;
              return this.impl_ValueChanged(grid, context, rowIndex, cellKey);

            case 5:
            case "end":
              return _context7.stop();
          }
        }
      }, _callee7, this);
    }));

    function cellValueChanged(_x25, _x26, _x27) {
      return _cellValueChanged.apply(this, arguments);
    }

    return cellValueChanged;
  }(),
  valueChanged: function () {
    var _valueChanged = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee8(com) {
      var affectItem, i, size, exp;
      return regeneratorRuntime.wrap(function _callee8$(_context8) {
        while (1) {
          switch (_context8.prev = _context8.next) {
            case 0:
              affectItem = this.form.dependency.enableTree.affectItems[com.key]; // var affectItem;
              // for (var i = 0, len = affectItems.length; i < len; i++) {
              //     if (affectItems[i].key === com.key) {
              //         affectItem = affectItems[i];
              //         break;
              //     }
              // }

              if (!affectItem) {
                _context8.next = 53;
                break;
              }

              i = 0, size = affectItem.length;

            case 3:
              if (!(i < size)) {
                _context8.next = 53;
                break;
              }

              exp = affectItem[i];
              com = this.form.getComponent(exp.source);
              _context8.t0 = exp.objectType;
              _context8.next = _context8.t0 === _YIUIBase.YIUI.ExprItem_Type.Item ? 9 : _context8.t0 === _YIUIBase.YIUI.ExprItem_Type.Set ? 27 : 49;
              break;

            case 9:
              if (!(exp.type == this.EnableItemType.Operation)) {
                _context8.next = 18;
                break;
              }

              _context8.t1 = this.form;
              _context8.t2 = exp.target;
              _context8.next = 14;
              return this.form.evalFormula(exp.content, this.newContext(this.form, -1, -1), null);

            case 14:
              _context8.t3 = _context8.sent;

              _context8.t1.setOperationEnable.call(_context8.t1, _context8.t2, _context8.t3);

              _context8.next = 26;
              break;

            case 18:
              _context8.t4 = this;
              _context8.t5 = com;
              _context8.t6 = exp;
              _context8.next = 23;
              return this.getFormEnable();

            case 23:
              _context8.t7 = _context8.sent;
              _context8.next = 26;
              return _context8.t4.calcHeadItem.call(_context8.t4, _context8.t5, _context8.t6, _context8.t7, true);

            case 26:
              return _context8.abrupt("break", 50);

            case 27:
              _context8.t8 = com.type;
              _context8.next = _context8.t8 === _YIUIBase.YIUI.CONTROLTYPE.GRID ? 30 : _context8.t8 === _YIUIBase.YIUI.CONTROLTYPE.LISTVIEW ? 39 : 48;
              break;

            case 30:
              _context8.t9 = this;
              _context8.t10 = com;
              _context8.t11 = this.initTree(exp);
              _context8.next = 35;
              return this.getFormEnable();

            case 35:
              _context8.t12 = _context8.sent;
              _context8.next = 38;
              return _context8.t9.calcGrid.call(_context8.t9, _context8.t10, _context8.t11, _context8.t12, true);

            case 38:
              return _context8.abrupt("break", 48);

            case 39:
              _context8.t13 = this;
              _context8.t14 = com;
              _context8.t15 = this.initTree(exp);
              _context8.next = 44;
              return this.getFormEnable();

            case 44:
              _context8.t16 = _context8.sent;
              _context8.next = 47;
              return _context8.t13.calcListViewColumns.call(_context8.t13, _context8.t14, _context8.t15, _context8.t16);

            case 47:
              return _context8.abrupt("break", 48);

            case 48:
              return _context8.abrupt("break", 50);

            case 49:
              return _context8.abrupt("break", 50);

            case 50:
              i++;
              _context8.next = 3;
              break;

            case 53:
            case "end":
              return _context8.stop();
          }
        }
      }, _callee8, this);
    }));

    function valueChanged(_x28) {
      return _valueChanged.apply(this, arguments);
    }

    return valueChanged;
  }(),
  impl_ValueChanged: function () {
    var _impl_ValueChanged = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee9(grid, context, rowIndex, cellKey) {
      var items, item, com, i;
      return regeneratorRuntime.wrap(function _callee9$(_context9) {
        while (1) {
          switch (_context9.prev = _context9.next) {
            case 0:
              items = this.form.dependency.enableTree.affectItems[cellKey];

              if (items) {
                _context9.next = 3;
                break;
              }

              return _context9.abrupt("return");

            case 3:
              i = 0;

            case 4:
              if (!(item = items[i])) {
                _context9.next = 42;
                break;
              }

              com = this.form.getComponent(item.source);

              if (!(!com && item.type !== this.EnableItemType.Operation)) {
                _context9.next = 8;
                break;
              }

              return _context9.abrupt("continue", 39);

            case 8:
              _context9.t0 = item.objectType;
              _context9.next = _context9.t0 === _YIUIBase.YIUI.ExprItem_Type.Item ? 11 : _context9.t0 === _YIUIBase.YIUI.ExprItem_Type.Set ? 23 : 38;
              break;

            case 11:
              if (!(item.type == this.EnableItemType.Operation)) {
                _context9.next = 20;
                break;
              }

              _context9.t1 = this.form;
              _context9.t2 = item.target;
              _context9.next = 16;
              return this.form.eval(item.content, this.newContext(this.form, -1, -1), null);

            case 16:
              _context9.t3 = _context9.sent;

              _context9.t1.setOperationEnable.call(_context9.t1, _context9.t2, _context9.t3);

              _context9.next = 22;
              break;

            case 20:
              _context9.next = 22;
              return this.calcHeadItem(com, item, true);

            case 22:
              return _context9.abrupt("break", 39);

            case 23:
              if (!(grid.key === com.key && cellKey.indexOf(":RowIndex") == -1)) {
                _context9.next = 29;
                break;
              }

              context.rowIndex = rowIndex;
              _context9.next = 27;
              return this.impl_calcGridRow(context, grid, rowIndex, item, true);

            case 27:
              _context9.next = 37;
              break;

            case 29:
              if (!_YIUIBase.YIUI.SubDetailUtil.isSubDetail(this.form, grid, com.key)) {
                _context9.next = 35;
                break;
              }

              context.rowIndex = com.getFocusRowIndex();
              _context9.next = 33;
              return this.impl_calcGridRow(context, com, com.getFocusRowIndex(), item, true);

            case 33:
              _context9.next = 37;
              break;

            case 35:
              _context9.next = 37;
              return this.calcGrid(com, item, true);

            case 37:
              return _context9.abrupt("break", 39);

            case 38:
              return _context9.abrupt("break", 39);

            case 39:
              i++;
              _context9.next = 4;
              break;

            case 42:
            case "end":
              return _context9.stop();
          }
        }
      }, _callee9, this);
    }));

    function impl_ValueChanged(_x29, _x30, _x31, _x32) {
      return _impl_ValueChanged.apply(this, arguments);
    }

    return impl_ValueChanged;
  }(),
  doAfterDeleteRow: function () {
    var _doAfterDeleteRow = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee10(grid) {
      var ctx;
      return regeneratorRuntime.wrap(function _callee10$(_context10) {
        while (1) {
          switch (_context10.prev = _context10.next) {
            case 0:
              ctx = this.newContext(this.form, -1, -1); // 计算行数改变的影响

              _context10.next = 3;
              return this.impl_ValueChanged(grid, ctx, -1, grid.key + ":RowCount");

            case 3:
              _context10.next = 5;
              return this.impl_ValueChanged(grid, ctx, -1, grid.key + ":RowIndex");

            case 5:
            case "end":
              return _context10.stop();
          }
        }
      }, _callee10, this);
    }));

    function doAfterDeleteRow(_x33) {
      return _doAfterDeleteRow.apply(this, arguments);
    }

    return doAfterDeleteRow;
  }(),
  doAfterInsertRow: function () {
    var _doAfterInsertRow = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee11(component, rowIndex) {
      return regeneratorRuntime.wrap(function _callee11$(_context11) {
        while (1) {
          switch (_context11.prev = _context11.next) {
            case 0:
              if (!(component.type != _YIUIBase.YIUI.CONTROLTYPE.GRID)) {
                _context11.next = 2;
                break;
              }

              return _context11.abrupt("return");

            case 2:
              _context11.next = 4;
              return this.calcGridRow(component, rowIndex);

            case 4:
            case "end":
              return _context11.stop();
          }
        }
      }, _callee11, this);
    }));

    function doAfterInsertRow(_x34, _x35) {
      return _doAfterInsertRow.apply(this, arguments);
    }

    return doAfterInsertRow;
  }(),
  doAfterRowChanged: function () {
    var _doAfterRowChanged = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee12(grid) {
      var ctx;
      return regeneratorRuntime.wrap(function _callee12$(_context12) {
        while (1) {
          switch (_context12.prev = _context12.next) {
            case 0:
              ctx = this.newContext(this.form, -1, -1); // 计算行号改变的影响

              _context12.next = 3;
              return this.impl_ValueChanged(grid, ctx, -1, grid.key + ":RowIndex");

            case 3:
            case "end":
              return _context12.stop();
          }
        }
      }, _callee12, this);
    }));

    function doAfterRowChanged(_x36) {
      return _doAfterRowChanged.apply(this, arguments);
    }

    return doAfterRowChanged;
  }(),
  calcGridRow: function () {
    var _calcGridRow = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee13(grid, rowIndex) {
      var ctx, items, i, size;
      return regeneratorRuntime.wrap(function _callee13$(_context13) {
        while (1) {
          switch (_context13.prev = _context13.next) {
            case 0:
              ctx = this.newContext(this.form, rowIndex, -1);
              items = this.form.dependency.enableTree.items;
              i = 0, size = items.length;

            case 3:
              if (!(i < size)) {
                _context13.next = 10;
                break;
              }

              if (!(items[i].objectType == _YIUIBase.YIUI.ExprItem_Type.Set && items[i].source === grid.key)) {
                _context13.next = 7;
                break;
              }

              _context13.next = 7;
              return this.impl_calcGridRow(ctx, grid, rowIndex, items[i], this.getFormEnable(), false);

            case 7:
              i++;
              _context13.next = 3;
              break;

            case 10:
              // 计算行数改变的影响
              this.impl_ValueChanged(grid, ctx, -1, grid.key + ":RowCount"); // 计算行号改变的影响

              this.impl_ValueChanged(grid, ctx, -1, grid.key + ":RowIndex");

            case 12:
            case "end":
              return _context13.stop();
          }
        }
      }, _callee13, this);
    }));

    function calcGridRow(_x37, _x38) {
      return _calcGridRow.apply(this, arguments);
    }

    return calcGridRow;
  }(),
  reCalcComponent: function () {
    var _reCalcComponent = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee14(component) {
      var items, i, size;
      return regeneratorRuntime.wrap(function _callee14$(_context14) {
        while (1) {
          switch (_context14.prev = _context14.next) {
            case 0:
              items = this.form.dependency.enableTree.items;
              i = 0, size = items.length;

            case 2:
              if (!(i < size)) {
                _context14.next = 27;
                break;
              }

              if (!(items[i].source !== component.key)) {
                _context14.next = 5;
                break;
              }

              return _context14.abrupt("continue", 24);

            case 5:
              _context14.t0 = component.type;
              _context14.next = _context14.t0 === _YIUIBase.YIUI.CONTROLTYPE.GRID ? 8 : _context14.t0 === _YIUIBase.YIUI.CONTROLTYPE.LISTVIEW ? 16 : 24;
              break;

            case 8:
              if (!(items[i].objectType == _YIUIBase.YIUI.ExprItem_Type.Set)) {
                _context14.next = 13;
                break;
              }

              _context14.next = 11;
              return this.calcGrid(component, items[i], this.getFormEnable(), false);

            case 11:
              _context14.next = 15;
              break;

            case 13:
              _context14.next = 15;
              return this.calcHeadItem(component, items[i], this.getFormEnable(), false);

            case 15:
              return _context14.abrupt("break", 24);

            case 16:
              if (!(items[i].objectType == _YIUIBase.YIUI.ExprItem_Type.Set)) {
                _context14.next = 21;
                break;
              }

              _context14.next = 19;
              return this.calcListViewColumns(component, this.initTree(items[i]), this.getFormEnable(), false);

            case 19:
              _context14.next = 23;
              break;

            case 21:
              _context14.next = 23;
              return this.calcHeadItem(component, items[i], this.getFormEnable(), false);

            case 23:
              return _context14.abrupt("break", 24);

            case 24:
              i++;
              _context14.next = 2;
              break;

            case 27:
            case "end":
              return _context14.stop();
          }
        }
      }, _callee14, this);
    }));

    function reCalcComponent(_x39) {
      return _reCalcComponent.apply(this, arguments);
    }

    return reCalcComponent;
  }(),
  calcAll: function () {
    var _calcAll = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee15() {
      var items, i, size, exp, component;
      return regeneratorRuntime.wrap(function _callee15$(_context15) {
        while (1) {
          switch (_context15.prev = _context15.next) {
            case 0:
              items = this.form.dependency.enableTree.items;
              i = 0, size = items.length;

            case 2:
              if (!(i < size)) {
                _context15.next = 28;
                break;
              }

              exp = items[i];
              component = this.form.getComponent(exp.source);

              if (!(exp.type == this.EnableItemType.Operation)) {
                _context15.next = 7;
                break;
              }

              return _context15.abrupt("continue", 25);

            case 7:
              if (component) {
                _context15.next = 9;
                break;
              }

              return _context15.abrupt("continue", 25);

            case 9:
              _context15.t0 = exp.objectType;
              _context15.next = _context15.t0 === _YIUIBase.YIUI.ExprItem_Type.Item ? 12 : _context15.t0 === _YIUIBase.YIUI.ExprItem_Type.Set ? 15 : 25;
              break;

            case 12:
              _context15.next = 14;
              return this.calcHeadItem(component, exp, this.getFormEnable(), false);

            case 14:
              return _context15.abrupt("break", 25);

            case 15:
              _context15.t1 = component.type;
              _context15.next = _context15.t1 === _YIUIBase.YIUI.CONTROLTYPE.GRID ? 18 : _context15.t1 === _YIUIBase.YIUI.CONTROLTYPE.LISTVIEW ? 21 : 24;
              break;

            case 18:
              _context15.next = 20;
              return this.calcGrid(component, exp, this.getFormEnable(), false);

            case 20:
              return _context15.abrupt("break", 24);

            case 21:
              _context15.next = 23;
              return this.calcListViewColumns(component, exp, this.getFormEnable());

            case 23:
              return _context15.abrupt("break", 24);

            case 24:
              return _context15.abrupt("break", 25);

            case 25:
              i++;
              _context15.next = 2;
              break;

            case 28:
            case "end":
              return _context15.stop();
          }
        }
      }, _callee15, this);
    }));

    function calcAll() {
      return _calcAll.apply(this, arguments);
    }

    return calcAll;
  }()
}); // })();


exports["default"] = _default;