"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _YIUIBase = require("../YIUI-base");

require("../YIUI-common");

require("../YIUI-parser");

require("../YIUI-svr");

var _yesCommon = require("yes-common");

require("../uiprocess");

require("../abstractuiprocess");

require("../yes-ui");

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var _default = _YIUIBase.YIUI.UIParaProcess = function () {
  /**
   * 静态私有方法,刷新一个参数的值
   * @param para 参数
   */
  var refreshPara =
  /*#__PURE__*/
  function () {
    var _ref = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee(form, para) {
      var value, cellLocation, key, row, column, comp;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.t0 = para.type;
              _context.next = _context.t0 === _YIUIBase.YIUI.ParameterSourceType.CONST ? 3 : _context.t0 === _YIUIBase.YIUI.ParameterSourceType.FORMULA ? 5 : _context.t0 === _YIUIBase.YIUI.ParameterSourceType.FIELD ? 9 : 13;
              break;

            case 3:
              value = _YIUIBase.YIUI.TypeConvertor.toDataType(para.dataType, para.value);
              return _context.abrupt("break", 13);

            case 5:
              _context.next = 7;
              return form.eval(para.formula, {
                form: form
              }, null);

            case 7:
              value = _context.sent;
              return _context.abrupt("break", 13);

            case 9:
              cellLocation = form.getCellLocation(para.value);

              if (cellLocation) {
                // 固定行单元格
                key = cellLocation.key, row = cellLocation.row, column = cellLocation.column;
                value = form.getCellValByIndex(key, row, column);
              } else {
                // 头控件
                comp = form.getComponent(key);

                if (!comp) {
                  _YIUIBase.YIUI.ViewException.throwException(_YIUIBase.YIUI.ViewException.COMPONENT_NOT_EXISTS, key);
                }

                value = comp.getValue();
              }

              if (value instanceof _YIUIBase.YIUI.ItemData) {
                value = value.getOID();
              }

              return _context.abrupt("break", 13);

            case 13:
              form.setPara(para.key, value);

            case 14:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function refreshPara(_x, _x2) {
      return _ref.apply(this, arguments);
    };
  }();

  var Return = {
    // 计算所有参数的值
    calcAll: function () {
      var _calcAll = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee2(form) {
        var paras, i, size;
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                paras = form.dependency.paraTree.items;
                i = 0, size = paras.length;

              case 2:
                if (!(i < size)) {
                  _context2.next = 8;
                  break;
                }

                _context2.next = 5;
                return refreshPara(form, paras[i]);

              case 5:
                i++;
                _context2.next = 2;
                break;

              case 8:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }));

      function calcAll(_x3) {
        return _calcAll.apply(this, arguments);
      }

      return calcAll;
    }(),
    // 值改变影响的参数值重新计算
    valueChanged: function valueChanged(form, component) {
      var affectItems = form.dependency.paraTree.affectItems;
      if (!affectItems) return;
      var affect;

      for (var i = 0, length = affectItems.length; i < length; i++) {
        if (affectItems[i].key === component.key) {
          affect = affectItems[i];
          break;
        }
      }

      if (affect) {
        for (var i = 0, size = affect.expItems.length; i < size; i++) {
          refreshPara(form, affect.expItems[i]);
        }
      }
    }
  };
  return Return;
}();

exports["default"] = _default;