"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _YIUIBase = require("../YIUI-base");

require("../YIUI-common");

require("../YIUI-parser");

require("../YIUI-svr");

var _yesCommon = require("yes-common");

require("../uiprocess");

require("../abstractuiprocess");

require("../yes-ui");

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

// (function () {
var _default = _YIUIBase.YIUI.UIVisibleProcess = _YIUIBase.YIUI.extend(_YIUIBase.YIUI.AbstractUIProcess, {
  VisibleItemType: {
    Head: 0,
    Column: 1,
    Operation: 2
  },
  init: function init(form) {
    this.base(form);
  },
  calcExprItemObject: function () {
    var _calcExprItemObject = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee(component, item) {
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.t0 = item.objectType;
              _context.next = _context.t0 === _YIUIBase.YIUI.ExprItem_Type.Item ? 3 : _context.t0 === _YIUIBase.YIUI.ExprItem_Type.Set ? 6 : 16;
              break;

            case 3:
              _context.next = 5;
              return this.calcHeadItem(component, item);

            case 5:
              return _context.abrupt("break", 16);

            case 6:
              _context.t1 = component.type;
              _context.next = _context.t1 === _YIUIBase.YIUI.CONTROLTYPE.GRID ? 9 : _context.t1 === _YIUIBase.YIUI.CONTROLTYPE.LISTVIEW ? 12 : 15;
              break;

            case 9:
              _context.next = 11;
              return this.calcGrid(component, this.initTree(item), this.newContext(this.form, -1, -1));

            case 11:
              return _context.abrupt("break", 15);

            case 12:
              _context.next = 14;
              return this.calcListView(component, this.initTree(item), this.newContext(this.form, -1, -1));

            case 14:
              return _context.abrupt("break", 15);

            case 15:
              return _context.abrupt("break", 16);

            case 16:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    function calcExprItemObject(_x, _x2) {
      return _calcExprItemObject.apply(this, arguments);
    }

    return calcExprItemObject;
  }(),
  calcAll: function () {
    var _calcAll = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee2() {
      var items, i, size, exp, component;
      return regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              items = this.form.dependency.visibleTree.items;
              i = 0, size = items.length;

            case 2:
              if (!(i < size)) {
                _context2.next = 12;
                break;
              }

              exp = items[i];
              component = this.form.getComponent(exp.source);

              if (component) {
                _context2.next = 7;
                break;
              }

              return _context2.abrupt("continue", 9);

            case 7:
              _context2.next = 9;
              return this.calcExprItemObject(component, exp);

            case 9:
              i++;
              _context2.next = 2;
              break;

            case 12:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, this);
    }));

    function calcAll() {
      return _calcAll.apply(this, arguments);
    }

    return calcAll;
  }(),
  calcSubDetail: function calcSubDetail(grid) {
    var items = this.form.dependency.visibleTree.items;

    for (var i = 0, size = items.length; i < size; i++) {
      var exp = items[i];
      var component = this.form.getComponent(exp.source);
      if (!component || _YIUIBase.YIUI.SubDetailUtil.isSubDetail(this.form, component, grid.key)) ;
      continue;
      this.calcExprItemObject(component, exp);
    }
  },
  calcHeadItem: function () {
    var _calcHeadItem = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee3(component, item) {
      var visible, oldVisible;
      return regeneratorRuntime.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              if (!(_yesCommon.lodash.inArray(item.source, this.form.buddyKeys) !== -1)) {
                _context3.next = 2;
                break;
              }

              return _context3.abrupt("return");

            case 2:
              _context3.next = 4;
              return this.calcVisible(item, this.newContext(this.form, -1, -1));

            case 4:
              visible = _context3.sent;
              oldVisible = component.isVisible(); // 设置可见性

              component.setVisible(visible, false); // 如果组件不可见且带有错误信息,那么显示在表单上
              // 如果此时为错误,计算检查规则后正确,不影响显示

              if (oldVisible !== visible) {
                if (!visible) {
                  if (!this.form.isError() || this.form.formKey != this.form.errorInfo.errorSource) {
                    if (component.isError()) {
                      this.form.setError(true, component.errorInfo.msg, component.key);
                    }

                    if (component.isRequired() && !component.getValue()) {
                      this.form.setError(true, component.caption + "is Required", component.key);
                    }
                  }
                } else {
                  // 否则清除表单的错误信息
                  if (this.form.isError() && this.form.errorInfo.errorSource == component.key) {
                    this.form.setError(false, null);
                  }
                }
              }

            case 8:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3, this);
    }));

    function calcHeadItem(_x3, _x4) {
      return _calcHeadItem.apply(this, arguments);
    }

    return calcHeadItem;
  }(),
  calcListView: function () {
    var _calcListView = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee4(listView, item, context) {
      var items, i, size, exp, visible;
      return regeneratorRuntime.wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              items = item.items;

              if (items) {
                _context4.next = 3;
                break;
              }

              return _context4.abrupt("return");

            case 3:
              i = 0, size = item.items.length;

            case 4:
              if (!(i < size)) {
                _context4.next = 15;
                break;
              }

              exp = item.items[i];

              if (!(exp.type != this.VisibleItemType.Column)) {
                _context4.next = 8;
                break;
              }

              return _context4.abrupt("continue", 12);

            case 8:
              _context4.next = 10;
              return this.calcVisible(exp, context);

            case 10:
              visible = _context4.sent;
              listView.setColumnVisible(exp.target, visible);

            case 12:
              i++;
              _context4.next = 4;
              break;

            case 15:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4, this);
    }));

    function calcListView(_x5, _x6, _x7) {
      return _calcListView.apply(this, arguments);
    }

    return calcListView;
  }(),
  calcGrid: function () {
    var _calcGrid = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee5(grid, item, cxt) {
      var items, unVisible, visible, exp, pos, i, size, k, length;
      return regeneratorRuntime.wrap(function _callee5$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              items = item.items;

              if (items) {
                _context5.next = 3;
                break;
              }

              return _context5.abrupt("return");

            case 3:
              unVisible = this.form.dependency.unVisibleKeys;
              i = 0, size = item.items.length;

            case 5:
              if (!(i < size)) {
                _context5.next = 37;
                break;
              }

              exp = item.items[i], pos = exp.pos;

              if (!(exp.type != this.VisibleItemType.Column)) {
                _context5.next = 9;
                break;
              }

              return _context5.abrupt("continue", 34);

            case 9:
              if (!pos.columnExpand) {
                _context5.next = 26;
                break;
              }

              k = 0, length = pos.indexes.length;

            case 11:
              if (!(k < length)) {
                _context5.next = 24;
                break;
              }

              cxt.colIndex = pos.indexes[k];

              if (!(unVisible && _yesCommon.lodash.inArray(exp.target, unVisible) != -1)) {
                _context5.next = 17;
                break;
              }

              visible = false;
              _context5.next = 20;
              break;

            case 17:
              _context5.next = 19;
              return this.calcVisible(exp, cxt);

            case 19:
              visible = _context5.sent;

            case 20:
              grid.setColumnVisible(pos.indexes[k], visible);

            case 21:
              k++;
              _context5.next = 11;
              break;

            case 24:
              _context5.next = 34;
              break;

            case 26:
              if (!(unVisible && _yesCommon.lodash.inArray(exp.target, unVisible) != -1)) {
                _context5.next = 30;
                break;
              }

              visible = false;
              _context5.next = 33;
              break;

            case 30:
              _context5.next = 32;
              return this.calcVisible(exp, cxt);

            case 32:
              visible = _context5.sent;

            case 33:
              grid.setColumnVisible(pos.index, visible);

            case 34:
              i++;
              _context5.next = 5;
              break;

            case 37:
            case "end":
              return _context5.stop();
          }
        }
      }, _callee5, this);
    }));

    function calcGrid(_x8, _x9, _x10) {
      return _calcGrid.apply(this, arguments);
    }

    return calcGrid;
  }(),
  valueChanged: function () {
    var _valueChanged = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee6(com) {
      var affectItem, i, size, exp;
      return regeneratorRuntime.wrap(function _callee6$(_context6) {
        while (1) {
          switch (_context6.prev = _context6.next) {
            case 0:
              affectItem = this.form.dependency.visibleTree.affectItems[com.key]; // var affectItem;
              // for (var i = 0, len = affectItems.length; i < len; i++) {
              //     if (affectItems[i].key === com.key) {
              //         affectItem = affectItems[i];
              //         break;
              //     }
              // }

              if (!affectItem) {
                _context6.next = 35;
                break;
              }

              i = 0, size = affectItem.length;

            case 3:
              if (!(i < size)) {
                _context6.next = 35;
                break;
              }

              exp = affectItem[i];
              com = this.form.getComponent(exp.source);
              _context6.t0 = exp.objectType;
              _context6.next = _context6.t0 === _YIUIBase.YIUI.ExprItem_Type.Item ? 9 : _context6.t0 === _YIUIBase.YIUI.ExprItem_Type.Set ? 21 : 31;
              break;

            case 9:
              if (!(exp.type == this.VisibleItemType.Operation)) {
                _context6.next = 18;
                break;
              }

              _context6.t1 = this.form;
              _context6.t2 = exp.target;
              _context6.next = 14;
              return this.form.eval(exp.content, this.newContext(this.form, -1, -1), null);

            case 14:
              _context6.t3 = _context6.sent;

              _context6.t1.setOperationVisible.call(_context6.t1, _context6.t2, _context6.t3);

              _context6.next = 20;
              break;

            case 18:
              _context6.next = 20;
              return this.calcHeadItem(com, exp);

            case 20:
              return _context6.abrupt("break", 32);

            case 21:
              _context6.t4 = com.type;
              _context6.next = _context6.t4 === _YIUIBase.YIUI.CONTROLTYPE.GRID ? 24 : _context6.t4 === _YIUIBase.YIUI.CONTROLTYPE.LISTVIEW ? 27 : 30;
              break;

            case 24:
              _context6.next = 26;
              return this.calcGrid(com, exp, this.newContext(this.form, -1, -1));

            case 26:
              return _context6.abrupt("break", 30);

            case 27:
              _context6.next = 29;
              return this.calcListView(com, exp, this.newContext(this.form, -1, -1));

            case 29:
              return _context6.abrupt("break", 30);

            case 30:
              return _context6.abrupt("break", 32);

            case 31:
              return _context6.abrupt("break", 32);

            case 32:
              i++;
              _context6.next = 3;
              break;

            case 35:
            case "end":
              return _context6.stop();
          }
        }
      }, _callee6, this);
    }));

    function valueChanged(_x11) {
      return _valueChanged.apply(this, arguments);
    }

    return valueChanged;
  }(),
  reCalcComponent: function () {
    var _reCalcComponent = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee7(component) {
      var items, i, size;
      return regeneratorRuntime.wrap(function _callee7$(_context7) {
        while (1) {
          switch (_context7.prev = _context7.next) {
            case 0:
              items = this.form.dependency.visibleTree.items;
              i = 0, size = items.length;

            case 2:
              if (!(i < size)) {
                _context7.next = 19;
                break;
              }

              if (!(items[i].objectType != _YIUIBase.YIUI.ExprItem_Type.Set)) {
                _context7.next = 5;
                break;
              }

              return _context7.abrupt("continue", 16);

            case 5:
              if (!(items[i].source !== component.key)) {
                _context7.next = 7;
                break;
              }

              return _context7.abrupt("continue", 16);

            case 7:
              _context7.t0 = component.type;
              _context7.next = _context7.t0 === _YIUIBase.YIUI.CONTROLTYPE.GRID ? 10 : _context7.t0 === _YIUIBase.YIUI.CONTROLTYPE.LISTVIEW ? 13 : 16;
              break;

            case 10:
              _context7.next = 12;
              return this.calcGrid(component, items[i], this.newContext(this.form, -1, -1));

            case 12:
              return _context7.abrupt("break", 16);

            case 13:
              _context7.next = 15;
              return this.calcListView(component, items[i], this.newContext(this.form, -1, -1));

            case 15:
              return _context7.abrupt("break", 16);

            case 16:
              i++;
              _context7.next = 2;
              break;

            case 19:
            case "end":
              return _context7.stop();
          }
        }
      }, _callee7, this);
    }));

    function reCalcComponent(_x12) {
      return _reCalcComponent.apply(this, arguments);
    }

    return reCalcComponent;
  }(),
  cellValueChanged: function () {
    var _cellValueChanged = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee8(grid, rowIndex, colIndex) {
      var ctx, rowData, cellKey, affectItems, affectItem, i, len, size, exp, component;
      return regeneratorRuntime.wrap(function _callee8$(_context8) {
        while (1) {
          switch (_context8.prev = _context8.next) {
            case 0:
              ctx = this.newContext(this.form, rowIndex, colIndex);
              rowData = grid.getRowDataAt(rowIndex);
              cellKey = rowData.cellKeys[colIndex];
              affectItems = this.form.dependency.visibleTree.affectItems;
              i = 0, len = affectItems.length;

            case 5:
              if (!(i < len)) {
                _context8.next = 12;
                break;
              }

              if (!(affectItems[i].key === cellKey)) {
                _context8.next = 9;
                break;
              }

              affectItem = affectItems[i];
              return _context8.abrupt("break", 12);

            case 9:
              i++;
              _context8.next = 5;
              break;

            case 12:
              if (!affectItem) {
                _context8.next = 37;
                break;
              }

              i = 0, size = affectItem.expItems.length;

            case 14:
              if (!(i < size)) {
                _context8.next = 37;
                break;
              }

              exp = affectItem.expItems[i];
              component = this.form.getComponent(exp.source);

              if (component) {
                _context8.next = 19;
                break;
              }

              return _context8.abrupt("continue", 34);

            case 19:
              _context8.t0 = exp.objectType;
              _context8.next = _context8.t0 === _YIUIBase.YIUI.ExprItem_Type.Item ? 22 : _context8.t0 === _YIUIBase.YIUI.ExprItem_Type.Set ? 25 : 34;
              break;

            case 22:
              _context8.next = 24;
              return this.calcHeadItem(component, exp);

            case 24:
              return _context8.abrupt("break", 34);

            case 25:
              _context8.t1 = component.type;
              _context8.next = _context8.t1 === _YIUIBase.YIUI.CONTROLTYPE.Grid ? 28 : _context8.t1 === _YIUIBase.YIUI.CONTROLTYPE.LISTVIEW ? 31 : 34;
              break;

            case 28:
              _context8.next = 30;
              return this.calcGrid(component, items[i], ctx);

            case 30:
              return _context8.abrupt("break", 34);

            case 31:
              _context8.next = 33;
              return this.calcListView(component, items[i], ctx);

            case 33:
              return _context8.abrupt("break", 34);

            case 34:
              i++;
              _context8.next = 14;
              break;

            case 37:
            case "end":
              return _context8.stop();
          }
        }
      }, _callee8, this);
    }));

    function cellValueChanged(_x13, _x14, _x15) {
      return _cellValueChanged.apply(this, arguments);
    }

    return cellValueChanged;
  }(),
  doAfterDeleteRow: function () {
    var _doAfterDeleteRow = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee9(grid) {
      return regeneratorRuntime.wrap(function _callee9$(_context9) {
        while (1) {
          switch (_context9.prev = _context9.next) {
            case 0:
            case "end":
              return _context9.stop();
          }
        }
      }, _callee9);
    }));

    function doAfterDeleteRow(_x16) {
      return _doAfterDeleteRow.apply(this, arguments);
    }

    return doAfterDeleteRow;
  }(),
  doAfterInsertRow: function doAfterInsertRow(grid, rowIndex) {// TODO Auto-generated method stub
  }
}); // })();


exports["default"] = _default;