"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _YIUIBase = require("../YIUI-base");

require("../YIUI-common");

require("../YIUI-parser");

require("../YIUI-svr");

var _yesCommon = require("yes-common");

require("../uiprocess");

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var _default = _YIUIBase.YIUI.ViewDataMonitor = function (form) {
  this.form = form;
  this.uiProcess = new _YIUIBase.YIUI.UIProcess(form);

  this.preFireCellValueChanged = function (grid, rowIndex, colIndex, cellKey) {
    this.uiProcess.doPreCellValueChanged(grid, rowIndex, colIndex, cellKey);
  };

  this.fireCellValueChanged = function (grid, rowIndex, colIndex) {
    var row = grid.dataModel.data[rowIndex],
        metaRow = grid.getMetaObj().rows[row.metaRowIndex],
        cellKey = row.cellKeys[colIndex];
    this.uiProcess.doCellValueChanged(grid, rowIndex, colIndex, cellKey);

    _YIUIBase.YIUI.GridSumUtil.evalAffectSum(form, grid, rowIndex, colIndex);

    var valueChanged = metaRow.cells[colIndex].valueChanged;

    if (valueChanged !== undefined && valueChanged.length > 0) {
      form.eval(_yesCommon.lodash.trim(valueChanged), {
        form: form,
        rowIndex: rowIndex
      }, null);
    }
  };

  this.postFireCellValueChanged = function (grid, rowIndex, colIndex, cellKey) {
    this.uiProcess.doPostCellValueChanged(grid, rowIndex, colIndex, cellKey);
  };

  this.preFireValueChanged = function (component) {
    this.uiProcess.preFireValueChanged(component);
  };

  this.fireValueChanged =
  /*#__PURE__*/
  function () {
    var _ref = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee(component) {
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return this.uiProcess.fireValueChanged(component);

            case 2:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    return function (_x) {
      return _ref.apply(this, arguments);
    };
  }();

  this.postFireValueChanged =
  /*#__PURE__*/
  function () {
    var _ref2 = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee2(component) {
      return regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _context2.next = 2;
              return this.uiProcess.postFireValueChanged(component);

            case 2:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, this);
    }));

    return function (_x2) {
      return _ref2.apply(this, arguments);
    };
  }();

  this.getUIProcess = function () {
    return this.uiProcess;
  };
};

exports["default"] = _default;