"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _YIUIBase = require("../YIUI-base");

require("../YIUI-common");

require("../YIUI-parser");

var _YIUISvr = _interopRequireDefault(require("../YIUI-svr"));

var _yesCommon = require("yes-common");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var _default = _YIUIBase.YIUI.BPMService = function () {
  var _Return;

  var Return = (_Return = {
    /**
     * 关闭流程
     */
    killInstance: function killInstance(instanceID) {
      var params = {
        service: "BPM",
        cmd: "KillInstance",
        instanceID: instanceID
      };
      return _YIUISvr["default"].Request.getData(params);
    },

    /**
    * 重启流程
    */
    restartInstance: function restartInstance(instanceID) {
      var params = {
        service: "BPM",
        cmd: "RestartInstance",
        instanceID: instanceID
      };
      return _YIUISvr["default"].Request.getData(params);
    },

    /**
    * 启动流程
    */
    startInstance: function () {
      var _startInstance = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee(formKey, oid, processKey, formDoc) {
        var doc, params;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                doc = _YIUIBase.YIUI.DataUtil.toJSONDoc(formDoc);
                params = {
                  service: "BPM",
                  cmd: "StartInstance",
                  formKey: formKey,
                  oid: oid,
                  processKey: processKey,
                  document: _yesCommon.lodash.toJSON(doc)
                };
                _context.next = 4;
                return _YIUISvr["default"].Request.getSyncData(_YIUISvr["default"].SvrMgr.ServletURL, params);

              case 4:
                return _context.abrupt("return", _context.sent);

              case 5:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      function startInstance(_x, _x2, _x3, _x4) {
        return _startInstance.apply(this, arguments);
      }

      return startInstance;
    }(),

    /**
        * 直送启动
        */
    dirStartInstance: function dirStartInstance(instanceID, auditResult, formDoc) {
      var doc = _YIUIBase.YIUI.DataUtil.toJSONDoc(formDoc);

      var params = {
        service: "BPM",
        cmd: "DirStartInstance",
        InstanceID: instanceID,
        document: _yesCommon.lodash.toJSON(doc),
        auditResult: auditResult
      };
      return _YIUISvr["default"].Request.getSyncData(_YIUISvr["default"].SvrMgr.ServletURL, params);
    },
    // startInstance: function (formKey, oid, processKey) {
    // 	var params = {
    // 		service: "BPM",
    // 		cmd: "StartInstance",
    // 		formKey: formKey,
    // 		oid: oid,
    // 		processKey: processKey
    // 	};
    // 	return Svr.Request.getData(params);
    // },

    /**
    * 重启流程
    */
    restartInstanceByOID: function restartInstanceByOID(oid) {
      var params = {
        service: "BPM",
        cmd: "RestartInstanceByOID",
        OID: oid
      };
      return _YIUISvr["default"].Request.getData(params);
    },

    /**
     * 单据对应的流程是否启动
     */
    isInstanceStarted: function isInstanceStarted(oid) {
      var params = {
        service: "BPM",
        cmd: "IsInstanceStarted",
        OID: oid
      };
      return _YIUISvr["default"].Request.getSyncData(_YIUISvr["default"].SvrMgr.ServletURL, params); //return Svr.Request.getData(params);
    },

    /**
    * 结束一个流程实例
    */
    endInstance: function () {
      var _endInstance = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee2(form, instanceID, userinfo) {
        var parameters, params;
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                form.refreshParas();
                parameters = form.getParas();
                params = {
                  service: "BPM",
                  cmd: "EndInstance",
                  instanceID: instanceID,
                  userInfo: userinfo
                };

                if (parameters) {
                  params.parameters = parameters.toJSON();
                }

                _context2.next = 6;
                return _YIUISvr["default"].Request.getData(params);

              case 6:
                return _context2.abrupt("return", _context2.sent);

              case 7:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }));

      function endInstance(_x5, _x6, _x7) {
        return _endInstance.apply(this, arguments);
      }

      return endInstance;
    }(),

    /**
    * 暂停一个流程实例
    */
    // 	pauseInstance: async function (wid) {
    // 		var params = {
    // 			service: "BPM",
    // 			cmd: "PauseInstance",
    // 			workitemID: wid
    // 		};
    // 		return await Svr.Request.getData(params);
    // 	},
    // 	/**
    //  * 取消暂停一个流程实例
    //  */
    // 	canclePause: async function (wid) {
    // 		var params = {
    // 			service: "BPM",
    // 			cmd: "CanclePause",
    // 			workitemID: wid
    // 		};
    // 		return await Svr.Request.getData(params);
    // 	},
    pauseInstance: function () {
      var _pauseInstance = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee3(form, instanceID, userinfo) {
        var parameters, params;
        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                form.refreshParas();
                parameters = form.getParas();
                params = {
                  service: "BPM",
                  cmd: "PauseInstance",
                  instanceID: instanceID,
                  userInfo: userinfo
                }; // var def = $.Deferred();
                // var success = function (ret) {
                // 	def.resolve(ret);
                // };

                if (parameters) {
                  params.parameters = parameters.toJSON();
                }

                _context3.next = 6;
                return _YIUISvr["default"].Request.getSyncData(_YIUISvr["default"].SvrMgr.ServletURL, params);

              case 6:
                return _context3.abrupt("return", _context3.sent);

              case 7:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3);
      }));

      function pauseInstance(_x8, _x9, _x10) {
        return _pauseInstance.apply(this, arguments);
      }

      return pauseInstance;
    }(),

    /**
    * 取消暂停一个流程实例
    */
    resume: function () {
      var _resume = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee4(form, instanceID, userinfo) {
        var parameters, params;
        return regeneratorRuntime.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                form.refreshParas();
                parameters = form.getParas();
                params = {
                  service: "BPM",
                  cmd: "Resume",
                  instanceID: instanceID,
                  userInfo: userinfo
                };

                if (parameters) {
                  params.parameters = parameters.toJSON();
                }

                _context4.next = 6;
                return _YIUISvr["default"].Request.getData(params);

              case 6:
                return _context4.abrupt("return", _context4.sent);

              case 7:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4);
      }));

      function resume(_x11, _x12, _x13) {
        return _resume.apply(this, arguments);
      }

      return resume;
    }(),

    /**
    * 提交一个工作项
    */
    commitWorkitem: function () {
      var _commitWorkitem = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee5(workitemInfo, formDoc) {
        var doc, params;
        return regeneratorRuntime.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                doc = _YIUIBase.YIUI.DataUtil.toJSONDoc(formDoc);
                params = {
                  service: "BPM",
                  cmd: "CommitWorkitem",
                  workitemInfo: _yesCommon.lodash.toJSON(workitemInfo),
                  document: _yesCommon.lodash.toJSON(doc)
                };
                _context5.next = 4;
                return _YIUISvr["default"].Request.getData(params);

              case 4:
                return _context5.abrupt("return", _context5.sent);

              case 5:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5);
      }));

      function commitWorkitem(_x14, _x15) {
        return _commitWorkitem.apply(this, arguments);
      }

      return commitWorkitem;
    }(),

    /**
    * 查询一个工作项
    */
    loadWorkitemInfo: function () {
      var _loadWorkitemInfo = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee6(workitemID) {
        var params;
        return regeneratorRuntime.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                params = {
                  service: "BPM",
                  cmd: "LoadWorkitemInfo",
                  workitemID: workitemID
                };
                _context6.next = 3;
                return _YIUISvr["default"].Request.getData(params);

              case 3:
                return _context6.abrupt("return", _context6.sent);

              case 4:
              case "end":
                return _context6.stop();
            }
          }
        }, _callee6);
      }));

      function loadWorkitemInfo(_x16) {
        return _loadWorkitemInfo.apply(this, arguments);
      }

      return loadWorkitemInfo;
    }(),

    /**
    * 批量提交工作项
    */
    batchCommitWorkitem: function batchCommitWorkitem(oids, result, userInfo) {
      var params = {
        service: "BPM",
        cmd: "BatchCommitWorkitem",
        OIDListStr: _yesCommon.lodash.toJSON(oids),
        binaryResult: result,
        userInfo: userInfo
      };
      return _YIUISvr["default"].Request.getData(params);
    },

    /**
    * 批量提交工作项
    */
    batchCommitWorkitemByWID: function () {
      var _batchCommitWorkitemByWID = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee7(wids, result, userInfo) {
        var params;
        return regeneratorRuntime.wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                params = {
                  service: "BPM",
                  cmd: "BatchCommitWorkitemByWID",
                  WIDListStr: _yesCommon.lodash.toJSON(wids),
                  binaryResult: result,
                  userInfo: userInfo
                };
                _context7.next = 3;
                return _YIUISvr["default"].Request.getData(params);

              case 3:
                return _context7.abrupt("return", _context7.sent);

              case 4:
              case "end":
                return _context7.stop();
            }
          }
        }, _callee7);
      }));

      function batchCommitWorkitemByWID(_x17, _x18, _x19) {
        return _batchCommitWorkitemByWID.apply(this, arguments);
      }

      return batchCommitWorkitemByWID;
    }(),

    /**
    * 回滚
    */
    rollbackToWorkitem: function rollbackToWorkitem(workitemID, logicCheck) {
      var params = {
        service: "BPM",
        cmd: "RollbackToWorkitem",
        workitemID: workitemID,
        logicCheck: logicCheck
      };
      return _YIUISvr["default"].Request.getData(params);
    },

    /**
    * 跳至某个节点
    */
    skipToNode: function skipToNode(workitemID, nodeID) {
      var params = {
        service: "BPM",
        cmd: "SkipToNode",
        workitemID: workitemID,
        nodeID: nodeID
      };
      return _YIUISvr["default"].Request.getData(params);
    },

    /**
    * 在叙事薄界面为勾选的若个单据，进行批量审批
    */
    batchStateAction: function batchStateAction(processKey, actionNodeKey, oids, result, userInfo) {
      var params = {
        service: "BPM",
        cmd: "BatchStateAction",
        OIDListStr: _yesCommon.lodash.toJSON(oids),
        processKey: processKey,
        binaryResult: result,
        userInfo: userInfo,
        actionNodeKey: actionNodeKey
      };
      return _YIUISvr["default"].Request.getData(params);
    },

    /**
    * 添加代理
    */
    addDelegateData: function addDelegateData(delegateType, srcOperatorID, tgtOperatorID, objectType, objectKey, nodeKey, startTime, endTime, alwaysValid) {
      var params = {
        service: "BPM",
        cmd: "AddDelegateData",
        delegateType: delegateType,
        srcOperatorID: srcOperatorID,
        tgtOperatorID: tgtOperatorID,
        objectType: objectType,
        objectKey: objectKey,
        nodeKey: nodeKey,
        startTime: startTime.getTime(),
        endTime: endTime.getTime(),
        alwaysValid: alwaysValid
      }; //return Svr.Request.getSyncData(Svr.SvrMgr.ServletURL, params);

      return _YIUISvr["default"].Request.getData(params);
    },

    /**
    * 删除代理
    */
    deleteDelegateData: function deleteDelegateData(delegateID) {
      var params = {
        service: "BPM",
        cmd: "DeleteDelegateData",
        delegateID: delegateID
      };
      return _YIUISvr["default"].Request.getData(params);
    },

    /**
    * 修改代理
    */
    updateDelegateDataState: function updateDelegateDataState(delegateID, onUse) {
      var params = {
        service: "BPM",
        cmd: "UpdateDelegateDataState",
        delegateID: delegateID,
        onUse: onUse
      };
      return _YIUISvr["default"].Request.getData(params);
    },

    /**
    * 注册附件
    */
    registerAttachment: function registerAttachment(oid, key, attachmentOID, attachmentInfo, attachmentPara) {
      var params = {
        service: "BPM",
        cmd: "RegisterAttachment",
        OID: oid,
        Key: key,
        AttachmentOID: attachmentOID,
        AttachmentInfo: attachmentInfo,
        AttachmentPara: attachmentPara
      };
      return _YIUISvr["default"].Request.getSyncData(_YIUISvr["default"].SvrMgr.ServletURL, params); //return Svr.Request.getData(params);
    },

    /**
    * 生成当前流程运转路径
    */
    loadProcessPath: function loadProcessPath(oid) {
      var params = {
        service: "BPMDefService",
        cmd: "LoadProcessPath",
        OID: oid
      };
      return _YIUISvr["default"].Request.getSyncData(_YIUISvr["default"].SvrMgr.ServletURL, params); //return Svr.Request.getData(params);
    },

    /**
    * 在指定的工作项上发起加签动作，会产生一个新的加签工作项，只有这个加签工作项被提交了，当前工作项才可以被提交
    */
    launchTask: function launchTask(wid, nodeKey, ppObject, launchInfo, hideActiveWorkitem) {
      var params = {
        service: "BPMExtend",
        cmd: "LaunchTask",
        WorkitemID: wid,
        NodeKey: nodeKey,
        HideActiveWorkitem: hideActiveWorkitem,
        LaunchInfo: launchInfo,
        PPObject: _yesCommon.lodash.toJSON(ppObject.toJSON())
      }; //return Svr.Request.getSyncData(Svr.SvrMgr.ServletURL, params);

      return _YIUISvr["default"].Request.getData(params);
    },

    /**
    * 在指定的工作项上发起加签动作，会产生一个新的加签工作项，只有这个加签工作项被提交了，当前工作项才可以被提交
    */
    endorseTask: function () {
      var _endorseTask = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee8(wid, operatorID, launchInfo, hide) {
        var params;
        return regeneratorRuntime.wrap(function _callee8$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                params = {
                  service: "BPMExtend",
                  cmd: "EndorseTask",
                  WorkitemID: wid,
                  OperatorID: operatorID,
                  LaunchInfo: launchInfo,
                  HideActiveWorkitem: hide
                };
                _context8.next = 3;
                return _YIUISvr["default"].Request.getSyncData(_YIUISvr["default"].SvrMgr.ServletURL, params);

              case 3:
                return _context8.abrupt("return", _context8.sent);

              case 4:
              case "end":
                return _context8.stop();
            }
          }
        }, _callee8);
      }));

      function endorseTask(_x20, _x21, _x22, _x23) {
        return _endorseTask.apply(this, arguments);
      }

      return endorseTask;
    }()
  }, _defineProperty(_Return, "endorseTask", function endorseTask(wid, operatorID, launchInfo) {
    var params = {
      service: "BPMExtend",
      cmd: "EndorseTask",
      WorkitemID: wid,
      OperatorID: operatorID,
      LaunchInfo: launchInfo
    }; //return Svr.Request.getSyncData(Svr.SvrMgr.ServletURL, params);

    return _YIUISvr["default"].Request.getData(params);
  }), _defineProperty(_Return, "transferTask", function () {
    var _transferTask = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee9(wid, operatorID, createRecord, userinfo, auditResult, srcOperator, transferType) {
      var params;
      return regeneratorRuntime.wrap(function _callee9$(_context9) {
        while (1) {
          switch (_context9.prev = _context9.next) {
            case 0:
              params = {
                service: "BPMExtend",
                cmd: "TransferTask",
                WorkitemID: wid,
                OperatorID: operatorID,
                CreateRecord: createRecord,
                UserInfo: userinfo,
                AuditResult: auditResult,
                SrcOpt: srcOperator,
                TransferType: transferType
              };
              _context9.next = 3;
              return _YIUISvr["default"].Request.getSyncData(_YIUISvr["default"].SvrMgr.ServletURL, params);

            case 3:
              return _context9.abrupt("return", _context9.sent);

            case 4:
            case "end":
              return _context9.stop();
          }
        }
      }, _callee9);
    }));

    function transferTask(_x24, _x25, _x26, _x27, _x28, _x29, _x30) {
      return _transferTask.apply(this, arguments);
    }

    return transferTask;
  }()), _defineProperty(_Return, "transferToNode", function () {
    var _transferToNode = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee10(workiteminfo, formDoc) {
      var doc, params;
      return regeneratorRuntime.wrap(function _callee10$(_context10) {
        while (1) {
          switch (_context10.prev = _context10.next) {
            case 0:
              doc = _YIUIBase.YIUI.DataUtil.toJSONDoc(formDoc);
              params = {
                service: "BPM",
                cmd: "TransferToNode",
                workiteminfo: _yesCommon.lodash.toJSON(workiteminfo),
                document: _yesCommon.lodash.toJSON(doc)
              };
              _context10.next = 4;
              return _YIUISvr["default"].Request.getData(params);

            case 4:
              return _context10.abrupt("return", _context10.sent);

            case 5:
            case "end":
              return _context10.stop();
          }
        }
      }, _callee10);
    }));

    function transferToNode(_x31, _x32) {
      return _transferToNode.apply(this, arguments);
    }

    return transferToNode;
  }()), _defineProperty(_Return, "getAliasKey", function () {
    var _getAliasKey = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee11(platform, formKey) {
      var params;
      return regeneratorRuntime.wrap(function _callee11$(_context11) {
        while (1) {
          switch (_context11.prev = _context11.next) {
            case 0:
              params = {
                cmd: "GetAliasKey",
                service: "WebMetaService",
                PlatForm: platform || 'mobile',
                FormKey: formKey
              };
              _context11.next = 3;
              return _YIUISvr["default"].Request.getData(params);

            case 3:
              return _context11.abrupt("return", _context11.sent);

            case 4:
            case "end":
              return _context11.stop();
          }
        }
      }, _callee11);
    }));

    function getAliasKey(_x33, _x34) {
      return _getAliasKey.apply(this, arguments);
    }

    return getAliasKey;
  }()), _Return);
  return Return;
}();

exports["default"] = _default;