"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _YIUIBase = require("../YIUI-base");

require("../YIUI-common");

require("../YIUI-parser");

var _YIUISvr = _interopRequireDefault(require("../YIUI-svr"));

var _yesCommon = require("yes-common");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var _default = _YIUIBase.YIUI.DataMapService = function () {
  function _DataMapService(f) {
    // this.request = new Svr.Request(f);
    this.request = _YIUISvr["default"].Request;
  }
  /**
   * 中间层批量下推
   */


  _DataMapService.prototype.batchMidMap =
  /*#__PURE__*/
  function () {
    var _ref = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee(mapKey, oids) {
      var paras;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              paras = {
                service: "MapData",
                cmd: "BatchMidMap",
                MapKey: mapKey,
                OIDListStr: _yesCommon.lodash.toJSON(oids)
              };
              _context.next = 3;
              return this.request.getSyncData(null, paras);

            case 3:
              return _context.abrupt("return", true);

            case 4:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    return function (_x, _x2) {
      return _ref.apply(this, arguments);
    };
  }();

  _DataMapService.prototype.mapData =
  /*#__PURE__*/
  function () {
    var _ref2 = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee2(mapKey, srcFormKey, tgtFormKey, srcDoc, tgtDoc) {
      var paras;
      return regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              paras = {
                service: "WebMapData",
                cmd: "Map",
                mapKey: mapKey,
                tgtFormKey: tgtFormKey,
                srcFormKey: srcFormKey,
                srcDoc: _yesCommon.lodash.toJSON(srcDoc),
                tgtDoc: tgtDoc ? _yesCommon.lodash.toJSON(tgtDoc) : ""
              };
              _context2.next = 3;
              return this.request.getData(paras);

            case 3:
              return _context2.abrupt("return", _context2.sent);

            case 4:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, this);
    }));

    return function (_x3, _x4, _x5, _x6, _x7) {
      return _ref2.apply(this, arguments);
    };
  }();

  _DataMapService.prototype.midMap =
  /*#__PURE__*/
  function () {
    var _ref3 = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee3(mapKey, oid) {
      var paras;
      return regeneratorRuntime.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              paras = {
                service: "MapData",
                cmd: "MidMap",
                mapKey: mapKey,
                srcOID: oid
              };
              _context3.next = 3;
              return this.request.getData(paras);

            case 3:
              return _context3.abrupt("return", _context3.sent);

            case 4:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3, this);
    }));

    return function (_x8, _x9) {
      return _ref3.apply(this, arguments);
    };
  }();

  _DataMapService.prototype.autoMap =
  /*#__PURE__*/
  function () {
    var _ref4 = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee4(mapKey, srcDoc) {
      var paras;
      return regeneratorRuntime.wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              paras = {
                service: "MapData",
                cmd: "MidMap",
                mapKey: mapKey,
                srcOrignalDocument: _yesCommon.lodash.toJSON(srcDoc),
                saveTarget: true
              };
              _context4.next = 3;
              return this.request.getData(paras);

            case 3:
              return _context4.abrupt("return", _context4.sent);

            case 4:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4, this);
    }));

    return function (_x10, _x11) {
      return _ref4.apply(this, arguments);
    };
  }();

  return _DataMapService;
}();

exports["default"] = _default;