"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _YIUIBase = require("../YIUI-base");

require("../YIUI-common");

require("../YIUI-parser");

var _YIUISvr = _interopRequireDefault(require("../YIUI-svr"));

var _yesCommon = require("yes-common");

var _cache = _interopRequireDefault(require("../cache"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var _default = _YIUIBase.YIUI.DictService = function () {
  var Return = {
    /**
     * 获取所有父节点ID
     */
    getAllParentID: function () {
      var _getAllParentID = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee(itemKey, itemDatas, callback) {
        var result, data;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                result = true;
                data = {};
                data.itemKey = itemKey;
                data.itemDatas = _yesCommon.lodash.toJSON(itemDatas);
                data.service = "DictService";
                data.cmd = "GetParentPath"; // var success = function(msg) {
                // 	if ($.isFunction(callback)){
                // 		callback(msg);
                // 	}else{
                // 		result = msg;
                // 	}
                // };

                _context.next = 8;
                return _YIUISvr["default"].Request.getData(data);

              case 8:
                return _context.abrupt("return", _context.sent);

              case 9:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      function getAllParentID(_x, _x2, _x3) {
        return _getAllParentID.apply(this, arguments);
      }

      return getAllParentID;
    }(),

    /**
     * 获取所有字典项
     */
    getAllItems: function () {
      var _getAllItems = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee2(itemKey, filter, stateMask, callback) {
        var result, data;
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                result = true;
                data = {};
                data.service = "DictService";
                data.cmd = "GetAllItems";
                data.itemKey = itemKey;

                if (filter != null) {
                  data.filter = _yesCommon.lodash.toJSON(filter);
                }

                data.stateMask = stateMask; // var success = function (msg) {
                //     if ($.isFunction(callback)) {
                //         callback(msg);
                //     } else {
                //         result = msg;
                //     }
                // };

                _context2.next = 9;
                return _YIUISvr["default"].Request.getSyncData(data);

              case 9:
                return _context2.abrupt("return", _context2.sent);

              case 10:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }));

      function getAllItems(_x4, _x5, _x6, _x7) {
        return _getAllItems.apply(this, arguments);
      }

      return getAllItems;
    }(),

    /**
    *批量获取字典项
     */
    getItems: function getItems(itemKey, oids) {
      var result = true;
      var data = {};
      data.service = "DictService";
      data.cmd = "LoadItems";
      data.oids = _yesCommon.lodash.toJSON(oids);
      data.itemKey = itemKey;
      return _YIUISvr["default"].Request.getSyncData(_YIUISvr["default"].SvrMgr.ServletURL, data);
    },

    /**
     * 根据父节点获取子节点
     */
    getDictChildren: function () {
      var _getDictChildren = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee3(itemKey, itemData, filter, stateMask, formKey, fieldKey) {
        var result, params;
        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                result = true;
                params = {};
                params.itemKey = itemKey;
                params.itemData = _yesCommon.lodash.toJSON(itemData);

                if (filter != null) {
                  params.filter = _yesCommon.lodash.toJSON(filter);
                }

                params.service = "WebDictService";
                params.cmd = "GetDictChildren";
                params.stateMask = stateMask;
                params.formKey = formKey;
                params.fieldKey = fieldKey;
                _context3.next = 12;
                return _YIUISvr["default"].Request.getData(params);

              case 12:
                return _context3.abrupt("return", _context3.sent);

              case 13:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3);
      }));

      function getDictChildren(_x8, _x9, _x10, _x11, _x12, _x13) {
        return _getDictChildren.apply(this, arguments);
      }

      return getDictChildren;
    }(),

    /**
     * 精确查找 GetDictOID调用 暂时保留 此同步方法
     */
    locate: function () {
      var _locate = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee4(itemKey, field, value, filter, root, statMask, callback) {
        var result, data;
        return regeneratorRuntime.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                result = true;
                data = {};
                data.itemKey = itemKey;

                if (field != null) {
                  data.field = field;
                }

                data.value = value;

                if (filter != null) {
                  data.filter = _yesCommon.lodash.toJSON(filter);
                }

                data.root = _yesCommon.lodash.toJSON(root);
                data.statMask = statMask;
                data.service = "DictService";
                data.cmd = "Locate";
                _context4.next = 12;
                return _YIUISvr["default"].Request.getData(data);

              case 12:
                return _context4.abrupt("return", _context4.sent);

              case 13:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4);
      }));

      function locate(_x14, _x15, _x16, _x17, _x18, _x19, _x20) {
        return _locate.apply(this, arguments);
      }

      return locate;
    }(),

    /**
    * 精确查找 GetDictOID调用 暂时保留 此同步方法
    */
    lookup: function () {
      var _lookup = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee5(itemKey, field, value, filter, root, statMask, callback) {
        var result, data;
        return regeneratorRuntime.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                result = true;
                data = {};
                data.itemKey = itemKey;

                if (field != null) {
                  data.field = field;
                }

                data.value = value;

                if (filter != null) {
                  data.filter = _yesCommon.lodash.toJSON(filter);
                }

                data.root = _yesCommon.lodash.toJSON(root);
                data.statMask = statMask;
                data.service = "DictService";
                data.cmd = "Locate"; // var success = function(msg) {
                // 	if ($.isFunction(callback)){
                // 		callback(msg);
                // 	}else{
                // 		result = msg;
                // 	}
                // };

                _context5.next = 12;
                return _YIUISvr["default"].Request.getData(data);

              case 12:
                return _context5.abrupt("return", _context5.sent);

              case 13:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5);
      }));

      function lookup(_x21, _x22, _x23, _x24, _x25, _x26, _x27) {
        return _lookup.apply(this, arguments);
      }

      return lookup;
    }(),

    /**
     * 精确查找
     */
    locate2: function () {
      var _locate2 = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee6(itemKey, field, value, filter, root, statMask) {
        var result, params;
        return regeneratorRuntime.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                result = true;
                params = {};
                params.itemKey = itemKey;

                if (field != null) {
                  params.field = field;
                }

                params.value = value;

                if (filter != null) {
                  params.filter = _yesCommon.lodash.toJSON(filter);
                }

                params.root = _yesCommon.lodash.toJSON(root);
                params.statMask = statMask;
                params.service = "DictService";
                params.cmd = "Locate";
                _context6.next = 12;
                return _YIUISvr["default"].Request.getData(params);

              case 12:
                return _context6.abrupt("return", _context6.sent);

              case 13:
              case "end":
                return _context6.stop();
            }
          }
        }, _callee6);
      }));

      function locate2(_x28, _x29, _x30, _x31, _x32, _x33) {
        return _locate2.apply(this, arguments);
      }

      return locate2;
    }(),

    /**
     * 获取一个字典缓存,异步
     */
    getItem: function () {
      var _getItem = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee7(itemKey, oid, statMask, callback) {
        var data, item;
        return regeneratorRuntime.wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                _context7.next = 2;
                return _cache["default"].current.DictCache.get("".concat(itemKey, ".").concat(oid));

              case 2:
                data = _context7.sent;

                if (data) {
                  _context7.next = 5;
                  break;
                }

                return _context7.abrupt("return", null);

              case 5:
                item = _YIUIBase.YIUI.DataUtil.fromJSONItem(data);
                return _context7.abrupt("return", item);

              case 7:
              case "end":
                return _context7.stop();
            }
          }
        }, _callee7);
      }));

      function getItem(_x34, _x35, _x36, _x37) {
        return _getItem.apply(this, arguments);
      }

      return getItem;
    }(),
    getQueryData: function () {
      var _getQueryData = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee8(itemKey, startRow, maxRows, pageIndicatorCount, fuzzyValue, stateMask, filter, root, formKey, fieldKey) {
        var result, params;
        return regeneratorRuntime.wrap(function _callee8$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                result = true;
                params = {};
                params.itemKey = itemKey;
                params.startRow = startRow;
                params.maxRows = maxRows;
                params.pageIndicatorCount = pageIndicatorCount;
                params.value = fuzzyValue;
                params.stateMask = stateMask;

                if (filter != null) {
                  params.filter = _yesCommon.lodash.toJSON(filter);
                }

                if (root != null) {
                  params.root = _yesCommon.lodash.toJSON(root);
                }

                params.formKey = formKey;
                params.fieldKey = fieldKey;
                params.service = "WebDictService";
                params.cmd = "GetQueryData";
                _context8.next = 16;
                return _YIUISvr["default"].Request.getData(params);

              case 16:
                return _context8.abrupt("return", _context8.sent);

              case 17:
              case "end":
                return _context8.stop();
            }
          }
        }, _callee8);
      }));

      function getQueryData(_x38, _x39, _x40, _x41, _x42, _x43, _x44, _x45, _x46, _x47) {
        return _getQueryData.apply(this, arguments);
      }

      return getQueryData;
    }(),
    getQueryCols: function () {
      var _getQueryCols = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee9(itemKey) {
        var params;
        return regeneratorRuntime.wrap(function _callee9$(_context9) {
          while (1) {
            switch (_context9.prev = _context9.next) {
              case 0:
                params = {};
                params.itemKey = itemKey;
                params.service = "WebMetaService";
                params.cmd = "GetQueryColumns";
                _context9.next = 6;
                return _YIUISvr["default"].Request.getData(params);

              case 6:
                return _context9.abrupt("return", _context9.sent);

              case 7:
              case "end":
                return _context9.stop();
            }
          }
        }, _callee9);
      }));

      function getQueryCols(_x48) {
        return _getQueryCols.apply(this, arguments);
      }

      return getQueryCols;
    }(),
    getDisplayCols: function () {
      var _getDisplayCols = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee10(itemKey) {
        var params;
        return regeneratorRuntime.wrap(function _callee10$(_context10) {
          while (1) {
            switch (_context10.prev = _context10.next) {
              case 0:
                params = {};
                params.itemKey = itemKey;
                params.service = "WebMetaService";
                params.cmd = "GetDisplayColumns";
                _context10.next = 6;
                return _YIUISvr["default"].Request.getData(params);

              case 6:
                return _context10.abrupt("return", _context10.sent);

              case 7:
              case "end":
                return _context10.stop();
            }
          }
        }, _callee10);
      }));

      function getDisplayCols(_x49) {
        return _getDisplayCols.apply(this, arguments);
      }

      return getDisplayCols;
    }(),

    /**
     * 直接输入文本时智能提示相关数据
     */
    getSuggestData: function () {
      var _getSuggestData = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee11(itemKey, suggestValue, stateMask, filter, root, callback) {
        var result, data;
        return regeneratorRuntime.wrap(function _callee11$(_context11) {
          while (1) {
            switch (_context11.prev = _context11.next) {
              case 0:
                result = true;
                data = {};
                data.itemKey = itemKey;
                data.value = suggestValue;
                data.stateMask = stateMask;

                if (filter != null) {
                  data.filter = _yesCommon.lodash.toJSON(filter);
                }

                if (root != null) {
                  data.root = _yesCommon.lodash.toJSON(root);
                }

                data.service = "WebDictService";
                data.cmd = "GetSuggestData"; //			var success = function(msg) {
                //				if ($.isFunction(callback)){
                //					callback(msg);
                //				}else{
                //					result = msg;
                //				}
                //			};
                //			Svr.Request.getSyncData(Svr.SvrMgr.ServletURL, data, success);

                _context11.next = 11;
                return _YIUISvr["default"].Request.getData(data);

              case 11:
                return _context11.abrupt("return", _context11.sent);

              case 13:
              case "end":
                return _context11.stop();
            }
          }
        }, _callee11);
      }));

      function getSuggestData(_x50, _x51, _x52, _x53, _x54, _x55) {
        return _getSuggestData.apply(this, arguments);
      }

      return getSuggestData;
    }(),

    /**
     * 获取当前节点的父节点ID
     
    getParentID: function(itemKey, itemData, callback){
    	var result = true;
    	var data = {};
    	data.itemKey = itemKey;
    	data.itemData = $.toJSON(itemData);
    	data.cmd = "GetParentID";
    	data.service = "WebDictService";
    	
    	var success = function(msg) {
    		if ($.isFunction(callback)){
    			callback(msg);
    		}else{
    			result = msg;
    		}
    	};
    		Svr.Request.getSyncData(Svr.SvrMgr.ServletURL, data, success);
    	return result;
    	
    },*/

    /**
     * 修改字典使用状态
     */
    enableDict: function enableDict(itemKey, oid, enable, allChildren, callback) {
      var result = true;
      var data = {};
      data.itemKey = itemKey;
      data.oid = oid;

      if (_typeof(enable) == undefined || enable == null) {
        enable = 1;
      }

      data.enable = enable.toString();
      data.allChildren = allChildren;
      data.cmd = "EnableDict";
      data.service = "WebDictService";

      var success = function success(msg) {
        if (_yesCommon.lodash.isFunction(callback)) {
          callback(msg);
        } else {
          result = msg;
        }
      };

      _YIUISvr["default"].Request.getSyncData(_YIUISvr["default"].SvrMgr.ServletURL, data, success);

      return result;
    },

    /**
     * 根据字典itemKey id取caption
     */
    getCaption: function () {
      var _getCaption = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee12(itemKey, oid) {
        var params;
        return regeneratorRuntime.wrap(function _callee12$(_context12) {
          while (1) {
            switch (_context12.prev = _context12.next) {
              case 0:
                params = {};
                params.itemKey = itemKey;

                if (_yesCommon.lodash.isArray(oid)) {
                  oid = _yesCommon.lodash.toJSON(oid);
                }

                params.oids = oid;
                params.cmd = "getCaption";
                params.service = "WebDictService";
                _context12.next = 8;
                return _YIUISvr["default"].Request.getData(params);

              case 8:
                return _context12.abrupt("return", _context12.sent);

              case 9:
              case "end":
                return _context12.stop();
            }
          }
        }, _callee12);
      }));

      function getCaption(_x56, _x57) {
        return _getCaption.apply(this, arguments);
      }

      return getCaption;
    }(),
    getDictValue: function () {
      var _getDictValue = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee13(itemKey, oid, fieldKey, callback) {
        var dictItem, ivSplit, tbKey, fldKey;
        return regeneratorRuntime.wrap(function _callee13$(_context13) {
          while (1) {
            switch (_context13.prev = _context13.next) {
              case 0:
                console.log("getDictValue(".concat(itemKey, ",").concat(oid, ")"));

                if (!(oid == undefined || oid == null)) {
                  _context13.next = 3;
                  break;
                }

                return _context13.abrupt("return", null);

              case 3:
                _context13.next = 5;
                return this.getItem(itemKey, oid);

              case 5:
                dictItem = _context13.sent;

                if (!dictItem) {
                  _context13.next = 13;
                  break;
                }

                if (!(fieldKey.indexOf('.') > 0)) {
                  _context13.next = 12;
                  break;
                }

                ivSplit = fieldKey.split('.');
                tbKey = ivSplit[0];
                fldKey = ivSplit[1];
                return _context13.abrupt("return", dictItem.getValue(fldKey, tbKey));

              case 12:
                return _context13.abrupt("return", dictItem.getValue(fieldKey));

              case 13:
                return _context13.abrupt("return", null);

              case 14:
              case "end":
                return _context13.stop();
            }
          }
        }, _callee13, this);
      }));

      function getDictValue(_x58, _x59, _x60, _x61) {
        return _getDictValue.apply(this, arguments);
      }

      return getDictValue;
    }(),

    /*
     *根据节点获取父节点路径
     */
    getTreePath: function () {
      var _getTreePath = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee14(itemKey, child) {
        var params;
        return regeneratorRuntime.wrap(function _callee14$(_context14) {
          while (1) {
            switch (_context14.prev = _context14.next) {
              case 0:
                params = {
                  service: "DictService",
                  cmd: "GetParentPath",
                  itemKey: itemKey
                };
                params[_yesCommon.lodash.isArray(child) ? 'itemDatas' : 'itemData'] = _yesCommon.lodash.toJSON(child);
                _context14.next = 4;
                return _YIUISvr["default"].Request.getData(params);

              case 4:
                return _context14.abrupt("return", _context14.sent);

              case 5:
              case "end":
                return _context14.stop();
            }
          }
        }, _callee14);
      }));

      function getTreePath(_x62, _x63) {
        return _getTreePath.apply(this, arguments);
      }

      return getTreePath;
    }(),
    getParentPath: function () {
      var _getParentPath = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee15(itemKey, child) {
        var paras;
        return regeneratorRuntime.wrap(function _callee15$(_context15) {
          while (1) {
            switch (_context15.prev = _context15.next) {
              case 0:
                paras = {
                  service: "DictService",
                  cmd: "GetParentPath",
                  itemKey: itemKey,
                  itemData: _yesCommon.lodash.toJSON(child)
                };
                _context15.next = 3;
                return _YIUISvr["default"].Request.getData(paras);

              case 3:
                return _context15.abrupt("return", _context15.sent);

              case 5:
              case "end":
                return _context15.stop();
            }
          }
        }, _callee15);
      }));

      function getParentPath(_x64, _x65) {
        return _getParentPath.apply(this, arguments);
      }

      return getParentPath;
    }()
  };
  return Return;
}();

exports["default"] = _default;