"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _YIUIBase = require("../YIUI-base");

require("../YIUI-common");

require("../YIUI-parser");

var _YIUISvr = _interopRequireDefault(require("../YIUI-svr"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var _default = _YIUIBase.YIUI.MetaService = function () {
  var Return = {
    /**
     * 获取web配置对象
     */
    getMetaForm: function () {
      var _getMetaForm = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee(formKey) {
        var _formKey$split, _formKey$split2, fKey, tKey, params;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                //这里的formKey可能会带有一个templateKey用于反向模版类单据显示
                _formKey$split = formKey.split('|'), _formKey$split2 = _slicedToArray(_formKey$split, 2), fKey = _formKey$split2[0], tKey = _formKey$split2[1];
                params = {
                  cmd: "GetForm",
                  service: "WebMetaService",
                  formKey: fKey,
                  templateKey: tKey
                };
                _context.next = 4;
                return _YIUISvr["default"].Request.getData(params);

              case 4:
                return _context.abrupt("return", _context.sent);

              case 5:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      function getMetaForm(_x) {
        return _getMetaForm.apply(this, arguments);
      }

      return getMetaForm;
    }(),

    /**
    * 根据EntryPath获取web配置对象
    */
    getMetaFormByEntry: function () {
      var _getMetaFormByEntry = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee2(entryPath) {
        var params;
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                params = {
                  cmd: "GetFormByEntry",
                  service: "WebMetaService",
                  path: entryPath
                };
                _context2.next = 3;
                return _YIUISvr["default"].Request.getData(params);

              case 3:
                return _context2.abrupt("return", _context2.sent);

              case 4:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }));

      function getMetaFormByEntry(_x2) {
        return _getMetaFormByEntry.apply(this, arguments);
      }

      return getMetaFormByEntry;
    }(),

    /**
    * 获取预加载表单列表
    */
    getPreLoadItems: function getPreLoadItems() {
      var params = {
        cmd: "GetPreLoadItems",
        service: "WebMetaService"
      };
      return _YIUISvr["default"].Request.getData(params);
    },

    /**
    * 获取菜单
    */
    getEntry: function getEntry(rootEntry, appKey) {
      var params = {
        cmd: "GetEntry",
        service: "WebMetaService",
        rootEntry: rootEntry,
        appKey: appKey
      };
      return _YIUISvr["default"].Request.getData(params);
    },

    /**
    * 获取ParaGroup
    */
    getParaGroup: function getParaGroup(groupKey, formKey) {
      var paras = {
        service: "WebMetaService",
        cmd: "GetParaGroup",
        formKey: formKey,
        groupKey: groupKey
      };
      return _YIUISvr["default"].Request.getSyncData(_YIUISvr["default"].SvrMgr.ServletURL, paras);
    },
    getClientAppStatusInfo: function getClientAppStatusInfo() {
      var params = {
        cmd: "GetClientAppStatusInfo",
        service: "WebMetaService"
      };
      return _YIUISvr["default"].Request.getData(params);
    },
    getServerList: function getServerList() {
      var params = {
        service: "GetServerList"
      };
      return _YIUISvr["default"].Request.getData(params);
    }
  };
  return Return;
}();

exports["default"] = _default;