"use strict";

var _YIUIBase = require("../YIUI-base");

require("../YIUI-common");

require("../YIUI-parser");

var _YIUISvr = _interopRequireDefault(require("../YIUI-svr"));

var _yesCommon = require("yes-common");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

_YIUIBase.YIUI.RemoteService = function () {
  var Return = {
    /**
     * 获取一个新增的oid
     */
    applyNewOID: function () {
      var _applyNewOID = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee() {
        var params, response;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                params = {
                  service: "ApplyNewOID",
                  random: Math.random()
                };
                _context.next = 3;
                return _YIUISvr["default"].Request.getData(params);

              case 3:
                response = _context.sent;
                return _context.abrupt("return", response.OID);

              case 5:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      function applyNewOID() {
        return _applyNewOID.apply(this, arguments);
      }

      return applyNewOID;
    }(),

    /**
     * 获取平台公共密钥
     */
    getPublicKey: function getPublicKey() {
      var paras = {
        isWeb: true,
        service: "GetPublicKey"
      };
      return _YIUISvr["default"].Request.getData(paras);
    },

    /**
    * 获取登录人员信息
     * @param formKey 表单标识
     * @param mode 登录模式
     */
    getSvrUser: function getSvrUser(formKey, mode) {
      var params = {
        service: "SessionRights",
        cmd: "GetLoginOperators",
        formKey: formKey,
        loginMode: mode
      };
      return _YIUISvr["default"].Request.getData(params);
    },

    /**
     * 修改密码
     */
    changePWD: function changePWD(operatorID, password, newPassword) {
      var paras = {
        service: "SessionRights",
        cmd: "ChangePWD",
        operatorID: operatorID,
        password: password,
        newPassword: newPassword
      };
      return _YIUISvr["default"].Request.getData(paras);
    },

    /**
    * 设置sessionParas，存放在服务器端
    */
    setSessionParas: function setSessionParas(paras) {
      var params = {
        cmd: "SetSessionParas",
        service: "HttpAuthenticate",
        paras: _yesCommon.lodash.toJSON(_YIUIBase.YIUI.YesJSONUtil.toJSONObject(paras))
      };
      return _YIUISvr["default"].Request.getData(params);
    }
  };
  return Return;
}();