"use strict";

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.InitSession = InitSession;
exports.loadHistory = loadHistory;
exports.getSession = getSession;
exports.getUserInfo = getUserInfo;
exports.setSession = setSession;
exports.setUserInfo = setUserInfo;
exports.setParas = setParas;
exports.getParas = getParas;
exports.setServerDate = setServerDate;
exports.getServerDate = getServerDate;
exports.clear = clear;
exports.setLocale = setLocale;
exports.getLocale = getLocale;

var _memoryAdapter = _interopRequireDefault(require("./memoryAdapter"));

var _yesCommon = require("yes-common");

var _dispatchers = _interopRequireWildcard(require("../dispatchers"));

var _actions = require("../actions");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var sessionKey = 'yigomobile';
var clientId = '';
var userInfo = null;
var adapter = _memoryAdapter["default"];
var timeSpan = 0;
var loaded = false;
var locale = 'zh-CN';
var paras = {};

function InitSession(_x, _x2) {
  return _InitSession.apply(this, arguments);
}

function _InitSession() {
  _InitSession = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee(key, sessionAdapter) {
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            if (sessionAdapter) adapter = sessionAdapter;
            sessionKey = key;
            _context.next = 4;
            return loadHistory();

          case 4:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _InitSession.apply(this, arguments);
}

function loadHistory() {
  return _loadHistory.apply(this, arguments);
}

function _loadHistory() {
  _loadHistory = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee2() {
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            if (!loaded) {
              _context2.next = 2;
              break;
            }

            return _context2.abrupt("return");

          case 2:
            _context2.next = 4;
            return adapter.getItem(sessionKey);

          case 4:
            clientId = _context2.sent;

            if (!clientId) {}

            _context2.next = 8;
            return adapter.getItem(sessionKey + "_userinfo");

          case 8:
            userInfo = _context2.sent;
            _context2.next = 11;
            return adapter.getItem(sessionKey + "_sessionParas");

          case 11:
            paras = _context2.sent;
            _yesCommon.DummyDocument.clientID = clientId;
            loaded = true;

          case 14:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
  return _loadHistory.apply(this, arguments);
}

function getSession() {
  return clientId;
}

function getUserInfo() {
  return userInfo;
}

function setSession(_x3) {
  return _setSession.apply(this, arguments);
}

function _setSession() {
  _setSession = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee3(clientID) {
    return regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            clientId = clientID;
            _yesCommon.DummyDocument.clientID = clientID;
            _context3.next = 4;
            return adapter.setItem(sessionKey, clientID);

          case 4:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  }));
  return _setSession.apply(this, arguments);
}

function setUserInfo(_x4) {
  return _setUserInfo.apply(this, arguments);
}

function _setUserInfo() {
  _setUserInfo = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee4(ui) {
    return regeneratorRuntime.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            userInfo = ui;
            _context4.next = 3;
            return adapter.setItem(sessionKey + '_userinfo', userInfo);

          case 3:
            console.log('setUserInfo');
            (0, _dispatchers["default"])().dispatch((0, _actions.changeuser)(userInfo));

          case 5:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4);
  }));
  return _setUserInfo.apply(this, arguments);
}

function setParas(_x5) {
  return _setParas.apply(this, arguments);
}

function _setParas() {
  _setParas = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee5(p) {
    return regeneratorRuntime.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            paras = p;
            _context5.next = 3;
            return adapter.setItem(sessionKey + '_sessionParas', p);

          case 3:
          case "end":
            return _context5.stop();
        }
      }
    }, _callee5);
  }));
  return _setParas.apply(this, arguments);
}

function getParas() {
  return paras;
}

function setServerDate(_x6) {
  return _setServerDate.apply(this, arguments);
}

function _setServerDate() {
  _setServerDate = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee6(dt) {
    var now;
    return regeneratorRuntime.wrap(function _callee6$(_context6) {
      while (1) {
        switch (_context6.prev = _context6.next) {
          case 0:
            //记录服务器和当前机器之间的事件差，用于后续计算服务器事件
            now = Date.now();
            timeSpan = dt - now;

          case 2:
          case "end":
            return _context6.stop();
        }
      }
    }, _callee6);
  }));
  return _setServerDate.apply(this, arguments);
}

function getServerDate() {
  return new Date(Date.now() + timeSpan);
}

function clear() {
  clientId = '';
  userInfo = null;
  (0, _dispatchers["default"])().dispatch((0, _actions.changeuser)(userInfo));
}

function setLocale(newLocale) {
  locale = newLocale;
}

function getLocale() {
  return locale;
}

(0, _dispatchers.ready)(function () {
  return (0, _dispatchers["default"])().register(function (action) {
    switch (action.type) {
      case 'CHANGELANGUAGE':
        locale = action.language;
        break;

      default:
    }
  });
});