"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ShowListView = exports.ShowData = void 0;

var _YIUIBase = require("./YIUI-base");

var _YIUICommon = require("./YIUI-common");

var _YIUIParser = require("./YIUI-parser");

require("./YIUI-svr");

require("./formIdGenerator");

require("./yes-ui");

require("./utils/totalrowcountutil");

require("./utils/gridutil");

require("./statusproxy");

require("./utils/rowgroup");

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

// (function () {
var ShowData = _YIUIBase.YIUI.ShowData = function (form) {
  var Return = {
    prepare: function prepare() {
      // 1.重置文档状态，主要是将每个表的游标移到第一行
      var document = form.getDocument();

      if (document == null) {
        return;
      }

      var table = null;

      for (var i = 0, len = document.tbls.length; i < len; i++) {
        table = document.tbls[i];
        table.first();
      } // 2.处理流程关联表单的权限代理类
      // var workitemInfo = form.getDocument().getExpData(YIUI.BPMConstants.WORKITEM_INFO);
      // if (workitemInfo != null) {
      //     form.setBPMStatusProxy(new YIUI.BPMStatusProxy(workitemInfo));
      // }

    },
    loadHeader: function () {
      var _loadHeader = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee(cmp) {
        var document, tableKey, table, columnKey, value, itemKey;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                document = form.getDocument();

                if (document) {
                  _context.next = 3;
                  break;
                }

                return _context.abrupt("return");

              case 3:
                tableKey = cmp.tableKey;
                table = tableKey && document.getByKey(tableKey);

                if (table) {
                  _context.next = 7;
                  break;
                }

                return _context.abrupt("return");

              case 7:
                columnKey = cmp.columnKey, value = "";

                if (table.getRowCount() > 0) {
                  value = table.getByKey(columnKey);

                  if (cmp.type == _YIUIBase.YIUI.CONTROLTYPE.DYNAMICDICT) {
                    itemKey = table.getByKey(columnKey + "ItemKey");
                    cmp.itemKey = itemKey;
                  }
                }

                _context.next = 11;
                return cmp.setValue(value, false, false);

              case 11:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      function loadHeader(_x) {
        return _loadHeader.apply(this, arguments);
      }

      return loadHeader;
    }(),
    loadListView: function loadListView(listView) {
      var showLV = new _YIUIBase.YIUI.ShowListView(form, listView);
      showLV.load();
    },
    loadGrid: function () {
      var _loadGrid = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee2(grid) {
        var showGrid;
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _YIUIBase.YIUI.SubDetailUtil.clearSubDetailData(form, grid);

                showGrid = new _YIUIBase.YIUI.ShowGridData(form, grid); // grid.loadData();

                _context2.next = 4;
                return showGrid.load();

              case 4:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }));

      function loadGrid(_x2) {
        return _loadGrid.apply(this, arguments);
      }

      return loadGrid;
    }(),
    loadChart: function loadChart(chart) {
      var document = form.getDocument();
      var metaChart = chart.getMetaObj();
      var dataJSON = {};
      var dataSource = metaChart.dataSource;
      var sourceType = metaChart.sourceType;
      var categoryKey = new _YIUICommon.HashMap();

      if (dataSource != null) {
        // 来源于数据对象
        if ("DataObject".equalsIgnoreCase(sourceType)) {
          var table = document.getByKey(dataSource.bindingKey); // 计算项目列表

          var metaCategory = dataSource.category;
          table.beforeFirst();
          var index = 0;
          var categoryCount = 0;
          var categories = [];

          while (table.next()) {
            var o = table.getByKey(metaCategory.dataKey);

            var value = _YIUIBase.YIUI.TypeConvertor.toString(o);

            if (!categoryKey.containsKey(value)) {
              categories.push(value);
              categoryKey.put(value, index);
              ++index;
              ++categoryCount;
            }
          }

          dataJSON.categories = categories;
          var metaSeriesArray = dataSource.series;
          var series = [];
          var metaSeries = null;
          metaSeriesArray.forEach(function (metaSeries) {
            var splitDataKey = metaSeries.splitDataKey;
            var splitSeries = splitDataKey;

            if (splitSeries) {
              var seriesMap = new _YIUICommon.HashMap();
              table.beforeFirst();
              var jsonObj = null;

              while (table.next()) {
                jsonObj = {};
                var splitData = table.getByKey(splitDataKey);
                var o = table.getByKey(metaSeries.dataKey);

                var value = _YIUIBase.YIUI.TypeConvertor.toInt(o);

                var seriesData = seriesMap.get(splitData);

                if (seriesData == null) {
                  seriesData = {};
                  var data = [];

                  for (var i = 0; i < categoryCount; ++i) {
                    data.push(parseInt(0));
                  }

                  jsonObj.data = data;
                  jsonObj.name = splitData.toString();
                  seriesMap.put(splitData, jsonObj);
                  series.push(jsonObj);
                } else {
                  jsonObj.data = data;
                  jsonObj.name = splitData.toString();
                }

                o = table.getByKey(metaCategory.dataKey);

                var c_value = _YIUIBase.YIUI.TypeConvertor.toString(o);

                var c_index = categoryKey.get(c_value);

                if (c_index != null) {
                  var data = jsonObj["data"];
                  data[c_index] = value;
                }
              }
            } else {
              table.beforeFirst();
              var jsonObj = {
                "name": metaSeries.title
              };
              var data = [];

              while (table.next()) {
                var o = table.getByKey(metaSeries.dataKey);

                var value = _YIUIBase.YIUI.TypeConvertor.toInt(o);

                data.push(value);
              }

              jsonObj.data = data;
              series.push(jsonObj);
            }
          });
          dataJSON.series = series;
        }
      }

      chart.setDataModel(dataJSON);
    },
    loadBPMGraph: function loadBPMGraph(graph) {
      var meta = graph.getMetaObj();
      var processKey = "";
      var processVer = -1;
      var path = null;
      var keyFormula = meta.processKey;
      var verFormula = meta.processVer;
      var pathFormula = meta.processPath;
      var cxt = {
        form: form
      }; // if (keyFormula != null && !keyFormula.isEmpty()) {
      //     processKey = form.eval(keyFormula, cxt);
      // }
      // if (verFormula != null && !verFormula.isEmpty()) {
      //     processVer = form.eval(verFormula, cxt);
      // }
      // if (pathFormula != null && !pathFormula.isEmpty()) {
      //     path = form.eval(pathFormula, cxt);
      // }
      // var data = {
      //     cmd: "DownloadProcessGraph",
      //     service: "BPMDefService",
      //     processKey: processKey,
      //     processVer: processVer
      // };
      // var transGraph = Svr.Request.getSyncData(Svr.SvrMgr.ServletURL, data);
      // if (transGraph != null) {
      //     graph.transPath = path;
      //     graph.swims = transGraph.swims;
      //     var nodes = transGraph.nodes;
      //     var transitions = [];
      //     for (var j = 0, len = nodes.length; j < len; j++) {
      //         var node = nodes[j];
      //         var n_transitions = node.transitions;
      //         if (n_transitions) {
      //             for (var i = 0, size = n_transitions.length; i < size; ++i) {
      //                 var n_transition = n_transitions[i];
      //                 var transition = {
      //                     "lineStyle": n_transition["line-style"],
      //                     "source": node["key"],
      //                     "tagName": n_transition["tag-name"],
      //                     "target": n_transition["target-node-key"]
      //                 };
      //                 transitions.push(transition);
      //             }
      //         }
      //         delete node.transitions;
      //     }
      //     graph.nodes = nodes;
      //     graph.transitions = transitions;
      //     graph.refreshGraph();
      // }
    },

    /**
     * 默认不提交值,下推后提交值
     * @param commitValue 是否提交值
     * @returns {boolean}
     */
    show: function () {
      var _show = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee3(commitValue) {
        var cmpList, cmp, i;
        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                form.setShowing(true);
                console.time('prepare');
                this.prepare();
                console.timeEnd('prepare');
                console.time('load data');
                cmpList = form.getComponentList();
                _context3.t0 = regeneratorRuntime.keys(cmpList);

              case 7:
                if ((_context3.t1 = _context3.t0()).done) {
                  _context3.next = 29;
                  break;
                }

                i = _context3.t1.value;
                cmp = cmpList[i];

                if (!cmp.isSubDetail) {
                  _context3.next = 12;
                  break;
                }

                return _context3.abrupt("continue", 7);

              case 12:
                _context3.t2 = cmp.type;
                _context3.next = _context3.t2 === _YIUIBase.YIUI.CONTROLTYPE.LISTVIEW ? 15 : _context3.t2 === _YIUIBase.YIUI.CONTROLTYPE.GRID ? 17 : _context3.t2 === _YIUIBase.YIUI.CONTROLTYPE.CHART ? 21 : _context3.t2 === _YIUIBase.YIUI.CONTROLTYPE.BPM_GRAPH ? 23 : 25;
                break;

              case 15:
                this.loadListView(cmp);
                return _context3.abrupt("break", 27);

              case 17:
                cmp.rootGroupBkmk = null;
                _context3.next = 20;
                return this.loadGrid(cmp);

              case 20:
                return _context3.abrupt("break", 27);

              case 21:
                this.loadChart(cmp);
                return _context3.abrupt("break", 27);

              case 23:
                this.loadBPMGraph(cmp);
                return _context3.abrupt("break", 27);

              case 25:
                if (cmp.hasDataBinding()) {
                  // if (cmp.needClean()) {
                  //     cmp.setValue(null);
                  // }
                  this.loadHeader(cmp);
                }

                return _context3.abrupt("break", 27);

              case 27:
                _context3.next = 7;
                break;

              case 29:
                console.timeEnd('load data');
                _context3.next = 32;
                return this.postShowData(commitValue);

              case 32:
                form.setShowing(false);
                return _context3.abrupt("return", true);

              case 34:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function show(_x3) {
        return _show.apply(this, arguments);
      }

      return show;
    }(),
    postShowData: function () {
      var _postShowData = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee4(commitValue) {
        return regeneratorRuntime.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                _context4.next = 2;
                return form.getUIProcess().doPostShowData(commitValue);

              case 2:
                console.log('postShowData over');
                console.time('addoperation');
                _context4.next = 6;
                return form.getUIProcess().addOperation();

              case 6:
                console.log('toolbar over');
                console.timeEnd('addoperation');

              case 8:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4);
      }));

      function postShowData(_x4) {
        return _postShowData.apply(this, arguments);
      }

      return postShowData;
    }()
  };
  return Return;
};

exports.ShowData = ShowData;

var ShowListView = _YIUIBase.YIUI.ShowListView = function (form, listView) {
  var Return = {
    load: function load() {
      listView.clearAllRows();
      var document = form.getDocument();

      if (!document) {
        return;
      }

      var tableKey = listView.tableKey;
      if (!tableKey) return;
      var table = document.getByKey(tableKey);
      listView.setTotalRowCount(_YIUIBase.YIUI.TotalRowCountUtil.getRowCount(document, tableKey));
      var cxt = new _YIUIParser.View.Context(form),
          backColor,
          rowList = [];

      for (var j = 0, length = table.getRowCount(); j < length; j++) {
        var row = {}; // listView.data.push(row);

        table.setPos(j); // var bkmkRow = new YIUI.DetailRowBkmk();
        // bkmkRow.setBookmark(table.getBkmk());

        row.bkmkRow = table.getBkmk();

        for (var m = 0, size = listView.columnInfo.length; m < size; m++) {
          var column = listView.columnInfo[m];
          var columnKey = column.columnKey;
          var value = null;

          if (columnKey) {
            value = table.getByKey(columnKey);
          } else {
            if (column.type == _YIUIBase.YIUI.CONTROLTYPE.HYPERLINK || column.type == _YIUIBase.YIUI.CONTROLTYPE.BUTTON || column.type == _YIUIBase.YIUI.CONTROLTYPE.LABEL) {
              value = column.caption;
            } else if (column.type == _YIUIBase.YIUI.CONTROLTYPE.HYPERLINK) {
              value = false;
            }
          } // listView.setValueAt(j, m, value);


          row[columnKey] = value;
        }

        rowList.push(row);
      }

      listView.resetData(rowList); //TODO::
      // if (listView._pagination) {
      //     if (!listView.pageRowCount || listView.totalRowCount < listView.pageRowCount) {
      //         listView._pagination.hidePagination();
      //     } else if (listView.totalRowCount) {
      //         var reset = true;
      //         if (listView.curPageIndex > 1) {
      //             reset = false;
      //         }
      //         listView._pagination.setTotalRowCount(listView.totalRowCount, reset);
      //         listView.curPageIndex = -1;
      //     }
      // }
      // listView.repaint();
      // listView.refreshSelectEnable();
    }
  };
  return Return;
}; // })();


exports.ShowListView = ShowListView;