/*
 * @Author: gmf
 * @Date:   2016-05-03 11:17:40
 * @Last Modified by:   gmf
 * @Last Modified time: 2016-05-03 11:20:02
 */

import BaseControl from './control';
import { YIUI } from '../../YIUI-base';
import '../../YIUI-common';
import '../../YIUI-svr';
import '../../YIUI-parser';
import { regControlType } from './controlUtil';
import Decimal from 'decimal.js';

const NumberEditor = YIUI.extend(BaseControl, {
    // handler: YIUI.NumberEditorHandler,
    calculateDisplayValue(v) {
        if (!v) {
            return v;
        }
        const scale = this.getMetaObj().scale === null ? 2 : this.getMetaObj().scale;
        if (v instanceof Decimal) {
            return v.toFixed(scale);
        }
        const dt = new Decimal(v);
        return dt.toFixed(scale);
    },
    isNull() {
        const v = this.getValue();
        if (v) {
            return v.isZero();
        }
        return true;
    },
    getText() {
        if (this.value instanceof Decimal) {
            return this.value.toNumber();
        }
        return this.value;
    },
});
YIUI.reg('numbereditor', NumberEditor);
regControlType(YIUI.CONTROLTYPE.NUMBEREDITOR, 'numbereditor');
export default NumberEditor;
