/*
 * @Author: gmf
 * @Date:   2016-03-18 10:50:14
 * @Last Modified by:   gmf
 * @Last Modified time: 2017-02-20 13:52:06
 */

import BaseControl from './control';
import { YIUI } from '../../YIUI-base';
import '../../YIUI-common';
import '../../YIUI-svr';
import '../../YIUI-parser';
import { regControlType } from './controlUtil';
import Immutable from 'immutable';
const Radiobox = YIUI.extend(BaseControl, {
    init(options) {
        this.base(options);
        this.state = this.state.set('items', Immutable.fromJS([]));
    },
    // handler: YIUI.ButtonHandler,
    async calculateDisplayValue(v) {
        try {
            await this.resetItems(false);
            const itm = this.state.get('items').find((item) => item.get('value') == v);
            let text = itm ? itm.get('caption') : '';
            return text;
        } catch (ex) {
            console.log(ex);
            return '出错';
        }
    },
    getGroupKey() {
        return this.getMetaObj().groupKey;
    },
    async resetItems(trigger = true) {
        const form = YIUI.FormStack.getForm(this.ofFormID);
        if (!form) {
            return;
        }
        const radios = form.getRadios(this.getMetaObj().groupKey);
        const items = [];
        radios.forEach((radio) => {
            // if (radio.isVisible() && radio.isEnable()) {
            const enable = radio.isVisible() && radio.isEnable();
            const metaObj = radio.getMetaObj();
            items.push({
                value: metaObj.metaValue,
                caption: metaObj.caption,
                enable,
            });
            // }
        });
        const state = this.state.mergeDeepIn(['items'], Immutable.fromJS(items));
        this.changeState(state, trigger);
    },
});
YIUI.reg('radiobutton', Radiobox);
regControlType(YIUI.CONTROLTYPE.RADIOBUTTON, 'radiobutton');
export default Radiobox;

