/**
 * Created by 陈瑞 on 2017/3/14 use WebStorm.
 */
import { YIUI } from '../YIUI-base';
import '../YIUI-common';
import '../YIUI-parser';
import '../YIUI-svr';
import { lodash as $ } from 'yes-common';
import '../uiprocess';
import '../abstractuiprocess';
import '../yes-ui';
export default YIUI.UIDependencyProcess = (function () {

    // 单例对象
    var Return = {
        valueChanged: function (form, component) {
            var relations = form.dependency.relationTree;
            var targetFields, targetField, targetComp, cellLocation, grid, columnInfo;
            for (var field in relations) {
                if (field !== component.key)
                    continue;
                var targetFields = relations[field];
                for (var i = 0, len = targetFields.length; i < len; i++) {
                    targetField = targetFields[i];
                    targetComp = form.getComponent(targetField);
                    if (targetComp != null) {
                        targetComp.dependedValueChange(targetField, field, null);
                        continue;
                    }
                    cellLocation = form.getCellLocation(targetField);
                    if (cellLocation != null) {
                        grid = form.getComponent(cellLocation.key);
                        grid.dependedValueChange(targetField, field, null);
                    }
                }
            }
        },

        cellValueChanged: async function (form, grid, rowIndex, colIndex, cellKey) {
            var relations = form.dependency.relationTree, targetFields;
            for (var field in relations) {
                if (field !== cellKey)
                    continue;
                targetFields = relations[field];
                for (var i = 0, len = targetFields.length; i < len; i++) {
                    let loc = form.getCellLocation(targetFields[i]);

                    if (loc.expand) {
                        var columns = loc.columns;
                        for (var j = 0; j < columns.length; j++) {
                            await grid.setValueAt(rowIndex, columns[j], null, true, true);
                        }
                    } else {
                        await grid.setValueAt(rowIndex, loc.column, null, true, true);
                    }
                    // grid.doPostCellValueChanged(rowIndex, field, targetFields[i], null);
                }
            }
        },

        doAfterInsertRow: function (grid, rowIndex) {
            // var gridRow = grid.getRowDataAt(rowIndex), metaRow = grid.getMetaObj().rows[gridRow.metaRowIndex];
            // for (var i = 0, len = metaRow.cells.length; i < len; i++) {
            //     var metaCell = metaRow.cells[i];
            //     if (metaCell.cellType == YIUI.CONTROLTYPE.DYNAMIC) {
            //         //TODO 刷新动态单元格
            //     }
            // }
        }
    }

    return Return;
})();
