"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _YIUIBase = require("./YIUI-base");

require("./YIUI-common");

require("./YIUI-parser");

require("./YIUI-svr");

require("./process/uienableprocess");

require("./process/uivisibleprocess");

require("./process/uicalcprocess");

require("./process/uicheckruleprocess");

require("./process/uidependencyprocess");

require("./process/uiparaprocess");

require("./bpm");

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var _default = _YIUIBase.YIUI.UIProcess = function (form) {
  this.form = form;
  this.enableProcess = new _YIUIBase.YIUI.UIEnableProcess(form);
  this.visibleProcess = new _YIUIBase.YIUI.UIVisibleProcess(form);
  this.calcProcess = new _YIUIBase.YIUI.UICalcProcess(form);
  this.checkRuleProcess = new _YIUIBase.YIUI.UICheckRuleProcess(form);

  this.resetUIStatus =
  /*#__PURE__*/
  function () {
    var _ref = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee(mask) {
      var calcEnable, calcVisible, addOperation;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              calcEnable = (mask & _YIUIBase.YIUI.FormUIStatusMask.ENABLE) !== 0;
              calcVisible = (mask & _YIUIBase.YIUI.FormUIStatusMask.VISIBLE) !== 0;
              addOperation = (mask & _YIUIBase.YIUI.FormUIStatusMask.OPERATION) !== 0;

              if (!calcEnable) {
                _context.next = 8;
                break;
              }

              _context.next = 6;
              return this.enableProcess.calcAll();

            case 6:
              _context.next = 8;
              return this.checkRuleProcess.calcAll();

            case 8:
              if (!calcVisible) {
                _context.next = 11;
                break;
              }

              _context.next = 11;
              return this.visibleProcess.calcAll();

            case 11:
              if (!addOperation) {
                _context.next = 14;
                break;
              }

              _context.next = 14;
              return this.addOperation();

            case 14:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    return function (_x) {
      return _ref.apply(this, arguments);
    };
  }();

  this.hasOptRights = function (operation) {
    if (!operation.key) return false;
    if (operation.type == _YIUIBase.YIUI.OPERATIONTYPE.OPERATION && operation.managed) return true;
    return this.form.hasOptRight(operation.key); // var host = this.form.getBPMStatusProxy();
    // if (host && host.hasOptRights(operation.key))
    //     return true;
    // var formRights = this.form.getFormRights();
    // return formRights.allOptRights || $.inArray(operation.key, formRights.optRights) != -1;
  };

  this.addOperation =
  /*#__PURE__*/
  function () {
    var _ref2 = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee5(defaultToolbar) {
      var toolbar, _this, addOneOperation, _addOneOperation, addOneMenuOperation, _addOneMenuOperation, replaceInplaceToolBar, addDefaultOperation, _addDefaultOperation;

      return regeneratorRuntime.wrap(function _callee5$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              _addDefaultOperation = function _ref9() {
                _addDefaultOperation = _asyncToGenerator(
                /*#__PURE__*/
                regeneratorRuntime.mark(function _callee4(form, toolbar) {
                  var item, i, len, m, size, items;
                  return regeneratorRuntime.wrap(function _callee4$(_context4) {
                    while (1) {
                      switch (_context4.prev = _context4.next) {
                        case 0:
                          i = 0, len = form.operations.length;

                        case 1:
                          if (!(i < len)) {
                            _context4.next = 25;
                            break;
                          }

                          item = form.operations[i]; // if (item.tag === "WORKITEM" || item.tag === "BPM" || item.key === "StartInstance") {//TODO:暂时在天和中这样修改一下

                          if (!(item.type == _YIUIBase.YIUI.OPERATIONTYPE.OPERATION)) {
                            _context4.next = 20;
                            break;
                          }

                          if (!item.tag) {
                            _context4.next = 16;
                            break;
                          }

                          items = replaceInplaceToolBar(item);

                          if (!(items != null && items.length > 0)) {
                            _context4.next = 14;
                            break;
                          }

                          m = 0, size = items.length;

                        case 8:
                          if (!(m < size)) {
                            _context4.next = 14;
                            break;
                          }

                          _context4.next = 11;
                          return addOneOperation(toolbar, items[m]);

                        case 11:
                          m++;
                          _context4.next = 8;
                          break;

                        case 14:
                          _context4.next = 18;
                          break;

                        case 16:
                          _context4.next = 18;
                          return addOneOperation(toolbar, item);

                        case 18:
                          _context4.next = 22;
                          break;

                        case 20:
                          _context4.next = 22;
                          return addOneMenuOperation(toolbar, item);

                        case 22:
                          i++;
                          _context4.next = 1;
                          break;

                        case 25:
                        case "end":
                          return _context4.stop();
                      }
                    }
                  }, _callee4);
                }));
                return _addDefaultOperation.apply(this, arguments);
              };

              addDefaultOperation = function _ref8(_x7, _x8) {
                return _addDefaultOperation.apply(this, arguments);
              };

              replaceInplaceToolBar = function _ref7(item) {
                var instance = new _YIUIBase.YIUI.InplaceToolBar({
                  tag: item.tag
                });
                var opts = instance.replace(form, item);
                var items = [];
                if (!opts) return items;

                for (var n = 0, length = opts.length; n < length; n++) {
                  items.push({
                    type: _YIUIBase.YIUI.OPERATIONTYPE.OPERATION,
                    key: opts[n].key,
                    caption: opts[n].caption,
                    action: opts[n].action,
                    tag: opts[n].tag,
                    preAction: opts[n].preAction,
                    managed: true,
                    // 受管理,有权限
                    enableCnt: opts[n].enable,
                    visibleCnt: opts[n].visible
                  });
                }

                return items;
              };

              _addOneMenuOperation = function _ref6() {
                _addOneMenuOperation = _asyncToGenerator(
                /*#__PURE__*/
                regeneratorRuntime.mark(function _callee3(toolbar, item) {
                  var _item, cxt, visibleCnt, enableCnt, m, length, subVisibleCnt, subEnableCnt;

                  return regeneratorRuntime.wrap(function _callee3$(_context3) {
                    while (1) {
                      switch (_context3.prev = _context3.next) {
                        case 0:
                          if (_this.hasOptRights(item)) {
                            _context3.next = 2;
                            break;
                          }

                          return _context3.abrupt("return");

                        case 2:
                          if (item.items) {
                            _context3.next = 4;
                            break;
                          }

                          return _context3.abrupt("return");

                        case 4:
                          cxt = {
                            form: _this.form
                          };
                          visibleCnt = item.visibleCnt;
                          enableCnt = item.enableCnt;

                          if (!visibleCnt) {
                            _context3.next = 13;
                            break;
                          }

                          _context3.next = 10;
                          return _this.form.evalFormula(visibleCnt, cxt, null);

                        case 10:
                          _context3.t0 = _context3.sent;
                          _context3.next = 14;
                          break;

                        case 13:
                          _context3.t0 = true;

                        case 14:
                          item.visible = _context3.t0;
                          item.enable = true;

                          if (!(!item.selfDisable && item.visible)) {
                            _context3.next = 25;
                            break;
                          }

                          if (!enableCnt) {
                            _context3.next = 23;
                            break;
                          }

                          _context3.next = 20;
                          return _this.form.evalFormula(enableCnt, cxt, null);

                        case 20:
                          _context3.t1 = _context3.sent;
                          _context3.next = 24;
                          break;

                        case 23:
                          _context3.t1 = true;

                        case 24:
                          item.enable = _context3.t1;

                        case 25:
                          m = 0, length = item.items.length;

                        case 26:
                          if (!(m < length)) {
                            _context3.next = 55;
                            break;
                          }

                          _item = item.items[m];
                          subVisibleCnt = _item.visibleCnt;
                          subEnableCnt = _item.enableCnt;

                          if (!item.visible) {
                            _context3.next = 50;
                            break;
                          }

                          if (!subVisibleCnt) {
                            _context3.next = 37;
                            break;
                          }

                          _context3.next = 34;
                          return _this.form.evalFormula(subVisibleCnt, cxt, null);

                        case 34:
                          _context3.t2 = _context3.sent;
                          _context3.next = 38;
                          break;

                        case 37:
                          _context3.t2 = true;

                        case 38:
                          _item.visible = _context3.t2;

                          if (!_item.visible) {
                            _context3.next = 48;
                            break;
                          }

                          if (!subEnableCnt) {
                            _context3.next = 46;
                            break;
                          }

                          _context3.next = 43;
                          return _this.form.evalFormula(subEnableCnt, cxt, null);

                        case 43:
                          _context3.t3 = _context3.sent;
                          _context3.next = 47;
                          break;

                        case 46:
                          _context3.t3 = true;

                        case 47:
                          _item.enable = _context3.t3;

                        case 48:
                          _context3.next = 52;
                          break;

                        case 50:
                          _item.visible = false;
                          _item.enable = false;

                        case 52:
                          m++;
                          _context3.next = 26;
                          break;

                        case 55:
                          // toolbar.items.push(item);
                          toolbar.addItem(item);

                        case 56:
                        case "end":
                          return _context3.stop();
                      }
                    }
                  }, _callee3);
                }));
                return _addOneMenuOperation.apply(this, arguments);
              };

              addOneMenuOperation = function _ref5(_x5, _x6) {
                return _addOneMenuOperation.apply(this, arguments);
              };

              _addOneOperation = function _ref4() {
                _addOneOperation = _asyncToGenerator(
                /*#__PURE__*/
                regeneratorRuntime.mark(function _callee2(toolbar, item) {
                  var cxt, visibleCnt, enableCnt;
                  return regeneratorRuntime.wrap(function _callee2$(_context2) {
                    while (1) {
                      switch (_context2.prev = _context2.next) {
                        case 0:
                          if (_this.hasOptRights(item)) {
                            _context2.next = 2;
                            break;
                          }

                          return _context2.abrupt("return");

                        case 2:
                          // var metaItem = _this.form.getMetaOpt(item.key);
                          cxt = {
                            form: _this.form
                          };
                          visibleCnt = item.visibleCnt;
                          enableCnt = item.enableCnt; // var visibleCnt = metaItem ? metaItem.visible : item.visibleCnt;
                          // var enableCnt = metaItem ? metaItem.enable : item.enableCnt;
                          // item.visible = visibleCnt ? _this.form.eval(visibleCnt, cxt, null) : true;
                          // item.enable = enableCnt ? _this.form.eval(enableCnt, cxt, null) : true;

                          if (!visibleCnt) {
                            _context2.next = 11;
                            break;
                          }

                          _context2.next = 8;
                          return _this.form.evalFormula(visibleCnt, cxt, null);

                        case 8:
                          _context2.t0 = _context2.sent;
                          _context2.next = 12;
                          break;

                        case 11:
                          _context2.t0 = true;

                        case 12:
                          item.visible = _context2.t0;

                          if (!item.visible) {
                            _context2.next = 22;
                            break;
                          }

                          if (!enableCnt) {
                            _context2.next = 20;
                            break;
                          }

                          _context2.next = 17;
                          return _this.form.evalFormula(enableCnt, cxt, null);

                        case 17:
                          _context2.t1 = _context2.sent;
                          _context2.next = 21;
                          break;

                        case 20:
                          _context2.t1 = true;

                        case 21:
                          item.enable = _context2.t1;

                        case 22:
                          toolbar.addItem(item); // toolbar.items.push(item);

                        case 23:
                        case "end":
                          return _context2.stop();
                      }
                    }
                  }, _callee2);
                }));
                return _addOneOperation.apply(this, arguments);
              };

              addOneOperation = function _ref3(_x3, _x4) {
                return _addOneOperation.apply(this, arguments);
              };

              toolbar = defaultToolbar || this.form.defaultToolBar;

              if (!(!toolbar || toolbar.isDestroyed)) {
                _context5.next = 10;
                break;
              }

              return _context5.abrupt("return");

            case 10:
              // var container = this.form.getContainer();
              // if (!container.mergeOperation) {
              //     toolbar.items.length = 0;
              // }
              _this = this;
              // 处理合并
              // var mergeOptContainer = form.getMergeOptContainer();
              // if (mergeOptContainer) {
              //     var ctn = form.getComponent(mergeOptContainer);
              //     var activePane = ctn.getActivePane();
              //     if (activePane) {
              //         activePane.getUIProcess().addOperation(toolbar);
              //     }
              // }
              console.time('root');
              toolbar.clear();
              this.form.clearFormulaCache();
              _context5.next = 16;
              return addDefaultOperation(this.form, toolbar);

            case 16:
              console.timeEnd('root'); // if (toolbar.rendered) {
              //     toolbar.repaint();
              // }

            case 17:
            case "end":
              return _context5.stop();
          }
        }
      }, _callee5, this);
    }));

    return function (_x2) {
      return _ref2.apply(this, arguments);
    };
  }();

  this.doPostShowData =
  /*#__PURE__*/
  function () {
    var _ref10 = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee6(commitValue) {
      return regeneratorRuntime.wrap(function _callee6$(_context6) {
        while (1) {
          switch (_context6.prev = _context6.next) {
            case 0:
              console.time('calc value');
              _context6.next = 3;
              return this.calcProcess.calcAll(commitValue);

            case 3:
              console.timeEnd('calc value');
              console.time('calc enable');
              _context6.next = 7;
              return this.enableProcess.calcAll();

            case 7:
              console.timeEnd('calc enable');
              console.time('calc visible');
              _context6.next = 11;
              return this.visibleProcess.calcAll();

            case 11:
              console.timeEnd('calc visible');
              console.time('calc rule');
              _context6.next = 15;
              return this.checkRuleProcess.calcAll();

            case 15:
              console.timeEnd('calc rule');
              console.time('calc para');
              _context6.next = 19;
              return _YIUIBase.YIUI.UIParaProcess.calcAll(this.form);

            case 19:
              console.timeEnd('calc para');

            case 20:
            case "end":
              return _context6.stop();
          }
        }
      }, _callee6, this);
    }));

    return function (_x9) {
      return _ref10.apply(this, arguments);
    };
  }();

  this.doPreCellValueChanged =
  /*#__PURE__*/
  function () {
    var _ref11 = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee7(grid, rowIndex, colIndex, cellKey) {
      return regeneratorRuntime.wrap(function _callee7$(_context7) {
        while (1) {
          switch (_context7.prev = _context7.next) {
            case 0:
              _context7.next = 2;
              return _YIUIBase.YIUI.UIDependencyProcess.cellValueChanged(form, grid, rowIndex, colIndex, cellKey);

            case 2:
            case "end":
              return _context7.stop();
          }
        }
      }, _callee7);
    }));

    return function (_x10, _x11, _x12, _x13) {
      return _ref11.apply(this, arguments);
    };
  }();

  this.doCellValueChanged =
  /*#__PURE__*/
  function () {
    var _ref12 = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee8(grid, rowIndex, colIndex, cellKey) {
      return regeneratorRuntime.wrap(function _callee8$(_context8) {
        while (1) {
          switch (_context8.prev = _context8.next) {
            case 0:
              _context8.next = 2;
              return this.calcProcess.cellValueChanged(grid, rowIndex, colIndex, cellKey);

            case 2:
            case "end":
              return _context8.stop();
          }
        }
      }, _callee8, this);
    }));

    return function (_x14, _x15, _x16, _x17) {
      return _ref12.apply(this, arguments);
    };
  }();

  this.doPostCellValueChanged =
  /*#__PURE__*/
  function () {
    var _ref13 = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee9(grid, rowIndex, colIndex, cellKey) {
      return regeneratorRuntime.wrap(function _callee9$(_context9) {
        while (1) {
          switch (_context9.prev = _context9.next) {
            case 0:
              if (!this.calcProcess.isInAllCalculating()) {
                _context9.next = 2;
                break;
              }

              return _context9.abrupt("return");

            case 2:
              this.form.clearFormulaCache();
              _context9.next = 5;
              return this.enableProcess.cellValueChanged(grid, rowIndex, colIndex, cellKey);

            case 5:
              _context9.next = 7;
              return this.visibleProcess.cellValueChanged(grid, rowIndex, colIndex, cellKey);

            case 7:
              _context9.next = 9;
              return this.checkRuleProcess.cellValueChanged(grid, rowIndex, colIndex, cellKey);

            case 9:
            case "end":
              return _context9.stop();
          }
        }
      }, _callee9, this);
    }));

    return function (_x18, _x19, _x20, _x21) {
      return _ref13.apply(this, arguments);
    };
  }();

  this.calcSubDetail = function (gridKey) {
    this.calcProcess.calcSubDetail(gridKey);
    this.enableProcess.calcSubDetail(gridKey);
    this.visibleProcess.calcSubDetail(gridKey);
    this.checkRuleProcess.calcSubDetail(gridKey);
  };

  this.doPostInsertRow =
  /*#__PURE__*/
  function () {
    var _ref14 = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee10(grid, rowIndex, emptyRow) {
      return regeneratorRuntime.wrap(function _callee10$(_context10) {
        while (1) {
          switch (_context10.prev = _context10.next) {
            case 0:
              _context10.next = 2;
              return this.calcProcess.doAfterInsertRow(grid, rowIndex, emptyRow);

            case 2:
              _context10.next = 4;
              return this.enableProcess.doAfterInsertRow(grid, rowIndex);

            case 4:
              _context10.next = 6;
              return this.visibleProcess.doAfterInsertRow(grid, rowIndex);

            case 6:
              _context10.next = 8;
              return this.checkRuleProcess.doAfterInsertRow(grid, rowIndex);

            case 8:
              if (!emptyRow) {
                _context10.next = 11;
                break;
              }

              _context10.next = 11;
              return _YIUIBase.YIUI.UIDependencyProcess.doAfterInsertRow(grid, rowIndex);

            case 11:
            case "end":
              return _context10.stop();
          }
        }
      }, _callee10, this);
    }));

    return function (_x22, _x23, _x24) {
      return _ref14.apply(this, arguments);
    };
  }();

  this.doPostDeleteRow =
  /*#__PURE__*/
  function () {
    var _ref15 = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee11(grid) {
      return regeneratorRuntime.wrap(function _callee11$(_context11) {
        while (1) {
          switch (_context11.prev = _context11.next) {
            case 0:
              _context11.next = 2;
              return this.calcProcess.doAfterDeleteRow(grid);

            case 2:
              _context11.next = 4;
              return this.enableProcess.doAfterDeleteRow(grid);

            case 4:
              _context11.next = 6;
              return this.checkRuleProcess.doAfterDeleteRow(grid);

            case 6:
            case "end":
              return _context11.stop();
          }
        }
      }, _callee11, this);
    }));

    return function (_x25) {
      return _ref15.apply(this, arguments);
    };
  }();

  this.resetComponentStatus =
  /*#__PURE__*/
  function () {
    var _ref16 = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee12(component) {
      return regeneratorRuntime.wrap(function _callee12$(_context12) {
        while (1) {
          switch (_context12.prev = _context12.next) {
            case 0:
              _context12.next = 2;
              return this.calcProcess.reCalcComponent(component);

            case 2:
              _context12.next = 4;
              return this.enableProcess.reCalcComponent(component);

            case 4:
              _context12.next = 6;
              return this.visibleProcess.reCalcComponent(component);

            case 6:
              _context12.next = 8;
              return this.checkRuleProcess.reCalcComponent(component);

            case 8:
            case "end":
              return _context12.stop();
          }
        }
      }, _callee12, this);
    }));

    return function (_x26) {
      return _ref16.apply(this, arguments);
    };
  }();

  this.doPostClearAllRow = function (grid) {
    this.enableProcess.doAfterDeleteRow(grid, -1);
  };

  this.preFireValueChanged = function (component) {
    _YIUIBase.YIUI.UIDependencyProcess.valueChanged(this.form, component);
  };

  this.fireValueChanged =
  /*#__PURE__*/
  function () {
    var _ref17 = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee13(component) {
      return regeneratorRuntime.wrap(function _callee13$(_context13) {
        while (1) {
          switch (_context13.prev = _context13.next) {
            case 0:
              _context13.next = 2;
              return this.calcProcess.valueChanged(component);

            case 2:
              if (!component.valueChanged) {
                _context13.next = 5;
                break;
              }

              _context13.next = 5;
              return this.form.eval(component.valueChanged, {
                form: this.form
              });

            case 5:
            case "end":
              return _context13.stop();
          }
        }
      }, _callee13, this);
    }));

    return function (_x27) {
      return _ref17.apply(this, arguments);
    };
  }();

  this.postFireValueChanged =
  /*#__PURE__*/
  function () {
    var _ref18 = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee14(component) {
      return regeneratorRuntime.wrap(function _callee14$(_context14) {
        while (1) {
          switch (_context14.prev = _context14.next) {
            case 0:
              if (!this.calcProcess.isInAllCalculating()) {
                _context14.next = 2;
                break;
              }

              return _context14.abrupt("return");

            case 2:
              _context14.next = 4;
              return this.enableProcess.valueChanged(component);

            case 4:
              _context14.next = 6;
              return this.visibleProcess.valueChanged(component);

            case 6:
              _context14.next = 8;
              return this.checkRuleProcess.valueChanged(component);

            case 8:
              _context14.next = 10;
              return _YIUIBase.YIUI.UIParaProcess.valueChanged(this.form, component);

            case 10:
            case "end":
              return _context14.stop();
          }
        }
      }, _callee14, this);
    }));

    return function (_x28) {
      return _ref18.apply(this, arguments);
    };
  }();

  this.refreshParas =
  /*#__PURE__*/
  _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee15() {
    return regeneratorRuntime.wrap(function _callee15$(_context15) {
      while (1) {
        switch (_context15.prev = _context15.next) {
          case 0:
            _context15.next = 2;
            return _YIUIBase.YIUI.UIParaProcess.calcAll(this.form);

          case 2:
          case "end":
            return _context15.stop();
        }
      }
    }, _callee15, this);
  }));

  this.doAfterRowChanged = function (component) {
    this.enableProcess.doAfterRowChanged(component);
  };

  this.calcItems = function (items) {
    this.calcProcess.calcAllItems(true, items, false);
  };
};

exports["default"] = _default;