"use strict";

var _YIUIBase = require("../YIUI-base");

require("../YIUI-common");

require("../YIUI-parser");

require("../YIUI-svr");

require("../yes-ui");

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

// (function () {
_YIUIBase.YIUI.MultiKeyNode = _YIUIBase.YIUI.extend({
  dataType: -1,
  value: null,
  columnKey: null,
  init: function init(dataType, value) {
    this.dataType = dataType;
    this.value = value;
  },
  getDataType: function getDataType() {
    return this.dataType;
  },
  getValue: function getValue() {
    return this.value;
  },
  equals: function equals(obj) {
    if (this == obj) return true;
    if (obj == null) return false;
    if (_typeof(obj) != _typeof(this)) return false;
    if (this.dataType != obj.dataType) return false;

    if (this.value == null) {
      if (obj.value != null) return false;
    } else if (this.value == obj.value) {
      return true;
    }

    return false;
  },
  clone: function clone() {
    return new _YIUIBase.YIUI.MultiKeyNode(this.columnKey, this.dataType, this.value);
  }
});
_YIUIBase.YIUI.MultiKey = _YIUIBase.YIUI.extend({
  values: [],
  userObject: null,
  init: function init() {
    this.values = [];
  },
  setValues: function setValues(values) {
    this.values = values;
  },
  addValue: function addValue(value) {
    this.values.push(value);
  },
  addAll: function addAll(valueList) {
    for (var value in valueList) {
      this.values.push(valueList[value]);
    }
  },
  getValueCount: function getValueCount() {
    return this.values.length;
  },
  getValue: function getValue(index) {
    return this.values[index];
  },
  setUserObject: function setUserObject(userObj) {
    this.userObject = userObj;
  },
  getUserObject: function getUserObject() {
    return this.userObject;
  },
  clone: function clone() {
    var newObj = new _YIUIBase.YIUI.MultiKey();

    for (var i = 0, len = this.values.length; i < len; i++) {
      var value = this.values[i];
      newObj.addValue(value.clone());
    }

    return newObj;
  },
  shallowClone: function shallowClone() {
    var newObj = new _YIUIBase.YIUI.MultiKey();
    newObj.addAll(this.values);
    return newObj;
  },
  equals: function equals(obj) {
    if (obj == this) return true;
    if (obj == null) return false;
    if (_typeof(obj) != _typeof(this)) return false;
    if (this.getValueCount() != obj.getValueCount()) return false;

    for (var i = 0, len = this.getValueCount(); i < len; i++) {
      var node_A = this.getValue(i);
      var node_B = obj.getValue(i);

      if (!node_A.equals(node_B)) {
        return false;
      }
    }

    return true;
  },
  compare: function compare(other) {
    var count = this.getValueCount(),
        result = 0;

    for (var i = 0; i < count; i++) {
      var node1 = this.getValue(i),
          node2 = other.getValue(i),
          value1 = node1.getValue(),
          value2 = node2.getValue();

      if (value1 == null && value2 != null) {
        return -1;
      } else if (value1 != null && value2 == null) {
        return -1;
      } else if (value1 == null && value2 == null) {
        continue;
      }

      switch (node1.getDataType()) {
        case _YIUIBase.YIUI.JavaDataType.USER_INT:
        case _YIUIBase.YIUI.JavaDataType.USER_LONG:
        case _YIUIBase.YIUI.JavaDataType.USER_NUMERIC:
          result = _YIUIBase.YIUI.TypeConvertor.toDecimal(value1).comparedTo(_YIUIBase.YIUI.TypeConvertor.toDecimal(value2));
          break;

        case _YIUIBase.YIUI.JavaDataType.USER_DATETIME:
          var date1 = _YIUIBase.YIUI.TypeConvertor.toDate(value1).getTime(),
              date2 = _YIUIBase.YIUI.TypeConvertor.toDate(value2).getTime();

          result = date1 - date2 > 0 ? 1 : date1 == date2 ? 0 : -1;
          break;

        case _YIUIBase.YIUI.JavaDataType.USER_STRING:
          result = _YIUIBase.YIUI.TypeConvertor.toString(value1).localeCompare(_YIUIBase.YIUI.TypeConvertor.toString(value2));
          break;
      }

      if (result != 0) {
        break;
      }
    }

    return result;
  }
});
_YIUIBase.YIUI.BaseRowBkmk = _YIUIBase.YIUI.extend({
  bookmark: -1,
  init: function init() {},
  setBookmark: function setBookmark(bkmk) {
    this.bookmark = bkmk;
  },
  getBookmark: function getBookmark() {
    return this.bookmark;
  }
});
_YIUIBase.YIUI.FixRowBkmk = _YIUIBase.YIUI.extend(_YIUIBase.YIUI.BaseRowBkmk, {
  getRowType: function getRowType() {
    return _YIUIBase.YIUI.IRowBkmk.Fix;
  }
});
_YIUIBase.YIUI.DetailRowBkmk = _YIUIBase.YIUI.extend(_YIUIBase.YIUI.BaseRowBkmk, {
  getRowType: function getRowType() {
    return _YIUIBase.YIUI.IRowBkmk.Detail;
  },
  toString: function toString() {
    return "Detail_" + this.bookmark;
  },
  equals: function equals(obj) {
    if (obj == null) {
      return false;
    }

    if (!(obj instanceof _YIUIBase.YIUI.DetailRowBkmk)) {
      return false;
    }

    return this.bookmark == obj.bookmark;
  }
});
_YIUIBase.YIUI.GroupRowBkmk = _YIUIBase.YIUI.extend(_YIUIBase.YIUI.BaseRowBkmk, {
  rowArray: [],
  metaGroup: null,
  isLeaf: false,
  init: function init() {
    this.rowArray = [];
  },
  getRowType: function getRowType() {
    return _YIUIBase.YIUI.IRowBkmk.Group;
  },
  addRow: function addRow(bkmk) {
    this.rowArray.push(bkmk);
  },
  setLeaf: function setLeaf(isLeaf) {
    this.isLeaf = isLeaf;
  },
  getRowCount: function getRowCount() {
    return this.rowArray.length;
  },
  getRowAt: function getRowAt(rowIndex) {
    if (rowIndex < 0 || rowIndex >= this.rowArray.length) return null;
    return this.rowArray[rowIndex];
  },
  setMetaGroup: function setMetaGroup(metaGroup) {
    this.metaGroup = metaGroup;
  },
  getMetaGroup: function getMetaGroup() {
    return this.metaGroup;
  }
});
_YIUIBase.YIUI.ExpandRowBkmk = _YIUIBase.YIUI.extend(_YIUIBase.YIUI.BaseRowBkmk, {
  rowArray: [],
  expandRowMapList: [],
  init: function init(count) {
    this.rowArray = [];
    this.expandRowMapList = [];

    for (var i = 0; i < count; i++) {
      this.expandRowMapList.push(new _YIUIBase.YIUI.RowMap());
    }
  },
  getRowType: function getRowType() {
    return _YIUIBase.YIUI.IRowBkmk.Expand;
  },
  size: function size() {
    return this.rowArray.length;
  },
  add: function add(areaIndex, key, row) {
    if (this.rowArray.indexOf(row) < 0) {
      this.rowArray.push(row);
    }

    var map = this.expandRowMapList[areaIndex],
        isMatch = false;

    for (var i = 0, len = map.size(); i < len; i++) {
      if (map.getAt(i).key.equals(key)) {
        map.getAt(i).row = row;
        isMatch = true;
        break;
      }
    }

    if (!isMatch) {
      map.put(key, row);
    }
  },
  getAt: function getAt(index) {
    return this.rowArray[index];
  },
  getAtArea: function getAtArea(areaIndex, key) {
    var map = this.expandRowMapList[areaIndex];

    for (var i = 0, len = map.size(); i < len; i++) {
      if (map.getAt(i).key.equals(key)) {
        return map.getAt(i).row;
      }
    }

    return null;
  }
});
_YIUIBase.YIUI.ExpandItem = _YIUIBase.YIUI.extend({
  value: null,
  caption: '',
  dataType: -1,
  init: function init(value, caption, dataType) {
    this.value = value;
    this.caption = caption;
    this.dataType = dataType;
  }
}); // })();