"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _YIUIBase = require("../YIUI-base");

var _YIUICommon = require("../YIUI-common");

var _YIUIParser = require("../YIUI-parser");

require("../YIUI-svr");

require("../yes-ui");

var _decimal = _interopRequireDefault(require("decimal.js"));

var _gridhandler = _interopRequireDefault(require("../handlers/gridhandler"));

var _yesCommon = require("yes-common");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

_YIUIBase.YIUI.GridColumnExpand = _YIUIBase.YIUI.extend({
  form: null,
  grid: null,
  groups: null,
  init: function init(form, grid) {
    this.form = form;
    this.grid = grid;
    this.groups = [];
  },
  extractExpandSources: function () {
    var _extractExpandSources = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee(metaColumn) {
      var columnExpand, colKey, tableKey, dataTable, columnKey, column, dataType, items, cxt, set, i, source, result, value, caption, ret, v, item, idx, j;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              columnExpand = metaColumn.columnExpand;
              colKey = metaColumn.key;
              tableKey = this.grid.tableKey;

              if (!tableKey) {
                tableKey = columnExpand.tableKey;
              }

              dataTable = this.form.getDocument().getByKey(tableKey), columnKey = columnExpand.columnKey;
              column = dataTable.getColByKey(columnKey), dataType = column.type, items = [];
              cxt = new _YIUIParser.View.Context(this.form);

              if (!(columnExpand.expandSourceType == _YIUIBase.YIUI.ExpandSourceType.DATA)) {
                _context.next = 21;
                break;
              }

              set = [];
              dataTable.beforeFirst();

              while (dataTable.next()) {
                value = dataTable.getByKey(columnKey);

                if (set.indexOf(value) == -1) {
                  set.push(value);
                }
              }

              i = 0;

            case 12:
              if (!(value = set[i])) {
                _context.next = 19;
                break;
              }

              if (!(value == null || dataType == _YIUIBase.YIUI.DataType.INT && _YIUIBase.YIUI.TypeConvertor.toInt(value) == 0)) {
                _context.next = 15;
                break;
              }

              return _context.abrupt("continue", 16);

            case 15:
              items.push(new _YIUIBase.YIUI.ExpandItem(value, value.toString(), dataType));

            case 16:
              i++;
              _context.next = 12;
              break;

            case 19:
              _context.next = 28;
              break;

            case 21:
              source = columnExpand.content;

              if (source) {
                _context.next = 24;
                break;
              }

              throw new Error("expand content undefind");

            case 24:
              _context.next = 26;
              return this.form.eval(source, cxt);

            case 26:
              result = _context.sent;

              if (result instanceof _YIUICommon.DataDef.DataTable) {
                result.beforeFirst();

                while (result.next()) {
                  value = _YIUIBase.YIUI.TypeConvertor.toDataType(dataType, result.get(0));
                  caption = _YIUIBase.YIUI.TypeConvertor.toString(result.get(1));
                  items.push(new _YIUIBase.YIUI.ExpandItem(value, caption, dataType));
                }
              } else if (typeof result == "string") {
                ret = _YIUIBase.YIUI.TypeConvertor.toString(result);

                if (ret.length > 0) {
                  v = ret.split(";");

                  for (j = 0; item = v[j]; j++) {
                    idx = item.indexOf(",");
                    value = item.substring(0, idx);
                    caption = item.substring(idx + 1);
                    items.push(new _YIUIBase.YIUI.ExpandItem(_YIUIBase.YIUI.TypeConvertor.toDataType(dataType, value), caption, dataType));
                  }
                }
              }

            case 28:
              return _context.abrupt("return", items);

            case 29:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    function extractExpandSources(_x) {
      return _extractExpandSources.apply(this, arguments);
    }

    return extractExpandSources;
  }(),
  initGroups: function initGroups(metaGrid) {
    var columns = metaGrid.columns,
        orgMeta = this.grid.getOrgMetaObj(),
        expandModel = this.grid.dataModel.expandModel,
        metaColumn,
        area = 0,
        info;

    for (var i = 0, len = columns.length; i < len; i++) {
      metaColumn = columns[i], info = [];
      var columnExpand = metaColumn.columnExpand;

      if (columnExpand) {
        var root = new _YIUIBase.YIUI.ColumnExpandGroup();
        root.setColumn(metaColumn);
        root.setArea(area);

        if (columnExpand.expandType == _YIUIBase.YIUI.ColumnExpandType.DATA) {
          info.push(columnExpand.columnKey);
        }

        this.fillColumnGroups(root, info, metaColumn, area);
        root.calcCount();
        root.left = orgMeta.leafIndexMap[root.getFirst().key];
        root.right = root.left + root.count;
        this.groups.push(root);
        expandModel.push(info);
        area++;
      }
    }
  },
  fillColumnGroups: function fillColumnGroups(parent, info, column, area) {
    var columns = column.columns,
        metaGrid = this.grid.getOrgMetaObj(),
        rows = metaGrid.rows;
    var child, metaRow, columnExpand;

    if (columns) {
      for (var i = 0, len = columns.length; i < len; i++) {
        child = columns[i], columnExpand = child.columnExpand;

        if (columnExpand) {
          var group = new _YIUIBase.YIUI.ColumnExpandGroup();
          group.setColumn(child);
          group.area = area;
          parent.add(group);

          if (columnExpand.expandType == _YIUIBase.YIUI.ColumnExpandType.DATA) {
            info.push(columnExpand.columnKey);
          }

          this.fillColumnGroups(group, info, child, area);
        } else {
          var cells = new _YIUIBase.YIUI.ColumnExpandCells();
          cells.setColumn(child);
          var idx = metaGrid.leafIndexMap[child.key];

          for (var j = 0, count = rows.length; j < count; j++) {
            metaRow = rows[j];
            cells.addCell(metaRow.cells[idx]);
          }

          parent.add(cells);
        }
      }
    } else {
      var cells = new _YIUIBase.YIUI.ColumnExpandCells();
      cells.setColumn(column);
      var idx = metaGrid.leafIndexMap[column.key];

      for (var j = 0, count = rows.length; j < count; j++) {
        metaRow = rows[j];
        cells.addCell(metaRow.cells[idx]);
      }

      parent.add(cells);
    }
  },
  expandColumns: function () {
    var _expandColumns = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee2(metaGrid) {
      return regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _context2.next = 2;
              return this.expandColumn(metaGrid.columns);

            case 2:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, this);
    }));

    function expandColumns(_x2) {
      return _expandColumns.apply(this, arguments);
    }

    return expandColumns;
  }(),
  expandColumn: function () {
    var _expandColumn = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee3(collection) {
      var columns, metaColumn, i, expand, items, j, item, cloneColumn, secondKey, _column, k, child;

      return regeneratorRuntime.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              if (!(collection == null)) {
                _context3.next = 2;
                break;
              }

              return _context3.abrupt("return");

            case 2:
              columns = [];
              i = 0;

            case 4:
              if (!(metaColumn = collection[i])) {
                _context3.next = 24;
                break;
              }

              if (!(metaColumn.columnExpand != null)) {
                _context3.next = 20;
                break;
              }

              expand = metaColumn.columnExpand;

              if (!(expand.expandType == _YIUIBase.YIUI.ColumnExpandType.DATA)) {
                _context3.next = 17;
                break;
              }

              _context3.next = 10;
              return this.extractExpandSources(metaColumn);

            case 10:
              items = _context3.sent;

              if (!(items == null || items.length == 0)) {
                _context3.next = 14;
                break;
              }

              metaColumn.invalidExpand = true;
              return _context3.abrupt("return");

            case 14:
              for (j = 0; item = items[j]; j++) {
                cloneColumn = _YIUIBase.YIUI.UIUtil.copyObject(metaColumn);
                secondKey = _YIUIBase.YIUI.TypeConvertor.toString(item.value);
                cloneColumn.key = cloneColumn.key + secondKey;
                cloneColumn.caption = item.caption;
                cloneColumn.expValue = item.value;
                columns.push(cloneColumn);
              }

              _context3.next = 18;
              break;

            case 17:
              columns.push(metaColumn);

            case 18:
              _context3.next = 21;
              break;

            case 20:
              columns.push(metaColumn);

            case 21:
              i++;
              _context3.next = 4;
              break;

            case 24:
              collection.length = 0;

              for (i = 0; _column = columns[i]; i++) {
                collection.push(_column);
              }

              k = 0;

            case 27:
              if (!(child = collection[k])) {
                _context3.next = 35;
                break;
              }

              if (!(child.columnExpand != null)) {
                _context3.next = 32;
                break;
              }

              this.form.setPara("PEV", child.expValue);
              _context3.next = 32;
              return this.expandColumn(child.columns);

            case 32:
              k++;
              _context3.next = 27;
              break;

            case 35:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3, this);
    }));

    function expandColumn(_x3) {
      return _expandColumn.apply(this, arguments);
    }

    return expandColumn;
  }(),
  expandGroups: function () {
    var _expandGroups = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee4() {
      var i, len;
      return regeneratorRuntime.wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              i = 0, len = this.groups.length;

            case 1:
              if (!(i < len)) {
                _context4.next = 7;
                break;
              }

              _context4.next = 4;
              return this.expandOneGroup(this.groups[i]);

            case 4:
              i++;
              _context4.next = 1;
              break;

            case 7:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4, this);
    }));

    function expandGroups() {
      return _expandGroups.apply(this, arguments);
    }

    return expandGroups;
  }(),
  expandOneGroup: function () {
    var _expandOneGroup = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee5(group) {
      var column, columnExpand, i, obj;
      return regeneratorRuntime.wrap(function _callee5$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              column = group.getColumn(), columnExpand = column.columnExpand;

              if (!(columnExpand.expandType == _YIUIBase.YIUI.ColumnExpandType.DATA)) {
                _context5.next = 4;
                break;
              }

              _context5.next = 4;
              return this.impl_expandGroup(column, group);

            case 4:
              i = 0;

            case 5:
              if (!(obj = group.columnArray[i])) {
                _context5.next = 13;
                break;
              }

              if (!(obj.getObjectType() == _YIUIBase.YIUI.ColumnExpandObjectType.Group)) {
                _context5.next = 10;
                break;
              }

              this.form.setPara("PEV", obj.expValue);
              _context5.next = 10;
              return this.expandOneGroup(obj);

            case 10:
              i++;
              _context5.next = 5;
              break;

            case 13:
            case "end":
              return _context5.stop();
          }
        }
      }, _callee5, this);
    }));

    function expandOneGroup(_x4) {
      return _expandOneGroup.apply(this, arguments);
    }

    return expandOneGroup;
  }(),
  impl_expandGroup: function () {
    var _impl_expandGroup = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee6(column, group) {
      var columnExpand, columnKey, items, item, obj, newObj, tempList, i, size, k, length;
      return regeneratorRuntime.wrap(function _callee6$(_context6) {
        while (1) {
          switch (_context6.prev = _context6.next) {
            case 0:
              columnExpand = column.columnExpand, columnKey = columnExpand.columnKey;
              _context6.next = 3;
              return this.extractExpandSources(column);

            case 3:
              items = _context6.sent;

              if (!(!items || items.length == 0)) {
                _context6.next = 6;
                break;
              }

              return _context6.abrupt("return");

            case 6:
              tempList = [];

              for (i = 0, size = items.length; i < size; i++) {
                item = items[i];

                for (k = 0, length = group.size(); k < length; k++) {
                  obj = group.get(k);
                  newObj = obj.clone();
                  newObj.expValue = item.value;
                  newObj.traversal(item, function (item, cell) {
                    var key = cell.key;
                    cell.columnArea = group.area;
                    cell.isColExpand = true;
                    var crossValue = cell.crossValue,
                        crossValueMap = cell.crossValueMap;

                    if (!crossValue) {
                      crossValue = new _YIUIBase.YIUI.MultiKey();
                      cell.crossValue = crossValue;
                    }

                    if (!crossValueMap) {
                      crossValueMap = {};
                      cell.crossValueMap = crossValueMap;
                    }

                    var value = item.value,
                        javaType = _YIUIBase.YIUI.UIUtil.dataType2JavaDataType(item.dataType);

                    var node = new _YIUIBase.YIUI.MultiKeyNode(javaType, value);
                    crossValue.addValue(node);
                    crossValueMap[columnKey] = node;
                  });
                  tempList.push(newObj);
                }
              }

              group.clear();
              group.addAll(tempList);

            case 10:
            case "end":
              return _context6.stop();
          }
        }
      }, _callee6, this);
    }));

    function impl_expandGroup(_x5, _x6) {
      return _impl_expandGroup.apply(this, arguments);
    }

    return impl_expandGroup;
  }(),
  replaceGroups: function replaceGroups(targetMetaGrid) {
    for (var i = this.groups.length - 1; i >= 0; i--) {
      var group = this.groups[i];
      var left = group.left,
          count = group.count;

      for (var j = 0, len = targetMetaGrid.rows.length; j < len; j++) {
        var metaRow = targetMetaGrid.rows[j];
        metaRow.cells.splice(left, count);
        metaRow.cellKeys.splice(left, count);
        var leafCells = group.getLeafCells(j);

        for (var m = 0, mLen = leafCells.length; m < mLen; m++) {
          metaRow.cells.splice(left + m, 0, leafCells[m]);
          metaRow.cellKeys.splice(left + m, 0, leafCells[m].key);
        }
      }
    }
  },
  expand: function () {
    var _expand = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee7() {
      var targetMetaGrid;
      return regeneratorRuntime.wrap(function _callee7$(_context7) {
        while (1) {
          switch (_context7.prev = _context7.next) {
            case 0:
              // 每次拓展需要使用原始的配置对象
              targetMetaGrid = _YIUIBase.YIUI.UIUtil.copyObject(this.grid.getOrgMetaObj()); //初始化分组区域

              this.initGroups(targetMetaGrid); //扩展组

              _context7.next = 4;
              return this.expandGroups();

            case 4:
              _context7.next = 6;
              return this.expandColumns(targetMetaGrid);

            case 6:
              // 分区域替换单元格,从后往前替换
              this.replaceGroups(targetMetaGrid); // 设置表格的配置对象

              this.grid.setMetaObj(targetMetaGrid);

            case 8:
            case "end":
              return _context7.stop();
          }
        }
      }, _callee7, this);
    }));

    function expand() {
      return _expand.apply(this, arguments);
    }

    return expand;
  }()
});
_YIUIBase.YIUI.ColumnExpandObjectType = {
  Column: 0,
  Group: 1
};
_YIUIBase.YIUI.ColumnExpandCells = _YIUIBase.YIUI.extend({
  column: null,
  cellArray: null,
  init: function init() {
    this.cellArray = [];
  },
  addCell: function addCell(cellOpt) {
    this.cellArray.push(cellOpt);
  },
  setColumn: function setColumn(column) {
    this.column = column;
  },
  getColumn: function getColumn() {
    return this.column;
  },
  getObjectType: function getObjectType() {
    return _YIUIBase.YIUI.ColumnExpandObjectType.Column;
  },
  clone: function clone() {
    var newObj = new _YIUIBase.YIUI.ColumnExpandCells(this.column);

    for (var i = 0, len = this.cellArray.length; i < len; i++) {
      var cell = this.cellArray[i];
      var cloneCell = Object.assign({
        extendInfo: {}
      }, _YIUIBase.YIUI.UIUtil.copyObject(cell));

      if (cell.crossValue != null) {
        cloneCell.crossValue = cell.crossValue.clone();
      }

      newObj.addCell(cloneCell);
    }

    return newObj;
  },
  getCell: function getCell(index) {
    return this.cellArray[index];
  },
  traversal: function traversal(context, process) {
    for (var i = 0, obj; obj = this.cellArray[i]; i++) {
      process.call(this, context, obj);
    }
  },
  getColumnCount: function getColumnCount() {
    return 1;
  }
});
_YIUIBase.YIUI.ColumnExpandGroup = _YIUIBase.YIUI.extend({
  columnArray: null,
  expandCell: null,
  rowIndex: -1,
  column: null,
  left: -1,
  count: -1,
  firstColumn: null,
  area: -1,
  init: function init() {
    this.columnArray = [];
    this.count = 0;
  },
  setColumn: function setColumn(column) {
    this.column = column;
  },
  getColumn: function getColumn() {
    return this.column;
  },
  setArea: function setArea(area) {
    this.area = area;
  },
  getLeafColumnList: function getLeafColumnList(list) {
    for (var i = 0, len = this.columnArray.length; i < len; i++) {
      var obj = this.columnArray[i];

      if (obj.getObjectType() == _YIUIBase.YIUI.ColumnExpandObjectType.Column) {
        list.push(obj);
      } else {
        obj.getLeafColumnList(list);
      }
    }
  },
  getLeafCells: function getLeafCells(rowIndex) {
    var list = [],
        leafColumnList = [],
        column;
    this.getLeafColumnList(leafColumnList);

    for (var i = 0, len = leafColumnList.length; i < len; i++) {
      column = leafColumnList[i];
      list.push(column.getCell(rowIndex));
    }

    return list;
  },
  calcCount: function calcCount() {
    this.count = 0;
    var obj;

    for (var i = 0, len = this.columnArray.length; i < len; i++) {
      obj = this.columnArray[i];

      if (obj.getObjectType() == _YIUIBase.YIUI.ColumnExpandObjectType.Group) {
        obj.calcCount();
        this.count += obj.count;
      } else {
        this.count += 1;
      }
    }
  },
  getFirst: function getFirst() {
    var obj = this.columnArray[0];

    if (obj.getObjectType() == _YIUIBase.YIUI.ColumnExpandObjectType.Group) {
      return obj.getFirst();
    } else {
      return obj.getColumn();
    }
  },
  add: function add(obj) {
    this.columnArray.push(obj);
  },
  size: function size() {
    return this.columnArray.length;
  },
  clear: function clear() {
    this.columnArray = [];
  },
  addAll: function addAll(list) {
    for (var i = 0, len = list.length; i < len; i++) {
      this.columnArray.push(list[i]);
    }
  },
  replace: function replace(index, list) {
    this.columnArray.splice(index, 1);

    for (var i = 0, len = list.length; i < len; i++) {
      this.columnArray.splice(index + i, 0, list[i]);
    }
  },
  get: function get(index) {
    return this.columnArray[index];
  },
  getObjectType: function getObjectType() {
    return _YIUIBase.YIUI.ColumnExpandObjectType.Group;
  },
  clone: function clone() {
    var newObj = new _YIUIBase.YIUI.ColumnExpandGroup();
    newObj.setColumn(this.column);

    for (var i = 0, len = this.columnArray.length; i < len; i++) {
      newObj.add(this.columnArray[i].clone());
    }

    newObj.area = this.area;
    return newObj;
  },
  traversal: function traversal(context, process) {
    for (var i = 0, obj; obj = this.columnArray[i]; i++) {
      obj.traversal(context, process);
    }
  }
});

var _default = _YIUIBase.YIUI.ShowGridData = _YIUIBase.YIUI.extend({
  form: null,
  grid: null,
  init: function init(form, grid) {
    this.form = form;
    this.grid = grid;
    this.grid.hasRowExpand = false;
  },
  load: function () {
    var _load = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee8() {
      var doc, dataTable, gridRowGroup, builder;
      return regeneratorRuntime.wrap(function _callee8$(_context8) {
        while (1) {
          switch (_context8.prev = _context8.next) {
            case 0:
              doc = this.form.getDocument();

              if (!(doc == null)) {
                _context8.next = 3;
                break;
              }

              return _context8.abrupt("return");

            case 3:
              dataTable = doc.getByKey(this.grid.tableKey);
              _context8.next = 6;
              return this.constructGrid();

            case 6:
              gridRowGroup = new _YIUIBase.YIUI.GridRowGroup(this.form, this.grid);
              gridRowGroup.group(); // if (this.grid.getMetaObj().treeType != -1) {
              //     builder = new YIUI.GridTreeBuilder(this.form, this.grid);
              // } else if (this.grid.hasRowExpand) {
              //     builder = new YIUI.GridRowExpandBuilder(this.form, this.grid);
              // } else {

              builder = new _YIUIBase.YIUI.GridNormalRowBuilder(this.form, this.grid); // }

              builder.build();
              this.grid.setTotalRowCount(_YIUIBase.YIUI.TotalRowCountUtil.getRowCount(doc, this.grid.tableKey));

            case 11:
            case "end":
              return _context8.stop();
          }
        }
      }, _callee8, this);
    }));

    function load() {
      return _load.apply(this, arguments);
    }

    return load;
  }(),
  constructGrid: function () {
    var _constructGrid = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee9() {
      var columnExpand;
      return regeneratorRuntime.wrap(function _callee9$(_context9) {
        while (1) {
          switch (_context9.prev = _context9.next) {
            case 0:
              if (!this.grid.hasColExpand) {
                _context9.next = 7;
                break;
              }

              this.grid.dataModel.expandModel = [];
              columnExpand = new _YIUIBase.YIUI.GridColumnExpand(this.form, this.grid);
              _context9.next = 5;
              return columnExpand.expand();

            case 5:
              this.buildColumnHeader(); // 更新单元格位置信息

              _YIUIBase.YIUI.GridLookupUtil.buildCellLookup(this.form, this.grid);

            case 7:
              if (this.grid.hasRowExpand) {// var rowExpand = new YIUI.GridRowExpand(this.form, this.grid);
                // rowExpand.dealRowExpand();
              }

              this.grid.initLeafColumns();
              this.grid.initDataModel();

            case 10:
            case "end":
              return _context9.stop();
          }
        }
      }, _callee9, this);
    }));

    function constructGrid() {
      return _constructGrid.apply(this, arguments);
    }

    return constructGrid;
  }(),
  buildColumnHeader: function buildColumnHeader() {
    var leafColumns = [];

    var initLeafColumns = function initLeafColumns(columns, leafColumns) {
      for (var i = 0, len = columns.length; i < len; i++) {
        var column = columns[i];

        if (column.columns != null && column.columns.length > 0) {
          initLeafColumns(column.columns, leafColumns);
        } else {
          leafColumns.push(column);
        }
      }
    };

    initLeafColumns(this.grid.getMetaObj().columns, leafColumns);
    var gridColumns = [],
        cells = {};

    for (var i = 0, len = leafColumns.length; i < len; i++) {
      var metaColumn = leafColumns[i],
          colObj = {};
      colObj.key = metaColumn.key;
      colObj.label = metaColumn.caption;
      colObj.formulaCaption = metaColumn.formulaCaption;

      if (metaColumn.refColumn != null) {
        colObj.isExpandCol = true;
        colObj.refColumn = metaColumn.refColumn.key;
      }

      colObj.name = "column" + i;
      colObj.index = i;
      colObj.width = metaColumn.width;
      colObj.hidden = false;
      colObj.sortable = metaColumn.sortable;
      colObj.visible = metaColumn.visible;
      colObj.visibleDependency = metaColumn.visibleDependency;
      colObj.columnType = metaColumn.columnType;

      if (this.grid.treeColIndex >= 0 && i == this.grid.treeColIndex) {
        colObj.editable = false;
      }

      gridColumns.push(colObj);
    }

    for (var j = 0, jLen = this.grid.getMetaObj().rows.length; j < jLen; j++) {
      var metaRow = this.grid.getMetaObj().rows[j];

      for (var m = 0, mLen = metaRow.cells.length; m < mLen; m++) {
        var metaCell = metaRow.cells[m],
            cellObj = _YIUIBase.YIUI.UIUtil.copyObject(metaCell);

        cellObj.colIndex = m;

        if (metaCell.cellType == _YIUIBase.YIUI.CONTROLTYPE.COMBOBOX || metaCell.cellType == _YIUIBase.YIUI.CONTROLTYPE.CHECKLISTBOX) {
          var items = [],
              item;

          switch (metaCell.sourceType) {
            case _YIUIBase.YIUI.COMBOBOX_SOURCETYPE.STATUS:
              var statusItems = this.form.statusItems;

              if (statusItems != null && statusItems.length > 0) {
                for (var k = 0, kLen = statusItems.length; k < kLen; k++) {
                  item = {
                    value: statusItems[k].value,
                    caption: statusItems[k].caption
                  };
                  items.push(item);
                }

                cellObj.option.items = items;
              }

              break;

            case _YIUIBase.YIUI.COMBOBOX_SOURCETYPE.PARAGROUP:
              var paraGroups = this.form.paraGroups;

              if (paraGroups != null && paraGroups.length > 0) {
                for (var h = 0, hLen = paraGroups.length; h < hLen; k++) {
                  item = {
                    value: paraGroups[h].value,
                    caption: paraGroups[h].caption
                  };
                  items.push(item);
                }

                cellObj.option.items = items;
              }

              break;
          }
        }

        cells[cellObj.key] = cellObj;

        if (metaRow.rowType == "Detail" && metaCell.cellType == _YIUIBase.YIUI.CONTROLTYPE.CHECKBOX && metaCell.isSelect) {
          gridColumns[j].isSelect = true;
        }
      }
    }

    this.grid.dataModel.colModel.columns = gridColumns;
    this.grid.dataModel.colModel.cells = cells;
  } // calcRowDataByLayer: function (form, grid, dataTable) {  //层次数据过滤计算。
  //     var defaultLayer = grid.getMetaObj().defaultLayer;
  //     if (dataTable == null || defaultLayer == -1) return;
  //     if (dataTable.getColByKey("Layer") == null || dataTable.getColByKey("Hidden") == null) {
  //         YIUI.ViewException.throwException(YIUI.ViewException.LAYER_OR_HIDDEN_NO_DEFINE);
  //     }
  //     var layerTree = {};
  //     dataTable.beforeFirst();
  //     while (dataTable.next()) {
  //         var layer = dataTable.getByKey("Layer");
  //         layer = (layer == null ? 0 : layer);
  //         var rows = layerTree[layer];
  //         if (rows == null) {
  //             rows = [];
  //             layerTree[layer] = rows;
  //         }
  //         var curBookmark = dataTable.getBookmark();
  //         if (!$.inArray(curBookmark, rows)) {
  //             rows.push(curBookmark);
  //         }
  //         dataTable.setByKey("Hidden", 0);
  //         //TODO 没处理完，主要是DataTable的过滤没法处理
  //     }
  // }

});

exports["default"] = _default;
_YIUIBase.YIUI.GridNormalRowBuilder = _YIUIBase.YIUI.extend({
  form: null,
  grid: null,
  init: function init(form, grid) {
    this.form = form;
    this.grid = grid;
  },
  build: function build() {
    this.grid.clearGridData();
    var document = this.form.getDocument(),
        dataTable = document.getByKey(this.grid.tableKey),
        rootRowLayer = this.grid.getMetaObj().rowLayer,
        metaRow;

    for (var i = 0, len = rootRowLayer.objectArray.length; i < len; i++) {
      var rowObj = rootRowLayer.objectArray[i];

      if (rowObj.objectType == _YIUIBase.YIUI.MetaGridRowObjectType.ROW) {
        metaRow = this.grid.getMetaObj().rows[rowObj.rowIndex];

        var newRowIndex = _YIUIBase.YIUI.GridUtil.insertRow(this.grid, -1, metaRow, null, 0);

        if (newRowIndex != null) {
          _gridhandler["default"].showFixRowData(this.form, this.grid, newRowIndex);
        }
      } else if (rowObj.objectType == _YIUIBase.YIUI.MetaGridRowObjectType.AREA) {
        var root = this.grid.dataModel.rootBkmk,
            groupLevel = 0;

        for (var j = 0, jLen = rowObj.objectArray.length; j < jLen; j++) {
          var subObj = rowObj.objectArray[j];

          if (subObj.objectType == _YIUIBase.YIUI.MetaGridRowObjectType.ROW) {
            metaRow = this.grid.getMetaObj().rows[subObj.rowIndex];

            _YIUIBase.YIUI.GridUtil.insertRow(this.grid, -1, metaRow, null, 0);
          } else if (subObj.objectType == _YIUIBase.YIUI.MetaGridRowObjectType.GROUP) {
            for (var k = 0, kLen = root.getRowCount(); k < kLen; k++) {
              this.buildGroupRows(this.grid, dataTable, groupLevel, root.getRowAt(k));
            }
          }
        }
      }
    } //重建表头
    // YIUI.GridUtil.buildGroupHeaders(this.grid);

  },
  buildGroupRows: function buildGroupRows(grid, dataTable, groupLevel, parentgroup) {
    var gridData = grid.dataModel.data;
    var metaGridRowGroup = parentgroup.getMetaGroup(),
        objectCount = metaGridRowGroup.objectArray.length,
        metaRow;

    if (parentgroup.isLeaf) {
      for (var i = 0; i < objectCount; i++) {
        var subObj = metaGridRowGroup.objectArray[i];
        metaRow = this.grid.getMetaObj().rows[subObj.rowIndex];

        switch (metaRow.rowType) {
          case "Group":
            // YIUI.GridUtil.insertRow(this.grid, -1, metaRow, null, groupLevel);
            break;

          case "Detail":
            groupLevel++;
            var rowCount = parentgroup.getRowCount();
            var start = 0,
                end = rowCount; // if (this.grid.getMetaObj().pageLoadType == YIUI.PageLoadType.UI) {
            //     var curPageIndex = this.grid.pageInfo.curPageIndex,
            //         pageRowCount = this.grid.getMetaObj().pageRowCount;
            //     curPageIndex = curPageIndex == null ? 0 : curPageIndex;
            //     start = curPageIndex <= 0 ? 0 : curPageIndex * pageRowCount;
            //     end = start + pageRowCount > rowCount ? rowCount : start + pageRowCount;
            // }

            for (var m = start; m < end; m++) {
              var bkmkRow = parentgroup.getRowAt(m);

              var newRowIndex = _YIUIBase.YIUI.GridUtil.insertRow(grid, -1, metaRow, bkmkRow, groupLevel);

              _gridhandler["default"].showDetailRowData(this.form, this.grid, newRowIndex, false);
            }

            groupLevel--;
            break;
        }
      }
    } else {
      for (var j = 0; j < objectCount; j++) {
        var rowObj = metaGridRowGroup.objectArray[j];
        metaRow = this.grid.getMetaObj().rows[rowObj.rowIndex];

        if (rowObj.objectType == _YIUIBase.YIUI.MetaGridRowObjectType.ROW) {
          _YIUIBase.YIUI.GridUtil.insertRow(grid, -1, metaRow, null, groupLevel);
        } else {
          for (var k = 0, kLen = parentgroup.getRowCount(); k < kLen; k++) {
            groupLevel++;
            this.buildGroupRows(grid, dataTable, groupLevel, parentgroup.getRowAt(k));
            groupLevel--;
          }
        }
      }
    }
  }
});
_YIUIBase.YIUI.GridRowExpandBuilder = _YIUIBase.YIUI.extend({
  form: null,
  grid: null,
  init: function init(form, grid) {
    this.form = form;
    this.grid = grid;
  },
  build: function build() {
    this.grid.clearGridData();
    var dataTable = this.form.getDocument().getByKey(this.grid.tableKey);
    var detailRow = this.grid.getDetailMetaRow();
    var rowExpandIndex = this.grid.rowExpandIndex;
    var expandCell = detailRow.cells[rowExpandIndex];
    var leafGroup = this.getLeafGroupBkmkFromRoot(this.grid.dataModel.rootBkmk);
    if (leafGroup == null) return;
    var bkmkMap = {},
        detailRowBkmk,
        bkmk,
        value;

    for (var i = 0, len = leafGroup.getRowCount(); i < len; i++) {
      bkmk = leafGroup.getRowAt(i);

      if (this.grid.hasColExpand) {
        detailRowBkmk = bkmk.getAt(0);
      } else {
        detailRowBkmk = bkmk;
      }

      dataTable.setByBkmk(detailRowBkmk.getBookmark());
      var colInfo = dataTable.getColByKey(expandCell.columnKey);
      value = _YIUIBase.YIUI.TypeConvertor.toDataType(colInfo.type, dataTable.getByKey(expandCell.columnKey));

      if (value != null) {
        bkmkMap[value] = bkmk;
      }
    }

    var expandModel = this.grid.getRowExpandModel();

    for (var j = 0, size = expandModel.length; j < size; j++) {
      value = expandModel[j];
      bkmk = bkmkMap[value];

      var newRowIndex = _YIUIBase.YIUI.GridUtil.insertRow(this.grid, -1, detailRow, bkmk, 0);

      if (bkmk != undefined) {
        _gridhandler["default"].showDetailRowData(this.form, this.grid, newRowIndex);
      } else {
        this.grid.setValueAt(newRowIndex, rowExpandIndex, value);
      }
    }
  },
  getLeafGroupBkmkFromRoot: function getLeafGroupBkmkFromRoot(groupRowBkmk) {
    for (var i = 0, len = groupRowBkmk.getRowCount(); i < len; i++) {
      var bkmk = groupRowBkmk.getRowAt(i);

      if (bkmk.getRowType() == _YIUIBase.YIUI.IRowBkmk.Group) {
        if (bkmk.isLeaf) {
          return bkmk;
        }
      }
    }

    return null;
  }
});
_YIUIBase.YIUI.GridTreeBuilder = _YIUIBase.YIUI.extend({
  form: null,
  grid: null,
  init: function init(form, grid) {
    this.form = form;
    this.grid = grid;
  },
  build: function build() {
    this.grid.clearGridData();
    var metaGrid = this.grid.getMetaObj(),
        detailRow = this.grid.getDetailMetaRow();

    if (detailRow == null) {
      _YIUIBase.YIUI.ViewException.throwException(_YIUIBase.YIUI.ViewException.NO_DETAIL_ROW_DEFINE);
    }

    var dataTable = this.form.getDocument().getByKey(this.grid.tableKey);
    var treeIndex = this.grid.treeIndex,
        treeCell = detailRow.cells[treeIndex],
        metaTree = treeCell.tree,
        bkmkMap = {},
        id,
        bkmk;
    dataTable.beforeFirst();

    switch (metaTree.treeType) {
      case _YIUIBase.YIUI.TreeType.DICT:
        if (treeCell.cellType != _YIUIBase.YIUI.CONTROLTYPE.DICT) {
          _YIUIBase.YIUI.ViewException.throwException(_YIUIBase.YIUI.ViewException.GRID_TREE_COLUMN_DEFINE_ERROR);
        }

        var editOpt = treeCell.editOptions,
            itemKey = editOpt.itemKey,
            dictFilter = _YIUIBase.YIUI.DictHandler.getDictFilter(this.form, treeCell.key, editOpt.itemFilters, itemKey);

        while (dataTable.next()) {
          id = _YIUIBase.YIUI.TypeConvertor.toLong(dataTable.getByKey(treeCell.columnKey));
          bkmk = new _YIUIBase.YIUI.DetailRowBkmk();
          bkmk.setBookmark(dataTable.getBkmk());
          bkmkMap[id] = bkmk;
        }

        this.buildTreeRelation(bkmkMap, dictFilter, metaTree.isExpand, itemKey, editOpt.sortColumns, detailRow);
        break;

      case _YIUIBase.YIUI.TreeType.CUSTOM:
        // 根据数据,主关系字段的值唯一
        var fgn2RowMap = {},
            fgnValue,
            rows;

        while (dataTable.next()) {
          id = dataTable.getByKey(metaTree.reference);

          if (id != null) {
            bkmk = new _YIUIBase.YIUI.DetailRowBkmk();
            bkmk.setBookmark(dataTable.getBkmk());
            bkmkMap[id] = bkmk;
          }

          fgnValue = dataTable.getByKey(metaTree.foreign);
          rows = fgn2RowMap[fgnValue ? fgnValue : "_root"];

          if (!rows) {
            rows = [];
            fgn2RowMap[fgnValue ? fgnValue : "_root"] = rows;
          }

          rows.push(id);
        }

        var rootItems = fgn2RowMap["_root"]; // 根节点

        this.buildCustomRow(fgn2RowMap, bkmkMap, metaTree.isExpand, rootItems, detailRow);
        break;

      default:
        break;
    }
  },
  buildCustomRow: function buildCustomRow(fgn2RowMap, bkmkMap, expand, references, metaRow, parentRow) {
    for (var i = 0, len = references.length; i < len; i++) {
      var bkmkRow = bkmkMap[references[i]];

      var newRowIndex = _YIUIBase.YIUI.GridUtil.insertRow(this.grid, -1, metaRow, bkmkRow, 0);

      var rowData = this.grid.dataModel.data[newRowIndex];
      rowData.treeLevel = parentRow ? parentRow.treeLevel + 1 : 0;

      _gridhandler["default"].showDetailRowData(this.form, this.grid, newRowIndex);

      if (parentRow != null) {
        var childRows = parentRow.childRows;

        if (!childRows) {
          childRows = [];
          parentRow.childRows = childRows;
        }

        childRows.push(rowData.rowID);
        rowData.parentRow = parentRow;
      }

      var referItems = fgn2RowMap[references[i]];

      if (referItems) {
        rowData.isExpand = expand;
        this.buildCustomRow(fgn2RowMap, bkmkMap, expand, referItems, metaRow, rowData);
      } else {
        rowData.isLeaf = true;
      }
    }
  },
  buildTreeRelation: function buildTreeRelation(bkmkMap, filter, expand, itemKey, sortColumns, metaRow) {
    var items = _YIUIBase.YIUI.DictService.getAllItems(itemKey, filter, _YIUIBase.YIUI.DictStateMask.Enable);

    var getParentID = function getParentID(item, colKey) {
      var table = item.itemTables[item.mainTableKey];
      var value;

      if (table.itemRows.length > 0) {
        if (table.tableMode == _YIUIBase.YIUI.TableMode.HEAD) {
          value = table.itemRows[0][colKey];
        } else {
          var list = [];

          for (var j = 0, jlen = table.itemRows.length; j < jlen; j++) {
            list.push(table.itemRows[j][colKey]);
          }

          value = list;
        }
      }

      return value;
    };

    var PID2ItemMap = {};

    for (var i = 0, len = items.length; i < len; i++) {
      var item = items[i],
          parentID = getParentID(item, "ParentID");
      var itemsList = PID2ItemMap[parentID];

      if (itemsList == null) {
        itemsList = [];
        PID2ItemMap[parentID] = itemsList;
      }

      itemsList.push(item);
    }

    var roots = PID2ItemMap["0"];

    if (roots) {
      this.buildTreeRow(PID2ItemMap, bkmkMap, expand, roots, metaRow, 0); // 根据层次关系构建表格行
    }
  },
  buildTreeRow: function buildTreeRow(PID2ItemMap, bkmkMap, expand, items, metaRow, parentRow) {
    for (var i = 0, len = items.length; i < len; i++) {
      var item = items[i],
          opts = {
        oid: item.oid,
        caption: item.caption,
        itemKey: item.itemKey
      },
          itemData = new _YIUIBase.YIUI.ItemData(opts);
      var bkmkRow = bkmkMap[itemData.oid];

      var newRowIndex = _YIUIBase.YIUI.GridUtil.insertRow(this.grid, -1, metaRow, bkmkRow, 0);

      var rowData = this.grid.dataModel.data[newRowIndex];
      rowData.treeLevel = parentRow ? parentRow.treeLevel + 1 : 0;

      if (bkmkRow) {
        _gridhandler["default"].showDetailRowData(this.form, this.grid, newRowIndex);
      } else {
        this.grid.setValueAt(newRowIndex, this.grid.treeIndex, itemData);
      }

      if (parentRow != null) {
        var childRows = parentRow.childRows;

        if (childRows == null) {
          childRows = [];
          parentRow.childRows = childRows;
        }

        childRows.push(rowData.rowID);
        rowData.parentRow = parentRow;
      }

      var itemsList = PID2ItemMap[item.oid];

      if (itemsList != null) {
        rowData.isExpand = expand;
        this.buildTreeRow(PID2ItemMap, bkmkMap, expand, itemsList, metaRow, rowData);
      } else {
        rowData.isLeaf = true;
      }
    }
  }
}); // })();

_YIUIBase.YIUI.GridUtil = function () {
  var Return = {
    appendDetailRow: function appendDetailRow(grid) {
      var detailMetaRow = grid.getDetailMetaRow();
      var group = grid.dataModel.rootBkmk.getRowAt(0);
      var detailGridRow = new _YIUIBase.YIUI.DetailRowBkmk();
      detailGridRow.setBookmark(table.getBkmk());
      group.add(detailGridRow);
      this.insertRow(grid, -1, detailMetaRow, detailGridRow, group);
    },
    //表格数据模型中加行
    insertRow: function insertRow(grid, rowIndex, metaRow, bookmarkRow, groupLevel) {
      var initRowData = function initRowData(metaRow, groupLevel) {
        var rowData = {};
        rowData.rowType = metaRow.rowType;
        rowData.metaRowIndex = grid.getMetaObj().rows.indexOf(metaRow);
        rowData.cellKeys = metaRow.cellKeys;
        rowData.isDetail = metaRow.rowType == 'Detail' ? true : false;
        rowData.isEditable = metaRow.rowType == 'Total' || metaRow.rowType == 'Group' ? false : true;
        rowData.rowHeight = metaRow.rowHeight || 32;
        rowData.rowID = grid.randID();
        rowData.data = [];
        rowData.cellBkmks = [];
        rowData.backColor = "";

        if (bookmarkRow) {
          rowData.bkmkRow = bookmarkRow;

          if (bookmarkRow instanceof _YIUIBase.YIUI.ExpandRowBkmk) {
            rowData.bookmark = [];

            for (var h = 0, hLen = bookmarkRow.size(); h < hLen; h++) {
              rowData.bookmark.push(bookmarkRow.getAt(h).getBookmark());
            }
          } else {
            rowData.bookmark = bookmarkRow.getBookmark();
          }
        }

        if (groupLevel !== undefined) {
          rowData.rowGroupLevel = groupLevel;
        }

        if (metaRow.rowType == 'Group') {
          rowData.isGroupHead = metaRow.isGroupHead;
          rowData.isGroupTail = metaRow.isGroupTail;
        }

        return rowData;
      },
          //添加明细行
      addDetailRow = function addDetailRow(metaRow, groupLevel) {
        var rowData = initRowData(metaRow, groupLevel),
            metaCell,
            value,
            meta;

        for (var i = 0, len = metaRow.cells.length; i < len; i++) {
          metaCell = metaRow.cells[i], meta = metaCell.editOptions;
          var value = null,
              caption = null;

          switch (metaCell.cellType) {
            case _YIUIBase.YIUI.CONTROLTYPE.LABEL:
            case _YIUIBase.YIUI.CONTROLTYPE.BUTTON:
            case _YIUIBase.YIUI.CONTROLTYPE.HYPERLINK:
              if (!metaCell.hasDB) {
                caption = metaRow.cells[i].caption;
              }

              break;

            case _YIUIBase.YIUI.CONTROLTYPE.NUMBEREDITOR:
              value = new _decimal["default"](0); // if ( meta.zeroString ) {
              //     caption = meta.zeroString;
              // } else if (meta.showZero) {
              //     var opt = {};
              //     opt.mDec = meta.scale ? meta.scale : 2;
              //     caption = YIUI.DecimalFormat.format(0, opt) ;
              // }

              break;

            case _YIUIBase.YIUI.CONTROLTYPE.TEXTEDITOR:
            case _YIUIBase.YIUI.CONTROLTYPE.TEXTBUTTON:
            case _YIUIBase.YIUI.CONTROLTYPE.CHECKLISTBOX:
              value = '';
              break;
          }

          rowData.data.push([value, caption, true]);
          rowData.cellBkmks.push(null);
        }

        return rowData;
      },
          //添加汇总行
      addTotalRow = function addTotalRow(metaRow, groupLevel) {
        var rowData = initRowData(metaRow, groupLevel);

        for (var i = 0, len = metaRow.cells.length; i < len; i++) {
          var metaCell = metaRow.cells[i],
              cellData = {};
          cellData = [metaCell.caption, metaCell.caption];
          rowData.data.push(cellData);
        }

        return rowData;
      },
          //添加固定行
      addFixRow = function addFixRow(metaRow) {
        var rowData = initRowData(metaRow);

        for (var i = 0, len = metaRow.cells.length; i < len; i++) {
          var metaCell = metaRow.cells[i],
              cellData = {};

          if (metaCell.tableKey) {
            cellData = [null, '', true];

            if (!metaCell.tableKey && !metaCell.columnKey && (metaCell.cellType == _YIUIBase.YIUI.CONTROLTYPE.LABEL || metaCell.cellType == _YIUIBase.YIUI.CONTROLTYPE.BUTTON || metaCell.cellType == _YIUIBase.YIUI.CONTROLTYPE.HYPERLINK)) {
              cellData[1] = metaRow.cells[i].caption;
            }
          } else {
            cellData = [metaCell.caption, metaCell.caption, false];
          }

          rowData.data.push(cellData);
        }

        return rowData;
      };

      var rowData = null;

      switch (metaRow.rowType) {
        case "Group":
        case "Total":
          return;
          rowData = addTotalRow(metaRow, groupLevel);
          break;

        case "Detail":
          rowData = addDetailRow(metaRow, groupLevel);
          break;

        case "Fix":
          return;
          rowData = addFixRow(metaRow, groupLevel);
          break;

        default:
          console.log("error row type");
      } // var data = grid.dataModel.data, len = data.length,
      // dtrRowIndex = grid.getMetaObj().detailMetaRowIndex;


      var newRowIndex = 0;

      if (rowIndex >= 0) {
        newRowIndex = rowIndex;
        grid.insertRow(rowIndex, rowData);
      } else {
        newRowIndex = grid.getRowCount();
        grid.appendRow(rowData);
      } // 插行以后,更新固定行位置
      // var form = YIUI.FormStack.getForm(grid.ofFormID);
      // YIUI.GridLookupUtil.updateFixPos(form, grid);


      return newRowIndex;
    },
    buildGroupHeaders: function buildGroupHeaders(grid) {
      var groupHeaders = [];

      var calcLeafColumns = function calcLeafColumns(column, leafColumns) {
        for (var i = 0, len = column.columns.length; i < len; i++) {
          var subCol = column.columns[i];

          if (subCol.columns == null || subCol.columns.length == 0) {
            leafColumns.push(subCol);
          } else {
            calcLeafColumns(subCol, leafColumns);
          }
        }
      };

      var gridLeafColumns = [],
          rootColumn = {
        columns: grid.getMetaObj().columns
      };
      calcLeafColumns(rootColumn, gridLeafColumns);

      var initGroupHeaderArray = function initGroupHeaderArray(columns, groupHeaders) {
        var groupHeaderArray = [],
            nextColumns = [],
            column;

        for (var i = 0, len = columns.length; i < len; i++) {
          column = columns[i];

          if (column.columns != null && column.columns.length > 0) {
            var leafColumns = [],
                groupHeaderObj = {},
                index = -1;
            calcLeafColumns(column, leafColumns);
            index = gridLeafColumns.indexOf(leafColumns[0]);
            groupHeaderObj.startColumnName = "column" + index;
            groupHeaderObj.numberOfColumns = leafColumns.length;
            groupHeaderObj.titleText = column.caption;
            groupHeaderArray.push(groupHeaderObj);
            nextColumns = nextColumns.concat(column.columns);
          }
        }

        if (groupHeaderArray.length > 0) {
          groupHeaders.push(groupHeaderArray);
        }

        if (nextColumns.length > 0) {
          initGroupHeaderArray(nextColumns, groupHeaders);
        }
      };

      initGroupHeaderArray(grid.getMetaObj().columns, groupHeaders);
      grid.groupHeaders = groupHeaders;
    },
    isEmptyRow: function isEmptyRow(rowData) {
      if (rowData) {
        return rowData.rowType == 'Detail' ? rowData.bookmark == null && rowData.bkmkRow == null : false;
      }

      return false;
    }
  };
  return Return;
}();