"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _YIUIBase = require("../YIUI-base");

require("../YIUI-common");

require("../YIUI-parser");

require("../YIUI-svr");

// (function() {
var _default = _YIUIBase.YIUI.RTS_Service = function () {
  var rt = {
    getUserData: function getUserData(pageNum, maxRows, pageIndicatorCount, fuzzyValue, itemKey) {
      var paras = {
        service: "DictService",
        cmd: "GetQueryData",
        itemKey: itemKey,
        startRow: pageNum * maxRows,
        maxRows: maxRows,
        pageIndicatorCount: pageIndicatorCount,
        value: fuzzyValue
      };
      return Svr.Request.getData(paras);
    },
    LoadRightsList: function LoadRightsList(operatorID, roleID) {
      var paras = {
        cmd: "LoadSetRightsList",
        service: "SetRightsService",
        operatorID: operatorID,
        roleID: roleID
      };
      return Svr.Request.getData(paras);
    },
    LoadEntryRightsData: function LoadEntryRightsData(operatorID, roleID) {
      var paras = {
        cmd: "LoadEntryRightsData",
        service: "SetRightsService",
        operatorID: operatorID,
        roleID: roleID
      };
      return Svr.Request.getData(paras);
    },
    SaveEntryRights: function SaveEntryRights(operatorID, roleID, entryKeys, allRights) {
      var paras = {
        operatorID: operatorID,
        roleID: roleID,
        rights: entryKeys,
        allRights: allRights,
        cmd: "SaveEntryRights",
        service: "SetRightsService"
      };
      return Svr.Request.getData(paras);
    },
    LoadFormRightsData: function LoadFormRightsData(operatorID, roleID, formKey) {
      var paras = {
        cmd: "LoadFormRightsData",
        service: "SetRightsService",
        formKey: formKey,
        operatorID: operatorID,
        roleID: roleID
      };
      return Svr.Request.getData(paras);
    },
    SaveFormRights: function SaveFormRights(operatorID, roleID, formKey, optRts, allOptRts, enableRts, allEnableRts, visibleRts, allVisibleRts) {
      var paras = {
        operatorID: operatorID,
        roleID: roleID,
        cmd: "SaveFormRights",
        service: "SetRightsService",
        allOptRights: allOptRts,
        optRights: optRts,
        allEnableRights: allEnableRts,
        enableRights: enableRts,
        allVisibleRights: allVisibleRts,
        visibleRights: visibleRts,
        formKey: formKey
      };
      return Svr.Request.getData(paras);
    },
    LoadDictRightsData: function LoadDictRightsData(operatorID, roleID, itemKey, isChain, startRow, fuzzyValue, maxRows, pageIndicatorCount) {
      var paras = {
        cmd: "LoadDictRightsData",
        service: "SetRightsService",
        itemKey: itemKey,
        operatorID: operatorID,
        roleID: roleID
      };

      if (isChain) {
        paras.cmd = "LoadChainDictRightsData";
        paras.startRow = startRow;
        paras.maxRows = maxRows;
        paras.pageIndicatorCount = pageIndicatorCount;
        paras.value = fuzzyValue;
      }

      return Svr.Request.getData(paras);
    },
    dictExpand: function dictExpand(operatorID, roleID, itemKey, parentID) {
      var paras = {
        cmd: "LoadDictRightsData",
        service: "SetRightsService",
        itemKey: itemKey,
        parentID: parentID,
        operatorID: operatorID,
        roleID: roleID
      };
      return Svr.Request.getData(paras);
    },
    getChainDictData: function getChainDictData(operatorID, roleID, itemKey, startRow, maxRows, pageIndicatorCount, fuzzyValue) {
      var paras = {
        cmd: "LoadChainDictRightsData",
        service: "SetRightsService",
        itemKey: itemKey,
        startRow: startRow,
        maxRows: maxRows,
        pageIndicatorCount: pageIndicatorCount,
        value: fuzzyValue,
        operatorID: operatorID,
        roleID: roleID
      };
      return Svr.Request.getData(paras);
    },
    SaveDictRights: function SaveDictRights(operatorID, roleID, isChain, halfCheckRts, delRts, addRts, allRts, saveType, itemKey) {
      var paras = {
        operatorID: operatorID,
        roleID: roleID,
        allRights: allRts,
        delRights: delRts,
        addRights: addRts,
        saveType: saveType,
        itemKey: itemKey,
        cmd: "SaveDictRights",
        service: "SetRightsService"
      };

      if (!isChain) {
        paras.halfCheckRights = halfCheckRts;
      }

      return Svr.Request.getData(paras);
    }
  };
  return rt;
}(); // })();


exports["default"] = _default;