"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _YIUIBase = require("../YIUI-base");

require("../YIUI-common");

require("../YIUI-parser");

require("../YIUI-svr");

var _default = _YIUIBase.YIUI.ViewUtil = function () {
  /**
   * 组件或者单元格是否数据源定义了访问控制
   */
  var accessControl = function accessControl(form, com) {
    return com.getMetaObj().accessControl; // if( !com.tableKey || !com.columnKey )
    //     return false;
    // var doc = form.getDocument();
    // if( doc ) {
    //     var table = doc.getByKey(com.tableKey);
    //     return table ? table.getColByKey(com.columnKey).getAccessControl() : false;
    // }
    // return false;
  };

  var Return = {
    findShadowBkmk: function findShadowBkmk(doc, tableKey) {
      var sdt = doc.getShadow(tableKey);

      if (sdt == null) {
        return -1;
      }

      var bookmark = -1;
      var dt = doc.getByKey(tableKey);
      var colIndex = sdt.indexByKey(_YIUIBase.YIUI.SystemField.OID_SYS_KEY);

      if (colIndex >= 0) {
        var oid = dt.get(colIndex);

        if (sdt.first()) {
          while (!sdt.isAfterLast()) {
            if (oid == sdt.get(colIndex)) {
              bookmark = sdt.getPos();
              break;
            }

            sdt.next();
          }
        }
      } else {
        var multiKey = [];

        for (var i = 0, len = sdt.cols.length; i < len; i++) {
          if (sdt.cols[i].isPrimary) {
            multiKey.push(i);
          }
        }

        if (multiKey.length == 0) {
          _YIUIBase.YIUI.ViewException.throwException(_YIUIBase.YIUI.ViewException.PRIMARYKEYS_UNDEFINED);
        }

        if (sdt.first()) {
          while (!sdt.isAfterLast()) {
            for (var index in multiKey) {
              if (sdt.get(index) != dt.get(index)) {
                bookmark = -1;
                break;
              }

              bookmark = sdt.getPos();
            }

            if (bookmark > -1) {
              break;
            }

            sdt.next();
          }
        }
      }

      return bookmark;
    },
    checkComAccessControl: function checkComAccessControl(form, com) {
      if (!accessControl(form, com)) return true;
      var table = form.getDocument().getByKey(com.tableKey);
      var val = -1;

      if (table.first()) {
        val = _YIUIBase.YIUI.TypeConvertor.toInt(table.getByKey(com.columnKey + "_CF"));
      }

      return (val & _YIUIBase.YIUI.FormUIStatusMask.ENABLE) != 0 ? false : true;
    },
    checkCellAccessControl: function checkCellAccessControl(form, grid, ri, key) {
      // var rowData = grid.getRowDataAt(ri);
      var metaCell = grid.getMetaCellByKey(key); // if( rowData.rowType !== 'Fix' && YIUI.GridUtil.isEmptyRow(rowData) )

      if (grid.getRowType(ri) !== 'Fix' && grid.isEmptyRow(ri)) return true;
      if (metaCell.isColExpand || !metaCell.accessControl) return true;
      var table = form.getDocument().getByKey(metaCell.tableKey);

      if (table.tableMode == _YIUIBase.YIUI.TableMode.HEAD) {
        table.first();
      } else {
        table.setByBkmk(grid.geRowBookmark(ri));
      }

      var val = _YIUIBase.YIUI.TypeConvertor.toInt(table.getByKey(metaCell.columnKey + "_CF"));

      return (val & _YIUIBase.YIUI.FormUIStatusMask.ENABLE) != 0 ? false : true;
    }
  };
  return Return;
}();

exports["default"] = _default;