/**
 * Created by 陈瑞 on 2017/3/1.
 */
import { YIUI } from './YIUI-base';
import './YIUI-common';
import './YIUI-parser';
import './YIUI-svr';
import { lodash as $ } from 'yes-common';
// var YIUI = YIUI || {};
// (function () {
export default YIUI.AbstractUIProcess = YIUI.extend({
    form: null,
    // formRights: null,
    // allEnableRights : true,
    // allVisibleRights : true,

    init: function (form) {
        this.form = form;
        // this.formRights = form.getFormRights();
        // if( form.metaForm.authenticate ) {
        //     this.allEnableRights = this.formRights.allEnableRights;
        //     this.allVisibleRights = this.formRights.allVisibleRights;
        // }
    },

    getFormEnable: function () {
        return this.form.operationState == YIUI.Form_OperationState.New ||
            this.form.operationState == YIUI.Form_OperationState.Edit;
    },

    enableOnly: function () {
        return (this.form.operationState == YIUI.Form_OperationState.New ||
            this.form.operationState == YIUI.Form_OperationState.edit) ? false :
            this.form.operationState == YIUI.Form_OperationState.Default;
    },

    newContext: function (form, rowIndex, colIndex) {
        var cxt = {};
        cxt.form = form;
        cxt.rowIndex = rowIndex;
        cxt.colIndex = colIndex;
        return cxt;
    },

    isNullValue: function (v) {
        if (v == null || v == '')
            return true;
        if (v instanceof Decimal)
            return parseFloat(v) == 0;
        return false;
    },

    initTree: function (item) {
        if (!item.items)
            return;
        for (var i = 0, exp, cnt; exp = item.items[i]; i++) {
            cnt = exp.content || exp.formulaValue;
            if (cnt) {
                exp.syntaxTree = this.form.getSyntaxTree(cnt);
            }
        }
        return item;
    },

    // hasEnableRights: function (key) {
    //     var host = this.form.getBPMStatusProxy();
    //     if (host) {
    //         return host.hasEnableRights(key);
    //     }
    //     return this.allEnableRights || $.inArray(key, this.formRights.enableRights) == -1;
    // },

    // hasVisibleRights: function (key) {
    //     var host = this.form.getBPMStatusProxy();
    //     if (host) {
    //         return host.hasVisibleRights(key);
    //     }
    //     return this.allVisibleRights || $.inArray(key, this.formRights.visibleRights) == -1;
    // },

    calcFormulaValue: async function (item, context) {
        var result = null;
        if (item.syntaxTree) {
            result = await this.form.evalByTree(item.syntaxTree, context, null);
        } else if (item.formula) {
            result = await this.form.eval(item.formula, context, null);
        } else if (item.defaultValue) {
            result = item.defaultValue;
        }
        return result;
    },

    calcEnable: async function (item, context, defaultValue, accessControl) {
        if (!this.form.hasEnableRight(item.target) || !accessControl)
            return false;
        if (item.items.length == 0) {
            return defaultValue;
        }
        for (let i = 0; i < item.items.length; i++) {
            const it = item.items[i];
            let v = true;
            if (it.syntaxTree) {
                v = YIUI.TypeConvertor.toBoolean(await this.form.evalByTree(it.syntaxTree, context, null));
            } else if (it.content) {
                v = YIUI.TypeConvertor.toBoolean(await this.form.evalFormula(it.content, context, null));
            }
            if (!v) {
                return false;
            }
        }
        return true;
    },

    calcVisible: async function (item, context) {
        if (!this.form.hasVisibleRight(item.target))
            return false;
        for (let i = 0; i < item.items.length; i++) {
            const it = item.items[i];
            let v = true;
            if (it.syntaxTree) {
                v = YIUI.TypeConvertor.toBoolean(await this.form.evalByTree(it.syntaxTree, context, null));
            } else if (it.content) {
                v = YIUI.TypeConvertor.toBoolean(await this.form.evalFormula(it.content, context, null));
            }
            if (!v) {
                return false;
            }
        }
        return true;
    },
    calcCheckRule: async function (it, context) {
        var result = null;
        for (let i = 0; i < it.items.length; i++) {
            const item = it.items[i] ;
            if (item.syntaxTree) {
                result = await this.form.evalByTree(item.syntaxTree, context, null);
            } else if (item.content) {
                result = await this.form.evalFormula(item.content, context, null);
            }
        }
        if (result == null || (typeof result === 'string' && result === 'true')) {
            result = true;
        }
        return result;
    },
});
