/*
 * @Author: gmf
 * @Date:   2016-03-18 10:47:19
 * @Last Modified by:   gmf
 * @Last Modified time: 2017-02-17 17:04:07
 */

import BaseControl from './control';
import cache from '../../cache';
import { regControlType } from './controlUtil';
import { YIUI } from '../../YIUI-base';
import { DataDef } from '../../YIUI-common';
import '../../YIUI-svr';
import '../../YIUI-parser';
const { DictCache } = cache.current;
const DictEditor = YIUI.extend(BaseControl, {
    value: null,
    handler: YIUI.DictHandler,
    needRebuild: true,
    setInnerValue(v) {
        let newV = '' + v;
        if (v == null || v == '') {
            newV = null;
        }
        //切换到字符串，避免一些公式返回的是数字导致change时间被异常触发
        const state = this.state.set('value', newV);
        this.changeState(state);
    },
    // getDictCaption: (dictItem, column)=> {
    //     if(!dictItem){
    //         return '';
    //     }
    //     dictItem.itemTabls[dictItem.mainTableKey];
    // }
    calculateDisplayValue: async function (v) { // eslint-disable-line object-shorthand
        if (!v) {
            return '';
        }
        const getValue = async (v) => {
            const dictKey = `${this.itemKey}.${v}`;
            const dictItem = await DictCache.get(dictKey);
            if (!dictItem) {
                return '';
            }
            let text = dictItem.caption;
            if(this.getMetaObj().textField) {
                const dataItem = new DataDef.Item(dictItem);
                return dataItem.getValue(this.getMetaObj().textField);
            }
            return text;
        };
        // 可能多选
        if (v && v.split) {
            const vArr = v.split(',');
            if (vArr.length > 1) {
                const textArr = [];
                for (const item of vArr) {
                    const text = await getValue(item);
                    textArr.push(text);
                }
                return textArr.join(', ');
            }
        }
        return await getValue(v);
    },
    isNull() {
        const v = this.getValue();
        return YIUI.TypeConvertor.toLong(v)<=0;
    },
    init(options) {
        this.base(options);
        this.dictFilter = this.dictFilter || this.getMetaObj().dictFilter;
        this.itemKey = this.itemKey || this.getMetaObj().itemKey;
        this.state = this.state.merge({
            dictFilter: this.dictFilter,
            itemKey: this.itemKey,
        });
    },
    setDictInfo(itemKey, dictFilter) {
        const state = this.state.merge({
            dictFilter,
            itemKey,
        });
        this.changetState(state);
    },
});
YIUI.reg('dict', DictEditor);
YIUI.reg('compdict', DictEditor);
YIUI.reg('dynamicdict', DictEditor);
regControlType(YIUI.CONTROLTYPE.DICT, 'dict');
regControlType(YIUI.CONTROLTYPE.COMPDICT, 'compdict');
regControlType(YIUI.CONTROLTYPE.DYNAMICDICT, 'dynamicdict');
export default DictEditor;
